/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.3.23566 at Sat Nov 17 11:52:49 AM CET 2012
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1999, 2012.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

/* TAU RTOS integration for Nucleus PLUS */


/************************************************************
                       IMPORTANT

This integration is not part of IBM Rational's products and no support
is given. The integration is provided "as is" and is intended to
be a starting point and thereby simplify the process to obtain a
working integration for this OS.

Status of the integration:
Status: The integration has been compiled and basic testing has been performed.
Tau version: SDL Suit 4.5 and Tau G2 2.4
OS version: Nucleus PLUS version 1.13.1

*************************************************************/

NU_SEMAPHORE xFreeSignalMutex;
NU_SEMAPHORE xFreeTimerMutex;
NU_SEMAPHORE xCreateMutex;
#ifdef USER_CFG_USE_MEMORY_PACK
  NU_SEMAPHORE xMemoryMutex;
#endif
NU_SEMAPHORE xInitSem;
#if (!defined(USER_CFG_USE_xInEnv)) && (!defined(XENV))
  NU_SEMAPHORE xMainThreadSem;
#endif
#ifdef USER_CFG_HANDLE_CLOCK_WRAP
  NU_SEMAPHORE xClockMutex;
#endif

NU_MEMORY_POOL System_Memory;
#if (defined(THREADED)) || (defined(CFG_USED_DYNAMIC_THREADS))
  NU_QUEUE        KillerQ;
  static UNSIGNED Unsigned_Per_VoidStar;
#endif


static VOID Main_th (UNSIGNED P1, VOID *P2)
{
  UML_main();
}


#if (defined(THREADED)) || (defined(CFG_USED_DYNAMIC_THREADS))
static VOID Killer_th (UNSIGNED P1, VOID *P2)
{
  UNSIGNED scratch;
  VOID    *Stack_Ptr;
  CHAR     Name[NU_MAX_NAME];
  struct _xSystemData *xSysDP;

  Unsigned_Per_VoidStar = (sizeof(VOID *) + 3)/4;
  (void)NU_Allocate_Memory(&System_Memory, &Stack_Ptr, 2*Unsigned_Per_VoidStar,
                           NU_NO_SUSPEND);
  (void)NU_Create_Queue(&KillerQ, "KillerQ", Stack_Ptr, 2*Unsigned_Per_VoidStar,
                        NU_FIXED_SIZE, Unsigned_Per_VoidStar, NU_PRIORITY);
  
  while (1) {
    (void)NU_Receive_From_Queue(&KillerQ, (VOID *)&xSysDP, Unsigned_Per_VoidStar, &scratch,
                                NU_SUSPEND);
    (void)NU_Terminate_Task(&xSysDP->ThreadVars.Task);
    (void)NU_Task_Information(&xSysDP->ThreadVars.Task, Name,
                              (DATA_ELEMENT *)&scratch, &scratch,
                              (OPTION *)&scratch, (OPTION *)&scratch,
                              &scratch, &Stack_Ptr, &scratch, &scratch);
    (void)NU_Delete_Task(&xSysDP->ThreadVars.Task);
    (void)NU_Deallocate_Memory(Stack_Ptr);
  }
}
#endif


void Application_Initialize (VOID *first_available_memory)
{
  NU_TASK *Task;
  VOID *Stack_Ptr;
  (void)NU_Create_Memory_Pool(&System_Memory, "SYSMEM", first_available_memory,
                              USER_CFG_SYSTEM_MEMORY, USER_CFG_MIN_ALLOCATION,
                              NU_PRIORITY);
  #if (defined(THREADED)) || (defined(CFG_USED_DYNAMIC_THREADS))
    (void)NU_Allocate_Memory(&System_Memory, &Stack_Ptr, USER_CFG_MANAGER_STACK_SIZE,
                             NU_NO_SUSPEND);
    (void)NU_Allocate_Memory(&System_Memory, &Task, sizeof(NU_TASK),
                             NU_NO_SUSPEND);
    (void)NU_Create_Task(Task, "Killer_th", Killer_th, 0, NULL,
                         Stack_Ptr, USER_CFG_MANAGER_STACK_SIZE,
                         0, 0, NU_PREEMPT, NU_START);
    
  #endif
  (void)NU_Allocate_Memory(&System_Memory, &Stack_Ptr, USER_CFG_MANAGER_STACK_SIZE,
                           NU_NO_SUSPEND);
  (void)NU_Allocate_Memory(&System_Memory, &Task, sizeof(NU_TASK),
                           NU_NO_SUSPEND);
  (void)NU_Create_Task(Task, "Main_th", Main_th, 0, NULL,
                       Stack_Ptr, USER_CFG_MANAGER_STACK_SIZE,
                       DEFAULT_PRIO, 0, NU_PREEMPT, NU_START);
}


void xThreadInit (void)
{       
  (void)NU_Create_Semaphore(&xFreeSignalMutex, "xFSMutex", 1, NU_FIFO);
  (void)NU_Create_Semaphore(&xFreeTimerMutex, "xFTMutex", 1, NU_FIFO);
  (void)NU_Create_Semaphore(&xCreateMutex, "xCMMutex", 1, NU_FIFO);
  #ifdef USER_CFG_USE_MEMORY_PACK
    (void)NU_Create_Semaphore(&xMemoryMutex, "MemMutex", 1, NU_FIFO);
  #endif
  (void)NU_Create_Semaphore(&xInitSem, "xInitSem", 0, NU_FIFO);
  #ifdef USER_CFG_HANDLE_CLOCK_WRAP
    (void)NU_Create_Semaphore(&xClockMutex, "xClockSem", 1, NU_FIFO);
  #endif
}


void xThreadInitOneThread (struct _xSystemData *xSysDP)
{
  (void)NU_Create_Semaphore(&xSysDP->ThreadVars.SignalQueueMutex, "xSQMutex", 1, NU_FIFO);
  (void)NU_Create_Semaphore(&xSysDP->ThreadVars.SignalQueueCond, "xSQCMutx", 0, NU_FIFO);
}


static VOID xThreadEntryFunc (UNSIGNED tmp, VOID *xSysDP)
{
  (void)NU_Obtain_Semaphore(&xInitSem, NU_SUSPEND);
  (void)NU_Release_Semaphore(&xInitSem);
  xMainLoop((xSystemData *)xSysDP);
}


void xThreadStartThread (struct _xSystemData *xSysDP,
                         unsigned int StackSize,
                         unsigned int Prio,
                         unsigned int User1,
                         unsigned int User2)
{
  VOID * Stack_Ptr;
  (void)NU_Allocate_Memory(&System_Memory, &Stack_Ptr, StackSize, NU_NO_SUSPEND);
  (void)NU_Create_Task(&xSysDP->ThreadVars.Task, "Thread",
                       xThreadEntryFunc, 0, (void *)xSysDP,
                       Stack_Ptr, StackSize, (OPTION)Prio, 0, NU_PREEMPT, NU_START);
}


#if (defined(THREADED)) || (defined(CFG_USED_DYNAMIC_THREADS))
void xThreadStopThread (struct _xSystemData *xSysDP)
{
  (void)NU_Delete_Semaphore(&xSysDP->ThreadVars.SignalQueueMutex);
  (void)NU_Delete_Semaphore(&xSysDP->ThreadVars.SignalQueueCond);
  (void)NU_Send_To_Queue(&KillerQ, (VOID *)&xSysDP, Unsigned_Per_VoidStar, NU_SUSPEND);
}
#endif


void xThreadGo (void)
{
  #ifdef USER_CFG_USE_xInEnv
    (void)NU_Release_Semaphore(&xInitSem);
    xInEnv();
  #elif defined(XENV)
    (void)NU_Release_Semaphore(&xInitSem);
    xInEnv(xNow());  /* Cadvanced */
  #else
    (void)NU_Create_Semaphore(&xMainThreadSem, "xMThrSem", 0, NU_FIFO);
    (void)NU_Release_Semaphore(&xInitSem);
    (void)NU_Obtain_Semaphore(&xMainThreadSem, NU_SUSPEND);
  #endif
}


void xThreadLock (NU_SEMAPHORE *Mutex)
{
  (void)NU_Obtain_Semaphore(Mutex, NU_SUSPEND);
}


void xThreadUnlock (NU_SEMAPHORE *Mutex)
{
  (void)NU_Release_Semaphore(Mutex);
}


void xThreadWaitUnlock (struct _xSystemData *xSysDP)
{
  (void)NU_Obtain_Semaphore(&xSysDP->ThreadVars.SignalQueueCond, NU_NO_SUSPEND);
  (void)NU_Release_Semaphore(&xSysDP->ThreadVars.SignalQueueMutex);

  #if (defined(CFG_USED_TIMER)) || (defined(THREADED))
  #ifdef THREADED
      /* Cadvanced */
    if (xSysDP->xTimerQueue->Suc == xSysDP->xTimerQueue) { 
  #else
      /* ExtremeC */
    if (! xSysDP->TimerQueue) {
  #endif
      (void)NU_Obtain_Semaphore(&xSysDP->ThreadVars.SignalQueueCond, NU_SUSPEND);
    } else {
      SDL_Time Timeout;     /* time/duration in seconds and nano-seconds */
      #ifdef THREADED
          /* Cadvanced */
        Timeout = xMinus_SDL_Duration(((xTimerNode)xSysDP->xTimerQueue->Suc)->TimerTime,
                                      xNow());
      #else
          /* ExtremeC */
        Timeout = xMinus_SDL_Duration(xSysDP->TimerQueue->Time, xNow());
      #endif
      (void)NU_Obtain_Semaphore(
              &xSysDP->ThreadVars.SignalQueueCond,
              Timeout.s*USER_CFG_TICKS_PER_SEC + Timeout.ns/USER_CFG_NS_PER_TICK);
    }
  #else
    (void)NU_Obtain_Semaphore(&xSysDP->ThreadVars.SignalQueueCond, NU_SUSPEND);
  #endif
}


void xThreadSignalUnlock (struct _xSystemData *xSysDP)
{
  (void)NU_Release_Semaphore(&xSysDP->ThreadVars.SignalQueueMutex);
  (void)NU_Release_Semaphore(&xSysDP->ThreadVars.SignalQueueCond);
}


SDL_Time xNow (void)
{
  UNSIGNED t;
  SDL_Time TimeVal;
  #ifdef USER_CFG_HANDLE_CLOCK_WRAP
    static UNSIGNED Prevt = 0;
    static UNSIGNED Adds = 0;
    static UNSIGNED Addns = 0;
  #endif
  t = NU_Retrieve_Clock();
  TimeVal.s  = t/USER_CFG_TICKS_PER_SEC;
  TimeVal.ns = (t % USER_CFG_TICKS_PER_SEC) * USER_CFG_NS_PER_TICK;
  #ifdef USER_CFG_HANDLE_CLOCK_WRAP
    (void)NU_Obtain_Semaphore(xClockMutex, NU_SUSPEND);
    if (t < Prevt) {
      Adds = Adds + 4294967296/USER_CFG_TICKS_PER_SEC;
      Addns = Addns + (4294967296 % USER_CFG_TICKS_PER_SEC) * USER_CFG_NS_PER_TICK;
      if (Addns >= 1000000000) {
        Adds = Adds + 1;
        Addns = Addns - 1000000000;
      }
    }
    Prevt = t;
    TimeVal.s = TimeVal.s + Adds;
    TimeVal.ns = TimeVal.ns + Addns;
    (void)NU_Release_Semaphore(xClockMutex);
    if (TimeVal.ns >= 1000000000) {
      TimeVal.s = TimeVal.s + 1;
      TimeVal.ns = TimeVal.ns - 1000000000;
    }
  #endif
  return TimeVal;
}
