/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.3.23566 at Sat Nov 17 11:52:49 AM CET 2012
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1999, 2012.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/* TAU RTOS integration for OSE */

SEMAPHORE *xFreeSignalMutex;
SEMAPHORE *xFreeTimerMutex;
SEMAPHORE *xCreateMutex;
#ifdef USER_CFG_USE_MEMORY_PACK
  SEMAPHORE *xMemoryMutex;
#endif
SEMAPHORE *xInitSem;
#if (!defined(USER_CFG_USE_xInEnv)) && (!defined(XENV))
  SEMAPHORE *xMainThreadSem;
#endif


void xThreadInit (void)
{
  xFreeSignalMutex = create_sem(1);
  xFreeTimerMutex = create_sem(1);
  xCreateMutex = create_sem(1);
  #ifdef USER_CFG_USE_MEMORY_PACK
    xMemoryMutex = create_sem(1);
  #endif
  xInitSem = create_sem(0);
}


void xThreadInitOneThread(struct _xSystemData *xSysDP)
{
  xSysDP->ThreadVars.SignalQueueMutex = create_sem(1);
}


static void xThreadEntryFunc (void)
{
  struct _xSystemData *xSysDP;
  union SIGNAL *xStartupSignal;
  wait_sem(xInitSem);
  signal_sem(xInitSem);
  xStartupSignal = receive((SIGSELECT *)any_sig); 
  xSysDP = ((struct uml_startup*)xStartupSignal)->xSysDP;
  free_buf(&xStartupSignal);
  xMainLoop(xSysDP);
}


void xThreadStartThread(struct _xSystemData *xSysDP,
                        unsigned int StackSize,
                        unsigned int Prio,
                        unsigned int User1,
                        unsigned int User2)
{
  union SIGNAL *xStartupSignal;
  xSysDP->ThreadVars.ThreadId =
    create_process(OS_PRI_PROC, "TauThread", xThreadEntryFunc, 4096, 16,0, 0, (struct OS_redir_entry *) NULL, 0, 0);
  /* Note: Hard coded prio and stack size. Use parameters to function instead??
   */
  xStartupSignal = alloc(sizeof(struct uml_startup), UML_STARTUP);
  ((struct uml_startup*)xStartupSignal)->xSysDP = xSysDP;
  start(xSysDP->ThreadVars.ThreadId);
  send(&xStartupSignal, xSysDP->ThreadVars.ThreadId);
}


void xThreadGo(void)
{
  #if defined(USER_CFG_USE_xInEnv)
    signal_sem(xInitSem);
    xInEnv();  /* ExtremeC */
  #elif defined(XENV)
    signal_sem(xInitSem);
    xInEnv(xNow());  /* Cadvanced */
  #else
    xMainThreadSem = create_sem(0);
    signal_sem(xInitSem);
    wait_sem(xMainThreadSem);
  #endif
}



void xThreadLock (SEMAPHORE **M)
{
  wait_sem(*M);
}


void xThreadUnlock (SEMAPHORE **M)
{
  signal_sem(*M);
}


void xThreadWaitUnlock (struct _xSystemData *xSysDP)
{
  union SIGNAL *MessagePtr;
  signal_sem(xSysDP->ThreadVars.SignalQueueMutex);
  #if (defined(CFG_USED_TIMER)) || (defined(THREADED))
  #ifdef THREADED
      /* Cadvanced */
    if (xSysDP->xTimerQueue->Suc == xSysDP->xTimerQueue) { 
  #else
      /* ExtremeC */
    if (! xSysDP->TimerQueue) {
  #endif
      MessagePtr = receive((SIGSELECT *)any_sig);
      free_buf(&MessagePtr);
    } else {
      SDL_Time Timeout;     /* time/duration in seconds and nano-seconds */
      #ifdef THREADED
          /* Cadvanced */
        Timeout = xMinus_SDL_Duration(((xTimerNode)xSysDP->xTimerQueue->Suc)->TimerTime,
                                      xNow());
      #else
          /* ExtremeC */
        Timeout = xMinus_SDL_Duration(xSysDP->TimerQueue->Time, xNow());
      #endif
      MessagePtr = receive_w_tmo(
                     Timeout.s*1000 + Timeout.ns/1000000 /* in ms */,
                     (SIGSELECT *)any_sig);
      if (MessagePtr != NIL) free_buf(&MessagePtr);
    }
  #else
    MessagePtr = receive((SIGSELECT *)any_sig);
    free_buf(&MessagePtr);
  #endif
}


void xThreadSignalUnlock (struct _xSystemData *xSysDP)
{
  union SIGNAL *MessagePtr;
  MessagePtr = alloc(sizeof(struct uml_wakeup), UML_WAKEUP);
  send(&MessagePtr, xSysDP->ThreadVars.ThreadId);
  signal_sem(xSysDP->ThreadVars.SignalQueueMutex);
}


SDL_Time xNow (void)
{
  struct TimePair t;
  SDL_Time TimeVal;
  rtc_get_time(&t);
  TimeVal.s  = (xint32)(t.seconds);
  TimeVal.ns = (xint32)(t.micros*1000);
  return TimeVal;
}


void *xAlloc (unsigned int Size)
{
  char * Ptr;
  /* Use memory management from C Compiler or RTOS */
  /* It is assumed that the function malloc, calloc, free are threadsafe */
  Ptr = (char *)alloc((OSBUFSIZE)Size, (SIGSELECT)999);
  if (Ptr)
    (void)memset(Ptr, 0, (int)Size);
  return Ptr;
}
 
 
void xFree (void ** Ptr)
{
  if (*Ptr) {
    free_buf((union SIGNAL **)Ptr);
    *Ptr = (void *)0;
  }
}
