/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.3.23566 at Sat Nov 17 11:52:49 AM CET 2012
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1999, 2012.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

/* TAU RTOS integration for microC/OS-II */


/************************************************************
                       IMPORTANT

This integration is not part of IBM Rational's products and no support
is given. The integration is provided "as is" and is intended to
be a starting point and thereby simplify the process to obtain a
working integration for this OS.

Status of the integration:
Status: The integration is just compiled. NO TESTING has been performed.
Tool: Tau SDL Suite 4.5, Cadvanced threaded (can also be used in G2)
Compiler: MS Visual C++

*************************************************************/


OS_EVENT *xFreeSignalMutex;
OS_EVENT *xFreeTimerMutex;
OS_EVENT *xCreateMutex;
#ifdef USER_CFG_USE_MEMORY_PACK
  OS_EVENT *xMemoryMutex;
#endif
OS_EVENT *xInitSem;
#if !defined(USER_CFG_USE_xInEnv) && !defined(XENV)
  OS_EVENT *xMainThreadSem;
#endif


void xThreadInit(void)
{
  xFreeSignalMutex = OSSemCreate(1);
  xFreeTimerMutex = OSSemCreate(1);
  xCreateMutex = OSSemCreate(1);
  #ifdef USER_CFG_USE_MEMORY_PACK
    xMemoryMutex = OSSemCreate(1);
  #endif
  xInitSem = OSSemCreate(0);
}


void xThreadInitOneThread(struct _xSystemData *xSysDP)
{
  xSysDP->ThreadVars.SignalQueueMutex = OSSemCreate(1);
  xSysDP->ThreadVars.SignalQueueCond = OSSemCreate(0);
}


static void xThreadEntryFunc(void *xSysDP)
{
  INT8U err;
  (void)OSSemPend(xInitSem, WAIT_FOREVER, &err);
  (void)OSSemPost(xInitSem);
  xMainLoop((xSystemData *)xSysDP);
}


void xThreadStartThread(struct _xSystemData *xSysDP,
                        unsigned int StackSize,
                        unsigned int Prio,
                        unsigned int User1,
                        unsigned int User2)
{
  INT8U err;

  xSysDP->ThreadVars.pbos  = (OS_STK *)xAlloc(StackSize);
  xSysDP->ThreadVars.ptos = xSysDP->ThreadVars.pbos + StackSize-1;
  xSysDP->ThreadVars.ThreadId = Prio; /* All threads must have different prio */

  err = OSTaskCreateExt(xThreadEntryFunc,(void *)xSysDP, 
        xSysDP->ThreadVars.ptos,
	(INT8U)Prio, (INT16U)Prio, 
	xSysDP->ThreadVars.pbos, 
        StackSize, (void *)0, 
        OS_TASK_OPT_STK_CLR);
}


#if defined(THREADED) || defined(CFG_USED_DYNAMIC_THREADS)
void xThreadStopThread(struct _xSystemData *xSysDP)
{
  INT8U err;
  OSSemDel((xSysDP->ThreadVars.SignalQueueMutex),OS_DEL_ALWAYS, &err);
  OSSemDel(xSysDP->ThreadVars.SignalQueueCond,OS_DEL_ALWAYS, &err);
  OSTaskDel((INT8U)xSysDP->ThreadVars.ThreadId);
}
#endif


void xThreadGo(void)
{
  INT8U err;
  #if defined(USER_CFG_USE_xInEnv)
    (void)OSSemPost(xInitSem);
    xInEnv();  /* ExtremeC */
  #elif defined(XENV)
    (void)OSSemPost(xInitSem);
    xInEnv(xNow());  /* Cadvanced */
  #else
    xMainThreadSem = OSSemCreate(0);
    (void)OSSemPost(xInitSem);
    (void)OSSemPend(xMainThreadSem, WAIT_FOREVER, &err);
  #endif
}


void xThreadLock (OS_EVENT *Mutex)
{
  INT8U err;
  (void)OSSemPend(Mutex, WAIT_FOREVER, &err);
}


void xThreadUnlock (OS_EVENT *Mutex)
{
  (void)OSSemPost(Mutex);
}


void xThreadWaitUnlock (struct _xSystemData *xSysDP)
{
  INT8U err;
  (void)OSSemPend(xSysDP->ThreadVars.SignalQueueCond, NO_WAIT, &err);/* set blocking mode */
  (void)OSSemPost(xSysDP->ThreadVars.SignalQueueMutex);

  #if defined(CFG_USED_TIMER) || defined(THREADED)
  #ifdef THREADED
      /* Cadvanced */
    if (xSysDP->xTimerQueue->Suc == xSysDP->xTimerQueue) { 
  #else
      /* ExtremeC */
    if (! xSysDP->TimerQueue) {
  #endif
      (void)OSSemPend(xSysDP->ThreadVars.SignalQueueCond, WAIT_FOREVER, &err);
    } else {
      int Ticks;
      SDL_Time TmpTime;

      TmpTime = xNow();
      #ifdef THREADED
          /* Cadvanced */
        TmpTime.s  = ((xTimerNode)xSysDP->xTimerQueue->Suc)->TimerTime.s  - TmpTime.s;
        TmpTime.ns = ((xTimerNode)xSysDP->xTimerQueue->Suc)->TimerTime.ns - TmpTime.ns;
      #else
          /* ExtremeC */
        TmpTime.s  = xSysDP->TimerQueue->Time.s  - TmpTime.s;
        TmpTime.ns = xSysDP->TimerQueue->Time.ns - TmpTime.ns;
      #endif
      Ticks =
        (int)((OS_TICKS_PER_SEC * ((TmpTime.s * 1000)+(TmpTime.ns / 1000000)))/1000);
      (void)OSSemPend(xSysDP->ThreadVars.SignalQueueCond, Ticks, &err);
    }
  #else
    (void)OSSemPend(xSysDP->ThreadVars.SignalQueueCond, WAIT_FOREVER, &err);
  #endif
}


void xThreadSignalUnlock (struct _xSystemData *xSysDP)
{
  (void)OSSemPost(xSysDP->ThreadVars.SignalQueueMutex);
  (void)OSSemPost(xSysDP->ThreadVars.SignalQueueCond); 
}


SDL_Time xNow (void)
{
  SDL_Time retval;
  xint32 temp1;
  temp1=     OSTimeGet() * 1.25; /* for ERDC_ARM9 */
  retval.s  = (xint32)(temp1/1000);
  retval.ns = (xint32)(temp1%1000)*1000000;
  return retval;
}
