/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.3.23566 at Sat Nov 17 11:52:49 AM CET 2012
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1999, 2012.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/******************************************************************

  C-code macros and functions for Nucleus tight integration.
  Provides hooks into the system to the user.

  To be used with SDT C Code Generator 4.3
  #clearcase

*******************************************************************/

#ifndef _scthooks_h
#define _scthooks_h

/****+*************************************************************
     HOOK_GLOBAL_DECLARATIONS
     This is the place to put all global declarations. The macro is
     used in the file sctsdl.c.
*******************************************************************/
#define HOOK_GLOBAL_DECLARATIONS  extern void MyExtTask XPP((UNSIGNED argc, VOID *argv));

/****+*************************************************************
     HOOK_MAIN_DECLARATIONS
     This macro declares variables used in the main function in the
     file sctsdl.c.
*******************************************************************/
#define HOOK_MAIN_DECLARATIONS

/****+*************************************************************
     HOOK_MAIN_START_OF_CODE
     This macro contains code that is executed first in the main
     function in the file sctsdl.c.
*******************************************************************/
#define HOOK_MAIN_START_OF_CODE

/****+*************************************************************
     HOOK_MAIN_AFTER_PROCESS_RELEASE
     This macro contains code that is executed directly after the 
     SDL system and all its static processes are allowed to run.
     This is the last chance to exit the main function before the
     eternal loop.
     The macro is used in the main function in the file sctsdl.c.
*******************************************************************/
#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define HOOK_MAIN_AFTER_PROCESS_RELEASE \
  { \
   NU_TASK	*Task_Ptr; \
   NU_QUEUE *Queue_Ptr; \
   VOID		*Stack_Ptr; \
   VOID		*Queue_Start_Ptr; \
   Err = NU_Allocate_Memory(&System_Memory, (VOID **)&Task_Ptr, sizeof(NU_TASK), NU_NO_SUSPEND); \
   XOS_ERROR("RTOSSYSINITPR_SEMGIVE", "NU_Allocate_Memory1", Err) \
   memset(Task_Ptr, 0, sizeof(NU_TASK) ); \
   Err = NU_Allocate_Memory(&System_Memory, &Stack_Ptr, ENV_STACK_SIZE, NU_NO_SUSPEND); \
   XOS_ERROR("RTOSSYSINITPR_SEMGIVE", "NU_Allocate_Memory2", Err) \
   memset(Stack_Ptr, 0, ENV_STACK_SIZE ); \
   Err = NU_Allocate_Memory(&System_Memory, (VOID **)&Queue_Ptr, sizeof(NU_QUEUE), NU_NO_SUSPEND); \
   XOS_ERROR("RTOSSYSINITPR_SEMGIVE", "NU_Allocate_Memory3", Err) \
   memset(Queue_Ptr, 0, sizeof(NU_QUEUE) ); \
   Err = NU_Allocate_Memory(&System_Memory, &Queue_Start_Ptr, ENV_QUEUE_SIZE*sizeof(UNSIGNED), NU_NO_SUSPEND); \
   XOS_ERROR("RTOSSYSINITPR_SEMGIVE", "NU_Allocate_Memory4", Err) \
   memset(Queue_Start_Ptr, 0, (ENV_QUEUE_SIZE*sizeof(UNSIGNED)) ); \
   Err = NU_Create_Queue(Queue_Ptr, "MyExtTk", Queue_Start_Ptr, ENV_QUEUE_SIZE, NU_FIXED_SIZE, MESSAGE_SIZE, NU_FIFO);\
   XOS_ERROR("RTOSSYSINITPR_SEMGIVE", "NU_Create_Queue", Err) \
   NU_Create_Task(Task_Ptr, "MyExtTk", MyExtTask, 0, Queue_Ptr, Stack_Ptr, ENV_STACK_SIZE, ENV_TASK_PRIORITY, ENV_TIME_SLICE, NU_PREEMPT, NU_START); \
   XOS_ERROR("RTOSSYSINITPR_SEMGIVE", "NU_Create_Task", Err); \
   (xEnvId->PROCID) = Queue_Ptr;\
  }
#else
#define HOOK_MAIN_AFTER_PROCESS_RELEASE \
  { \
   NU_TASK	*Task_Ptr; \
   NU_QUEUE *Queue_Ptr; \
   VOID		*Stack_Ptr; \
   VOID		*Queue_Start_Ptr; \
   Err = NU_Allocate_Memory(&System_Memory, (VOID **)&Task_Ptr, sizeof(NU_TASK), NU_NO_SUSPEND); \
   XOS_ERROR("RTOSSYSINITPR_SEMGIVE", "NU_Allocate_Memory1", Err) \
   memset(Task_Ptr, 0, sizeof(NU_TASK) ); \
   Err = NU_Allocate_Memory(&System_Memory, &Stack_Ptr, ENV_STACK_SIZE, NU_NO_SUSPEND); \
   XOS_ERROR("RTOSSYSINITPR_SEMGIVE", "NU_Allocate_Memory2", Err) \
   memset(Stack_Ptr, 0, ENV_STACK_SIZE ); \
   Err = NU_Allocate_Memory(&System_Memory, (VOID **)&Queue_Ptr, sizeof(NU_QUEUE), NU_NO_SUSPEND); \
   XOS_ERROR("RTOSSYSINITPR_SEMGIVE", "NU_Allocate_Memory3", Err) \
   memset(Queue_Ptr, 0, sizeof(NU_QUEUE) ); \
   Err = NU_Allocate_Memory(&System_Memory, &Queue_Start_Ptr, ENV_QUEUE_SIZE*sizeof(UNSIGNED), NU_NO_SUSPEND); \
   XOS_ERROR("RTOSSYSINITPR_SEMGIVE", "NU_Allocate_Memory4", Err) \
   memset(Queue_Start_Ptr, 0, (ENV_QUEUE_SIZE*sizeof(UNSIGNED)) ); \
   Err = NU_Create_Queue(Queue_Ptr, "MyExtTk", Queue_Start_Ptr, ENV_QUEUE_SIZE, NU_FIXED_SIZE, MESSAGE_SIZE, NU_FIFO);\
   XOS_ERROR("RTOSSYSINITPR_SEMGIVE", "NU_Create_Queue", Err) \
   xEnvPrs->Self=Queue_Ptr; \
   NU_Create_Task(Task_Ptr, "MyExtTk", MyExtTask, 0, Queue_Ptr, Stack_Ptr, ENV_STACK_SIZE, ENV_TASK_PRIORITY, ENV_TIME_SLICE, NU_PREEMPT, NU_START); \
   XOS_ERROR("RTOSSYSINITPR_SEMGIVE", "NU_Create_Task", Err) \
   XMSC_TRACE_STATIC_CREATE( Queue_Ptr, "MyExtTask");\
  }
#endif


/****+*************************************************************
     HOOK_MAIN_AFTER_SIGNAL_RECEPTION
     This macro contains code that is executed after a signal has
     been received and processed in the eternal loop of the main
     function. The macro is used in the file sctsdl.c.
*******************************************************************/
#define HOOK_MAIN_AFTER_SIGNAL_RECEPTION

#endif



































