/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.3.23566 at Sat Nov 17 11:52:49 AM CET 2012
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1999, 2012.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/******************************************************************

  C-code macros and functions for Nucleus MNT tight integration

  To be used with SDT C Code Generator 3.6
  #clearcase sctnucleus.h@@/main/1 07-Sep-98

*******************************************************************/

#ifndef _sctNUCLEUS_h
#define _sctNUCLEUS_h

#ifdef XUSING_SCCD


#define GERXCAT(X,Y) X##Y

#define STDIO_h GERXCAT(#,include <stdio.h>)
#define WINDOWS_h GERXCAT(#,include <windows.h>)
#define STRING_h GERXCAT(#,include <string.h>)
#define TIME_h GERXCAT(#,include <time.h>)
#define WINBASE_h GERXCAT(#,include <winbase.h>)
#define HARDWARE_h GERXCAT(#,include "hardware.h")
#define NUCLEUS_h GERXCAT(#,include "nucleus.h")

STDIO_h
WINDOWS_h
STRING_h
TIME_h
WINBASE_h
HARDWARE_h
NUCLEUS_h

#elif NUCLEUS_MNT

#include <stdio.h>
#include <windows.h>
#include <string.h>
#include <time.h>
#include <winbase.h>
#include "hardware.h"
#include "nucleus.h"

#else /* Header Files for target compilation */

#include "stdio.h"
#include "string.h"
#include "nucleus.h"

#endif

#include "sctcommon.h"		/* SDT tight integration header file */

#define RTOSPRIODEFAULT      10

#ifndef MINSTACK
#define MINSTACK 200		/* MINSTACK=200 (defined in nucleus.h for MNT+) */
#endif

/*  Constant Defines */
#define SDL_STACK_SIZE (MINSTACK+4000)
#define TIMER_STACK_SIZE (MINSTACK+4000)
#define MANAGER_STACK_SIZE (MINSTACK+4000)
#define ENV_STACK_SIZE (MINSTACK+4000)
#define SDLMAIN_STACK_SIZE (MINSTACK+4000)

#define SDL_QUEUE_SIZE 250
#define TIMER_QUEUE_SIZE 250
#define MANAGER_QUEUE_SIZE 250
#define ENV_QUEUE_SIZE 250
#define SDLMAIN_QUEUE_SIZE 250

#define SDL_TIME_SLICE 10
#define TIMER_TIME_SLICE 10
#define MANAGER_TIME_SLICE 10
#define ENV_TIME_SLICE 10
#define SDLMAIN_TIME_SLICE 10

#define SDL_TASK_PRIORITY 10
#define TIMER_TASK_PRIORITY 8
#define MANAGER_TASK_PRIORITY 5
#define ENV_TASK_PRIORITY 10
#define SDLMAIN_TASK_PRIORITY 10

#define MESSAGE_SIZE 1
#define MIN_ALLOCATION 50	/* Specifies the minimum no. of bytes in
				   each allocation from the memory pool.
				   Required for Application_initialize() */

extern STATUS Err;
extern NU_QUEUE *xEnvPIdQ;
extern int createdProcesses;
extern NU_SEMAPHORE yInitSem;
extern UNSIGNED received_size;
extern NU_MEMORY_POOL System_Memory;
extern NU_QUEUE Timer_Queue;
extern NU_QUEUE Task_Manager_Queue;

#define RTOSGLOBAL_VAR \
STATUS Err; \
NU_QUEUE *xEnvPIdQ; \
NU_SEMAPHORE yInitSem; \
int createdProcesses= 0; \
extern SDL_Time SDL_Now XPP((void)); \
UNSIGNED received_size; \
NU_MEMORY_POOL System_Memory; \
NU_QUEUE Timer_Queue; \
NU_QUEUE Task_Manager_Queue;

#ifdef X_ONE_TASK_PER_INSTANCE_SET
typedef xEPrsNode SDL_PId;
#else
typedef NU_QUEUE *SDL_PId;
#endif

#define NIL NULL

extern VOID ERC_System_Error ();
VOID System_Error (int Error);

/****+***************************************************************
     SDL Signal, Timer and Now
********************************************************************/
/****+***************************************************************
01   Typedef, Default value, Literals
********************************************************************/
#include "sctpred.h"		/* SDT tight integration header file */

#define SDT_TICKPERSEC 1000/RTC
#define SDT_NANOSECPERTICK 100000000

/* NOTE! xTimerHeaderRec and xSignalHeaderRec areidentical except
   for TimerTime last in xTimerHeaderRec. This means that it is
   possible to cast pointer between these two types freely as long
   as the TimerTime component is not accessed. */

#ifdef XOPTSIGNALALLOC

extern xSignalNode xGetSignal XPP ((xSignalIdNode, SDL_PId, SDL_PId));
#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define INSIGNAL_DATA_PTR (yInstanceSetVars->yInSignalPtr)

#define SIGNALVARSCOMP1 \
      SDL_PId        Receiver;
#else
#define INSIGNAL_DATA_PTR (yVarP->yInSignalPtr)
#define SIGNALVARSCOMP1
#endif

#ifdef XMSC_TRACE
#define SIGNALVARSCOMP2 \
      int            SignalId; \
      int            IsTimer;
#else
#define SIGNALVARSCOMP2
#endif

#define SIGNAL_VARS \
      int            SignalCode; \
      xSignalHeader  Pre, Suc; \
      SDL_PId        Sender; \
      xSignalIdNode NameNode; \
      SIGNALVARSCOMP1 \
      SIGNALVARSCOMP2

#else

#define SIGNAL_VARS

#endif /* XOPTSIGNALALLOC */

#define TIMER_VARS

#define XSIGNALHEADERTYPE xSignalHeaderRec

#define STARTUP_VARS \
   xEPrsNode PrsNode;

typedef struct xSignalHeaderStruct *xSignalHeader;
typedef struct xSignalHeaderStruct
  {
    int SignalCode;
    xSignalHeader Pre, Suc;
    SDL_PId Sender;
#ifdef XOPTSIGNALALLOC
    xSignalIdNode NameNode;
#endif
#ifndef XNOTIMERPARAMS
    int IsTimerSignal;
     \
    int SigSize;
#endif
#ifdef X_ONE_TASK_PER_INSTANCE_SET
    SDL_PId Receiver;
#endif
#ifdef XMSC_TRACE
    int SignalId;
    int IsTimer;
#endif
  }
xSignalHeaderRec;


#ifdef XOPTSIGNALALLOC
typedef struct xStartUpSignalHeaderStruct *xStartUpSignalHeader;
typedef struct xStartUpSignalHeaderStruct
  {
    SIGNAL_VARS
    STARTUP_VARS
  }
xStartUpSignalHeaderRec;
#else
typedef struct xStartUpSignalHeaderStruct *xStartUpSignalHeader;
typedef struct xStartUpSignalHeaderStruct
  {
    STARTUP_VARS
  }
xStartUpSignalHeaderRec;
#endif

typedef struct xTimerHeaderStruct *xTimerHeader;
typedef struct xTimerHeaderStruct
  {
    int SignalCode;
    xTimerHeader Pre, Suc;
    SDL_PId Sender;
#ifdef XOPTSIGNALALLOC
    xSignalIdNode NameNode;
#endif
#ifndef XNOTIMERPARAMS
    int IsTimerSignal;
     \
    int SigSize;
#endif
#ifdef X_ONE_TASK_PER_INSTANCE_SET
    SDL_PId Receiver;
#endif
#ifdef XMSC_TRACE
    int SignalId;
    int IsTimer;
#endif
    SDL_Time TimerTime;
    int TimerToSetOrReset;
      xbool (*yEq) ();
    xbool TestParams;
    xTimerHeader Param;
  }
xTimerHeaderRec;


#define RTOSTASK_TYPE SDL_PId
#define RTOSSIGNAL_DEF \
xSignalHeader
#define RTOSHANDLEMESS_TYPE
#define RTOSHANDLESIG_PAR
#define RTOSTIMER_DEF \
xTimerHeader

#ifdef NUCLEUS_MNT
#define RTC 50			/* PC Real Time Clock */

/*  MACRO to implement error check with action on Nucleus function calls */
#define XOS_ERROR(STRING1, STRING2, ERRCODE) \
  if (ERRCODE != NU_SUCCESS) { \
    printf("Error during %s found in NUCLEUS+ function %s. Error code %d\r\n", \
            STRING1, STRING2, ERRCODE); \
    System_Error(ERRCODE); \
  }

/* MACRO to implement error check for function NU_Receive_From_Queue() timing 
   out without receiving any message */
#define XERROR_RECEIVED_WITH_TIMEOUT(STRING1) \
  printf("%s: Queue is still empty even after suspending for the specified timeout value.\r\n", \
            STRING1);

#else /* For target compilation using hprint */

#define RTC 10			/* Target Real Time Clock */

#define XOS_ERROR(STRING1, STRING2, ERRCODE) \
  if (ERRCODE != NU_SUCCESS) { \
    printf("Error during %s found in NUCLEUS+ function %s. Error code %d\r\n", \
            STRING1, STRING2, ERRCODE); \
  }

#define XERROR_RECEIVED_WITH_TIMEOUT(STRING1) \
  printf("%s: Queue is still empty even after suspending for the specified timeout value.\r\n", \
            STRING1);

#endif /* NUCLEUS_MNT */

/****+***************************************************************
     Macros to Implement SDL
********************************************************************/

#ifdef X_ONE_TASK_PER_INSTANCE_SET
static NU_QUEUE *NUCLEUSQ_env;

#define RTOSXPROCESSDEF_C(PROC_NAME, PROC_NAME_STRING, PREFIX_PROC_NAME,PAD_FUNCTION, VDEF_TYPE) \
extern void XCAT(NUCLEUSPAD_,PREFIX_PROC_NAME) XPP(( \
  UNSIGNED argc, VOID *InputPortQ)) \
{ \
  xPrsInstanceSetVars   yInstanceSetVars; \
  yInstanceSetVars.SaveQ = (xSaveQ)xAlloc(sizeof(xSaveQStruct)); \
  yInstanceSetVars.SaveQ->Suc = yInstanceSetVars.SaveQ; \
  yInstanceSetVars.SaveQ->Pre = yInstanceSetVars.SaveQ; \
  yInstanceSetVars.CurrentInSaveQ = yInstanceSetVars.SaveQ; \
  yInstanceSetVars.PrsDataSize = sizeof(VDEF_TYPE); \
  strcpy( yInstanceSetVars.name, PROC_NAME_STRING); \
  Err = NU_Obtain_Semaphore(&yInitSem, NU_SUSPEND); \
  XOS_ERROR("RTOSXPROCESSDEF_C","sc_pend",Err) \
  PAD_FUNCTION((void *)0, (SDL_PId)InputPortQ, &yInstanceSetVars ); \
}

#define RTOSXPROCESSDEF_H(PROC_NAME, PROC_NAME_STRING, PREFIX_PROC_NAME, PAD_FUNCTION, VDEF_TYPE) \
extern void XCAT(NUCLEUSPAD_,PREFIX_PROC_NAME) XPP(( \
  UNSIGNED argc, VOID *InputPortQ)); \
static void * XCAT(NUCLEUSQ_,PREFIX_PROC_NAME);

#else

#define RTOSXPROCESSDEF_C(PROC_NAME, PROC_NAME_STRING, PREFIX_PROC_NAME, PAD_FUNCTION, VDEF_TYPE) \
 extern void XCAT(NUCLEUSPAD_,PREFIX_PROC_NAME) XPP(( \
  UNSIGNED argc, VOID *argv)) \
{ \
  VDEF_TYPE  yVarPVar; \
  VDEF_TYPE *yVarP = &yVarPVar; \
  SDL_PId Self = argv; \
  yVarP->RestartAddress = 0; \
  yVarP->PrsNode = 0; \
  yVarP->RestartPAD = PAD_FUNCTION; \
  yVarP->ActivePrd = (xPrdNode)0; \
  yVarP->Offspring = SDL_NULL; \
  yVarP->Parent = SDL_NULL; \
  yVarP->Self = (SDL_PId)Self; \
  yVarP->Sender = (SDL_PId)Self;\
  yVarP->State = START_STATE; \
  yVarP->StateAfterRPC = 0; \
  yVarP->FirstTime = 1; \
  yVarP->SaveQ = (xSaveQ)xAlloc(sizeof(xSaveQStruct)); \
  yVarP->SaveQ->Suc = yVarP->SaveQ; \
  yVarP->SaveQ->Pre = yVarP->SaveQ; \
  yVarP->CurrentInSaveQ = yVarP->SaveQ; \
  yVarP->pREPLY_Waited_For = (XSIGTYPE)0; \
  strcpy( yVarP->ProcName, PROC_NAME_STRING); \
  Err = NU_Obtain_Semaphore(&yInitSem, NU_SUSPEND); \
  XOS_ERROR("RTOSXPROCESSDEF_C","sc_pend",Err) \
  PAD_FUNCTION((void *)yVarP); \
}

#define RTOSXPROCESSDEF_H(PROC_NAME, PROC_NAME_STRING, PREFIX_PROC_NAME, PAD_FUNCTION, VDEF_TYPE) \
extern void XCAT(NUCLEUSPAD_,PREFIX_PROC_NAME) XPP((\
  UNSIGNED argc, VOID *argv));

#endif /* X_ONE_TASK_PER_INSTANCE_SET */


/* ----------------- Extra components in IdNodes ----------------- */

  /* Process, Process type */
#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define XPRS_EXTRAS(PREFIX_PROC_NAME) \
  , XCAT(NUCLEUSPAD_,PREFIX_PROC_NAME), (NU_QUEUE *)(&(XCAT(NUCLEUSQ_,PREFIX_PROC_NAME)))
#else
#define XPRS_EXTRAS(PREFIX_PROC_NAME) , XCAT(NUCLEUSPAD_,PREFIX_PROC_NAME)
#endif
#define RTOSXPAD_STRUCT_COMP \
void (*RestartPAD) XPP(( void *VarP,SDL_PId, \
xPrsInstanceSetVars *yInstanceSetVars ));

/*---------------- Variables in the PAD function ---------------- */
#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define YPAD_TEMP_VARS \
   xSignalHeader	yOutputSignalPtr; \
   xSignalHeader	pREPLY_Signal; \
   SDL_PId		    SenderRPCCall; \
   xPrdNode			yTempPrd; \
   STATUS			Err; \
   CHAR				queue_name[8]; \
   UNSIGNED			i; \
   VOID				*start_address; \
   UNSIGNED			size; \
   UNSIGNED			available; \
   UNSIGNED			messages; \
   OPTION			message_type; \
   UNSIGNED			message_size; \
   OPTION			suspend_type; \
   UNSIGNED			tasks_suspended; \
   NU_TASK			*first_task;

#else

#define PROCESS_VARS \
   int				RestartAddress; \
   xPrdNode			ActivePrd; \
   XPAD_STRUCT_COMP \
   SDL_PId			Self; \
   SDL_PId			Offspring; \
   SDL_PId			Parent; \
   SDL_PId			Sender; \
   int				State; \
   int				StateAfterRPC; \
   xSignalHeader	SaveQ; \
   xSignalHeader	yInSignalPtr; \
   xSignalHeader	CurrentInSaveQ; \
   xEPrsNode		PrsNode; \
   XSIGTYPE			pREPLY_Waited_For; \
   char				ProcName[100]; \
   int                          FirstTime;

#define YPAD_TEMP_VARS \
   xSignalHeader	yOutputSignalPtr; \
   xSignalHeader	pREPLY_Signal; \
   SDL_PId		    SenderRPCCall; \
   STATUS			Err; \
   xPrdNode			yTempPrd;

#endif /* X_ONE_TASK_PER_INSTANCE_SET */

#define YPRD_TEMP_VARS \
   xSignalHeader	yOutputSignalPtr; \
   xSignalHeader	pREPLY_Signal; \
   SDL_PId		    SenderRPCCall; \
   xPrdNode			yTempPrd; \
   STATUS			Err;

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define SDL_SELF	yVarP->PrsNode
#define RTOSENV_PROCID
#else
#define SDL_SELF	yVarP->Self
#define RTOSENV_PROCID
#endif

#define SDL_SENDER	yVarP->Sender

/* ------------------ Structure of PAD function ------------------ */

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#ifndef XNOPROTO
#define YPAD_PROTOTYPE(PAD)     void PAD ( void *VarP, SDL_PId InputPortQ, xPrsInstanceSetVars *yInstanceSetVars );
#define YPAD_FUNCTION(PAD)      void PAD ( void *VarP, SDL_PId InputPortQ, xPrsInstanceSetVars *yInstanceSetVars )
#define YPRD_PROTOTYPE(PAD)     xbool PAD ( void *VarP, xPrsInstanceSetVars *yInstanceSetVars );
#define YPRD_FUNCTION(PAD)      xbool PAD ( void *VarP, xPrsInstanceSetVars *yInstanceSetVars )
#else
#define YPAD_PROTOTYPE(PAD)     void PAD ();
#define YPAD_FUNCTION(PAD)      void PAD( VarP, InputPortQ, yInstanceSetVars ) void *VarP; SDL_PId InputPortQ; xPrsInstanceSetVars *yInstanceSetVars;
#define YPRD_PROTOTYPE(PAD)     xbool PAD();
#define YPRD_FUNCTION(PAD)      xbool PAD (VarP, yInstanceSetVars ) void * VarP; xPrsInstanceSetVars *yInstanceSetVars;
#endif
#endif

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define RTOSBEGIN_PAD(VDEF_TYPE)  \
   if (xInputSignal((xPrsNode*)&yVarP,yInstanceSetVars,0,InputPortQ)) return;\
   goto Label_Execute_Transition;

#ifdef XNOTIMERPARAMS
#define RTOSLOOP_LABEL \
   Label_New_Transition_No_Free : \
     if (xInputSignal((xPrsNode*)&yVarP,yInstanceSetVars,2, InputPortQ)) return; \
     goto Label_Execute_Transition; \
   Label_New_Transition : \
     if (xInputSignal((xPrsNode*)&yVarP,yInstanceSetVars,1,InputPortQ)) return; \
   Label_Execute_Transition : \
     ySVarP = ((xSignalHeader)(yInstanceSetVars->yInSignalPtr)+1); \
     yVarP->Sender = yInstanceSetVars->yInSignalPtr->Sender;

#else /* XNOTIMERPARAMS */

#define RTOSLOOP_LABEL \
   Label_New_Transition_No_Free : \
     if (xInputSignal((xPrsNode*)&yVarP,yInstanceSetVars,2, InputPortQ)) return; \
     goto Label_Execute_Transition; \
   Label_New_Transition : \
     if (xInputSignal((xPrsNode*)&yVarP,yInstanceSetVars,1,InputPortQ)) return; \
   Label_Execute_Transition : \
     if(yInstanceSetVars->yInSignalPtr->IsTimerSignal) \
       ySVarP =((xTimerHeader)(yInstanceSetVars->yInSignalPtr)+1); \
     else \
       ySVarP = ((xSignalHeader)(yInstanceSetVars->yInSignalPtr)+1); \
     yVarP->Sender = yInstanceSetVars->yInSignalPtr->Sender;

#endif /* XNOTIMERPARAMS */

#else /* X_ONE_TASK_PER_INSTANCE_SET */

#define RTOSBEGIN_PAD(VDEF_TYPE) \
   if(yVarP->FirstTime) { \
      memset((((xPrsRec*)yVarP)+1), 0, sizeof(VDEF_TYPE)-sizeof(xPrsRec)); \
      yVarP->FirstTime = 0; \
   } \
   if (xInputSignal((xPrsNode*)&yVarP,0)) return; \
   goto Label_Execute_Transition;

#ifdef XNOTIMERPARAMS
#define RTOSLOOP_LABEL \
   Label_New_Transition_No_Free : \
     if (xInputSignal((xPrsNode*)&yVarP,2)) return; \
     goto Label_Execute_Transition; \
   Label_New_Transition : \
     if (xInputSignal((xPrsNode*)&yVarP,1)) return; \
   Label_Execute_Transition : \
     ySVarP = ((xSignalHeader)(yVarP->yInSignalPtr)+1); \
     yVarP->Sender = yVarP->yInSignalPtr->Sender;

#else /* XNOTIMERPARAMS */
#define RTOSLOOP_LABEL \
   Label_New_Transition_No_Free : \
     if (xInputSignal((xPrsNode*)&yVarP,2)) return; \
     goto Label_Execute_Transition; \
   Label_New_Transition : \
     if (xInputSignal((xPrsNode*)&yVarP,1)) return; \
   Label_Execute_Transition : \
     if(yVarP->yInSignalPtr->IsTimerSignal) \
       ySVarP =((xTimerHeader)(yVarP->yInSignalPtr)+1); \
     else \
       ySVarP = ((xSignalHeader)(yVarP->yInSignalPtr)+1); \
     yVarP->Sender = yVarP->yInSignalPtr->Sender;

#endif /* XNOTIMERPARAMS */

#endif /* X_ONE_TASK_PER_INSTANCE_SET */

#ifdef XOPTSIGNALALLOC
#define RTOSFREE_BUF(SIGPTR) xReleaseSignal((void*)SIGPTR)
#else
#define RTOSFREE_BUF(SIGPTR) xFree((void*)SIGPTR)
#endif
#define RTOSFREE_BUF_SIGP(SIGPTR)

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define RTOSLOOP_LABEL_PRD \
   XOS_TRACE_CALL \
   if (yPrdVarP->RestartAddress != 0) { \
     ySVarP = (yInstanceSetVars->yInSignalPtr)+1; \
     yVarP->Sender = yInstanceSetVars->yInSignalPtr->Sender; \
   }

#define RTOSRECEIVE(SIGPTR,SELF,MSGLEN, QID) \
  while( (Err = NU_Receive_From_Queue((NU_QUEUE *)InputPortQ, &yInstanceSetVars->yInSignalPtr, 1, &received_size, NU_SUSPEND)) == NU_TIMEOUT) \
     XERROR_RECEIVED_WITH_TIMEOUT("RTOSRECEIVE") \
  XOS_ERROR("RTOSRECEIVE", "NU_Receive_From_Queue", Err)

#else

#ifdef XOPTSIGNALALLOC
extern xSignalHeader xAvailSignalLists[];
#endif


#define RTOSRECEIVE(SIGPTR,SELF,MSGLEN, QID) \
  while( (Err = NU_Receive_From_Queue((*yVarP)->Self, &(*yVarP)->yInSignalPtr, 1, &received_size, NU_SUSPEND)) == NU_TIMEOUT) \
    XERROR_RECEIVED_WITH_TIMEOUT("RTOSRECEIVE") \
  XOS_ERROR("RTOSRECEIVE", "sc_qpend", Err)

#define RTOSRECEIVEPRD(SIGPTR,SELF,MSGLEN, QID) \
  while( (Err = NU_Receive_From_Queue(yVarP->Self, &yVarP->yInSignalPtr, 1, &received_size, NU_SUSPEND)) == NU_TIMEOUT) \
     XERROR_RECEIVED_WITH_TIMEOUT("RTOSRECEIVEPRD") \
  XOS_ERROR("RTOSRECEIVEPRD", "NU_Receive_From_Queue", Err) \
  yVarP->Parent = yVarP->yInSignalPtr->Sender;

#define RTOSLABEL_EXECUTE_TRANSITION \
  ySVarP = (yVarP->yInSignalPtr)+1; \
  yVarP->Sender = yVarP->yInSignalPtr->Sender;

#endif /* X_ONE_TASK_PER_INSTANCE_SET */

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define RTOSSENDER yInstanceSetVars->yInSignalPtr->Sender;
#define RTOSCALLSUPER_PAD(PAD) \
   PAD(yVarP, InputPortQ, yInstanceSetVars);
#else

#define RTOSSENDER yVarP->yInSignalPtr->Sender;

#endif /* X_ONE_TASK_PER_INSTANCE_SET */


#define INSIGNAL_NAME	INSIGNAL_PTR->SignalCode

/* ---------------------------- Output --------------------------- */
#ifdef XNOTIMERPARAMS
#define RTOSALLOC_RPC_SIGNAL_EXTRA
#else
#define RTOSALLOC_RPC_SIGNAL_EXTRA \
   pREPLY_Signal->IsTimerSignal = 0; \
   pREPLY_Signal->SigSize = 0;
#endif /*XNOTIMERPARAMS */

#ifdef XNOTIMERPARAMS
#define RTOSALLOC_SIGNAL_EXTRA
#else
#define RTOSALLOC_SIGNAL_EXTRA \
   yOutputSignalPtr->IsTimerSignal = 0; \
   yOutputSignalPtr->SigSize = 0;
#endif /* XNOTIMERPARAMS */

#ifdef XOPTSIGNALALLOC
#define RTOSALLOC_SIGNAL(SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_TYPE) \
   yOutputSignalPtr = xGetSignal(SIG_IDNODE, SDL_NULL, SDL_SELF); \
   yOutputSignalPtr->SignalCode = SIG_NAME; \
   RTOSALLOC_SIGNAL_EXTRA \
   yOutputSignalPtr->Sender = SDL_SELF;

#define RTOSALLOC_SIGNAL_PAR(SIG_NAME,SIG_IDNODE, RECEIVER, SIG_PAR_TYPE) \
   yOutputSignalPtr = xGetSignal(SIG_IDNODE, SDL_NULL, SDL_SELF); \
   yOutputSignalPtr->SignalCode = SIG_NAME; \
   RTOSALLOC_SIGNAL_EXTRA \
   yOutputSignalPtr->Sender = SDL_SELF;

#else

#define RTOSALLOC_SIGNAL(SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_TYPE) \
   yOutputSignalPtr = xAlloc(sizeof(xSignalHeaderRec)); \
   yOutputSignalPtr->SignalCode = SIG_NAME; \
   RTOSALLOC_SIGNAL_EXTRA \
   yOutputSignalPtr->Sender = SDL_SELF;

#define RTOSALLOC_SIGNAL_PAR(SIG_NAME,SIG_IDNODE, RECEIVER, SIG_PAR_TYPE) \
   yOutputSignalPtr = xAlloc(sizeof(xSignalHeaderRec)+sizeof(SIG_PAR_TYPE)); \
   yOutputSignalPtr->SignalCode = SIG_NAME; \
   RTOSALLOC_SIGNAL_EXTRA \
   yOutputSignalPtr->Sender = SDL_SELF;

#endif

#ifdef XOPTSIGNALALLOC
#define OUTSIGNAL_DATA_PTR \
   ((xSignalHeader)yOutputSignalPtr)
#else
#define OUTSIGNAL_DATA_PTR \
   ((xSignalHeader)yOutputSignalPtr+1)
#endif

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define RTOSXHANDLESIG_BODY \
   OutputSignal->Receiver = Receiver; \
   Err = NU_Send_To_Queue((NU_QUEUE *)ReceiverTask, &OutputSignal, 1, NU_SUSPEND); \
   XOS_ERROR("RTOSXHANDLESIG_BODY", "NU_Send_To_Queue", Err)

#define RTOSXHANDLETIMER_BODY \
   ((xTimerHeader)OutputSignal)->SignalCode = SetTimer; \
   ((xTimerHeader)OutputSignal)->Sender = Sender; \
   ((xTimerHeader)OutputSignal)->Receiver = Sender; \
   ((xTimerHeader)OutputSignal)->TimerTime = Dur_Expr; \
   ((xTimerHeader)OutputSignal)->TestParams = 0; \
   Err = NU_Send_To_Queue(&Timer_Queue, &OutputSignal, 1, NU_SUSPEND); \
   XOS_ERROR("RTOSXHANDLETIMER_BODY", "NU_Send_To_Queue", Err) \

#else

#define RTOSSEND(SIGPTR,RECEIVER,SIG_PAR_SIZE) \
  Err = NU_Send_To_Queue(RECEIVER, SIGPTR, 1, NU_SUSPEND); \
  XOS_ERROR("RTOSSEND", "NU_Send_To_Queue", Err)

#define RTOSXHANDLETIMER_BODY \
   ((xTimerHeader)OutputSignal)->SignalCode = SetTimer; \
   ((xTimerHeader)OutputSignal)->Sender = Sender; \
   ((xTimerHeader)OutputSignal)->TimerTime = Dur_Expr; \
   ((xTimerHeader)OutputSignal)->TestParams = 0; \
   Err = NU_Send_To_Queue(&Timer_Queue, &OutputSignal, 1, NU_SUSPEND); \
   XOS_ERROR("RTOSXHANDLETIMER_BODY", "NU_Send_To_Queue", Err)

#endif

/* ----------------------------- RPC ----------------------------- */

#ifdef XOPTSIGNALALLOC

#define RTOSALLOC_REPLY_SIGNAL(SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_TYPE) \
   pREPLY_Signal = xGetSignal(SIG_IDNODE,SDL_NULL,SDL_NULL); \
   pREPLY_Signal->SignalCode = SIG_NAME; \
   RTOSALLOC_RPC_SIGNAL_EXTRA \
   pREPLY_Signal->Sender = SDL_SELF; \
   SenderRPCCall = yVarP->Sender;

#define RTOSALLOC_REPLY_SIGNAL_PAR(SIG_NAME, SIG_IDNODE, RECEIVER, \
                                   SIG_PAR_TYPE) \
   pREPLY_Signal = xGetSignal(SIG_IDNODE,SDL_NULL,SDL_NULL); \
   pREPLY_Signal->SignalCode = SIG_NAME; \
   RTOSALLOC_RPC_SIGNAL_EXTRA \
   pREPLY_Signal->Sender = SDL_SELF; \
   SenderRPCCall = yVarP->Sender;

#define RTOSALLOC_REPLY_SIGNAL_PRD(SIG_NAME, SIG_IDNODE, RECEIVER, \
                                   SIG_PAR_TYPE) \
   pREPLY_Signal = xGetSignal(SIG_IDNODE,SDL_NULL,SDL_NULL); \
   pREPLY_Signal->SignalCode = SIG_NAME; \
   RTOSALLOC_RPC_SIGNAL_EXTRA \
   pREPLY_Signal->Sender = SDL_SELF; \
   SenderRPCCall = yVarP->Sender;

#define RTOSALLOC_REPLY_SIGNAL_PRD_PAR(SIG_NAME, SIG_IDNODE, RECEIVER, \
                                   SIG_PAR_TYPE) \
   pREPLY_Signal = xGetSignal(SIG_IDNODE,SDL_NULL,SDL_NULL); \
   pREPLY_Signal->SignalCode = SIG_NAME; \
   RTOSALLOC_RPC_SIGNAL_EXTRA \
   pREPLY_Signal->Sender = SDL_SELF; \
   SenderRPCCall = yVarP->Sender;

#define REPLYSIGNAL_DATA_PTR \
   ((xSignalHeader)pREPLY_Signal)
#define REPLYSIGNAL_DATA_PTR_PRD \
   ((xSignalHeader)pREPLY_Signal)

#else

#define RTOSALLOC_REPLY_SIGNAL(SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_TYPE) \
   pREPLY_Signal = xAlloc(sizeof(xSignalHeaderRec)+sizeof(SIG_PAR_TYPE)); \
   pREPLY_Signal->SignalCode = SIG_NAME; \
   RTOSALLOC_RPC_SIGNAL_EXTRA \
   pREPLY_Signal->Sender = SDL_SELF; \
   SenderRPCCall = yVarP->Sender;

#define RTOSALLOC_REPLY_SIGNAL_PAR(SIG_NAME, SIG_IDNODE, RECEIVER, \
                                   SIG_PAR_TYPE) \
   pREPLY_Signal = xAlloc(sizeof(xSignalHeaderRec)+sizeof(SIG_PAR_TYPE)); \
   pREPLY_Signal->SignalCode = SIG_NAME; \
   RTOSALLOC_RPC_SIGNAL_EXTRA \
   pREPLY_Signal->Sender = SDL_SELF; \
   SenderRPCCall = yVarP->Sender;

#define RTOSALLOC_REPLY_SIGNAL_PRD(SIG_NAME, SIG_IDNODE, RECEIVER, \
                                   SIG_PAR_TYPE) \
   pREPLY_Signal = xAlloc(sizeof(xSignalHeaderRec)(sizeof(SIG_PAR_TYPE)); \
   pREPLY_Signal->SignalCode = SIG_NAME; \
   RTOSALLOC_RPC_SIGNAL_EXTRA \
   pREPLY_Signal->Sender = yVarP->Self; \
   SenderRPCCall = yVarP->Sender;

#define RTOSALLOC_REPLY_SIGNAL_PRD_PAR(SIG_NAME, SIG_IDNODE, RECEIVER, \
                                   SIG_PAR_TYPE) \
   pREPLY_Signal = xAlloc(sizeof(xSignalHeaderRec)+sizeof(SIG_PAR_TYPE)); \
   pREPLY_Signal->SignalCode = SIG_NAME; \
   RTOSALLOC_RPC_SIGNAL_EXTRA \
   pREPLY_Signal->Sender = SDL_SELF; \
   SenderRPCCall = yVarP->Sender;


#define REPLYSIGNAL_DATA_PTR \
   ((xSignalHeader)pREPLY_Signal+1)
#define REPLYSIGNAL_DATA_PTR_PRD \
   ((xSignalHeader)pREPLY_Signal+1)

#endif

/* ---------------------------- Create --------------------------- */

#ifdef XOPTSIGNALALLOC

#define RTOSALLOC_STARTUP(PROC_NAME, STARTUP_IDNODE, STARTUP_PAR_TYPE) \
   yOutputSignalPtr = xGetSignal(STARTUP_IDNODE,SDL_NULL,SDL_NULL); \
   yOutputSignalPtr->SignalCode = STARTUPSIGNAL; \
   RTOSALLOC_SIGNAL_EXTRA \
   yOutputSignalPtr->Sender = SDL_SELF;

#define RTOSALLOC_STARTUP_PAR(PROC_NAME, STARTUP_IDNODE, STARTUP_PAR_TYPE) \
   yOutputSignalPtr = xGetSignal(STARTUP_IDNODE,SDL_NULL,SDL_NULL); \
   yOutputSignalPtr->SignalCode = STARTUPSIGNAL; \
   RTOSALLOC_SIGNAL_EXTRA \
   yOutputSignalPtr->Sender = SDL_SELF;

#else

#define RTOSALLOC_STARTUP(PROC_NAME, STARTUP_IDNODE, STARTUP_PAR_TYPE) \
   yOutputSignalPtr = xAlloc(sizeof(xSignalHeaderRec)+ \
                             sizeof(STARTUP_PAR_TYPE)); \
   yOutputSignalPtr->SignalCode = STARTUPSIGNAL; \
   RTOSALLOC_SIGNAL_EXTRA \
   yOutputSignalPtr->Sender = SDL_SELF;

#define RTOSALLOC_STARTUP_PAR(PROC_NAME, STARTUP_IDNODE, STARTUP_PAR_TYPE) \
   yOutputSignalPtr = xAlloc(sizeof(XSIGNALHEADERTYPE)+ \
                             sizeof(STARTUP_PAR_TYPE)); \
   yOutputSignalPtr->SignalCode = STARTUPSIGNAL; \
   RTOSALLOC_SIGNAL_EXTRA \
   yOutputSignalPtr->Sender = SDL_SELF;

#endif

#ifdef XOPTSIGNALALLOC
#define STARTUP_DATA_PTR \
   (yOutputSignalPtr)
#else
#define STARTUP_DATA_PTR \
   (yOutputSignalPtr+1)
#endif

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define RTOSSDL_CREATE(PROC_NAME, PROC_IDNODE, PROC_NAME_STRING) \
   yOutputSignalPtr->Receiver = xAllocPrsUseMyMemory(PROC_IDNODE); \
   yOutputSignalPtr->Receiver->BlockInstNumber = \
     yVarP->PrsNode->BlockInstNumber; \
   yVarP->Offspring = yOutputSignalPtr->Receiver; \
   XOS_TRACE_CREATE( yVarP->Offspring->NameNode->PROCID, PROC_NAME_STRING) \
   XMSC_TRACE_CREATE( yVarP->Offspring->NameNode->PROCID, PROC_NAME_STRING) \
   Err = NU_Send_To_Queue((NU_QUEUE *)yVarP->Offspring->NameNode->PROCID, &yOutputSignalPtr, MESSAGE_SIZE, NU_SUSPEND); \
   XOS_ERROR("RTOSSDL_CREATE", "NU_Send_To_Queue", Err) \
   NU_Release_Semaphore(&yInitSem); \
   XOS_ERROR("RTOSSDL_CREATE","NU_Release_Semaphore",Err)

#else

#define RTOSSDL_CREATE(PROC_NAME, PROC_IDNODE, PROC_NAME_STRING) \
{ \
   NU_TASK		*Task_Ptr; \
   NU_QUEUE		*Queue_Ptr; \
   VOID			*Stack_Ptr; \
   VOID			*Queue_Start_Ptr; \
   createdProcesses++; \
   Err = NU_Allocate_Memory(&System_Memory, (VOID **)&Task_Ptr, sizeof(NU_TASK), NU_NO_SUSPEND); \
   XOS_ERROR("RTOSSDL_CREATE", "NU_Allocate_Memory1", Err) \
   memset(Task_Ptr, 0 , sizeof(NU_TASK) ); \
   Err = NU_Allocate_Memory(&System_Memory, &Stack_Ptr, SDL_STACK_SIZE, NU_NO_SUSPEND); \
   XOS_ERROR("RTOSSDL_CREATE", "NU_Allocate_Memory2", Err) \
   memset(Stack_Ptr, 0 , SDL_STACK_SIZE ); \
   Err = NU_Allocate_Memory(&System_Memory, (VOID **)&Queue_Ptr, sizeof(NU_QUEUE), NU_NO_SUSPEND); \
   XOS_ERROR("RTOSSDL_CREATE", "NU_Allocate_Memory3", Err) \
   memset(Queue_Ptr, 0 , sizeof(NU_QUEUE) ); \
   Err = NU_Allocate_Memory(&System_Memory, &Queue_Start_Ptr, SDL_QUEUE_SIZE*sizeof(UNSIGNED), NU_NO_SUSPEND); \
   XOS_ERROR("RTOSSDL_CREATE", "NU_Allocate_Memory4", Err) \
   memset(Queue_Start_Ptr, 0 , (SDL_QUEUE_SIZE*sizeof(UNSIGNED)) ); \
   Err = NU_Create_Queue(Queue_Ptr, PROC_NAME_STRING, Queue_Start_Ptr, SDL_QUEUE_SIZE, NU_FIXED_SIZE, MESSAGE_SIZE, NU_FIFO); \
   XOS_ERROR("RTOSSDL_CREATE", "NU_Create_Queue", Err) \
   yVarP->Offspring = Queue_Ptr; \
   NU_Create_Task(Task_Ptr, PROC_NAME_STRING, (PROC_IDNODE)->RTOSPAD, 0, Queue_Ptr, Stack_Ptr, SDL_STACK_SIZE, SDL_TASK_PRIORITY, SDL_TIME_SLICE, NU_PREEMPT, NU_START); \
   XOS_ERROR("RTOSSDL_CREATE", "NU_Create_Task", Err) \
   ((xStartUpSignalHeader)STARTUP_DATA_PTR)->PrsNode = \
     xAllocPrsUseMyMemory(PROC_IDNODE, yVarP->Offspring); \
   ((xStartUpSignalHeader)STARTUP_DATA_PTR)->PrsNode->BlockInstNumber = \
     yVarP->PrsNode->BlockInstNumber; \
   XOS_TRACE_CREATE(yVarP->Offspring, PROC_NAME_STRING) \
   XMSC_TRACE_CREATE( yVarP->Offspring,PROC_NAME_STRING) \
   Err = NU_Send_To_Queue(Queue_Ptr, &yOutputSignalPtr, MESSAGE_SIZE, NU_SUSPEND); \
   XOS_ERROR("RTOSSDL_CREATE", "NU_Send_To_Queue", Err) \
   NU_Release_Semaphore(&yInitSem); \
   XOS_ERROR("RTOSSDL_CREATE","NU_Release_Semaphore",Err) \
}

#endif

/* ------------------------- Static Create ------------------------ */

#define YINIT_TEMP_VARS \
  xSignalHeader	yOutputSignalPtr; \
  int			CurrentPId; \
  STATUS		Err;

#ifndef X_ONE_TASK_PER_INSTANCE_SET
#ifdef XOS_TRACE
#define BEGIN_YINIT \
  xInitTimer(); \
  LastUsedPId =SDL_NULL; \
  printf("\r\n\r\nSystem startup\r\n\r\n");
#else
#ifdef XMSC_TRACE
#define BEGIN_YINIT \
  xInitTimer();
#endif	/* XMSC_TRACE */
#endif	/* XOS_TRACE */

#if (!defined XOS_TRACE) && (!defined XMSC_TRACE)
#define BEGIN_YINIT \
  xInitTimer();
#endif
#endif /* X_ONE_TASK_PER_INSTANCE_SET */

#ifdef X_ONE_TASK_PER_INSTANCE_SET

#ifdef XENV
#define RTOSXCREATE_ENV_PROCESS \
   TempPId = sc_qecreate(ENVQUEUE, MAX_INPUTPORT_LENGTH, 1, &Err); \
   XOS_ERROR("RTOSXCREATE_ENV_PROCESS", "sc_qecreate", Err) \
   sc_tecreate(NUCLEUSPAD_env, -1, xDefaultPrioTask, PROC_NAME_MODE, \
       PROC_NAME_USTACK, PROC_NAME_SSTACK,(unsigned long)0, 0, &Err); \
   XOS_ERROR("RTOSXCREATE_ENV_PROCESS", "sc_tecreate", Err) \
   xEnvId->PROCID = TempPId; \
   xEnvPIdQ = TempPId; \
   xEnvPrs = xAllocPrsUseMyMemory(xEnvId);

#else

#define RTOSXCREATE_ENV_PROCESS \
{ \
  /* Create a queue to handle signal to environment */ \
   NU_QUEUE		*Queue_Ptr; \
   VOID			*Queue_Start_Ptr; \
   Err = NU_Allocate_Memory(&System_Memory, (VOID **)&Queue_Ptr, sizeof(NU_QUEUE), NU_NO_SUSPEND); \
   XOS_ERROR("RTOSSYSINITPR_SEMGIVE", "NU_Allocate_Memory3", Err) \
   memset(Queue_Ptr, 0, sizeof(NU_QUEUE) ); \
   Err = NU_Allocate_Memory(&System_Memory, &Queue_Start_Ptr, ENV_QUEUE_SIZE*sizeof(UNSIGNED), NU_NO_SUSPEND); \
   XOS_ERROR("RTOSSYSINITPR_SEMGIVE", "NU_Allocate_Memory4", Err) \
   memset(Queue_Start_Ptr, 0, (ENV_QUEUE_SIZE*sizeof(UNSIGNED)) ); \
   Err = NU_Create_Queue(Queue_Ptr, "MyExtTk", Queue_Start_Ptr, ENV_QUEUE_SIZE, NU_FIXED_SIZE, MESSAGE_SIZE, NU_FIFO);\
   XOS_ERROR("RTOSSYSINITPR_SEMGIVE", "NU_Create_Queue", Err) \
  xEnvId->PROCID = Queue_Ptr; \
  xEnvPIdQ = Queue_Ptr; \
  xEnvPrs = xAllocPrsUseMyMemory(xEnvId); \
}

#endif /* XENV */

#else /* X_ONE_TASK_PER_INSTANCE_SET */

#ifdef XENV
#define RTOSXCREATE_ENV_PROCESS \
{ \
   NU_TASK		*Task_Ptr; \
   NU_QUEUE		*Queue_Ptr; \
   VOID			*Stack_Ptr; \
   VOID			*Queue_Start_Ptr; \
   Err = NU_Allocate_Memory(&System_Memory, (VOID **)&Task_Ptr, sizeof(NU_TASK), NU_NO_SUSPEND); \
   XOS_ERROR("RTOSXCREATE_ENV_PROCESS", "NU_Allocate_Memory1", Err) \
   memset(Task_Ptr, 0, sizeof(NU_TASK) ); \
   Err = NU_Allocate_Memory(&System_Memory, &Stack_Ptr, SDL_STACK_SIZE, NU_NO_SUSPEND); \
   XOS_ERROR("RTOSXCREATE_ENV_PROCESS", "NU_Allocate_Memory2", Err) \
   memset(Stack_Ptr, 0, SDL_STACK_SIZE ); \
   Err = NU_Allocate_Memory(&System_Memory, (VOID **)&Queue_Ptr, sizeof(NU_QUEUE), NU_NO_SUSPEND); \
   XOS_ERROR("RTOSXCREATE_ENV_PROCESS", "NU_Allocate_Memory3", Err) \
   memset(Queue_Ptr, 0, sizeof(NU_QUEUE) ); \
   Err = NU_Allocate_Memory(&System_Memory, &Queue_Start_Ptr, ENV_QUEUE_SIZE*sizeof(UNSIGNED), NU_NO_SUSPEND); \
   XOS_ERROR("RTOSXCREATE_ENV_PROCESS", "NU_Allocate_Memory4", Err) \
   memset(Queue_Start_Ptr, 0, (ENV_QUEUE_SIZE*sizeof(UNSIGNED)) ); \
   Err = NU_Create_Queue(Queue_Ptr, "queue", Queue_Start_Ptr, ENV_QUEUE_SIZE, NU_FIXED_SIZE, MESSAGE_SIZE, NU_FIFO); \
   XOS_ERROR("RTOSXCREATE_ENV_PROCESS", "NU_Create_Queue", Err) \
   NU_Create_Task(Task_Ptr, "stack", NUCLEUSPAD_env, 0, Queue_Ptr, Stack_Ptr, ENV_STACK_SIZE, ENV_TASK_PRIORITY, ENV_TIME_SLICE, NU_PREEMPT, NU_START); \
   XOS_ERROR("RTOSXCREATE_ENV_PROCESS", "NU_Create_Task", Err) \
   xEnvPId = Queue_Ptr; \
   xEnvPrs = xAllocPrsUseMyMemory(xEnvId, xEnvPId); \
}

#else

#define RTOSXCREATE_ENV_PROCESS \
{ \
   NU_QUEUE		*Queue_Ptr; \
   VOID			*Queue_Start_Ptr; \
   Err = NU_Allocate_Memory(&System_Memory, (VOID **)&Queue_Ptr, sizeof(NU_QUEUE), NU_NO_SUSPEND); \
   XOS_ERROR("RTOSSYSINITPR_SEMGIVE", "NU_Allocate_Memory3", Err) \
   memset(Queue_Ptr, 0, sizeof(NU_QUEUE) ); \
   Err = NU_Allocate_Memory(&System_Memory, &Queue_Start_Ptr, ENV_QUEUE_SIZE*sizeof(UNSIGNED), NU_NO_SUSPEND); \
   XOS_ERROR("RTOSSYSINITPR_SEMGIVE", "NU_Allocate_Memory4", Err) \
   memset(Queue_Start_Ptr, 0, (ENV_QUEUE_SIZE*sizeof(UNSIGNED)) ); \
   Err = NU_Create_Queue(Queue_Ptr, "MyExtTk", Queue_Start_Ptr, ENV_QUEUE_SIZE, NU_FIXED_SIZE, MESSAGE_SIZE, NU_FIFO);\
   XOS_ERROR("RTOSSYSINITPR_SEMGIVE", "NU_Create_Queue", Err) \
   xEnvPId = Queue_Ptr; \
   xEnvPrs = xAllocPrsUseMyMemory(xEnvId, xEnvPId); \
}

#endif /* XENV */
#endif /* X_ONE_TASK_PER_INSTANCE_SET */

#define RTOSINIT_PROCESS_TYPE(PROC_NAME,PREFIX_PROC_NAME, PROC_IDNODE, \
PROC_NAME_STRING, MAX_NO_OF_INST, STATIC_INST, PRIV_DATA_TYPE, PRIO, \
PAD_FUNCTION) \
{ \
   NU_TASK		*Task_Ptr; \
   NU_QUEUE		*Queue_Ptr; \
   VOID			*Stack_Ptr; \
   VOID			*Queue_Start_Ptr; \
   createdProcesses++; \
   Err = NU_Allocate_Memory(&System_Memory, (VOID **)&Task_Ptr, sizeof(NU_TASK), NU_NO_SUSPEND); \
   XOS_ERROR("RTOSSDL_STATIC_CREATE", "NU_Allocate_Memory1", Err) \
   memset(Task_Ptr, 0, sizeof(NU_TASK) ); \
   Err = NU_Allocate_Memory(&System_Memory, &Stack_Ptr, SDL_STACK_SIZE, NU_NO_SUSPEND); \
   XOS_ERROR("RTOSSDL_STATIC_CREATE", "NU_Allocate_Memory2", Err) \
   memset(Stack_Ptr, 0, SDL_STACK_SIZE ); \
   Err = NU_Allocate_Memory(&System_Memory, (VOID **)&Queue_Ptr, sizeof(NU_QUEUE), NU_NO_SUSPEND); \
   XOS_ERROR("RTOSSDL_STATIC_CREATE", "NU_Allocate_Memory3", Err) \
   memset(Queue_Ptr, 0, sizeof(NU_QUEUE) ); \
   Err = NU_Allocate_Memory(&System_Memory, &Queue_Start_Ptr, SDL_QUEUE_SIZE*sizeof(UNSIGNED), NU_NO_SUSPEND); \
   XOS_ERROR("RTOSSDL_STATIC_CREATE", "NU_Allocate_Memory4", Err) \
   memset(Queue_Start_Ptr, 0, (SDL_QUEUE_SIZE*sizeof(UNSIGNED)) ); \
   Err = NU_Create_Queue(Queue_Ptr, "queue", Queue_Start_Ptr, SDL_QUEUE_SIZE, NU_FIXED_SIZE, MESSAGE_SIZE, NU_FIFO); \
   XOS_ERROR("RTOSSDL_STATIC_CREATE", "NU_Create_Queue", Err) \
   PROC_IDNODE->PROCID = Queue_Ptr; \
   NU_Create_Task(Task_Ptr, "stack", XCAT(NUCLEUSPAD_,PREFIX_PROC_NAME), 0, Queue_Ptr, Stack_Ptr, SDL_STACK_SIZE, SDL_TASK_PRIORITY, SDL_TIME_SLICE, NU_PREEMPT, NU_START); \
   XOS_ERROR("RTOSSDL_STATIC_CREATE", "NU_Create_Task", Err) \
}

#ifdef X_ONE_TASK_PER_INSTANCE_SET

#ifdef XOPTSIGNALALLOC

#define RTOSSDL_STATIC_CREATE(PROC_NAME, PREFIX_PROC_NAME, PROC_IDNODE, \
PROC_NAME_STRING, STARTUP_IDNODE, STARTUP_PAR_TYPE, PRIV_DATA_TYPE, \
PRIO, PAD_FUNCTION, BLOCK_INST_NUMBER) \
   yOutputSignalPtr = xGetSignal(STARTUP_IDNODE,SDL_NULL,SDL_NULL); \
   yOutputSignalPtr->SignalCode = STARTUPSIGNAL; \
   yOutputSignalPtr->Sender = SDL_NULL; \
   yOutputSignalPtr->Receiver = xAllocPrsUseMyMemory(PROC_IDNODE); \
   yOutputSignalPtr->Receiver->BlockInstNumber = BLOCK_INST_NUMBER; \
   XOS_TRACE_STATIC_CREATE(yOutputSignalPtr->Receiver, PROC_NAME_STRING) \
   XMSC_TRACE_STATIC_CREATE(PROC_IDNODE->PROCID, PROC_NAME_STRING) \
   Err = NU_Send_To_Queue((NU_QUEUE *)PROC_IDNODE->PROCID, &yOutputSignalPtr, MESSAGE_SIZE, NU_SUSPEND); \
   XOS_ERROR("RTOSSDL_STATIC_CREATE", "NU_Send_To_Queue", Err) \

#else

#define RTOSSDL_STATIC_CREATE(PROC_NAME, PREFIX_PROC_NAME, PROC_IDNODE, \
PROC_NAME_STRING, STARTUP_IDNODE, STARTUP_PAR_TYPE, PRIV_DATA_TYPE, \
PRIO, PAD_FUNCTION, BLOCK_INST_NUMBER) \
   yOutputSignalPtr = (xSignalHeader)xAlloc( sizeof(XSIGNALHEADERTYPE)+ \
   sizeof(STARTUP_PAR_TYPE)); \
   yOutputSignalPtr->SignalCode = STARTUPSIGNAL; \
   RTOSALLOC_SIGNAL_EXTRA \
   yOutputSignalPtr->Sender = SDL_NULL; \
   yOutputSignalPtr->Receiver = xAllocPrsUseMyMemory(PROC_IDNODE); \
   yOutputSignalPtr->Receiver->BlockInstNumber = BLOCK_INST_NUMBER; \
   XOS_TRACE_STATIC_CREATE(yOutputSignalPtr->Receiver, PROC_NAME_STRING) \
   XMSC_TRACE_STATIC_CREATE(PROC_IDNODE->PROCID, PROC_NAME_STRING) \
   Err = NU_Send_To_Queue((NU_QUEUE *)PROC_IDNODE->PROCID, &yOutputSignalPtr, MESSAGE_SIZE, NU_SUSPEND); \
   XOS_ERROR("RTOSSDL_STATIC_CREATE", "NU_Send_To_Queue", Err) \

#endif /*  XOPTSIGNALALLOC  */

#else /* X_ONE_TASK_PER_INSTANCE_SET */

#ifdef XOPTSIGNALALLOC

#define RTOSSDL_STATIC_CREATE(PROC_NAME, PREFIX_PROC_NAME, PROC_IDNODE,  \
  PROC_NAME_STRING, STARTUP_IDNODE, STARTUP_PAR_TYPE, PRIV_DATA_TYPE, PRIO, \
  PAD_FUNCTION, BLOCK_INST_NUMBER) \
{ \
   NU_TASK		*Task_Ptr; \
   NU_QUEUE		*Queue_Ptr; \
   VOID			*Stack_Ptr; \
   VOID			*Queue_Start_Ptr; \
   createdProcesses++; \
   Err = NU_Allocate_Memory(&System_Memory, (VOID **)&Task_Ptr, sizeof(NU_TASK), NU_NO_SUSPEND); \
   XOS_ERROR("RTOSSDL_STATIC_CREATE", "NU_Allocate_Memory1", Err) \
   memset(Task_Ptr, 0, sizeof(NU_TASK) ); \
   Err = NU_Allocate_Memory(&System_Memory, &Stack_Ptr, SDL_STACK_SIZE, NU_NO_SUSPEND); \
   XOS_ERROR("RTOSSDL_STATIC_CREATE", "NU_Allocate_Memory2", Err) \
   memset(Stack_Ptr, 0, SDL_STACK_SIZE ); \
   Err = NU_Allocate_Memory(&System_Memory, (VOID **)&Queue_Ptr, sizeof(NU_QUEUE), NU_NO_SUSPEND); \
   XOS_ERROR("RTOSSDL_STATIC_CREATE", "NU_Allocate_Memory3", Err) \
   memset(Queue_Ptr, 0, sizeof(NU_QUEUE) ); \
   Err = NU_Allocate_Memory(&System_Memory, &Queue_Start_Ptr, SDL_QUEUE_SIZE*sizeof(UNSIGNED), NU_NO_SUSPEND); \
   XOS_ERROR("RTOSSDL_STATIC_CREATE", "NU_Allocate_Memory4", Err) \
   memset(Queue_Start_Ptr, 0, (SDL_QUEUE_SIZE*sizeof(UNSIGNED)) ); \
   yOutputSignalPtr = xGetSignal(STARTUP_IDNODE,SDL_NULL,SDL_NULL); \
   yOutputSignalPtr->SignalCode = STARTUPSIGNAL; \
   yOutputSignalPtr->Sender = SDL_NULL; \
   Err = NU_Create_Queue(Queue_Ptr, PROC_NAME_STRING, Queue_Start_Ptr, SDL_QUEUE_SIZE, NU_FIXED_SIZE, MESSAGE_SIZE, NU_FIFO); \
   XOS_ERROR("RTOSSDL_STATIC_CREATE", "NU_Create_Queue", Err) \
   NU_Create_Task(Task_Ptr, PROC_NAME_STRING, XCAT(NUCLEUSPAD_,PREFIX_PROC_NAME), 0, Queue_Ptr, Stack_Ptr, SDL_STACK_SIZE, SDL_TASK_PRIORITY, SDL_TIME_SLICE, NU_PREEMPT, NU_START); \
   XOS_ERROR("RTOSSDL_STATIC_CREATE", "NU_Create_Task", Err) \
   ((STARTUP_PAR_TYPE *)STARTUP_DATA_PTR)->PrsNode = \
     xAllocPrsUseMyMemory(PROC_IDNODE, Queue_Ptr); \
   ((STARTUP_PAR_TYPE *)STARTUP_DATA_PTR)->PrsNode->BlockInstNumber = \
     BLOCK_INST_NUMBER; \
   XOS_TRACE_STATIC_CREATE(Queue_Ptr, PROC_NAME_STRING) \
   XMSC_TRACE_STATIC_CREATE(Queue_Ptr, PROC_NAME_STRING) \
   Err = NU_Send_To_Queue(Queue_Ptr, &yOutputSignalPtr, MESSAGE_SIZE, NU_SUSPEND); \
   XOS_ERROR("RTOSSDL_STATIC_CREATE", "NU_Send_To_Queue", Err) \
}

#else

#define RTOSSDL_STATIC_CREATE(PROC_NAME, PREFIX_PROC_NAME, PROC_IDNODE,  \
  PROC_NAME_STRING, STARTUP_IDNODE, STARTUP_PAR_TYPE, PRIV_DATA_TYPE, PRIO, \
  PAD_FUNCTION, BLOCK_INST_NUMBER) \
{ \
   NU_TASK		*Task_Ptr; \
   NU_QUEUE		*Queue_Ptr; \
   VOID			*Stack_Ptr; \
   VOID			*Queue_Start_Ptr; \
   createdProcesses++; \
   Err = NU_Allocate_Memory(&System_Memory, (VOID **)&Task_Ptr, sizeof(NU_TASK), NU_NO_SUSPEND); \
   XOS_ERROR("RTOSSDL_STATIC_CREATE", "NU_Allocate_Memory1", Err) \
   memset(Task_Ptr, 0, sizeof(NU_TASK) ); \
   Err = NU_Allocate_Memory(&System_Memory, &Stack_Ptr, SDL_STACK_SIZE, NU_NO_SUSPEND); \
   XOS_ERROR("RTOSSDL_STATIC_CREATE", "NU_Allocate_Memory2", Err) \
   memset(Stack_Ptr, 0, SDL_STACK_SIZE ); \
   Err = NU_Allocate_Memory(&System_Memory, (VOID **)&Queue_Ptr, sizeof(NU_QUEUE), NU_NO_SUSPEND); \
   XOS_ERROR("RTOSSDL_STATIC_CREATE", "NU_Allocate_Memory3", Err) \
   memset(Queue_Ptr, 0, sizeof(NU_QUEUE) ); \
   Err = NU_Allocate_Memory(&System_Memory, &Queue_Start_Ptr, SDL_QUEUE_SIZE*sizeof(UNSIGNED), NU_NO_SUSPEND); \
   XOS_ERROR("RTOSSDL_STATIC_CREATE", "NU_Allocate_Memory4", Err) \
   memset(Queue_Start_Ptr, 0, (SDL_QUEUE_SIZE*sizeof(UNSIGNED)) ); \
   yOutputSignalPtr = (xSignalHeader)xAlloc( \
     sizeof(STARTUP_PAR_TYPE) + sizeof(XSIGNALHEADERTYPE)); \
   yOutputSignalPtr->SignalCode = STARTUPSIGNAL; \
   RTOSALLOC_SIGNAL_EXTRA \
   yOutputSignalPtr->Sender = SDL_NULL; \
   Err = NU_Create_Queue(Queue_Ptr, PROC_NAME_STRING, Queue_Start_Ptr, SDL_QUEUE_SIZE, NU_FIXED_SIZE, MESSAGE_SIZE, NU_FIFO); \
   XOS_ERROR("RTOSSDL_STATIC_CREATE", "NU_Create_Queue", Err) \
   NU_Create_Task(Task_Ptr, PROC_NAME_STRING, XCAT(NUCLEUSPAD_,PREFIX_PROC_NAME), 0, Queue_Ptr, Stack_Ptr, SDL_STACK_SIZE, SDL_TASK_PRIORITY, SDL_TIME_SLICE, NU_PREEMPT, NU_START); \
   XOS_ERROR("RTOSSDL_STATIC_CREATE", "NU_Create_Task", Err) \
   ((STARTUP_PAR_TYPE *)STARTUP_DATA_PTR)->PrsNode = \
     xAllocPrsUseMyMemory(PROC_IDNODE, Queue_Ptr); \
   ((STARTUP_PAR_TYPE *)STARTUP_DATA_PTR)->PrsNode->BlockInstNumber = \
     BLOCK_INST_NUMBER; \
   XOS_TRACE_STATIC_CREATE(Queue_Ptr, PROC_NAME_STRING) \
   XMSC_TRACE_STATIC_CREATE(Queue_Ptr, PROC_NAME_STRING) \
   Err = NU_Send_To_Queue(Queue_Ptr, &yOutputSignalPtr, MESSAGE_SIZE, NU_SUSPEND); \
   XOS_ERROR("RTOSSDL_STATIC_CREATE", "NU_Send_To_Queue", Err) \
}
#endif /* XOPTSIGNALALLOC */
#endif /* X_ONE_TASK_PER_INSTANCE_SET */

/* ----------------------------- Stop ---------------------------- */

#ifdef X_ONE_TASK_PER_INSTANCE_SET

#define RTOSEMPTYQUEUE(SIGPTR) \
  Err = NU_Queue_Information(SDL_SELF->NameNode->PROCID, queue_name, &start_address, &size, &available, &messages, &message_type, &message_size, &suspend_type, &tasks_suspended, &first_task); \
  XOS_ERROR("RTOSEMPTYQUEUE", "NU_Queue_Information", Err) \
  for (i=0; i < messages; i++) { \
     while( (Err = NU_Receive_From_Queue(SDL_SELF->NameNode->PROCID, &yInstanceSetVars->yInSignalPtr, 1, &received_size, NU_NO_SUSPEND)) == NU_TIMEOUT) \
	    XERROR_RECEIVED_WITH_TIMEOUT("RTOSEMPTYQUEUE") \
     XOS_ERROR("RTOSEMPTYQUEUE", "NU_Receive_From_Queue", Err) \
     if ( xEq_SDL_PId( yInstanceSetVars->yInSignalPtr->Receiver, SDL_SELF) ){ \
       xFree((void*)(&(yInstanceSetVars->yInSignalPtr))); \
     } \
     else \
       xSaveSignal( yInstanceSetVars->SaveQ, yInstanceSetVars->yInSignalPtr); \
   }

#ifdef XOPTSIGNALALLOC

#define RTOSSDL_STOPREMOVETIMERS \
   xKillSaveQ(yInstanceSetVars->SaveQ, SDL_SELF); \
   yOutputSignalPtr = xGetSignal(&(TimerIdDummy),SDL_NULL,SDL_NULL); \
   yOutputSignalPtr->SignalCode = RemoveTimers; \
   yOutputSignalPtr->Sender = SDL_SELF; \
   Err = NU_Send_To_Queue(&Timer_Queue, &yOutputSignalPtr, MESSAGE_SIZE, NU_SUSPEND); \
   XOS_ERROR("RTOSSDL_STOPREMOVETIMERS", "NU_Send_To_Queue", Err) \
   xFreePrs(&yVarP->PrsNode); \
   goto Label_New_Transition_No_Free;

#else

#define RTOSSDL_STOPREMOVETIMERS \
   xKillSaveQ(yInstanceSetVars->SaveQ, SDL_SELF); \
   yOutputSignalPtr = xAlloc(sizeof(xTimerHeaderRec)); \
   yOutputSignalPtr->SignalCode = RemoveTimers; \
   RTOSALLOC_SIGNAL_EXTRA \
   yOutputSignalPtr->Sender = SDL_SELF; \
   Err = NU_Send_To_Queue(&Timer_Queue, &yOutputSignalPtr, MESSAGE_SIZE, NU_SUSPEND); \
   XOS_ERROR("RTOSSDL_STOPREMOVETIMERS", "NU_Send_To_Queue", Err) \
   xFreePrs(&yVarP->PrsNode); \
   goto Label_New_Transition_No_Free;

#endif /*  XOPTSIGNALALLOC  */

#else /* X_ONE_TASK_PER_INSTANCE_SET */

#define RTOSEMPTYQUEUE(SIGPTR) \
{ \
  UNSIGNED i; \
  CHAR          queue_name[8]; \
  VOID *start_address; \
  UNSIGNED size; \
  UNSIGNED available; \
  UNSIGNED messages; \
  OPTION message_type; \
  UNSIGNED message_size; \
  OPTION suspend_type; \
  UNSIGNED tasks_suspended; \
  NU_TASK *first_task; \
  Err = NU_Queue_Information(yVarP->Self, queue_name, &start_address, &size, &available, &messages, &message_type, &message_size, &suspend_type, &tasks_suspended, &first_task); \
  XOS_ERROR("RTOSEMPTYQUEUE", "NU_Queue_Information", Err) \
  for (i=0; i < messages; i++) { \
     while( (Err = NU_Receive_From_Queue(yVarP->Self, &yVarP->yInSignalPtr, 1, &received_size, NU_NO_SUSPEND)) == NU_TIMEOUT) \
	    XERROR_RECEIVED_WITH_TIMEOUT("RTOSEMPTYQUEUE") \
     XOS_ERROR("RTOSEMPTYQUEUE", "NU_Receive_From_Queue", Err) \
     xFree((void *)&(yVarP->yInSignalPtr)); \
  } \
}

#ifdef XOPTSIGNALALLOC

#define RTOSSDL_STOPREMOVETIMERS \
   yOutputSignalPtr = xGetSignal(&(TimerIdDummy),SDL_NULL,SDL_NULL); \
   yOutputSignalPtr->SignalCode = RemoveTimers; \
   yOutputSignalPtr->Sender = yVarP->Self; \
   Err = NU_Send_To_Queue(&Timer_Queue, &yOutputSignalPtr, MESSAGE_SIZE, NU_SUSPEND); \
   XOS_ERROR("RTOSSDL_STOPREMOVETIMERS", "NU_Send_To_Queue", Err) \

#else

#define RTOSSDL_STOPREMOVETIMERS \
   yOutputSignalPtr = xAlloc(sizeof(xTimerHeaderRec)); \
   yOutputSignalPtr->SignalCode = RemoveTimers; \
   RTOSALLOC_SIGNAL_EXTRA \
   yOutputSignalPtr->Sender = yVarP->Self; \
   Err = NU_Send_To_Queue(&Timer_Queue, &yOutputSignalPtr, MESSAGE_SIZE, NU_SUSPEND); \
   XOS_ERROR("RTOSSDL_STOPREMOVETIMERS", "NU_Send_To_Queue", Err) \

#endif /*  XOPTSIGNALALLOC  */

#define RTOSKILL_PROC \
{ \
  xSignalHeader yOutSignalPointer; \
  CHAR          queue_name[8]; \
  VOID *start_address; \
  UNSIGNED size; \
  UNSIGNED available; \
  UNSIGNED messages; \
  OPTION message_type; \
  UNSIGNED message_size; \
  OPTION suspend_type; \
  UNSIGNED tasks_suspended; \
  NU_TASK *first_task; \
  Err = NU_Queue_Information(yVarP->Self, queue_name, &start_address,&size, &available, &messages, &message_type, &message_size, &suspend_type, &tasks_suspended, &first_task); \
  XOS_ERROR("RTOSKILL_PROC", "NU_Queue_Information", Err) \
  if (start_address != 0) { \
		Err = NU_Deallocate_Memory(start_address); \
		XOS_ERROR("RTOSKILL_PROC", "NU_Deallocate_Memory1", Err) \
		start_address = (void *)0; \
  } \
   Err = NU_Delete_Queue(yVarP->Self); \
   XOS_ERROR("RTOSKILL_PROC", "NU_Delete_Queue", Err) \
   Err = NU_Deallocate_Memory((void *)yVarP->Self); \
   XOS_ERROR("RTOSKILL_PROC", "NU_Deallocate_Memory2", Err) \
   yOutSignalPointer = xAlloc(sizeof(xSignalHeaderRec)); \
   yOutSignalPointer->Sender = (NU_QUEUE *)NU_Current_Task_Pointer(); \
   Err = NU_Send_To_Queue(&Task_Manager_Queue, &yOutSignalPointer,MESSAGE_SIZE, NU_SUSPEND); \
   XOS_ERROR("RTOSKILL_PROC", "NU_Send_To_Queue", Err) \
   while(1); \
}

#endif /* X_ONE_TASK_PER_INSTANCE_SET */

/* ---------------------------- Timers --------------------------- */

#define TIMER_DATA_PTR \
((xTimerHeader)yOutputSignalPtr+1)

#ifdef XNOTIMERPARAMS
#define RTOSALLOC_TIMER_SIGNAL_EXTRA(TIMER_PAR_TYPE)
#else
#define RTOSALLOC_TIMER_SIGNAL_EXTRA(TIMER_PAR_TYPE) \
   ((xTimerHeader)yOutputSignalPtr)->IsTimerSignal = 1; \
   ((xTimerHeader)yOutputSignalPtr)->SigSize = sizeof(xTimerHeaderRec)+ sizeof(TIMER_PAR_TYPE);
#endif

#define RTOSALLOC_TIMER_SIGNAL(TIMER_NAME_PARAMETER,DUR_EXPR) \
   yOutputSignalPtr = (xSignalHeader)xAlloc(sizeof(xTimerHeaderRec)); \
   ((xTimerHeader)yOutputSignalPtr)->TimerToSetOrReset = TIMER_NAME_PARAMETER;\
   RTOSALLOC_TIMER_SIGNAL_EXTRA(NULL)

#define RTOS_ALLOC_TIMER_SIGNAL_PAR(TIMER_NAME, TIMER_IDNODE, TIMER_PAR_TYPE) \
  yOutputSignalPtr = (xSignalHeader)xAlloc(sizeof(xTimerHeaderRec)+sizeof(TIMER_PAR_TYPE)); \
  ((xTimerHeader)yOutputSignalPtr)->TimerToSetOrReset = TIMER_NAME; \
  ((xTimerHeader)yOutputSignalPtr)->TestParams = 1; \
  RTOSALLOC_TIMER_SIGNAL_EXTRA(TIMER_PAR_TYPE)

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define  RTOS_SDL_SET_DUR_WITH_PARA_EXTRA \
  yOutputSignalPtr->Receiver = SDL_SELF;
#else
#define  RTOS_SDL_SET_DUR_WITH_PARA_EXTRA
#endif /* X_ONE_TASK_PER_INSTANCE_SET */

#define RTOS_SDL_SET_DUR_WITH_PARA(TIME_EXPR, DUR_EXPR, TIMER_NAME, TIMER_IDNODE, TIMER_PAR_TYPE, EQ_FUNC, TIMER_VAR, TIMER_NAME_STRING) \
  XOS_TRACE_SET(TIMER_NAME_STRING) \
  yVarP->TIMER_VAR = TIMER_NAME; \
  yOutputSignalPtr->Sender = SDL_SELF; \
  RTOS_SDL_SET_DUR_WITH_PARA_EXTRA \
  ((xTimerHeader)yOutputSignalPtr)->TimerTime = DUR_EXPR; \
  ((xTimerHeader)yOutputSignalPtr)->SignalCode = SetTimer; \
  XSDLRESETWITHPARAM(TIMER_NAME, SDL_SELF, RTOSINSIGNALPTR, yOutputSignalPtr,EQ_FUNC,TIMER_NAME_STRING); \
  XMSC_TRACE_SET(yOutputSignalPtr, TIMER_NAME_STRING, DUR_EXPR) \
  Err = NU_Send_To_Queue(&Timer_Queue, &yOutputSignalPtr, MESSAGE_SIZE, NU_SUSPEND);\
  XOS_ERROR("RTOSXSDLRESET_INIT", "NU_Send_To_Queue", Err)

#define RTOS_SDL_RESET_WITH_PARA(EQ_FUNC, TIMER_VAR, TIMER_NAME_STRING) \
  XOS_TRACE_RESET(TIMER_NAME_STRING) \
  yOutputSignalPtr->Sender = SDL_SELF; \
  ((xTimerHeader)yOutputSignalPtr)->TimerTime = 0; \
  XSDLRESETWITHPARAM(yVarP->TIMER_VAR, SDL_SELF,  RTOSINSIGNALPTR, yOutputSignalPtr,EQ_FUNC,TIMER_NAME_STRING);

/* ------------------------ Execution trace ---------------------- */

#ifdef NUCLEUS_MNT

#define RTOSXOS_TRACE_CREATE(INSTANCE, PROC_NAME_STRING) \
  XOS_FPRINT(("%s: process %s:0x%08x created\r\n", ProcName, \
    PROC_NAME_STRING, INSTANCE))

#define RTOSXOS_TRACE_STATIC_CREATE(INSTANCE, PROC_NAME_STRING) \
   XOS_STATIC_FPRINT(("Process %s:0x%08x created\r\n", PROC_NAME_STRING, INSTANCE))

#else

#define RTOSXOS_TRACE_CREATE(INSTANCE, PROC_NAME_STRING) \
  XOS_FPRINT(("%s: process %s:0x%08x created\r\n", ProcName, \
    PROC_NAME_STRING, INSTANCE))

#define RTOSXOS_TRACE_STATIC_CREATE(INSTANCE, PROC_NAME_STRING) \
   XOS_STATIC_FPRINT(("Process %s:0x%08x created\r\n", PROC_NAME_STRING, INSTANCE))

#endif /* NUCLEUS_MNT */


#define RTOSMSCPRINT_START
#define RTOSMSCPRINT_STOP


#ifdef XMSC_TRACE

#ifdef X_ONE_TASK_PER_INSTANCE_SET

#define RTOSXMSC_TRACE_STATIC_CREATE(INSTANCE, PROC_NAME_STRING) \
  if (strcmp(PROC_NAME_STRING, "MyExtTask")==0) { \
   XMSC_FPRINT(("%d: instancehead process %s;\r\n", xEnvId->PROCID, PROC_NAME_STRING)) \
  } \
  else { \
   XMSC_FPRINT(("%d: instancehead process %s;\r\n", INSTANCE, PROC_NAME_STRING)) \
  }

#define RTOSXMSC_TRACE_CREATE( INSTANCE, PROC_NAME_STRING) \
   { SDL_PId ParentPId; ParentPId = SDL_SELF; \
   XMSC_TRACE_STATIC_CREATE(INSTANCE, PROC_NAME_STRING) \
   XMSC_FPRINT(("%d : create %d;\r\n", ParentPId, INSTANCE)) }

#define RTOSXMSC_TRACE_NEXTSTATE(STATE_NAME_STRING) \
   { SDL_PId CurrentPId; CurrentPId = SDL_SELF; \
   XMSC_FPRINT(("%d: condition %s;\r\n", CurrentPId, STATE_NAME_STRING)) }

#define XMSC_TRACE_INPUT(SIG_NAME_STRING) \
   { SDL_PId CurrentPId, SenderPId; \
     unsigned long ticks; \
     CurrentPId = SDL_SELF; \
     SenderPId = (SDL_PId)yVarP->Sender; \
     if (INSIGNAL_PTR->IsTimer) { \
       ticks = NU_Retrieve_Clock(); \
       XMSC_FPRINT(("%d: timeout  %s,%d; /* #SDTNOW(%ld) */\r\n", \
         CurrentPId, SIG_NAME_STRING, \
         INSIGNAL_PTR->SignalId, ticks)) \
     } \
     else \
       XMSC_FPRINT(("%d: in %s,%d from %d;\r\n", CurrentPId, \
         SIG_NAME_STRING, INSIGNAL_PTR->SignalId, \
         SenderPId))  \
   }

#define XMSC_TRACE_OUTPUT(RECEIVER, SIGNAL, SIG_NAME_STRING) \
   { SDL_PId CurrentPId; \
     CurrentPId = SDL_SELF; \
     SignalId = SignalId + 1; \
     SIGNAL->SignalId = SignalId; \
     SIGNAL->IsTimer = 0; \
     if ( xEq_SDL_PId(RECEIVER, xEnvPId) ) \
       XMSC_FPRINT(("%d: out %d,%d to %d;\r\n", CurrentPId, \
                     SIGNAL->SignalCode, SignalId,(SDL_PId)RECEIVER->NameNode->PROCID )) \
     else \
       XMSC_FPRINT(("%d: out %s,%d to %d;\r\n", CurrentPId, \
                     SIG_NAME_STRING, SignalId,(SDL_PId)RECEIVER->NameNode->PROCID )) }

#define XMSC_TRACE_STOP  \
   { SDL_PId CurrentPId; \
     CurrentPId = SDL_SELF; \
   XMSC_FPRINT(("%d: endinstance;\r\n", CurrentPId)) }

#define XMSC_TRACE_SET( TIMER, TIMER_NAME_STRING, DUR_EXPR) \
   { SDL_PId CurrentPId; \
     unsigned long ticks; \
     CurrentPId = SDL_SELF; \
     SignalId = SignalId + 1; \
     TIMER->SignalId = SignalId; \
     TIMER->IsTimer = 1; \
     ticks = NU_Retrieve_Clock(); \
     XMSC_FPRINT(("%d: set %s,%d (%d); /* #SDTNOW(%ld) */\r\n", CurrentPId, \
       TIMER_NAME_STRING, SignalId, DUR_EXPR, ticks)) }

#define RTOSSYSINITPR_MSCPRINT \
  XMSC_FPRINT(("%lu: in %d,%d from %lu;\r\n", xEnvId->PROCID, \
         yInSignalPtr->SignalCode , yInSignalPtr->SignalId,\
         (SDL_PId)yInSignalPtr->Sender->NameNode->PROCID))

#define XMSC_TRACE_RESET( TIMER_ID, TIMER_NAME_STRING) \
   { SDL_PId CurrentPId; \
     unsigned long ticks; \
     CurrentPId = Self; \
     ticks = NU_Retrieve_Clock(); \
     XMSC_FPRINT(("%d: reset %s,%d; /* #SDTNOW(%ld) */\r\n", CurrentPId, \
     TIMER_NAME_STRING, TIMER_ID, ticks)) }

#else

#define RTOSXMSC_TRACE_STATIC_CREATE(INSTANCE, PROC_NAME_STRING) \
   XMSC_FPRINT(("0x%08x: instancehead process %s;\r\n", INSTANCE, PROC_NAME_STRING))

#define RTOSXMSC_TRACE_CREATE( INSTANCE, PROC_NAME_STRING) \
   { SDL_PId ParentPId; ParentPId = SDL_SELF; \
   XMSC_TRACE_STATIC_CREATE(INSTANCE, PROC_NAME_STRING) \
   XMSC_FPRINT(("0x%08x : create 0x%08x;\r\n", ParentPId, INSTANCE)) }

#define RTOSXMSC_TRACE_NEXTSTATE(STATE_NAME_STRING) \
   { SDL_PId CurrentPId; CurrentPId = SDL_SELF; \
   XMSC_FPRINT(("0x%08x: condition %s;\r\n", CurrentPId, STATE_NAME_STRING)) }

#define XMSC_TRACE_INPUT(SIG_NAME_STRING) \
   { unsigned long CurrentPId, SenderPId; \
     unsigned long ticks; \
     CurrentPId = (unsigned long)SDL_SELF; \
     SenderPId = (unsigned long)yVarP->Sender; \
     if (INSIGNAL_PTR->IsTimer) { \
       ticks = NU_Retrieve_Clock(); \
       XMSC_FPRINT(("0x%08x: timeout  %s,%d; /* #SDTNOW(%ld) */\r\n", \
         CurrentPId, SIG_NAME_STRING, \
         INSIGNAL_PTR->SignalId, ticks)) \
     } \
     else \
       XMSC_FPRINT(("0x%08x: in %s,%d from 0x%08x;\r\n", CurrentPId, \
         SIG_NAME_STRING, INSIGNAL_PTR->SignalId, \
         SenderPId))  \
   }

#define XMSC_TRACE_OUTPUT(RECEIVER, SIGNAL, SIG_NAME_STRING) \
   { SDL_PId CurrentPId; \
     CurrentPId = SDL_SELF; \
     SignalId = SignalId + 1; \
     SIGNAL->SignalId = SignalId; \
     SIGNAL->IsTimer = 0; \
     if ( xEq_SDL_PId(RECEIVER, xEnvPId) ) \
       XMSC_FPRINT(("0x%08x: out %d,%d to 0x%08x;\r\n", CurrentPId, \
                     SIGNAL->SignalCode, SignalId, RECEIVER)) \
     else \
       XMSC_FPRINT(("0x%08x: out %s,%d to 0x%08x;\r\n", CurrentPId, \
                     SIG_NAME_STRING, SignalId, RECEIVER)) }

#define XMSC_TRACE_STOP  \
   { SDL_PId CurrentPId; \
     CurrentPId = SDL_SELF; \
   XMSC_FPRINT(("0x%08x: endinstance;\r\n", CurrentPId)) }

#define XMSC_TRACE_SET( TIMER, TIMER_NAME_STRING, DUR_EXPR) \
   { SDL_PId CurrentPId; \
     unsigned long ticks; \
     CurrentPId = SDL_SELF; \
     SignalId = SignalId + 1; \
     TIMER->SignalId = SignalId; \
     TIMER->IsTimer = 1; \
     ticks = NU_Retrieve_Clock(); \
     XMSC_FPRINT(("0x%08x: set %s,%d (%d); /* #SDTNOW(%ld) */\r\n", CurrentPId, \
       TIMER_NAME_STRING, SignalId, DUR_EXPR, ticks)) }

#define RTOSSYSINITPR_MSCPRINT \
  XMSC_FPRINT(("0x%08x: in %d,%d from 0x%08x;\r\n", xEnvPId, \
         yInSignalPtr->SignalCode , yInSignalPtr->SignalId,\
         yInSignalPtr->Sender))

#define XMSC_TRACE_RESET( TIMER_ID, TIMER_NAME_STRING) \
   { SDL_PId CurrentPId; \
     unsigned long ticks; \
     CurrentPId = Self; \
     ticks = NU_Retrieve_Clock(); \
     XMSC_FPRINT(("0x%08x: reset %s,%d; /* #SDTNOW(%ld) */\r\n", CurrentPId, \
     TIMER_NAME_STRING, TIMER_ID, ticks)) }

#endif /*  X_ONE_TASK_PER_INSTANCE_SET  */

#endif /* XMSC_TRACE */

#ifdef XOS_TRACE

#ifndef X_ONE_TASK_PER_INSTANCE_SET

#ifdef NUCLEUS_MNT
#define XOS_FPRINT(PARAM) \
{  SDL_PId CurrentPId; \
   CurrentPId = yVarP->Self; \
   if (LastUsedPId != CurrentPId) \
     printf("\r\nProcess instance 0x%08x\r\n", CurrentPId); \
   printf PARAM; \
   LastUsedPId = yVarP->Self; \
}

#define XOS_FPRINT(PARAM) \
{  SDL_PId CurrentPId; \
   CurrentPId = yVarP->Self; \
   if (LastUsedPId != CurrentPId) \
     printf("\r\nProcess instance 0x%08x\r\n", CurrentPId); \
   printf PARAM; \
   LastUsedPId = yVarP->Self; \
}
#define XOS_FPRINTADDR(PARAM) \
   {  \
   SDL_PId CurrentPId; \
   CurrentPId = (*yVarP)->Self; \
   if (LastUsedPId != CurrentPId) \
     printf("\r\n** Process: %s instance: 0x%08x **\r\n", \
            (*yVarP)->ProcName, CurrentPId); \
   printf PARAM; \
   LastUsedPId = (*yVarP)->Self; \
   }

#else /* NUCLEUS_MNT */

#define XOS_FPRINT(PARAM) \
{  SDL_PId CurrentPId; \
   CurrentPId = yVarP->Self; \
   if (LastUsedPId != CurrentPId) \
     printf("Process instance 0x%08x\r\n", CurrentPId); \
   printf PARAM; \
   LastUsedPId = yVarP->Self; \
}
#define XOS_FPRINTADDR(PARAM) \
   {  \
   SDL_PId CurrentPId; \
   CurrentPId = (*yVarP)->Self; \
   if (LastUsedPId != CurrentPId) \
     printf("\r\n** Process: %s instance: 0x%08x **\r\n", \
            (*yVarP)->ProcName, CurrentPId); \
   printf PARAM; \
   LastUsedPId = (*yVarP)->Self; \
   }

#endif /* NUCLEUS_MNT */

#else /* X_ONE_TASK_PER_INSTANCE_SET */

#ifdef NUCLEUS_MNT
#define XOS_FPRINT(PARAM) \
{  xEPrsNode CurrentPId; \
   CurrentPId = (SDL_PId)yVarP->PrsNode->NameNode->PROCID; \
   if (LastUsedPId != CurrentPId) \
   printf("\r\n** Process: %s instance: 0x%08x **\r\n", \
          yInstanceSetVars->name, CurrentPId); \
   printf PARAM; \
   LastUsedPId = SDL_SELF; \
}
#define XOS_FPRINTADDR(PARAM) \
   {  \
   xEPrsNode CurrentPId; \
   CurrentPId = (SDL_PId)(*yVarP)->PrsNode->NameNode->PROCID;  \
   if (LastUsedPId != CurrentPId) \
     printf("\r\n** Process: %s instance: 0x%08x **\r\n", \
            yInstanceSetVars->name, CurrentPId); \
   printf PARAM; \
   LastUsedPId = (*yVarP)->PrsNode; \
   }

#else /* NUCLEUS_MNT */

#define XOS_FPRINT(PARAM) \
{  xEPrsNode CurrentPId; \
   CurrentPId = (SDL_PId)yVarP->PrsNode->NameNode->PROCID; \
   if (LastUsedPId != CurrentPId) \
     printf("\r\n** Process: %s instance: 0x%08x **\r\n", \
          yInstanceSetVars->name, CurrentPId); \
   printf PARAM; \
   LastUsedPId = SDL_SELF; \
}
#define XOS_FPRINTADDR(PARAM) \
   {  \
   xEPrsNode CurrentPId; \
   CurrentPId = (SDL_PId)(*yVarP)->PrsNode->NameNode->PROCID;  \
   if (LastUsedPId != CurrentPId) \
     printf("\r\n** Process: %s instance: 0x%08x **\r\n", \
            yInstanceSetVars->name, CurrentPId); \
   printf PARAM; \
   LastUsedPId = (*yVarP)->PrsNode; \
   }

#endif /* NUCLEUS_MNT */

#endif /* X_ONE_TASK_PER_INSTANCE_SET */
#endif /* XOS_TRACE */

/****+***************************************************************
     SDL Save
********************************************************************/

typedef struct xSignalHeaderStruct xSaveQStruct;
typedef xSignalHeader xSaveQ;

#define RTOSSAVEQ_TYPE xSaveQ

/****+***************************************************************
     SDL Timer
********************************************************************/

extern void SDL_Reset (xTimerHeader TimerName, xSaveQ SaveQ);

#ifdef XMSC_TRACE
extern void xSDLReset XPP ((
			     int Timer_Name,
			     SDL_PId Self,
			     xSignalHeader SaveQ,
			     xSignalHeader InSignalPtr,
			     xSignalHeader yOutputSignalPtr,
			     xbool (*yEq) (void *VarP1, void *VarP2),
			     char *SignalName));
#else
extern void xSDLReset XPP ((
			     int Timer_Name,
			     SDL_PId Self,
			     xSignalHeader SaveQ,
			     xSignalHeader InSignalPtr,
			     xSignalHeader yOutputSignalPtr,
			     xbool (*yEq) (void *VarP1, void *VarP2)));
#endif

/****+***************************************************************
     sdl
********************************************************************/
extern void xSaveSignal XPP ((
			       RTOSSAVEQ_TYPE SaveQ,
			       RTOSSIGNAL_DEF yInSignalPtr));

extern void xDiscardSignal XPP ((
				  xSignalHeader * DiscardSignal));

#ifdef X_ONE_TASK_PER_INSTANCE_SET
extern void xKillSaveQ XPP ((
			      xSignalHeader SaveQ,
			      SDL_PId CurrentPId));
#else
extern void xKillSaveQ XPP ((
			      xSignalHeader SaveQ));
#endif /* X_ONE_TASK_PER_INSTANCE_SET */

extern SDL_PId xTo_Process XPP ((
				  xPrsIdNode PrsNode));

#ifdef X_ONE_TASK_PER_INSTANCE_SET

extern void xHandle_Sig XPP ((RTOSSIGNAL_DEF OutputSignal, SDL_PId Sender, int SigPar_Size, SDL_PId Receiver, RTOSTASK_TYPE ReceiverTask RTOSHANDLEMESS_TYPE));

#endif /* X_ONE_TASK_PER_INSTANCE_SET */

/****+***************************************************************
     Initialization functions
********************************************************************/

/*---+---------------------------------------------------------------
     System_Init_Process
-------------------------------------------------------------------*/
#define RTOSMAINRETURNTYPE void
#define RTOSMAINNAME SDL_main	/* Name for the SDL task's startup function */
#define RTOSMAINNAME_PARAM XPP((UNSIGNED argc, VOID *argv))

extern RTOSMAINRETURNTYPE RTOSMAINNAME XPP ((UNSIGNED argc, VOID * argv));

#define RTOSMAINRETURNSTMT	/* unreachable code! */

#define RTOSSYSINITFUNC_VAR \
  xSignalHeader yInSignalPtr; \
  int			i;

#define RTOSSYSINITFUNC_SDLNULL

#define RTOSSYSINITPR_SEMCREATE \
  Err = NU_Create_Semaphore(&yInitSem, "InitSem", 0, NU_FIFO); \
  XOS_ERROR("RTOSSYSINITPR_SEMCREATE","NU_Create_Semaphore",Err) \
 { \
   extern void  Manager_Task XPP((UNSIGNED argc, VOID *argv)); \
   NU_TASK	*Task_Manager; \
   VOID		*Queue_Start_Ptr; \
   VOID		*Stack_Ptr; \
   Err = NU_Allocate_Memory(&System_Memory, (VOID **)&Task_Manager, sizeof(NU_TASK), NU_NO_SUSPEND); \
   XOS_ERROR("RTOSSYSINITPR_SEMCREATE", "NU_Allocate_Memory1", Err) \
   memset(Task_Manager, 0, sizeof(NU_TASK)); \
   Err = NU_Allocate_Memory(&System_Memory, &Stack_Ptr, MANAGER_STACK_SIZE, NU_NO_SUSPEND); \
   XOS_ERROR("RTOSSYSINITPR_SEMCREATE", "NU_Allocate_Memory2", Err) \
   memset(Stack_Ptr, 0, MANAGER_STACK_SIZE); \
   Err = NU_Allocate_Memory(&System_Memory, &Queue_Start_Ptr, MANAGER_QUEUE_SIZE*sizeof(UNSIGNED), NU_NO_SUSPEND); \
   XOS_ERROR("RTOSSYSINITPR_SEMCREATE", "NU_Allocate_Memory4", Err) \
   memset(Queue_Start_Ptr, 0, (MANAGER_QUEUE_SIZE*sizeof(UNSIGNED)) ); \
   Err = NU_Create_Queue(&Task_Manager_Queue, "T_Man_Q", Queue_Start_Ptr, MANAGER_QUEUE_SIZE, NU_FIXED_SIZE, MESSAGE_SIZE, NU_FIFO); \
   XOS_ERROR("RTOSSYSINITPR_SEMCREATE", "NU_Create_Queue", Err) \
   Err = NU_Create_Task(Task_Manager, "Manage_T", Manager_Task, 0, 0, Stack_Ptr, MANAGER_STACK_SIZE, MANAGER_TASK_PRIORITY, MANAGER_TIME_SLICE, NU_PREEMPT, NU_START); \
   XOS_ERROR("RTOSSYSINITPR_SEMCREATE", "NU_Create_Task", Err) \
}

#define RTOSSYSINITPR_SEMGIVE \
  for (i=1;(i<=createdProcesses);i++) { \
     Err = NU_Release_Semaphore(&yInitSem); \
     XOS_ERROR("RTOSSYSINITPR_SEMGIVE", "NU_Release_Semaphore", Err) \
  }

#ifdef XRTOSTEST

#ifdef X_ONE_TASK_PER_INSTANCE_SET

#define RTOSSYSINITPROC_RECEIVE \
  if ( (Err = NU_Receive_From_Queue((NU_QUEUE *)xEnvPIdQ, &yInSignalPtr, 1, &received_size, 1200)) == NU_TIMEOUT) { \
    printf("************* TEST CASE FAILED *****************\n"); \
    exit(0); \
  } \
  else \
    XOS_ERROR("RTOSSYSINITPROC_RECEIVE", "NU_Receive_From_Queue", Err)

#else

#define RTOSSYSINITPROC_RECEIVE \
  if ( (Err = NU_Receive_From_Queue(xEnvPId, &yInSignalPtr, 1, &received_size, 1200)) == NU_TIMEOUT) { \
    printf("************* TEST CASE FAILED *****************\n"); \
    exit(0); \
  } \
  else \
    XOS_ERROR("RTOSSYSINITPROC_RECEIVE", "NU_Receive_From_Queue", Err)

#endif /* X_ONE_TASK_PER_INSTANCE_SET */

#else /* RTOSTEST */

#ifdef X_ONE_TASK_PER_INSTANCE_SET

#define RTOSSYSINITPROC_RECEIVE \
  while( (Err = NU_Receive_From_Queue((NU_QUEUE *)xEnvPIdQ, &yInSignalPtr, 1, &received_size, NU_SUSPEND)) == NU_TIMEOUT) \
     XERROR_RECEIVED_WITH_TIMEOUT("RTOSSYSINITPROC_RECEIVE") \
  XOS_ERROR("RTOSSYSINITPROC_RECEIVE", "NU_Receive_From_Queue", Err)

#else

#define RTOSSYSINITPROC_RECEIVE \
  while( (Err = NU_Receive_From_Queue(xEnvPId, &yInSignalPtr, 1, &received_size, NU_SUSPEND)) == NU_TIMEOUT) \
     XERROR_RECEIVED_WITH_TIMEOUT("RTOSSYSINITPROC_RECEIVE") \
  XOS_ERROR("RTOSSYSINITPROC_RECEIVE", "NU_Receive_From_Queue", Err)

#endif /* X_ONE_TASK_PER_INSTANCE_SET */
#endif /* RTOSTEST */

#ifdef RTOSTEST
#define RTOSTEST_ABORT \
exit(0);
#else
#define RTOSTEST_ABORT
#endif

#define RTOSSYSINITPR_SENDER SDL_NULL

/*---+---------------------------------------------------------------
     xInitTimer
-------------------------------------------------------------------*/
#define RTOSXTIMERTASK_PARAM UNSIGNED argc, VOID *argv
#define RTOSXTIMERTASK_RTNTYPE void
extern RTOSXTIMERTASK_RTNTYPE xTimerTask XPP ((RTOSXTIMERTASK_PARAM));

#define RTOSXINITTIMER \
{ \
   NU_TASK	*Timer_Task; \
   VOID		*Queue_Start_Ptr; \
   VOID		*Stack_Ptr; \
   Err = NU_Allocate_Memory(&System_Memory, (VOID **)&Timer_Task, sizeof(NU_TASK), NU_NO_SUSPEND); \
   XOS_ERROR("RTOSXINITTIMER", "NU_Allocate_Memory1", Err) \
   memset(Timer_Task, 0, sizeof(NU_TASK) ); \
   Err = NU_Allocate_Memory(&System_Memory, &Stack_Ptr, TIMER_STACK_SIZE, NU_NO_SUSPEND); \
   XOS_ERROR("RTOSXINITTIMER", "NU_Allocate_Memory2", Err) \
   memset(Stack_Ptr, 0, TIMER_STACK_SIZE ); \
   Err = NU_Allocate_Memory(&System_Memory, &Queue_Start_Ptr, TIMER_QUEUE_SIZE*sizeof(UNSIGNED), NU_NO_SUSPEND); \
   XOS_ERROR("RTOSXINITTIMER", "NU_Allocate_Memory4", Err) \
   memset(Queue_Start_Ptr, 0, (TIMER_QUEUE_SIZE*sizeof(UNSIGNED)) ); \
   Err = NU_Create_Queue(&Timer_Queue, "Timer_Q", Queue_Start_Ptr, TIMER_QUEUE_SIZE, NU_FIXED_SIZE, MESSAGE_SIZE, NU_FIFO); \
   XOS_ERROR("RTOSXINITTIMER", "NU_Create_Queue", Err) \
   Err = NU_Create_Task(Timer_Task, "Timer_Tk", xTimerTask, 0, 0, Stack_Ptr, TIMER_STACK_SIZE, TIMER_TASK_PRIORITY, TIMER_TIME_SLICE, NU_PREEMPT, NU_START); \
   XOS_ERROR("RTOSXINITTIMER", "NU_Create_Task", Err) \
}

/****+***************************************************************
     Timer Procedures
********************************************************************/
/*---+---------------------------------------------------------------
     xSDLReset
-------------------------------------------------------------------*/
#ifdef X_ONE_TASK_PER_INSTANCE_SET
#ifdef XMSC_TRACE
#define XSDLRESETWITHPARAM(TIMER_NAME, SELF,INPUTSIG, OUTPUTSIG,EQUALF, TIMER_NAME_STRING) \
   xSDLReset( TIMER_NAME, SELF, yInstanceSetVars->SaveQ, INPUTSIG, OUTPUTSIG, EQUALF,\
             TIMER_NAME_STRING);
#else /* XMSC_TRACE */
#define XSDLRESETWITHPARAM(TIMER_NAME, SELF,INPUTSIG, OUTPUTSIG,EQUALF, TIMER_NAME_STRING) \
   xSDLReset( TIMER_NAME, SELF, yInstanceSetVars->SaveQ, INPUTSIG, OUTPUTSIG, EQUALF);
#endif /* XMSC_TRACE */

#else /* X_ONE_TASK_PER_INSTANCE_SET */

#ifdef XMSC_TRACE
#define XSDLRESETWITHPARAM(TIMER_NAME, SELF,INPUTSIG, OUTPUTSIG,EQUALF, TIMER_NAME_STRING) \
   xSDLReset( TIMER_NAME, SELF, yVarP->SaveQ, INPUTSIG, OUTPUTSIG, EQUALF,\
             TIMER_NAME_STRING);
#else /* XMSC_TRACE */
#define XSDLRESETWITHPARAM(TIMER_NAME, SELF,INPUTSIG, OUTPUTSIG,EQUALF, TIMER_NAME_STRING) \
   xSDLReset( TIMER_NAME, SELF, yVarP->SaveQ, INPUTSIG, OUTPUTSIG, EQUALF);
#endif /* XMSC_TRACE */
#endif /* X_ONE_TASK_PER_INSTANCE_SET */

#ifdef XMSC_TRACE
#ifndef XNOPROTO
#define RTOSXSDLRESET_PARAMETERS \
( int		TimerName, \
  SDL_PId	Self, \
  xSignalHeader	SaveQ, \
  xSignalHeader InSignalPtr, \
  xSignalHeader yOutputSignalPtr, \
  xbool		(* yEq)(void * VarP1, void * VarP2), \
  char		*SignalName)

#else

#define RTOSXSDLRESET_PARAMETERS \
( TimerName, Self, SaveQ, InSignalPtr, yOutputSignalPtr, yEq, SignalName) \
  int		TimerName; \
  SDL_PId	Self; \
  xSignalHeader SaveQ; \
  xSignalHeader InSignalPtr; \
  xSignalHeader yOutputSignalPtr; \
  xbool         (* yEq)(); \
  char          *SignalName;

#endif /* XNOPROTO */

#define XSDLRESET( TIMER_NAME,SAVEQ, TIMER_NAME_STRING) \
   xSDLReset( TIMER_NAME,SDL_SELF, SAVEQ,  RTOSINSIGNALPTR, NULL, NULL,TIMER_NAME_STRING);

#else /* XMSC_TRACE */

#ifndef XNOPROTO

#define RTOSXSDLRESET_PARAMETERS \
( int           TimerName, \
  SDL_PId       Self, \
  xSignalHeader SaveQ, \
  xSignalHeader InSignalPtr, \
  xSignalHeader yOutputSignalPtr, \
  xbool         (* yEq)(void * VarP1, void * VarP2))

#else /* XNOPROTO */

#define RTOSXSDLRESET_PARAMETERS \
(TimerName, Self, SaveQ, InSignalPtr, yOutputSignal, yEq) \
  int           TimerName; \
  SDL_PId       Self; \
  xSignalHeader SaveQ;\
  xSignalHeader InSignalPtr; \
  xSignalHeader yOutputSignalPtr; \
  xbool         (* yEq)();

#endif /* XNOPROTO */

#define XSDLRESET( TIMER_NAME,SAVEQ, TIMER_NAME_STRING) \
   xSDLReset(TIMER_NAME, SDL_SELF, SAVEQ, RTOSINSIGNALPTR, NULL, NULL);

#endif /* XMSC_TRACE */

#define RTOSXSDLRESET_VARS \
  xTimerHeader  yTimerReset; \
  xSignalHeader TempSaved; \
  UNSIGNED      i; \
  STATUS        Err; \
  CHAR          queue_name[8]; \
  VOID			*start_address; \
  UNSIGNED		size; \
  UNSIGNED		available; \
  UNSIGNED		messages; \
  OPTION		message_type; \
  UNSIGNED		message_size; \
  OPTION		suspend_type; \
  UNSIGNED		tasks_suspended; \
  NU_TASK		*first_task;

#define RTOSXSDLRESET_INIT \
  yTimerReset = (xTimerHeader)xAlloc( sizeof(xTimerHeaderRec)); \
  yTimerReset->SignalCode = ResetTimer; \
  yTimerReset->Sender = Self; \
  yTimerReset->TimerToSetOrReset = TimerName; \
  yTimerReset->yEq = yEq; \
  yTimerReset->Param = (xTimerHeader)yOutputSignalPtr; \
  yTimerReset->TestParams = (yOutputSignalPtr != NULL && yEq != NULL); \
  Err = NU_Send_To_Queue(&Timer_Queue, &yTimerReset, MESSAGE_SIZE, NU_SUSPEND);\
  XOS_ERROR("RTOSXSDLRESET_INIT", "NU_Send_To_Queue", Err)

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define RTOSSELF \
(NU_QUEUE *)Self->NameNode->PROCID
#else
#define RTOSSELF \
(NU_QUEUE *)Self
#endif

#define RTOSCHECKEQPARAM_INTIMER \
  if(yInSignalPointer->TestParams) { \
    if(yEqFunc(((xTimerHeader)(((xTimerHeader)yInSignalPointer)->Param)+1),(((xTimerHeader)TempTimer)+1))) { \
      break; \
    } \
  } \
  else

#define RTOSCHECKEQPARAM \
  if(yOutputSignalPtr != NULL && yEq !=NULL) { \
    if((*yEq)(((xTimerHeader)yOutputSignalPtr)+1, ((xTimerHeader)TempSaved)+1)) { \
      xDiscardSignal(&TempSaved); \
      return; \
    } \
  } \
  else {

#define RTOSCHECKEQPARAM2 \
  if(yOutputSignalPtr != NULL && yEq !=NULL) { \
    if((*yEq)(((xTimerHeader)yOutputSignalPtr)+1, ((xTimerHeader)TempSaved)+1)) { \
      return; \
    } \
  } \
  else {

#define RTOSXSDLRESET_WAITREPLY \
  while( (Err = NU_Receive_From_Queue(RTOSSELF, &yTimerReset, 1, &received_size, NU_SUSPEND)) == NU_TIMEOUT) \
     XERROR_RECEIVED_WITH_TIMEOUT("RTOSXSDLRESET_WAITREPLY") \
  XOS_ERROR("RTOSXSDLRESET_WAITREPLY", "NU_Receive_From_Queue", Err) \
  while (yTimerReset->SignalCode != ResetTimer) { \
    xSaveSignal(SaveQ, (xSignalHeader)yTimerReset); \
    while( (Err = NU_Receive_From_Queue(RTOSSELF, &yTimerReset, 1, &received_size, NU_SUSPEND)) == NU_TIMEOUT) \
	   XERROR_RECEIVED_WITH_TIMEOUT("RTOSXSDLRESET_WAITREPLY") \
    XOS_ERROR("RTOSXSDLRESET_WAITREPLY", "NU_Receive_From_Queue", Err) \
  } \
  if (yTimerReset->TimerToSetOrReset == TimerWasFound) { \
    XMSC_TRACE_RESET(yTimerReset->SignalId, SignalName) \
    xFree((void **)&yTimerReset); \
    return; \
  } \
  xFree((void **)&yTimerReset);

#define RTOSTEMPSAVED \
TempSaved

#define RTOSTEMPSAVED_SIGNO \
  TempSaved->SignalCode

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define RTOSTEMPSAVED_RECEIVER \
TempSaved->Receiver
#else
#define RTOSTEMPSAVED_RECEIVER
#endif

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define RTOSYTIMERACTIVE_RECEIVER \
yTimerActive->Receiver
#else
#define RTOSYTIMERACTIVE_RECEIVER
#endif

#define RTOSXRESETTEMPTIMER_SIGNALID \
  yTimerReset->SignalId

#ifdef X_ONE_TASK_PER_INSTANCE_SET

#define RTOSXSDLRESET_REMOVETIMER \
  Err = NU_Queue_Information(RTOSSELF, queue_name, &start_address, &size, &available, &messages, &message_type, &message_size, &suspend_type, &tasks_suspended, &first_task); \
  XOS_ERROR("RTOSXSDLRESET_REMOVETIMER", "NU_Queue_Information", Err) \
  for (i=0; i < messages; i++) { \
    while( (Err = NU_Receive_From_Queue(RTOSSELF, &yTimerReset, 1, &received_size, NU_SUSPEND)) == NU_TIMEOUT) \
	   XERROR_RECEIVED_WITH_TIMEOUT("RTOSXSDLRESET_REMOVETIMER") \
    XOS_ERROR("RTOSXSDLRESET_REMOVETIMER", "NU_Receive_From_Queue", Err) \
    if (yTimerReset->SignalCode == TimerName && (xEq_SDL_PId(yTimerReset->Receiver,Self))) { \
      if (yOutputSignalPtr != NIL) { \
        if ((*yEq)(((xTimerHeader)yOutputSignalPtr)+1, (xTimerHeader)(TempSaved)+1)) { \
	  /* Timer found, free memory and return */ \
	  XMSC_TRACE_RESET(yTimerReset->SignalId, SignalName) \
          xFree((void **)&yTimerReset); \
          return; \
        } \
      } \
      else { \
	/* Timer found, free memory and return */ \
	XMSC_TRACE_RESET(yTimerReset->SignalId, SignalName) \
        xFree((void **)&yTimerReset); \
        return; \
      } \
    } \
    /* Other signal or timer found, put them in SaveQ and continue */ \
    xSaveSignal( SaveQ, (xSignalHeader)yTimerReset); \
  }

#else

#define RTOSXSDLRESET_REMOVETIMER \
  Err = NU_Queue_Information(RTOSSELF, queue_name, &start_address, &size, &available, &messages, &message_type, &message_size, &suspend_type, &tasks_suspended, &first_task); \
  XOS_ERROR("RTOSXSDLRESET_REMOVETIMER", "NU_Queue_Information", Err) \
  for (i=0; i < messages; i++) { \
    while( (Err = NU_Receive_From_Queue(RTOSSELF, &yTimerReset, 1, &received_size, NU_SUSPEND)) == NU_TIMEOUT) \
	   XERROR_RECEIVED_WITH_TIMEOUT("RTOSXSDLRESET_REMOVETIMER") \
    XOS_ERROR("RTOSXSDLRESET_REMOVETIMER", "NU_Receive_From_Queue", Err) \
    if (yTimerReset->SignalCode == TimerName) { \
      if (yOutputSignalPtr != NIL) { \
        if ((*yEq)(((xTimerHeader)yOutputSignalPtr)+1, (xTimerHeader)(TempSaved)+1)) { \
	  /* Timer found, free memory and return */ \
	  XMSC_TRACE_RESET(yTimerReset->SignalId, SignalName) \
          xFree((void **)&yTimerReset); \
          return; \
        } \
      } \
      else { \
	/* Timer found, free memory and return */ \
	XMSC_TRACE_RESET(yTimerReset->SignalId, SignalName) \
        xFree((void **)&yTimerReset); \
        return; \
      } \
    } \
    /* Other signal or timer found, put them in SaveQ and continue */ \
    xSaveSignal( SaveQ, (xSignalHeader)yTimerReset); \
  }

#endif
/*---+---------------------------------------------------------------
     xSDLActive
-------------------------------------------------------------------*/

#define RTOSXSDLACTIVE_PARAMETERS \
XPP(( \
 int			TimerName, \
 SDL_PId		Self, \
 xSignalHeader	SaveQ,\
 xSignalHeader	CurrentInSaveQ))

#define RTOSXSDLACTIVE_VARS \
  xTimerHeader  yTimerActive; \
  xSignalHeader TempSaved; \
  STATUS        Err; \
  CHAR          queue_name[8]; \
  VOID			*start_address; \
  UNSIGNED		size; \
  UNSIGNED		available; \
  UNSIGNED		messages; \
  OPTION		message_type; \
  UNSIGNED		message_size; \
  OPTION		suspend_type; \
  UNSIGNED		tasks_suspended; \
  NU_TASK		*first_task;

#ifdef XOPTSIGNALALLOC
#define RTOSXSDLACTIVE_ALLOC \
  yTimerActive =(xTimerHeader) xGetSignal(&(TimerIdDummy), SDL_NULL,SDL_NULL); \
  yTimerActive->SignalCode = ActiveTimer; \
  yTimerActive->Sender = Self;
#else
#define RTOSXSDLACTIVE_ALLOC \
  yTimerActive = (xTimerHeader)xAlloc( sizeof(xTimerHeaderRec)); \
  yTimerActive->SignalCode = ActiveTimer; \
  yTimerActive->Sender = Self;
#endif /* XOPTSIGNALALLOC */

#define RTOSACTIVEINTIMERPROCESS_VARS \
  STATUS          Err;

#define RTOSXACTIVETIMER_TIMERTOFIND_2 \
  yTimerActive->TimerToSetOrReset

#define RTOSXSDLACTIVE_WAITREPLY \
  while( (Err = NU_Receive_From_Queue(RTOSSELF, &yTimerActive, 1, &received_size, NU_SUSPEND)) == NU_SUSPEND) \
     XERROR_RECEIVED_WITH_TIMEOUT("RTOSXSDLACTIVE_WAITREPLY") \
  XOS_ERROR("RTOSXSDLACTIVE_WAITREPLY", "NU_Receive_From_Queue", Err) \
    while (yTimerActive->SignalCode != ActiveTimer) { \
      xSaveSignal(SaveQ, (xSignalHeader)yTimerActive); \
      while( (Err = NU_Receive_From_Queue(RTOSSELF, &yTimerActive, 1, &received_size, NU_SUSPEND)) == NU_SUSPEND) \
	    XERROR_RECEIVED_WITH_TIMEOUT("RTOSXSDLACTIVE_WAITREPLY") \
      XOS_ERROR("RTOSXSDLACTIVE_WAITREPLY", "NU_Receive_From_Queue", Err) \
	} \
  if (yTimerActive->TimerToSetOrReset == TimerWasFound) { \
    xFree((void **)&yTimerActive); \
    return( SDL_True); \
  } \
  xFree((void **)&yTimerActive);

#define RTOSSENDTIMERALLOCTIMER

#define RTOSSENDTIMERALLOCREPLY

#define RTOSSENDTIMERALLOC

#define RTOSSENDTIMER(SIGPTR,RECEIVER) \
  Err = NU_Send_To_Queue(RECEIVER, SIGPTR, MESSAGE_SIZE, NU_SUSPEND); \
  XOS_ERROR("RTOSSENDTIMER", "NU_Send_To_Queue", Err)

#define RTOSALLOCMESS \
  while( (Err = NU_Receive_From_Queue(RTOSSELF, &yTimerActive, 1, &received_size, NU_SUSPEND)) == NU_TIMEOUT) \
	XERROR_RECEIVED_WITH_TIMEOUT("RTOSALLOCMESS") \
  XOS_ERROR("RTOSALLOCMESS", "NU_Receive_From_Queue", Err)

#define RTOSLOOK_FOR_TIMER \
  Err = NU_Queue_Information(RTOSSELF, queue_name, &start_address, &size, &available, &messages, \
             &message_type, &message_size, &suspend_type, &tasks_suspended, &first_task); \
  XOS_ERROR("RTOSLOOK_FOR_TIMER", "NU_Queue_Information", Err)

#define RTOSMSG_IN_Q \
  messages >0

#define RTOSYTIMERACTIVE_SIGNO \
  yTimerActive->SignalCode

/****+***************************************************************
     xEPrsNode handling
********************************************************************/

/*---+---------------------------------------------------------------
     xAllocPrsUseMyMemory
-------------------------------------------------------------------*/
#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define RTOSALLOCPRSSEMTAKE
#else
#define RTOSALLOCPRSSEMTAKE
#endif

#define RTOSALLOCPRSSEMGIVE

#ifdef X_ONE_TASK_PER_INSTANCE_SET
extern xEPrsNode xAllocPrsUseMyMemory XPP ((xPrsIdNode PType));
#else
extern xEPrsNode xAllocPrsUseMyMemory XPP ((xPrsIdNode PType, SDL_PId PId));
#endif

/****+***************************************************************
     Structure nodes
********************************************************************/

#ifdef X_ONE_TASK_PER_INSTANCE_SET
typedef struct
  {
    xSignalHeader SaveQ;
    xSignalHeader CurrentInSaveQ;
    xSignalHeader yInSignalPtr;
    char name[100];
    xptrint PrsDataSize;
  }
xPrsInstanceSetVars;
#endif

#define RTOSXPRSIDCOMP0    void              (*RTOSPAD) XPP((UNSIGNED, VOID *));
#define RTOSXPRSIDCOMP1 \
   void     (*PAD_Function) XPP((void *, SDL_PId, xPrsInstanceSetVars *));


#define RTOSXPRSIDCOMP2 \
   void              (*PAD_Function) XPP((void *));

#define RTOSXPRSIDCOMP3 \
    NU_QUEUE *PROCID;

/****+***************************************************************
     SDL PId
********************************************************************/
#define xEq_SDL_PId(A,B)        ((A)==(B))
#define xEq_SDL_PId_NULL(A)     ((A)==(SDL_NULL))
extern SDL_PId xEnvPId;
extern SDL_PId SDL_NULL;

/****+***************************************************************
sctpred.h
********************************************************************/

/****+***************************************************************
01   Typedef, Default value, Literals
********************************************************************/

/****+***************************************************************
     SDL Save
********************************************************************/

/*---+---------------------------------------------------------------
     xSaveSignal
-------------------------------------------------------------------*/
#define RTOSXSAVESIGNAL \
{ \
  /* Insert New signal (yInSignalPtr) last in save queue */ \
  SaveQ->Pre->Suc = (xSaveQ)yInSignalPtr; \
  yInSignalPtr->Suc = (xSignalHeader)SaveQ; \
  yInSignalPtr->Pre = (xSignalHeader)SaveQ->Pre; \
  SaveQ->Pre = (xSaveQ)yInSignalPtr; \
}

/*---+---------------------------------------------------------------
     xKillSaveQ
-------------------------------------------------------------------*/

#define RTOSTEMP_RECEIVER \
  Temp1->Receiver

/*------------------------------------------------------------------------
 *      xInputSignal
 *-----------------------------------------------------------------------*/

#define RTOSCURRENTINSAVEQPTR RTOSCURRENTINSAVEQ

#ifdef X_ONE_TASK_PER_INSTANCE_SET

#define RTOSINSIGNALPTR \
yInstanceSetVars->yInSignalPtr

#define RTOSCURRENTINSAVEQ \
  yInstanceSetVars->CurrentInSaveQ

#define RTOSSTARTUPSIGNAL \
  yInstanceSetVars->yInSignalPtr->SignalCode

#define RTOSSTARTUPSIGNALVARP \
  yInstanceSetVars->yInSignalPtr->Receiver->VarP

#define RTOSSTARTUPSIGNALRESTARTPAD \
  yInstanceSetVars->yInSignalPtr->Receiver->NameNode->PAD_Function;

#define RTOSSTARTUPSIGNALRECEIVER \
  yInstanceSetVars->yInSignalPtr->Receiver

#define RTOSSTARTUPSIGNALPARENT \
  yInstanceSetVars->yInSignalPtr->Sender

#define RTOSXINPUTSIGNALVARS

#define RTOSXINPUTRESTARTPAD_CALL \
  (*(*yVarP)->RestartPAD)(*yVarP,(SDL_PId) \
                        ((*yVarP)->PrsNode)->NameNode->PROCID, \
                         yInstanceSetVars);

#define RTOSXINPUTSIGNAL_SEMS

#else /* X_ONE_TASK_PER_INSTANCE_SET */

#define RTOSINSIGNALPTR \
yVarP->yInSignalPtr

#define RTOSSTARTUPSIGNAL \
(*yVarP)->yInSignalPtr->SignalCode

#ifdef XOPTSIGNALALLOC
#define RTOSSTARTUPSIGNAL_PADFUNCTION \
  *(*(xStartUpSignalHeader)((*yVarP)->yInSignalPtr)).PrsNode->NameNode->PAD_Function;
#else
#define RTOSSTARTUPSIGNAL_PADFUNCTION \
  *(*(xStartUpSignalHeader)((*yVarP)->yInSignalPtr+1)).PrsNode->NameNode->PAD_Function;
#endif /* XOPTSIGNALALLOC */

#define RTOSXINPUTSIGNALVARS \
  STATUS Err ;

#define RTOSCURRENTINSAVEQ \
  (*yVarP)->CurrentInSaveQ

#define RTOSSTARTSIGNAL \
  (*yVarP)->yInSignalPtr->sig_no

#define RTOSSIGNALNO \
  (*yVarP)->yInSignalPtr->SignalCode

#endif /* X_ONE_TASK_PER_INSTANCE_SET */

/****+***************************************************************
     Initialization functions
********************************************************************/

/*---+---------------------------------------------------------------
     xAllocPrs
-------------------------------------------------------------------*/
#define RTOSXALLOCPRS \
{ \
  return(0); \
}

/****+***************************************************************
     SDL Timers
********************************************************************/

#define RTOSTIMER_QUEUEID \
&Timer_Queue

#define RTOSTIMERTASK_VAR \
  STATUS          Err;

#define RTOSTIMERTASKALLOC_Q \
  TimerQ = (xTimerHeader)xAlloc( sizeof(xTimerHeaderRec)); \
  TimerQ->SignalCode = EndOfTimerQueue;

#define RTOSTIMERTASKALLOC_INSIGNAL

#define RTOSSET_SIGNALCODE \
  yInSignalPointer->SignalCode = yInSignalPointer->TimerToSetOrReset;

#define RTOSTIMERTASKVAR_EXTRAS

#define RTOSTIMERQ_PRE \
  TimerQ->Pre

#define RTOSTIMERQ_SUC \
  TimerQ->Suc

#define RTOSTIMERWRAPPTR_PRE \
  (*TimerWrapPtr)->Pre

#define RTOSTIMERWRAPPTR_SUC \
  (*TimerWrapPtr)->Suc

#define RTOSTIMERQ_RECEIVER \
  TimerQ->Sender

#define RTOSTIMERQ_TIMERTIME \
  TimerQ->TimerTime

#define RTOSTIMERSENDER \
  yInSignalPointer->Sender

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define RTOSTIMERSENDER2 \
  (NU_QUEUE *)yInSignalPointer->Sender->NameNode->PROCID
#else
#define RTOSTIMERSENDER2 \
  (NU_QUEUE *)yInSignalPointer->Sender
#endif /* X_ONE_TASK_PER_INSTANCE_SET */

#define RTOSTEMPTIMERSIGNAL_SENDER \
  yInSignalPointer->Sender

#define RTOSTEMPTIMERSIGNAL_PRE \
  yInSignalPointer->Pre

#define RTOSTEMPTIMERSIGNAL_SUC \
  yInSignalPointer->Suc

#define RTOSTEMPTIMERSIGNAL_TIMERTIME \
  yInSignalPointer->TimerTime

#define RTOSXACTIVETIMER_TIMERTOFIND \
  yInSignalPointer->TimerToSetOrReset

#define RTOSXRESETTIMER_TIMERTORESET \
  yInSignalPointer->TimerToSetOrReset

#define RTOSXRESETTIMER_SIGNALID \
  yInSignalPointer->SignalId

#define RTOSTEMPTIMERSIGNAL_RECEIVER \
  TempTimer->Sender

#define RTOSTEMPTIMER_TIMERTIME \
  TempTimer->TimerTime

#define RTOSTEMPTIMERSIGNAL_SIGNO \
  TempTimer->SignalCode

#define RTOSTEMPTIMERSIGNAL_SIGNALID \
  TempTimer->SignalId

#define RTOSTEMPTIMER_PRE \
  TempTimer->Pre

#define RTOSTEMPTIMER_SUC \
  TempTimer->Suc

#define RTOSTEMPTIMER_PRE_SUC \
  TempTimer->Pre->Suc

#define RTOSTEMPTIMER_SUC_PRE \
  TempTimer->Suc->Pre

#define RTOSHELPTEMPTIMER_PRE \
  HelpTempTimer->Pre

#define RTOSHELPTEMPTIMER_SUC \
  HelpTempTimer->Suc

#define RTOSHELPTEMPTIMER_PRE_SUC \
  HelpTempTimer->Pre->Suc

#define RTOSHELPTEMPTIMER_SUC_PRE \
  HelpTempTimer->Suc->Pre

#define RTOSXSDLRESETINTIMERPROCESS_VARS \
  STATUS           Err; \
  xbool         (* yEqFunc)(); \
\
  yEqFunc = yInSignalPointer->yEq;

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define RTOSRESETINTIMER_SENDER \
  (NU_QUEUE *)(yInSignalPointer->Sender)->NameNode->PROCID
#else
#define RTOSRESETINTIMER_SENDER \
  (NU_QUEUE *)yInSignalPointer->Sender
#endif

#define RTOSXSDLRESETINTIMERPROCESS_REPLY \
  Err = NU_Send_To_Queue(RTOSRESETINTIMER_SENDER, &yInSignalPointer, 1, NU_SUSPEND); \
  XOS_ERROR("RTOSXSDLRESETINTIMERPROCESS_REPLY", "NU_Send_To_Queue", Err)

#define RTOSOSTIME \
  SDL_Time

#define RTOSSDLNOW1

#define RTOSSDLNOW2 \
  SDL_Now()

#define RTOSGETCURRENTTIME2 \
  CurrentTime = RTOSSDLNOW2;

#define RTOSTIMERRECEIVE(SIGPTR,SELF,WAITTIME, QID) \
  while( (Err = NU_Receive_From_Queue(&Timer_Queue, &yInSignalPointer, 1, &received_size, NU_SUSPEND)) == NU_TIMEOUT) \
     XERROR_RECEIVED_WITH_TIMEOUT("RTOSTIMERRECEIVE") \
  XOS_ERROR("RTOSTIMERRECEIVE", "NU_Receive_From_Queue", Err)

#define RTOSTIMERQ_SUC_TIMERTIME \
  TimerQ->Suc->TimerTime

#define RTOSXTIMER_SUC \
  yOutputSignalPtr->Suc

#define RTOSTIMERQ_SUC_PRE \
  TimerQ->Suc->Pre

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define RTOSOUTPUTSIGNAL_RECEIVER \
  yOutputSignalPtr->Sender->NameNode->PROCID
#else
#define RTOSOUTPUTSIGNAL_RECEIVER \
  yOutputSignalPtr->Sender
#endif /* X_ONE_TASK_PER_INSTANCE_SET */

#define RTOSRECEIVE_MESSAGE2 \
  Err = NU_Receive_From_Queue(&Timer_Queue, &yInSignalPointer, 1, &received_size, (TimerQ->Suc->TimerTime - CurrentTime));\
  if (Err == NU_TIMEOUT) { \
    yInSignalPointer = NIL; \
  } \
  else { \
    XOS_ERROR("RTOSRECEIVE_MESSAGE2", "NU_Receive_From_Queue", Err) \
  }

#define RTOSTEMPTIMERSIGNAL_SIG_NO \
  yInSignalPointer->SignalCode

#define RTOSSENDTIMERFREE_OUTPUT \
  yOutputSignalPtr = NULL;

/*---+---------------------------------------------------------------
     env
-------------------------------------------------------------------*/
#define RTOSRTOSPAD_HEAD \
  extern void NUCLEUSPAD_env XPP((UNSIGNED argc, VOID *argv))

#ifdef XENV
#define RTOSRTOSPAD_ENV \
  RTOSRTOSPAD_HEAD \
  { \
  }

#else

#define RTOSRTOSPAD_ENV \
  RTOSRTOSPAD_HEAD \
  { \
  }

#endif /* XENV */

/****+***************************************************************
     sctsdl.c
********************************************************************/
/*---+---------------------------------------------------------------
     xAlloc
-------------------------------------------------------------------*/
#define RTOSXALLOC \
{ \
  VOID *Mem_Ptr; \
  /* standard implementation: */ \
  if ( Size > (xptrint)0 ) { \
    Err = NU_Allocate_Memory(&System_Memory, &Mem_Ptr, Size, NU_NO_SUSPEND); \
    XOS_ERROR("RTOSXALLOC", "NU_Allocate_Memory", Err) \
	memset(Mem_Ptr, 0, Size);\
    return(Mem_Ptr); \
  } \
  else \
    return (void *)0; \
}

/*---+---------------------------------------------------------------
     xFree
-------------------------------------------------------------------*/
#define RTOSXFREE \
{ \
  VOID *Mem_Ptr; \
  Mem_Ptr = *P; \
  if (*P != 0) { \
    Err = NU_Deallocate_Memory(Mem_Ptr); \
    XOS_ERROR("RTOSXFREE", "NU_Deallocate_Memory", Err) \
  *P = (void *)0; \
  } \
      }


/* Macro to access the SignalCode (or number) with
   a given Pointer to a SignalHeaderStruct 
 */
#define RTOS_SIGNAL_SIGNAL_CODE(XSIGPTR) (XSIGPTR)->SignalCode

/* Macro to access the Signal Parameters with
   a given Pointer to a SignalHeaderStruct
 */
#define RTOS_SIGNAL_VAR_PTR(XSIGPTR) ((xSignalHeader)((XSIGPTR))+1)


#endif /* _sctnucleus_h */
