/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.3.23566 at Sat Nov 17 11:52:49 AM CET 2012
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1999, 2012.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/******************************************************************

External task for the example Simple.
Solaris tight integration version.

*******************************************************************/

#include "scttypes.h"
#include "simple.hs"
#include "simple.ifc"

/****+***************************************************************
     Simple example: MyExtTask
********************************************************************/

void           *
MyExtTask(void *dummy)
{
    xSignalHeader   yOutputSignalPtr, yInputSignalPtr;
    SDL_PId         MyOwnPId;
    xPrsIdRec       NameNodeStruct;
    xEPrsRec        MyEPrsStruct;
    mqd_t           QueuePId;
    int             i;
#ifdef X_ONE_TASK_PER_INSTANCE_SET
	char *          pchMyProcName = "MyExtTask_ISET";
#else
	char *          pchMyProcName = "MyExtTask_INST";
#endif
	char *          pchMyProcIdName = "/ExtTask";
#if (defined XMSC_TRACE) || (defined XOS_TRACE)
    char *          pchMyInSignalName = "ok";
	char *          pchMyOutSignalName = "go";
#endif

#ifdef X_ONE_TASK_PER_INSTANCE_SET
    MyOwnPId = &MyEPrsStruct;
    MyOwnPId->NameNode = &NameNodeStruct;
    MyOwnPId->NameNode->PROCID = pchMyProcIdName;
#else
    MyOwnPId = pchMyProcIdName;
#endif

#ifdef XMSC_TRACE
#ifdef XMSC_EDITOR
    RTOSMSCPRINT_START
    sprintf(msce_buf, "%lu %s %s %s", MyOwnPId, ": instancehead process ", pchMyProcName, ";");
    RTOSMSCPRINT_STOP
#else
    XMSC_TRACE_STATIC_CREATE(MyOwnPId, pchMyProcName);
#endif
#elif XOS_TRACE
    XOS_TRACE_STATIC_CREATE( MyOwnPId, pchMyProcName);
#endif

    for (i = 1; i <= 2; i++)
    {
        yOutputSignalPtr = (xSignalHeader) xAlloc(sizeof(xSignalHeaderRec) + sizeof(yPDef_go));
        yOutputSignalPtr->SignalCode = go;
#ifdef X_ONE_TASK_PER_INSTANCE_SET
        yOutputSignalPtr->Receiver = pr1[i];
#endif
        yOutputSignalPtr->Sender = MyOwnPId;
        if (i == 1)
            ((yPDef_go *) (yOutputSignalPtr + 1))->Param1 = startinstance1;
        else
            ((yPDef_go *) (yOutputSignalPtr + 1))->Param1 = startinstance2;

#ifdef XMSC_TRACE
        SignalId = SignalId + 1;
        yOutputSignalPtr->SignalId = SignalId;
        yOutputSignalPtr->IsTimer = 0;
#ifdef XMSC_EDITOR
        RTOSMSCPRINT_START
        sprintf(msce_buf, "%lu %s %s %s %d %s %lu %s", \
           yOutputSignalPtr->Sender, ": out ", pchMyOutSignalName, ",", SignalId, " to ", pr1[i], ";");
        RTOSMSCPRINT_STOP
#else
        XMSC_FPRINT(("%lu: out %s,%d to %lu;\n", yOutputSignalPtr->Sender, \
           pchMyOutSignalName, SignalId, pr1[i]))
#endif
#elif XOS_TRACE
        printf("%s: signal %s sent\n", pchMyProcName, pchMyOutSignalName);
#endif

#ifdef X_ONE_TASK_PER_INSTANCE_SET
        QueuePId = mq_open((char *) pr1[i]->NameNode->PROCID, 2, 0, 0);
#else
        QueuePId = mq_open((char *) pr1[i], 2, 0, 0);
#endif
        mq_open_ERROR(pchMyProcName, "mq_open", QueuePId);
        Err = mq_send(QueuePId, (char *) yOutputSignalPtr,
                      sizeof(xSignalHeaderRec) + sizeof(yPDef_go),
                      NULL);
        XOS_ERROR(pchMyProcName, "mq_send", Err);
        Err = mq_close(QueuePId);
        XOS_ERROR(pchMyProcName, "mq_close", Err);
        xFree( (void * *) &yOutputSignalPtr);
    }

    for (i = 1; i <= 2; i++)
    {
        yInputSignalPtr = xAlloc(4096);
        /* waiting for signal ok */
        QueuePId = mq_open( pchMyProcIdName, 2, 0, 0);
        mq_open_ERROR(pchMyProcName, "mq_open", QueuePId);
        Err_Rec = mq_receive(QueuePId, (char *) yInputSignalPtr, 4096, NULL);
        if (yInputSignalPtr->SignalCode == ok)
        {
#ifdef XMSC_TRACE
#ifdef XMSC_EDITOR
          RTOSMSCPRINT_START
#ifdef X_ONE_TASK_PER_INSTANCE_SET
          sprintf(msce_buf, "%lu %s %s %s %d %s %ld %s", \
                yInputSignalPtr->Receiver, ": in ", pchMyInSignalName, ",", \
                yInputSignalPtr->SignalId, " from ", yInputSignalPtr->Sender, ";");
#else
          sprintf(msce_buf, "%lu %s %s %s %d %s %ld %s", \
                MyOwnPId, ": in ", pchMyInSignalName, ",", \
                yInputSignalPtr->SignalId, " from ", yInputSignalPtr->Sender, ";");
#endif
          RTOSMSCPRINT_STOP
#else 
          XMSC_FPRINT(("%lu: in %s,%d from %lu;\n", \
                      yInputSignalPtr->Receiver, pchMyInSignalName, \
                      yInputSignalPtr->SignalId, yInputSignalPtr->Sender))
#endif
#elif XOS_TRACE
          printf("%s: in %s from %lu;\n",
                     pchMyProcName, pchMyInSignalName, yInputSignalPtr->Sender);
#endif
        }
        Err = mq_close(QueuePId);
        XOS_ERROR(pchMyProcName, "mq_close", Err);
        xFree( (void * *) &yInputSignalPtr);
    }
    Err = mq_unlink(pchMyProcIdName);
    XOS_ERROR(pchMyProcName, "mq_unlink", Err);
#ifdef sctMyCALL_EXIT
#ifdef XMSC_TRACE
    XMSC_FPRINT(("%lu: stop;\n", MyOwnPId));
#elif XOS_TRACE
    printf("%s: stopped\n\n", pchMyProcName);
#endif
    exit(0);
#endif
}

