/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.3.23566 at Sat Nov 17 11:52:49 AM CET 2012
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1999, 2012.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

/* 
Filename: sctEnv.c

     1.   The primary purpose of this file is to be a template for
          the standard signal I/O interface for a SDL-system generated
          by SDT.
     2.   The secondary purpose is to serve as a "dummy" for the
          user supplied environment module during early system
          testing.
     3.   Also included in this file are a set of rudimentary
          functions that can be used for signal and process
          logging in a target (or host) environment.

          All the C-functions in this file are intended to be 
          modified according to actual user requirements.
          Therefore, a good strategy is to leave an unmodified
          copy of this file in its original directory, and to 
          make any modifications in copies placed in other
          directories. The reason for this is that the standard
          Makefile which is supplied with the SDT Master Library
          assumes that a compilable copy of this file resides
          in the $sdtdir/INCLUDE directory for the purpose
          in paragraph 2.

FILE INDEX
00   Include Files
01   Global Variables
02   Environment routines
03   Signal and Process logging
*/


/****+***************************************************************
00   Include Files
********************************************************************/

#include "scttypes.h"

/*
   Here is where you may include signal and process definitons from
   your SDL system.
   Prerequisite: either you have turned on the 'generate env header'
   option in the SDT Analyzer Generate Option menu or, you have a
   manually produced header file with SDL system definitions.
   Usage: replace MySDLSystemName with your SDL system name and
   remove the comment characters surrounding the include statment
   below. */
#include "simple.ifc"

/*
#ifdef XENV
*/
/****+***************************************************************
01   Global Variables
********************************************************************/
/*
#ifndef XREADANDWRITEF
#ifdef XSIGLOG
#include <stdio.h>
#endif
#endif
*/

/****+***************************************************************
02   Environment routines
********************************************************************/

/*---+---------------------------------------------------------------
     xGlobalNodeNumber  extern
-------------------------------------------------------------------*/
#ifndef XNOPROTO
extern int xGlobalNodeNumber(void)
#else
extern int xGlobalNodeNumber()
#endif
{
/*
   Assign a unique global system Id to each SDL system in a cluster of
   systems.
*/
  return 1;
}

/*---+---------------------------------------------------------------
     xInitEnv  extern
-------------------------------------------------------------------*/
#ifndef XNOPROTO
extern void xInitEnv(void)
#else
extern void xInitEnv()
#endif
{
/*
   Code to initialize your SDL-system environment may be inserted here.
*/

#ifdef XTRACE
  xPrintString("xInitEnv: Called but did nothing!\n");
#endif
}

/*---+---------------------------------------------------------------
     xCloseEnv  extern
-------------------------------------------------------------------*/
#ifndef XNOPROTO
extern void xCloseEnv(void)
#else
extern void xCloseEnv()
#endif
{
/*
   Code to bring down the environment in a controlled manner
   may be inserted here.
*/

#ifdef XTRACE
  xPrintString("xCloseEnv: Called but did nothing!\n");
#endif
}

/*---+---------------------------------------------------------------
     xOutEnv  extern
-------------------------------------------------------------------*/
#ifndef XNOPROTO
extern void xOutEnv( xSignalNode  *S ) 
#else
extern void xOutEnv( S )
  xSignalNode  *S;
#endif
{

/*
   Below is a template for a xOutEnv implementation.
*/

  if ( ((*S)->NameNode) == ok ) {
    
   printf("Signal Ok received with the following parameter:%lu\n",
           ((yPDef_ok *)(*S))->Param1);
   xReleaseSignal( S );
   return;
  }
/*
   The code below, controlled by the XTRACE macro, is an option for
   limited host debugging of the environment module.
*/
#ifdef XTRACE
#ifdef XIDNAMES
  char  Temp[100];
  sprintf(Temp, "xOutEnv:  %s has been received by Env:1\n",
          (*S)->NameNode->Name );
  xPrintString(Temp);
#else
  xPrintString("xOutEnv:  One signal has been received by Env:1\n");
#endif
#endif


  /* discard all unimplemented signals */
  xReleaseSignal( S );
}

/*---+---------------------------------------------------------------
     xInEnv  extern
-------------------------------------------------------------------*/
extern
#ifndef XTENV
  void
#else
  SDL_Duration
#endif

#ifndef XNOPROTO
 xInEnv( SDL_Time Time_for_next_event )
#else
xInEnv( Time_for_next_event )
 SDL_Time Time_for_next_event;
#endif
{
  xSignalNode S;
  static int SendGo = 0;
 

  if(SendGo<=1){
     if(SendGo==0) {
       S = xGetSignal(go,  pr1[1],   xEnv );
       ((yPDef_go *)(S))->Param1 = startinstance1;
     }
     else {
       S = xGetSignal(go,  pr1[2],   xEnv );
       ((yPDef_go *)(S))->Param1 = startinstance2;
     }
     SDL_Output( S, xSigPrioPar(xDefaultPrioSignal) (xIdNode *)0 );
     SendGo++;
  }
}


/****+***************************************************************
03   Signal and Process logging
********************************************************************/

#ifdef XSIGLOG
/*
   Replace "(void)putchar(P)" with your function that sends
   one character to the appropriate log device.
   XPOST_MORTEM_TRACE writes the trace on a ring buffer
   instead of to some output port ( default sdtout ).
*/
#ifndef XPOST_MORTEM_TRACE

#define xPut( P )   (void)putchar( P )

#else
/*
   This section writes the last trace messages on to a ring
   buffer for 'post-mortem' analysis. The last written entry
   as suffixed by a '*'. To output this buffer to the appropriate
   port you may use a function like the one below, activated by
   some unused interrupt.
   void _interrupt_n coredump()
    {
     int i;
     for (i = 0; i < PMBUFF ; *Port_n = xPostMortemBuffer[i++]);
    }
*/
#define xPut( P )   xPostMortemPutchar( P )

#ifndef PMBUFF
#define PMBUFF 0x100
#endif
char   xPostMortemBuffer[PMBUFF];

 static void
#ifndef XNOPROTO
xPostMortemPutchar( char C )
#else
xPostMortemPutchar( C )
  char C;
#endif
{
  static char *xPostMortemPrintAt = xPostMortemBuffer ;
  *xPostMortemPrintAt = xPostMortemBuffer ;

  if ( xPostMortemPrintAt >= (xPostMortemBuffer + PMBUFF) )
    xPostMortemPrintAt = xPostMortemBuffer;
  *xPostMortemPrintAt++ = C;
  *xPostMortemPrintAt = '*';
}
#endif

/*---+---------------------------------------------------------------
     xPutString
-------------------------------------------------------------------*/
 static void
#ifndef XNOPROTO
xPutString ( char * StrPtr )
#else
xPutString ( StrPtr )
  char * StrPtr;
#endif
{
  while( *StrPtr != '\0' ) { xPut( *StrPtr++ ); }
}

/*---+---------------------------------------------------------------
     xSignalLog
-------------------------------------------------------------------*/
#ifndef XNOPROTO
 extern void
xSignalLog  (xSignalNode Signal,
             int         NrOfReceivers,
             xIdNode    *Path,
             int         PathIndex )
#else
 extern void
xSignalLog  ( Signal, NrOfReceivers, Path, PathIndex )
             xSignalNode Signal;
             int         NrOfReceivers;
             xIdNode    *Path;
             int         PathIndex;
#endif
{
  /* Note that if XOPTCHAN is defined, the parameters Path and
     PathIndex will not contain any information */

  if (Signal->NameNode->EC == xStartUpSignalEC) {
    xPutString( "CREATE " );
    xPutString( Signal->Receiver.LocalPId->PrsP->NameNode->Name );
    xPutString("\n");
  } else {
    if (NrOfReceivers != 1)
      xPutString( "ERROR in " );
    else if (Signal->NameNode->EC == xTimerEC)
      xPutString( "TIMER " );
    xPutString( "OUTPUT ");
    xPutString( Signal->NameNode->Name );
    if (!xEq_SDL_PId_NULL(Signal->Receiver))
      if (Signal->Receiver.LocalPId->PrsP->NameNode != (xPrsIdNode)0){
        xPutString( " TO " );
        xPutString( Signal->Receiver.LocalPId->PrsP->NameNode->Name );
      }
    xPutString("\n");
  }
}

/*---+---------------------------------------------------------------
     xProcessLog
-------------------------------------------------------------------*/
 extern void
#ifndef XNOPROTO
xProcessLog (xPrsNode P)
#else
xProcessLog ( P )
  xPrsNode P;
#endif
{
  xPutString("\n");
  if (P->Signal->NameNode->EC == xStartUpSignalEC) {
    xPutString( "START TRANSITION BY " );
    xPutString( P->NameNode->Name );
    xPutString("\n");
  } else {
    xPutString( "INPUT " );
    xPutString( P->Signal->NameNode->Name );
    xPutString( " BY PROCESS " );
    xPutString( P->NameNode->Name );
    xPutString( " IN STATE " );
    xPutString( P->NameNode->StateList[P->State]->Name );
    xPutString("\n");
    if (P->ActivePrd != (xPrdNode)0) {
      xPutString( "            IN PROCEDURE " );
      xPutString( P->ActivePrd->NameNode->Name );
      xPutString( " IN STATE " );
      xPutString( P->ActivePrd->NameNode->StateList
                    [P->ActivePrd->State]->Name );
      xPutString("\n");
    }
  }
}

#endif
       /* XSIGLOG */
