/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.3.23566 at Sat Nov 17 11:52:49 AM CET 2012
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1999, 2012.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/******************************************************************

  C-code macros for RTOS-integrations

  To be used with Cadvanced SDL to C Compiler 4.4
  
*******************************************************************/

/****+***************************************************************
     General macros
********************************************************************/
/* If function prototypes then XPP(x) defined as x */
/* If old style functions then define XPP(X) as () and
   XNOPROTO should be defined */
#define XPP(x)  x

/* xptrint should be the same length as a pointer */
#define xptrint unsigned
#define xint32 long int    /* xint32 only used for Time/Duration */

#define XCONST
#define XCONST_COMP
#define XCONST_CHAN

typedef struct xEPrsStruct *xEPrsNode;
typedef XCONST struct xIdStruct           *xIdNode;
typedef XCONST struct xPrsIdStruct        *xPrsIdNode;
#ifdef XOPTSIGNALALLOC
typedef XCONST struct xSignalIdStruct     *xSignalIdNode;
typedef struct xSignalHeaderStruct     *xSignalNode;
extern void xReleaseSignal XPP((xSignalNode *));

extern struct xSignalIdStruct TimerIdDummy;

#endif

#define xbool int

/****+***************************************************************
     Macros to Implement SDL
********************************************************************/
#define ALLOCPRSSIGNAL          31999
#define REPLYALLOCPRSSIGNAL     31998
#define EndOfTimerQueue         31997
#define ActiveTimer             31996
#define ResetTimer              31995
#define TimerWasFound           31994
#define RemoveTimers            31993
#ifdef WIN32_INTEGRATION
#define XXXSetTimer             31992 /* SetTimer is a reserved word in Win32 */
#else
#define SetTimer                31992
#endif

/* ------------------------ Execution trace ---------------------- */
#ifdef XMSC_EDITOR

#define XMSC_FPRINT(PARAM) \
RTOSMSCPRINT_START \
   sprintf PARAM; \
RTOSMSCPRINT_STOP

#else

#define XMSC_FPRINT(PARAM) \
RTOSMSCPRINT_START \
   printf PARAM; \
RTOSMSCPRINT_STOP

#endif  /* XMSC_EDITOR */
/****+***************************************************************
     os
********************************************************************/
extern void * xAlloc  XPP(( xptrint  Size ));
#ifdef OSE_INTEGRATION
extern void * memset  XPP(( void *s, int c, int n ));
#elif VXWORKS_INTEGRATION
extern void * memset  XPP(( void *s, int c, size_t n ));
#endif
extern void xFree XPP(( void * *  P ));

/*********************************************************************
	Free function for discarded signals
*********************************************************************/
#ifdef XFREESIGNALFUNCS
extern void RegSignalFreeFunc(int SignalCode, void (* xFree_Sig)(void * SVarP) );
extern void CallSignalFreeFunc( int SignalCode, void *SVarP );

typedef struct xFreeFuncList *xFreeFuncListPtr;
typedef struct xFreeFuncList {
  int SignalCode;
  void (*xFree_Sig)(void * );
  xFreeFuncListPtr Next;
} xFreeFuncListRec;


extern xFreeFuncListPtr xFreeFuncStructPtr;
extern xFreeFuncListPtr xHeadFreeFuncStructPtr;

/*  
 * The macro, XTIMERSWITHSTRINGPARAMS, should be set if you use timers  
 * with STRING type parameters, e.g. charstring, bit_string, octet_string, 
 * general arrays, general powersets, strings etc.
 * Otherwise it should be left undefined as this will give better
 * performance.
 */
/*
#ifndef XTIMERSWITHSTRINGPARAMS
#define XTIMERSWITHSTRINGPARAMS
#endif
*/
/* uses the macros 
     RTOS_SIGNAL_SIGNAL_CODE,
     RTOS_SIGNAL_VAR_PTR,
     RTOS_TIMER_TO_RE_SET and
	 RTOS_TIMER_VAR_PTR
   from the sct<RTOS>.h file to acces the xSignalHeaderStruct
   and xTimerHeaderStruct items.
*/



#ifdef OSE_D_INTEGRATION

#define RTOSCALLSIGNALFREEFUNC(XSIGNALPTR) \
	CallSignalFreeFunc(RTOS_SIGNAL_SIGNAL_CODE(XSIGNALPTR),(xTimerHeader)RTOS_SIGNAL_VAR_PTR(XSIGNALPTR));
 
#define RTOSCALLSIGNALFREEFUNCSAVEQ(XSIGNALPTR) \
	CallSignalFreeFunc(RTOS_SAVEQ_SIGNAL_CODE(XSIGNALPTR), RTOS_SAVEQ_SIGNAL_VAR_PTR(XSIGNALPTR));
#else	 /* OSE_D_INTEGRATION*/

#define RTOSCALLSIGNALFREEFUNC(XSIGNALPTR) \
{\
	if ((XSIGNALPTR)->IsTimerSignal)\
	  CallSignalFreeFunc(RTOS_SIGNAL_SIGNAL_CODE(XSIGNALPTR),(xTimerHeader)RTOS_SIGNAL_VAR_PTR(XSIGNALPTR));\
    else\
	  CallSignalFreeFunc(RTOS_SIGNAL_SIGNAL_CODE(XSIGNALPTR),(xSignalHeader)RTOS_SIGNAL_VAR_PTR(XSIGNALPTR));\
} 



#define RTOSCALLSIGNALFREEFUNCSAVEQ(XSIGNALPTR)\
{\
	if ((XSIGNALPTR)->IsTimerSignal)\
	  CallSignalFreeFunc(RTOS_SIGNAL_SIGNAL_CODE(XSIGNALPTR),(xTimerHeader)RTOS_SIGNAL_VAR_PTR(XSIGNALPTR));\
    else\
	  CallSignalFreeFunc(RTOS_SIGNAL_SIGNAL_CODE(XSIGNALPTR),(xSignalHeader)RTOS_SIGNAL_VAR_PTR(XSIGNALPTR));\
} 
#endif /* OSE_D_INTEGRATION */

#ifdef XTIMERSWITHSTRINGPARAMS
/* ------------------------ Timer with String Parameters --------- */

#define RTOSFREETIMERSTRINGPARAMS1(XSIGNALPTR) \
CallSignalFreeFunc(RTOS_SIGNAL_SIGNAL_CODE(XSIGNALPTR), RTOS_SIGNAL_VAR_PTR(XSIGNALPTR));

#define RTOSFREETIMERSTRINGPARAMS2(XSIGNALPTR) \
CallSignalFreeFunc(RTOS_TIMER_TO_RE_SET(XSIGNALPTR), RTOS_TIMER_VAR_PTR(XSIGNALPTR));

#else   /* XTIMERSWITHSTRINGPARAMS */
/* ------------------------ NO timers with string parameters ----- */

#define RTOSFREETIMERSTRINGPARAMS1(XSIGNALPTR)

#define RTOSFREETIMERSTRINGPARAMS2(XSIGNALPTR)

#endif  /* XTIMERSWITHSTRINGPARAMS */

#else   /* XFREESIGNALFUNCS */
/* ------------------------ NO free functions for discarded signals*/
#define RTOSCALLSIGNALFREEFUNC(XSIGNALPTR)

#define RTOSCALLSIGNALFREEFUNCSAVEQ(XSIGNALPTR)

#define RTOSFREETIMERSTRINGPARAMS1(XSIGNALPTR)

#define RTOSFREETIMERSTRINGPARAMS2(XSIGNALPTR)

#endif  /* XFREESIGNALFUNCS */

/*---+---------------------------------------------------------------
     Timer Task
-------------------------------------------------------------------*/
/*
extern void xTimerTask XPP(( void ));
*/
