/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.3.23566 at Sat Nov 17 11:52:49 AM CET 2012
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1999, 2012.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/******************************************************************

  C-code macros and functions for Neutrino 2.11 tight integration

  To be used with Cadvanced SDL to C Compiler 4.4
  
*******************************************************************/

#ifndef _sctneutrino_h
#define _sctneutrino_h

#define _REENTRANT
#define _POSIX_PTHREAD_SEMANTICS

#include <signal.h>
#include <pthread.h>
#include <errno.h>
#include <mqueue.h>
#include <semaphore.h>
#include <time.h>
#include <malloc.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/mman.h>
#include <fcntl.h>
#include <unistd.h>


#include "sctcommon.h"

#define DEF_STACK_SIZE 15000
#define MAXMSGLENGTH 500
#define MAXNOOFMSG 1000
#define MAXMSGSIZE 500
#define QUEUEFLAG  O_RDWR|O_CREAT  /*258 O_RDWR|O_CREAT */
#define QUEUEMODE 438 /*(438)0666 read and write permission */


#define RTOSPRIODEFAULT 8

#ifndef xTimerPrioProcess
#define xTimerPrioProcess 10
#endif

#ifndef xPrintPrioProcess
#define xPrintPrioProcess 9
#endif

extern int Err;
extern ssize_t Err_Rec;
extern char *xEnvPIdQ;
extern sem_t taskSem;
extern sem_t Count_Sem;
extern sem_t Mem_Sem;
extern sem_t psmidmsc;
extern sem_t psmidmsc2;
extern int createdProcesses;
extern pthread_mutex_t createdProcesses_Mutex;
extern mqd_t TimerPIdQ;
extern pthread_attr_t Attributes;
extern struct mq_attr mq_attr;
extern timer_t TimerId;
extern char msce_buf[1024];

#define RTOSGLOBAL_VAR	\
    int Err; \
	ssize_t Err_Rec; \
	char *xEnvPIdQ; \
	sem_t taskSem; \
	sem_t Count_Sem; \
	sem_t Mem_Sem; \
	sem_t psmidmsc; \
	sem_t psmidmsc2; \
	mqd_t TimerPIdQ; \
	int createdProcesses= 0; \
	pthread_mutex_t createdProcesses_Mutex; \
	extern unsigned long tickGet(); \
	extern void signal_handler(); \
	struct sigaction act; \
	sigset_t signal_set; \
	pthread_attr_t Attributes; \
	struct mq_attr mq_attr; \
	timer_t TimerId; \
	char msce_buf[1024];

#ifdef X_ONE_TASK_PER_INSTANCE_SET
typedef xEPrsNode SDL_PId;
#else
typedef char *SDL_PId;
#endif
#define NIL NULL


/****+***************************************************************
     SDL Signal, Timer and Now
********************************************************************/
/****+***************************************************************
01   Typedef, Default value, Literals
********************************************************************/

#include "sctpred.h"

#define SDT_TICKPERSEC 1000
#define SDT_NANOSECPERTICK 1000000

/* NOTE! xTimerHeaderRec and xSignalHeaderRec areidentical except
   for TimerTime last in xTimerHeaderRec. This means that it is
   possible to cast pointer between these two types freely as long
   as the TimerTime component is not accessed. */
#define SIGNAL_VARS
#define TIMER_VARS

#define XSIGNALHEADERTYPE xSignalHeaderRec

#define STARTUP_VARS \
   xEPrsNode PrsNode;

typedef struct xSignalHeaderStruct *xSignalHeader;
typedef struct xSignalHeaderStruct {
      int            SignalCode;
      xSignalHeader  Pre, Suc;
      SDL_PId        Sender;
  void          *SigP;
#ifdef X_ONE_TASK_PER_INSTANCE_SET
      SDL_PId        Receiver;
#endif
#ifndef XNOTIMERPARAMS
      int            IsTimerSignal;
      int            SigSize;
#endif
#ifdef XMSC_TRACE
      int            SignalId;
      int            IsTimer;
#endif
} xSignalHeaderRec;

/* Macro to access the SignalCode (or number) with
   a given Pointer to a SignalHeaderStruct 
*/
#define RTOS_SIGNAL_SIGNAL_CODE(XSIGPTR) (XSIGPTR)->SignalCode

/* Macro to access the Signal Parameters with
   a given Pointer to a SignalHeaderStruct
   */
/*#define RTOS_SIGNAL_VAR_PTR(XSIGPTR) (XSIGPTR)->SigP*/
/* SigP cant be used because POSIX mqueues copy the signalstruct */
#define RTOS_SIGNAL_VAR_PTR(XSIGPTR) (XSIGPTR)+1


typedef struct xStartUpSignalHeaderStruct *xStartUpSignalHeader;
typedef struct xStartUpSignalHeaderStruct {
  STARTUP_VARS
} xStartUpSignalHeaderRec;

typedef struct xTimerHeaderStruct *xTimerHeader;
typedef struct xTimerHeaderStruct {
      int            SignalCode;
      xTimerHeader   Pre, Suc;
      SDL_PId        Sender;
  void          *SigP;
#ifdef X_ONE_TASK_PER_INSTANCE_SET
      SDL_PId        Receiver;
#endif
#ifndef XNOTIMERPARAMS
      int            IsTimerSignal;
      int            SigSize;
#endif
#ifdef XMSC_TRACE
      int            SignalId;
      int            IsTimer;
#endif
      SDL_Time       TimerTime;
      int            TimerToSetOrReset;
      xbool          (* yEq)();
      xbool          TestParams;
      xTimerHeader   Param;
} xTimerHeaderRec;

/* Macro to access the number of Timer to set or rest with
   a given Pointer to a Timer HeaderStruct.
   */
#define RTOS_TIMER_TO_RE_SET(XSIGPTR) (XSIGPTR)->TimerToSetOrReset

   /* Macro to access the Signal Parameters with
   a given Pointer to a SignalHeaderStruct
   */
#define RTOS_TIMER_VAR_PTR(XSIGPTR) (XSIGPTR)->SigP


#define RTOSTASK_TYPE char *
#define RTOSSIGNAL_DEF \
xSignalHeader
#define RTOSHANDLEMESS_TYPE
#define RTOSHANDLESIG_PAR
#define RTOSTIMER_DEF \
xTimerHeader

#define XOS_ERROR(STRING1, STRING2, ERRCODE) \
  if (ERRCODE != 0) { \
    printf("Error during %s found in Neutrino 2.11 function %s. Error code %s\n", \
            STRING1, STRING2, strerror(errno)); \
    fflush(stdout); \
   }

#define mq_receive_ERROR(STRING1, STRING2, ERRCODE) \
  if (ERRCODE == -1) { \
    printf("Error during %s found in Neutrino 2.11 function %s. Error code %s\n", \
            STRING1, STRING2, strerror(errno)); \
    fflush(stdout); \
   }

#define mq_open_ERROR(STRING1, STRING2, ERRCODE) \
  if (ERRCODE == (mqd_t)-1) { \
    printf("Error during %s found in Neutrino 2.11 function %s. Error code %s\n", \
            STRING1, STRING2, strerror(errno)); \
    fflush(stdout); \
   }

/****+***************************************************************
     Macros to Implement SDL
********************************************************************/

#ifdef X_ONE_TASK_PER_INSTANCE_SET
static  void * NEUTRINOQ_env;

#define RTOSXPROCESSDEF_C(PROC_NAME, PROC_NAME_STRING, PREFIX_PROC_NAME,PAD_FUNCTION, VDEF_TYPE) \
extern void *XCAT(NEUTRINOPAD_,PREFIX_PROC_NAME) XPP(( \
  void *InputPortQ)) \
{ \
  xPrsInstanceSetVars   yInstanceSetVars; \
  yInstanceSetVars.SaveQ = (xSaveQ)xAlloc(sizeof(xSaveQStruct)); \
  yInstanceSetVars.SaveQ->Suc = yInstanceSetVars.SaveQ; \
  yInstanceSetVars.SaveQ->Pre = yInstanceSetVars.SaveQ; \
  yInstanceSetVars.CurrentInSaveQ = yInstanceSetVars.SaveQ; \
  yInstanceSetVars.PrsDataSize = sizeof(VDEF_TYPE); \
  strcpy( yInstanceSetVars.name, PROC_NAME_STRING); \
  Err = sem_wait(&taskSem); \
  XOS_ERROR("OUTPUT", "sem_wait", Err) \
  PAD_FUNCTION((void *)0, (SDL_PId)InputPortQ, &yInstanceSetVars ); \
}

#define RTOSXPROCESSDEF_H(PROC_NAME, PROC_NAME_STRING, PREFIX_PROC_NAME, PAD_FUNCTION, VDEF_TYPE) \
extern void *XCAT(NEUTRINOPAD_,PREFIX_PROC_NAME) XPP(( \
  void *InputPortQ)); \
static void * XCAT(NEUTRINOQ_,PREFIX_PROC_NAME);

#else

#define RTOSXPROCESSDEF_C(PROC_NAME, PROC_NAME_STRING, PREFIX_PROC_NAME, PAD_FUNCTION, VDEF_TYPE) \
 extern void * XCAT(NEUTRINOPAD_,PREFIX_PROC_NAME) XPP(( \
  void *Self)) \
{ \
 /* SDL_PId Self_tempPtr; */ \
  VDEF_TYPE  yVarPVar; \
  VDEF_TYPE *yVarP = &yVarPVar; \
  char * Self_tempPtr=Self; /* 1003244 (PD) MAS */ \
  yVarP->RestartAddress = 0; \
  yVarP->PrsNode = 0; \
  yVarP->RestartPAD = PAD_FUNCTION; \
  yVarP->ActivePrd = (xPrdNode)0; \
  yVarP->Offspring = SDL_NULL; \
  yVarP->Parent = SDL_NULL; \
  yVarP->Self = Self_tempPtr; \
  yVarP->Sender = Self_tempPtr;\
  yVarP->State = START_STATE; \
  yVarP->StateAfterRPC = 0; \
  yVarP->FirstTime = 1; \
  yVarP->SaveQ = (xSaveQ)xAlloc(sizeof(xSaveQStruct)); \
  yVarP->SaveQ->Suc = yVarP->SaveQ; \
  yVarP->SaveQ->Pre = yVarP->SaveQ; \
  yVarP->CurrentInSaveQ = yVarP->SaveQ; \
  yVarP->pREPLY_Waited_For = (XSIGTYPE)0; \
  strcpy( yVarP->ProcName, PROC_NAME_STRING); \
  Err = sem_wait(&taskSem); \
  XOS_ERROR("OUTPUT", "sem_wait", Err) \
  PAD_FUNCTION((void *)yVarP); \
}

#define RTOSXPROCESSDEF_H(PROC_NAME, PROC_NAME_STRING, PREFIX_PROC_NAME, PAD_FUNCTION, VDEF_TYPE) \
extern void *XCAT(NEUTRINOPAD_,PREFIX_PROC_NAME) XPP((\
  void *Self));

#endif
       /* X_ONE_TASK_PER_INSTANCE_SET */


/* ----------------- Extra components in IdNodes ----------------- */

  /* Process, Process type */
#ifdef X_ONE_TASK_PER_INSTANCE_SET 
#define XPRS_EXTRAS(PREFIX_PROC_NAME) \
  , *XCAT(NEUTRINOPAD_,PREFIX_PROC_NAME),  (void *)(&(XCAT(NEUTRINOQ_,PREFIX_PROC_NAME)))
#else
#define XPRS_EXTRAS(PREFIX_PROC_NAME) , *XCAT(NEUTRINOPAD_,PREFIX_PROC_NAME)
#endif
#define RTOSXPAD_STRUCT_COMP \
void (*RestartPAD) XPP(( void *VarP, SDL_PId, \
xPrsInstanceSetVars *yInstanceSetVars ));

 /*---------------- Variables in the PAD function ---------------- */
#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define YPAD_TEMP_VARS \
   xSignalHeader  yOutputSignalPtr; \
   xSignalHeader  pREPLY_Signal; \
   SDL_PId		  SenderRPCCall; \
   unsigned long  RetCode; \
   xPrdNode       yTempPrd; \
   pthread_t      ThreadPid; \
   mqd_t	  QueuePId; \
   int 		  i, NoOfMessages; \
   char	  	  *instanceno;
#else

#define PROCESS_VARS \
   int            RestartAddress; \
   xPrdNode       ActivePrd; \
   XPAD_STRUCT_COMP \
   SDL_PId        Self; \
   SDL_PId        Offspring; \
   SDL_PId        Parent; \
   SDL_PId        Sender; \
   int            State; \
   int            StateAfterRPC; \
   xSignalHeader  SaveQ; \
   xSignalHeader  yInSignalPtr; \
   xSignalHeader  CurrentInSaveQ; \
   xEPrsNode      PrsNode; \
   XSIGTYPE       pREPLY_Waited_For; \
   char           ProcName[100]; \
   int            FirstTime;

#define YPAD_TEMP_VARS \
   xSignalHeader  yOutputSignalPtr; \
   xSignalHeader  pREPLY_Signal; \
   SDL_PId		  SenderRPCCall; \
   unsigned long  RetCode; \
   xPrdNode       yTempPrd; \
   pthread_t      ThreadPid; \
   mqd_t	  QueuePId; \
   char	  	  *instanceno; \
   char  offspring[10];	/* MAS */ \
   char TMPNAME[20];
#endif
       /* X_ONE_TASK_PER_INSTANCE_SET */

#define YPRD_TEMP_VARS \
   xSignalHeader  yOutputSignalPtr; \
   xSignalHeader  pREPLY_Signal; \
   SDL_PId		  SenderRPCCall; \
   xPrdNode       yTempPrd; \
   pthread_t      ThreadPid; \
   mqd_t	  QueuePId;

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define SDL_SELF                yVarP->PrsNode
#else
#define SDL_SELF                yVarP->Self
#endif

#define SDL_SENDER              yVarP->Sender

/* ------------------ Structure of PAD function ------------------ */

#ifdef X_ONE_TASK_PER_INSTANCE_SET

#define YPAD_PROTOTYPE(PAD)     void PAD ( void *VarP, SDL_PId InputPortQ, xPrsInstanceSetVars *yInstanceSetVars );
#define YPAD_FUNCTION(PAD)      void PAD ( void *VarP, SDL_PId InputPortQ, xPrsInstanceSetVars *yInstanceSetVars )
#define YPRD_PROTOTYPE(PAD)     xbool PAD ( void *VarP, xPrsInstanceSetVars *yInstanceSetVars );
#define YPRD_FUNCTION(PAD)      xbool PAD ( void *VarP, xPrsInstanceSetVars *yInstanceSetVars )
#else
#define YPAD_PROTOTYPE(PAD)     void PAD ();
#define YPAD_FUNCTION(PAD)      void PAD( VarP, InputPortQ, yInstanceSetVars ) void *VarP; SDL_PId InputPortQ; xPrsInstanceSetVars *yInstanceSetVars;
#define YPRD_PROTOTYPE(PAD)     xbool PAD();
#define YPRD_FUNCTION(PAD)      xbool PAD (VarP, yInstanceSetVars ) void * VarP; xPrsInstanceSetVars *yInstanceSetVars;
#endif
#endif

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define RTOSBEGIN_PAD(VDEF_TYPE)  { \
   if (xInputSignal((xPrsNode*)&yVarP,yInstanceSetVars,0,InputPortQ)) return;\
   goto Label_Execute_Transition; \
}

#ifdef XNOTIMERPARAMS
#define RTOSLOOP_LABEL \
   Label_New_Transition_No_Free : \
     if (xInputSignal((xPrsNode*)&yVarP,yInstanceSetVars,2, InputPortQ)) return; \
     goto Label_Execute_Transition; \
   Label_New_Transition : \
     if (xInputSignal((xPrsNode*)&yVarP,yInstanceSetVars,1,InputPortQ)) return; \
   Label_Execute_Transition : \
     ySVarP =((xSignalHeader)(yInstanceSetVars->yInSignalPtr)+1); \
     yVarP->Sender = yInstanceSetVars->yInSignalPtr->Sender;

#else

#define RTOSLOOP_LABEL \
   Label_New_Transition_No_Free : \
     if (xInputSignal((xPrsNode*)&yVarP,yInstanceSetVars,2, InputPortQ)) return; \
     goto Label_Execute_Transition; \
   Label_New_Transition : \
     if (xInputSignal((xPrsNode*)&yVarP,yInstanceSetVars,1,InputPortQ)) return; \
   Label_Execute_Transition : \
     if(yInstanceSetVars->yInSignalPtr->IsTimerSignal) \
       ySVarP =((xTimerHeader)(yInstanceSetVars->yInSignalPtr)+1); \
     else \
       ySVarP =((xSignalHeader)(yInstanceSetVars->yInSignalPtr)+1); \
     yVarP->Sender = yInstanceSetVars->yInSignalPtr->Sender;

#endif  /* XNOTIMERPARAMS */

#else  /* X_ONE_TASK_PER_INSTANCE_SET */

#define RTOSBEGIN_PAD(VDEF_TYPE) \
   yVarP->Offspring=offspring; /*mas*/ \
   if(yVarP->FirstTime) { \
     memset((((xPrsRec*)yVarP)+1),NULL,sizeof(VDEF_TYPE)-sizeof(xPrsRec)); \
     yVarP->FirstTime = 0; \
   } \
   if (xInputSignal((xPrsNode*)&yVarP,0)) return; \
   goto Label_Execute_Transition;

#ifdef XNOTIMERPARAMS

#define RTOSLOOP_LABEL \
   Label_New_Transition_No_Free : \
     if (xInputSignal((xPrsNode*)&yVarP,2)) return; \
     goto Label_Execute_Transition; \
   Label_New_Transition : \
     if (xInputSignal((xPrsNode*)&yVarP,1)) return; \
   Label_Execute_Transition : \
     ySVarP =((xSignalHeader)(yVarP->yInSignalPtr)+1); \
     yVarP->Sender = yVarP->yInSignalPtr->Sender;

#else

#define RTOSLOOP_LABEL \
   Label_New_Transition_No_Free : \
     if (xInputSignal((xPrsNode*)&yVarP,2)) return; \
     goto Label_Execute_Transition; \
   Label_New_Transition : \
     if (xInputSignal((xPrsNode*)&yVarP,1)) return; \
   Label_Execute_Transition : \
     if(yVarP->yInSignalPtr->IsTimerSignal) \
       ySVarP =((xTimerHeader)(yVarP->yInSignalPtr)+1); \
     else \
       ySVarP =((xSignalHeader)(yVarP->yInSignalPtr)+1); \
     yVarP->Sender = yVarP->yInSignalPtr->Sender;

#endif /* XNOTIMERPARAMS */

#endif
       /* X_ONE_TASK_PER_INSTANCE_SET */

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define RTOSLOOP_LABEL_PRD \
   XOS_TRACE_CALL \
   if (yPrdVarP->RestartAddress != 0) { \
     if(yInstanceSetVars->yInSignalPtr->IsTimerSignal) \
       ySVarP =((xTimerHeader)(yInstanceSetVars->yInSignalPtr)+1); \
     else \
       ySVarP =((xSignalHeader)(yInstanceSetVars->yInSignalPtr)+1); \
     yVarP->Sender = yInstanceSetVars->yInSignalPtr->Sender; \
   }

#define RTOSFREE_BUF(SIGPTR) xFree((void*)SIGPTR)
#define RTOSFREE_BUF_SIGP(SIGPTR)

#define RTOSRECEIVE(SIGPTR,SELF,MSGLEN, QID){ \
     char *MsgQueue; \
     MsgQueue = (char *)InputPortQ; \
     SIGPTR = xAlloc(MAXMSGLENGTH); \
     QueuePId = mq_open((char *)MsgQueue, O_RDWR, 0, 0); \
     mq_open_ERROR("RTOSRECEIVE", "mq_open", QueuePId) \
     Err_Rec = mq_receive(QueuePId, \
                       (char *)(yInstanceSetVars->yInSignalPtr) , \
                       MAXMSGLENGTH,  NULL); \
     mq_receive_ERROR("RTOSRECEIVE", "mq_receive", Err_Rec) \
     Err = mq_close(QueuePId); /* MAS */ \
     XOS_ERROR("RTOSRECEIVE", "mq_close", Err) \
}

#else

#define RTOSFREE_BUF(SIGPTR) xFree((void*)SIGPTR)
#define RTOSFREE_BUF_SIGP(SIGPTR)

#define RTOSRECEIVE(SIGPTR,SELF,MSGLEN, QID) \
     SIGPTR = xAlloc(MAXMSGLENGTH); \
     QueuePId = mq_open((char *)(*yVarP)->Self, 2, 0, 0); \
     mq_open_ERROR("RTOSRECEIVE", "mq_open", QueuePId) \
     Err_Rec = mq_receive(QueuePId,(char *)(*yVarP)->yInSignalPtr , \
                       MAXMSGLENGTH,  NULL); \
     mq_receive_ERROR("RTOSRECEIVE", "mq_receive", Err_Rec) \
     Err = mq_close(QueuePId); \
     XOS_ERROR("RTOSRECEIVE", "mq_close", Err)

#define RTOSRECEIVEPRD(SIGPTR,SELF,MSGLEN, QID) \
    SIGPTR = xAlloc(MAXMSGLENGTH); \
    QueuePId = mq_open((char *)yVarP->Self, 2, 0, 0); \
    mq_open_ERROR("RTOSRECEIVEPRD", "mq_open", QueuePId) \
    Err_Rec = mq_receive(QueuePId,(char *)yVarP->yInSignalPtr , \
                       MAXMSGLENGTH,  NULL); \
    mq_receive_ERROR("RTOSRECEIVEPRD", "mq_receive", Err_Rec) \
    yVarP->Parent = yVarP->yInSignalPtr->Sender; \
    Err = mq_close(QueuePId); \
    XOS_ERROR("RTOSRECEIVEPRD", "mq_close", Err)


#define RTOSLABEL_EXECUTE_TRANSITION \
     if(yVarP->yInSignalPtr->IsTimerSignal) \
       ySVarP =((xTimerHeader)(yVarP->yInSignalPtr)+1); \
     else \
       ySVarP =((xSignalHeader)(yVarP->yInSignalPtr)+1); \
     yVarP->Sender = yVarP->yInSignalPtr->Sender;
#endif
   /* X_ONE_TASK_PER_INSTANCE_SET */


#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define RTOSSENDER yInstanceSetVars->yInSignalPtr->Sender;
#define RTOSCALLSUPER_PAD(PAD) \
   PAD(yVarP, InputPortQ, yInstanceSetVars); 
#else

#define RTOSSENDER yVarP->yInSignalPtr->Sender; 

#endif
       /* X_ONE_TASK_PER_INSTANCE_SET */


#define INSIGNAL_NAME           INSIGNAL_PTR->SignalCode

/* ---------------------------- Output --------------------------- */
#ifdef XNOTIMERPARAMS
#define RTOSALLOC_RPC_SIGNAL_EXTRA
#else
#define RTOSALLOC_RPC_SIGNAL_EXTRA \
   pREPLY_Signal->IsTimerSignal = 0; \
   pREPLY_Signal->SigSize = 0;
#endif /* XNOTIMERPARAMS */

#ifdef XNOTIMERPARAMS
#define RTOSALLOC_SIGNAL_EXTRA
#else
#define RTOSALLOC_SIGNAL_EXTRA \
   yOutputSignalPtr->IsTimerSignal = 0; \
   yOutputSignalPtr->SigSize = 0;
#endif /* XNOTIMERPARAMS */

#define RTOSALLOC_SIGNAL(SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_TYPE) \
   yOutputSignalPtr = xAlloc(sizeof(xSignalHeaderRec)); \
   yOutputSignalPtr->SignalCode = SIG_NAME; \
   RTOSALLOC_SIGNAL_EXTRA \
   yOutputSignalPtr->Sender = SDL_SELF;

#define RTOSALLOC_SIGNAL_PAR(SIG_NAME,SIG_IDNODE, RECEIVER, SIG_PAR_TYPE) \
   yOutputSignalPtr = \
        xAlloc(sizeof(xSignalHeaderRec)+sizeof(SIG_PAR_TYPE)); \
   yOutputSignalPtr->SigP = yOutputSignalPtr+1; \
   yOutputSignalPtr->SignalCode = SIG_NAME; \
   RTOSALLOC_SIGNAL_EXTRA \
   yOutputSignalPtr->Sender = SDL_SELF;

#define OUTSIGNAL_DATA_PTR \
   ((xSignalHeader)yOutputSignalPtr+1)

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define RTOSXHANDLESIG_BODY \
   mqd_t QueuePId; \
   OutputSignal->Receiver = Receiver; \
   QueuePId = mq_open((char *)ReceiverTask, 2, 0, 0); \
   mq_open_ERROR("RTOSXHANDLESIG_BODY", "mq_open", QueuePId) \
   Err = mq_send(QueuePId, \
            (char *)OutputSignal, \
            sizeof(xSignalHeaderRec)+ SigPar_Size, NULL); \
   xFree((void**)&OutputSignal); \
   XOS_ERROR("RTOSXHANDLESIG_BODY", "mq_send", Err) \
   Err = mq_close(QueuePId); /*MAS*/ \
   XOS_ERROR("RTOSSEND", "mq_close", Err)

#define RTOSXHANDLETIMER_BODY \
   ((xTimerHeader)OutputSignal)->SignalCode = SetTimer; \
   ((xTimerHeader)OutputSignal)->Sender = Sender; \
   ((xTimerHeader)OutputSignal)->Receiver = Sender; \
   ((xTimerHeader)OutputSignal)->TimerTime = Dur_Expr; \
   ((xTimerHeader)OutputSignal)->TestParams = 0; \
   Err = mq_send((mqd_t)TimerPIdQ, (char *)OutputSignal, \
                 sizeof(xTimerHeaderRec), NULL);\
   xFree((void**)&OutputSignal); \
   XOS_ERROR("SDLSET", "mq_send", Err)

#else

#define RTOSSEND(SIGPTR,RECEIVER,SIG_PAR_SIZE) \
   QueuePId = mq_open((char *)RECEIVER, 2, 0, 0); \
   mq_open_ERROR("RTOSSEND", "mq_open", QueuePId) \
   Err = mq_send(QueuePId, (char *)*SIGPTR, sizeof(xSignalHeaderRec)+\
                 SIG_PAR_SIZE, NULL); \
   XOS_ERROR("RTOSSEND", "mq_send", Err) \
   xFree((void**)SIGPTR); \
   Err = mq_close(QueuePId); \
   XOS_ERROR("RTOSSEND", "mq_close", Err)

#define RTOSXHANDLETIMER_BODY \
   ((xTimerHeader)OutputSignal)->SignalCode = SetTimer; \
   ((xTimerHeader)OutputSignal)->Sender = Sender; \
   ((xTimerHeader)OutputSignal)->TimerTime = Dur_Expr; \
   ((xTimerHeader)OutputSignal)->TestParams = 0; \
   Err = mq_send((mqd_t)TimerPIdQ, (char *)OutputSignal, \
                 sizeof(xTimerHeaderRec), \
                 NULL);\
   XOS_ERROR("RTOSXHANDLETIMER_BODY", "mq_send", Err) \
   xFree((void**)&OutputSignal);

#endif
/* ----------------------------- RPC ----------------------------- */

#define RTOSALLOC_REPLY_SIGNAL(SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_TYPE) \
   pREPLY_Signal = xAlloc(sizeof(xSignalHeaderRec)+sizeof(SIG_PAR_TYPE)); \
   pREPLY_Signal->SignalCode = SIG_NAME; \
   RTOSALLOC_RPC_SIGNAL_EXTRA \
   pREPLY_Signal->Sender = SDL_SELF; \
   SenderRPCCall = yVarP->Sender;

#define RTOSALLOC_REPLY_SIGNAL_PAR(SIG_NAME, SIG_IDNODE, RECEIVER,SIG_PAR_TYPE) \
   pREPLY_Signal = xAlloc(sizeof(xSignalHeaderRec)+sizeof(SIG_PAR_TYPE)); \
   pREPLY_Signal->SignalCode = SIG_NAME; \
   RTOSALLOC_RPC_SIGNAL_EXTRA \
   pREPLY_Signal->Sender = SDL_SELF; \
   SenderRPCCall = yVarP->Sender;

#define RTOSALLOC_REPLY_SIGNAL_PRD(SIG_NAME, SIG_IDNODE, RECEIVER,SIG_PAR_TYPE) \
   pREPLY_Signal = xAlloc(sizeof(xSignalHeaderRec)+sizeof(SIG_PAR_TYPE)); \
   pREPLY_Signal->SigP = pREPLY_Signal+1; \
   pREPLY_Signal->SignalCode = SIG_NAME; \
   RTOSALLOC_RPC_SIGNAL_EXTRA \
   pREPLY_Signal->Sender = SDL_SELF; \
   SenderRPCCall = yVarP->Sender;

#define RTOSALLOC_REPLY_SIGNAL_PRD_PAR(SIG_NAME, SIG_IDNODE, RECEIVER,SIG_PAR_TYPE) \
   pREPLY_Signal = xAlloc(sizeof(xSignalHeaderRec)+sizeof(SIG_PAR_TYPE)); \
   pREPLY_Signal->SigP = pREPLY_Signal+1; \
   pREPLY_Signal->SignalCode = SIG_NAME; \
   RTOSALLOC_RPC_SIGNAL_EXTRA \
   pREPLY_Signal->Sender = SDL_SELF; \
   SenderRPCCall = yVarP->Sender;


#define REPLYSIGNAL_DATA_PTR \
   ((xSignalHeader)pREPLY_Signal+1)
#define REPLYSIGNAL_DATA_PTR_PRD \
   ((xSignalHeader)pREPLY_Signal+1)


/* ---------------------------- Create --------------------------- */

#ifdef X_ONE_TASK_PER_INSTANCE_SET

#define RTOSALLOC_STARTUP(PROC_NAME, STARTUP_IDNODE, STARTUP_PAR_TYPE) \
{ \
   int sigstruct_size = sizeof(xSignalHeaderRec)+sizeof(STARTUP_PAR_TYPE); \
   yOutputSignalPtr = xAlloc(sigstruct_size); \
   yOutputSignalPtr->SigP = yOutputSignalPtr+1; \
   yOutputSignalPtr->SignalCode = STARTUPSIGNAL; \
   RTOSALLOC_SIGNAL_EXTRA \
   yOutputSignalPtr->Sender = SDL_SELF;

#define RTOSALLOC_STARTUP_PAR(PROC_NAME, STARTUP_IDNODE, STARTUP_PAR_TYPE) \
{ \
   int sigstruct_size = sizeof(XSIGNALHEADERTYPE)+sizeof(STARTUP_PAR_TYPE); \
   yOutputSignalPtr = xAlloc(sigstruct_size); \
   yOutputSignalPtr->SigP = yOutputSignalPtr+1; \
   yOutputSignalPtr->SignalCode = STARTUPSIGNAL; \
   RTOSALLOC_SIGNAL_EXTRA \
   yOutputSignalPtr->Sender = SDL_SELF;

#else

#define RTOSALLOC_STARTUP(PROC_NAME, STARTUP_IDNODE, STARTUP_PAR_TYPE) \
{ \
   char *instanceno; \
   /*char *queuename; */ /*defined twice, mas */ \
   int sigstruct_size = sizeof(xSignalHeaderRec)+sizeof(STARTUP_PAR_TYPE); \
   yOutputSignalPtr = xAlloc(sigstruct_size); \
   yOutputSignalPtr->SigP = yOutputSignalPtr+1; \
   yOutputSignalPtr->SignalCode = STARTUPSIGNAL; \
   RTOSALLOC_SIGNAL_EXTRA \
   yOutputSignalPtr->Sender = SDL_SELF;

#define RTOSALLOC_STARTUP_PAR(PROC_NAME, STARTUP_IDNODE, STARTUP_PAR_TYPE) \
{ \
   char *instanceno; \
   /*char *queuename;*/ /* mas */ \
   int sigstruct_size = sizeof(XSIGNALHEADERTYPE)+sizeof(STARTUP_PAR_TYPE); \
   yOutputSignalPtr = xAlloc(sigstruct_size); \
   yOutputSignalPtr->SigP = yOutputSignalPtr+1; \
   yOutputSignalPtr->SignalCode = STARTUPSIGNAL; \
   RTOSALLOC_SIGNAL_EXTRA \
   yOutputSignalPtr->Sender = SDL_SELF;

#endif  /* X_ONE_TASK_PER_INSTANCE_SET */

#define STARTUP_DATA_PTR \
   ((xSignalHeader)yOutputSignalPtr+1)

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define RTOSSDL_CREATE(PROC_NAME, PROC_IDNODE, PROC_NAME_STRING) \
   yOutputSignalPtr->Receiver = xAllocPrsUseMyMemory(PROC_IDNODE); \
   yOutputSignalPtr->Receiver->BlockInstNumber = \
     yVarP->PrsNode->BlockInstNumber; \
   yVarP->Offspring = yOutputSignalPtr->Receiver; \
   XOS_TRACE_CREATE( yVarP->Offspring, PROC_NAME_STRING) \
   XMSC_TRACE_CREATE( yVarP->Offspring, PROC_NAME_STRING) \
   QueuePId = mq_open((char *)yVarP->Offspring->NameNode->PROCID, 2, 0, 0); \
   mq_open_ERROR("RTOSSDL_CREATE", "mq_open", QueuePId) \
   Err = mq_send(QueuePId,\
         (char *)yOutputSignalPtr,sigstruct_size, NULL); \
   XOS_ERROR("RTOSSDL_CREATE", "mq_send", Err) \
   xFree((void**)&yOutputSignalPtr); \
   Err = sem_post(&taskSem); \
   XOS_ERROR("CREATE", "sem_post", Err) \
   Err = mq_close(QueuePId); /* MAS */ \
   XOS_ERROR("RTOSRECEIVE", "mq_close", Err) \
}

#else

#define RTOSSDL_CREATE(PROC_NAME, PROC_IDNODE, PROC_NAME_STRING) \
  { \
   char * queuename; /* 1003244 (PD) MAS */ \
   \
   (void)pthread_mutex_lock(&createdProcesses_Mutex); \
   createdProcesses++; \
   queuename = xAlloc(10);  \
   snprintf( queuename, 10, "/Y%d", createdProcesses); /* SC1000391/tsr */ \
   (void)pthread_mutex_unlock(&createdProcesses_Mutex); \
   \
   QueuePId = mq_open((char *)queuename ,QUEUEFLAG, QUEUEMODE, &mq_attr); \
   mq_open_ERROR("RTOSSDL_CREATE", "mq_open", QueuePId) \
   yVarP->Offspring = queuename; /* 1003244 (PD) MAS */ \
   Err= pthread_create(&ThreadPid, &Attributes, ((PROC_IDNODE)->RTOSPAD), (void *)queuename); \
   XOS_ERROR("RTOSSDL_CREATE", "pthread_create", Err) \
   ((xStartUpSignalHeader)STARTUP_DATA_PTR)->PrsNode = \
       xAllocPrsUseMyMemory(PROC_IDNODE, yVarP->Offspring); \
   ((xStartUpSignalHeader)STARTUP_DATA_PTR)->PrsNode->BlockInstNumber = \
       yVarP->PrsNode->BlockInstNumber; \
   XOS_TRACE_CREATE(yVarP->Offspring, PROC_NAME_STRING) \
   XMSC_TRACE_CREATE( yVarP->Offspring,PROC_NAME_STRING) \
   Err = mq_send(QueuePId, (char *)yOutputSignalPtr,sigstruct_size, NULL); \
   XOS_ERROR("RTOSSDL_CREATE", "mq_send", Err) \
   xFree((void**)&yOutputSignalPtr); \
   Err = mq_close(QueuePId); \
   XOS_ERROR("RTOSSDL_CREATE", "mq_close", Err) \
   Err = sem_post(&taskSem); \
   XOS_ERROR("CREATE", "sem_post", Err) \
   strcpy(yVarP->Offspring,queuename);/* 1003244 (PD) MAS */ \
}}
#endif

/* ------------------------- Static Create ------------------------ */
#define YINIT_TEMP_VARS \
  mqd_t QueuePId; \
  xSignalHeader yOutputSignalPtr; \
  int CurrentPId; \
  pthread_t ThreadPid; \
  char *instanceno; \
  char TMPNAME[20];

#ifndef X_ONE_TASK_PER_INSTANCE_SET
#ifdef XOS_TRACE
#define BEGIN_YINIT \
  xInitTimer(); \
  LastUsedPId =SDL_NULL;
#elif XMSC_TRACE
#define BEGIN_YINIT \
  xInitTimer();
#endif
#if (!defined XOS_TRACE) && (!defined XMSC_TRACE)
#define BEGIN_YINIT \
  xInitTimer();
#endif
#endif
       /* X_ONE_TASK_PER_INSTANCE_SET */

#ifdef X_ONE_TASK_PER_INSTANCE_SET

#ifdef XENV
#define RTOSXCREATE_ENV_PROCESS \
   QueuePId = mq_open("/EnvQueue",QUEUEFLAG, QUEUEMODE, &mq_attr); \
   mq_open_ERROR("RTOSXCREATE_ENV_PROCESS", "mq_open", QueuePId) \
   Err = pthread_create(&ThreadPid, &Attributes, NEUTRINOPAD_env, NULL); \
   XOS_ERROR("RTOSXCREATE_ENV_PROCESS", "pthread_create", Err) \
   xEnvId->PROCID = "/EnvQueue"; \
   xEnvPIdQ = "/EnvQueue"; \
   xAllocPrsUseMyMemory(xEnvId);

#else

#define RTOSXCREATE_ENV_PROCESS \
  /* Create a queue to handle signal to environment */ \
  QueuePId = mq_open("/EnvQueue",QUEUEFLAG, QUEUEMODE, &mq_attr); \
  mq_open_ERROR("RTOSXCREATE_ENV_PROCESS", "mq_open", QueuePId) \
  xEnvId->PROCID = "/EnvQueue"; \
  xEnvPIdQ = "/EnvQueue"; \
  xEnvPrs = xAllocPrsUseMyMemory(xEnvId);

#endif
         /* XENV */

#else

#ifdef XENV
#define RTOSXCREATE_ENV_PROCESS \
   QueuePId = mq_open("/EnvQueue",QUEUEFLAG, QUEUEMODE, &mq_attr); \
   mq_open_ERROR("RTOSXCREATE_ENV_PROCESS", "mq_open", QueuePId) \
   Err = pthread_create(&ThreadPid, &Attributes, NEUTRINOPAD_env, NULL); \
   XOS_ERROR("RTOSXCREATE_ENV_PROCESS", "pthread_create", Err) \
   xEnvPId = "EnvQueue"; \
   xAllocPrsUseMyMemory(xEnvId, xEnvPId);

#else

#define RTOSXCREATE_ENV_PROCESS \
  QueuePId = mq_open("/EnvQueue",QUEUEFLAG, QUEUEMODE, &mq_attr); \
  mq_open_ERROR("RTOSXCREATE_ENV_PROCESS", "mq_open", QueuePId) \
  xEnvPId = "/EnvQueue"; \
  xEnvPrs = xAllocPrsUseMyMemory(xEnvId, xEnvPId); \
  Err = mq_close(QueuePId); \
  XOS_ERROR("RTOSXCREATE_ENV_PROCESS", "mq_close", Err)


#endif
#endif

#define RTOSINIT_PROCESS_TYPE(PROC_NAME,PREFIX_PROC_NAME, PROC_IDNODE,PROC_NAME_STRING,MAX_NO_OF_INST,STATIC_INST,PRIV_DATA_TYPE, PRIO,PAD_FUNCTION) \
{ \
   char *queuename;   \
   \
   (void)pthread_mutex_lock(&createdProcesses_Mutex); \
   createdProcesses++; \
   queuename = (char *)xAlloc(10); \
   snprintf( queuename, 10, "/Y%d", createdProcesses); /* SC1000391/tsr */ \
   (void)pthread_mutex_unlock(&createdProcesses_Mutex); \
   \
   QueuePId = mq_open((char *)queuename,QUEUEFLAG, QUEUEMODE, &mq_attr); \
   mq_open_ERROR("RTOSINIT_PROCESS_TYPE", "mq_open", QueuePId) \
   PROC_IDNODE->PROCID = queuename; \
   Err = pthread_create(&ThreadPid, &Attributes, XCAT(NEUTRINOPAD_,PREFIX_PROC_NAME), (void *) queuename); \
   XOS_ERROR("RTOSINIT_PROCESS_TYPE", "pthread_create", Err) \
}

#ifdef X_ONE_TASK_PER_INSTANCE_SET

#define RTOSSDL_STATIC_CREATE(PROC_NAME, PREFIX_PROC_NAME, PROC_IDNODE,PROC_NAME_STRING, STARTUP_IDNODE,STARTUP_PAR_TYPE, PRIV_DATA_TYPE,PRIO, PAD_FUNCTION, BLOCK_INST_NUMBER) \
   yOutputSignalPtr = (xSignalHeader)xAlloc( sizeof(XSIGNALHEADERTYPE)+ \
   sizeof(STARTUP_PAR_TYPE)); \
   yOutputSignalPtr->SigP = yOutputSignalPtr+1; \
   yOutputSignalPtr->SignalCode = STARTUPSIGNAL; \
   RTOSALLOC_SIGNAL_EXTRA \
   yOutputSignalPtr->Sender = SDL_NULL; \
   yOutputSignalPtr->Receiver = xAllocPrsUseMyMemory(PROC_IDNODE); \
   yOutputSignalPtr->Receiver->BlockInstNumber = BLOCK_INST_NUMBER; \
   XOS_TRACE_STATIC_CREATE(yOutputSignalPtr->Receiver, PROC_NAME_STRING) \
   XMSC_TRACE_STATIC_CREATE(yOutputSignalPtr->Receiver, PROC_NAME_STRING) \
   Err = mq_send(QueuePId, (char *)yOutputSignalPtr, \
                  sizeof(xSignalHeaderRec)+sizeof(STARTUP_PAR_TYPE), \
                   NULL); \
   XOS_ERROR("RTOSSDL_STATIC_CREATE", "mq_send", Err) \
   xFree((void**)&yOutputSignalPtr);

#else

#define RTOSSDL_STATIC_CREATE(PROC_NAME, PREFIX_PROC_NAME, PROC_IDNODE,  \
  PROC_NAME_STRING, STARTUP_IDNODE, STARTUP_PAR_TYPE, PRIV_DATA_TYPE, PRIO, \
  PAD_FUNCTION, BLOCK_INST_NUMBER) \
{ \
   char *queuename; \
   yOutputSignalPtr = (xSignalHeader)xAlloc( sizeof(XSIGNALHEADERTYPE) + \
                       sizeof(STARTUP_PAR_TYPE)); \
   yOutputSignalPtr->SigP = yOutputSignalPtr+1; \
   queuename = (char *)xAlloc(10); \
   yOutputSignalPtr->SignalCode = STARTUPSIGNAL; \
   RTOSALLOC_SIGNAL_EXTRA \
   yOutputSignalPtr->Sender = SDL_NULL; \
   \
   (void)pthread_mutex_lock(&createdProcesses_Mutex); \
   createdProcesses++; \
   snprintf( queuename, 10, "/X%d", createdProcesses); /* SC1000391/tsr */ \
   (void)pthread_mutex_unlock(&createdProcesses_Mutex); \
   \
   QueuePId = mq_open((char *)queuename, QUEUEFLAG, QUEUEMODE, &mq_attr); \
   mq_open_ERROR("RTOSSDL_STATIC_CREATE", "mq_open", QueuePId) \
   Err = pthread_create(&ThreadPid, &Attributes, XCAT(NEUTRINOPAD_,PREFIX_PROC_NAME), (void *) queuename); \
   XOS_ERROR("SDL_STATIC_CREATE", "pthread_create", Err) \
   ((STARTUP_PAR_TYPE *)STARTUP_DATA_PTR)->PrsNode = \
       xAllocPrsUseMyMemory(PROC_IDNODE, queuename); \
   ((STARTUP_PAR_TYPE *)STARTUP_DATA_PTR)->PrsNode->BlockInstNumber = \
       BLOCK_INST_NUMBER; \
   XOS_TRACE_STATIC_CREATE(queuename, PROC_NAME_STRING) \
   XMSC_TRACE_STATIC_CREATE(queuename, PROC_NAME_STRING) \
   Err = mq_send(QueuePId, (char *)yOutputSignalPtr,\
                    sizeof(xSignalHeaderRec)+sizeof(STARTUP_PAR_TYPE), NULL); \
   XOS_ERROR("SDL_STATIC_CREATE", "mq_send", Err) \
   xFree((void**)&yOutputSignalPtr); \
   Err = mq_close(QueuePId); \
   XOS_ERROR("RTOSSDL_STATIC_CREATE", "mq_close", Err) \
}
#endif

/* ----------------------------- Stop ---------------------------- */
#ifdef X_ONE_TASK_PER_INSTANCE_SET

#define RTOSEMPTYQUEUE(SIGPTR) \
{ \
   struct mq_attr TmpQueueAttr; \
   QueuePId = mq_open((char *)SDL_SELF->NameNode->PROCID, 2, 0, 0); \
   mq_open_ERROR("RTOSEMPTYQUEUE","mq_open", QueuePId) \
   Err = mq_getattr(QueuePId,&TmpQueueAttr); \
   XOS_ERROR("RTOSEMPTYQUEUE", "mq_getattr", Err) \
   NoOfMessages = TmpQueueAttr.mq_curmsgs; \
   for (i=0; i<NoOfMessages; i++) { \
     yInstanceSetVars->yInSignalPtr = xAlloc(MAXMSGLENGTH); \
     Err_Rec = mq_receive(QueuePId,(char *)yInstanceSetVars->yInSignalPtr, \
                         MAXMSGLENGTH, NULL); \
     mq_receive_ERROR("RTOSEMPTYQUEUE", "mq_receive", Err_Rec) \
     if ( xEq_SDL_PId( yInstanceSetVars->yInSignalPtr->Receiver, SDL_SELF) ){ \
       xFree((void*)(&(yInstanceSetVars->yInSignalPtr))); \
     } \
     else \
       xSaveSignal( yInstanceSetVars->SaveQ, yInstanceSetVars->yInSignalPtr); \
   } \
   Err = mq_close(QueuePId); /*MAS*/ \
   XOS_ERROR("RTOSSEND", "mq_close", Err) \
}

#define RTOSSDL_STOPREMOVETIMERS \
   xKillSaveQ(yInstanceSetVars->SaveQ, SDL_SELF); \
   yOutputSignalPtr = xAlloc(sizeof(xTimerHeaderRec)); \
   yOutputSignalPtr->SignalCode = RemoveTimers; \
   RTOSALLOC_SIGNAL_EXTRA \
   yOutputSignalPtr->Sender = SDL_SELF; \
   Err = mq_send((mqd_t)TimerPIdQ, (char *)yOutputSignalPtr, \
                  sizeof(xTimerHeaderRec), NULL); \
   xFree((void**)&yOutputSignalPtr); \
   XOS_ERROR("RemoveTimers", "mq_send", Err) \
   xFreePrs(&yVarP->PrsNode); \
   goto Label_New_Transition_No_Free;

#else

#define RTOSEMPTYQUEUE(SIGPTR) \
  QueuePId = mq_open((char *)yVarP->Self, 2, 0, 0); \
  mq_open_ERROR("RTOSEMPTYQUEUE","mq_open", QueuePId) \
  Err = mq_close(QueuePId); \
  XOS_ERROR("RTOSEMPTYQUEUE","mq_close",Err) \
  Err = mq_unlink((char *)yVarP->Self); \
  XOS_ERROR("RTOSEMPTYQUEUE","mq_unlink",Err)

#define RTOSSDL_STOPREMOVETIMERS \
   yOutputSignalPtr = xAlloc(sizeof(xTimerHeaderRec)); \
   yOutputSignalPtr->SignalCode = RemoveTimers; \
   RTOSALLOC_SIGNAL_EXTRA \
   yOutputSignalPtr->Sender = yVarP->Self; \
   Err = mq_send((mqd_t)TimerPIdQ, (char *)yOutputSignalPtr, \
                 sizeof(xTimerHeaderRec), \
                 NULL); \
   XOS_ERROR("RemoveTimers", "mq_send", Err) \
   xFree((void**)&yOutputSignalPtr);   \
   xFree((void**)&(yVarP->Self)); /* 1003244 (PD) MAS */ 

#define RTOSKILL_PROC \
   pthread_exit((void *)0); \
   XOS_ERROR("STOP", "RTOSKILL_PROC", Err)
#endif 

/* ---------------------------- Timers --------------------------- */

#define TIMER_DATA_PTR \
((xTimerHeader)(yOutputSignalPtr)+1)

#ifdef XNOTIMERPARAMS
#define RTOSALLOC_TIMER_SIGNAL_EXTRA(TIMER_PAR_TYPE)
#else
#define RTOSALLOC_TIMER_SIGNAL_EXTRA(TIMER_PAR_TYPE) \
   ((xTimerHeader)yOutputSignalPtr)->IsTimerSignal = 1; \
   ((xTimerHeader)yOutputSignalPtr)->SigSize = sizeof(xTimerHeaderRec) + sizeof(TIMER_PAR_TYPE);
#endif

#define RTOS_ALLOC_TIMER_SIGNAL_PAR(TIMER_NAME, TIMER_IDNODE, TIMER_PAR_TYPE) \
  yOutputSignalPtr = (xSignalHeader)xAlloc(sizeof(xTimerHeaderRec)+sizeof(TIMER_PAR_TYPE)); \
  yOutputSignalPtr->SigP = ((xTimerHeader)yOutputSignalPtr) + 1; \
  ((xTimerHeader)yOutputSignalPtr)->TimerToSetOrReset = TIMER_NAME; \
  ((xTimerHeader)yOutputSignalPtr)->TestParams = 1; \
  RTOSALLOC_TIMER_SIGNAL_EXTRA(TIMER_PAR_TYPE)

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define  RTOS_SDL_SET_DUR_WITH_PARA_EXTRA \
  yOutputSignalPtr->Receiver = SDL_SELF;
#else
#define  RTOS_SDL_SET_DUR_WITH_PARA_EXTRA
#endif /* X_ONE_TASK_PER_INSTANCE_SET */

#define RTOS_SDL_SET_DUR_WITH_PARA(TIME_EXPR, DUR_EXPR, TIMER_NAME, TIMER_IDNODE, TIMER_PAR_TYPE, EQ_FUNC, TIMER_VAR, TIMER_NAME_STRING) \
  XOS_TRACE_SET(TIMER_NAME_STRING) \
  yVarP->TIMER_VAR = TIMER_NAME; \
  yOutputSignalPtr->Sender = SDL_SELF; \
  RTOS_SDL_SET_DUR_WITH_PARA_EXTRA \
  ((xTimerHeader)yOutputSignalPtr)->TimerTime = DUR_EXPR; \
  ((xTimerHeader)yOutputSignalPtr)->SignalCode = SetTimer; \
  XSDLRESETWITHPARAM(TIMER_NAME, SDL_SELF, RTOSINSIGNALPTR, yOutputSignalPtr,EQ_FUNC,TIMER_NAME_STRING); \
  XMSC_TRACE_SET(yOutputSignalPtr, TIMER_NAME_STRING, DUR_EXPR) \
  Err = mq_send((mqd_t)TimerPIdQ, (char *)yOutputSignalPtr, \
                 (sizeof(xTimerHeaderRec)+sizeof(TIMER_PAR_TYPE)), \
                 NULL); \
  XOS_ERROR("RTOS_SDL_SET_DUR_WITH_PARA", "mq_send", Err) \
  xFree((void**)&yOutputSignalPtr);

#define RTOS_SDL_RESET_WITH_PARA(EQ_FUNC, TIMER_VAR, TIMER_NAME_STRING) \
  XOS_TRACE_RESET(TIMER_NAME_STRING) \
  yOutputSignalPtr->Sender = SDL_SELF; \
  ((xTimerHeader)yOutputSignalPtr)->TimerTime = 0; \
  XSDLRESETWITHPARAM(yVarP->TIMER_VAR, SDL_SELF, RTOSINSIGNALPTR, yOutputSignalPtr,EQ_FUNC,TIMER_NAME_STRING); \
  RTOSFREETIMERSTRINGPARAMS2((xTimerHeader)yOutputSignalPtr) \
  xFree((void**)&yOutputSignalPtr);

#define RTOSALLOC_TIMER_SIGNAL(TIMER_NAME_PARAMETER,DUR_EXPR) \
   yOutputSignalPtr = (xSignalHeader)xAlloc(sizeof(xTimerHeaderRec)); \
   ((xTimerHeader)yOutputSignalPtr)->TimerToSetOrReset = TIMER_NAME_PARAMETER; \
   RTOSALLOC_TIMER_SIGNAL_EXTRA(NULL)

/* ------------------------ Execution trace ---------------------- */
#ifdef X_ONE_TASK_PER_INSTANCE_SET

#define RTOSXOS_TRACE_CREATE(INSTANCE, PROC_NAME_STRING) \
  XOS_FPRINT(("%s: process %s:%ld created\n", ProcName, \
    PROC_NAME_STRING, INSTANCE))

#define RTOSXOS_TRACE_STATIC_CREATE(INSTANCE, PROC_NAME_STRING) \
   XOS_STATIC_FPRINT(("Process %s:%ld created\n", \
     PROC_NAME_STRING, INSTANCE))

#else

#define RTOSXOS_TRACE_CREATE(INSTANCE, PROC_NAME_STRING) \
  XOS_FPRINT(("%s: process %s:%s created\n", ProcName, \
    PROC_NAME_STRING, INSTANCE))

#define RTOSXOS_TRACE_STATIC_CREATE(INSTANCE, PROC_NAME_STRING) \
   XOS_STATIC_FPRINT(("Process %s:%s created\n", \
     PROC_NAME_STRING, INSTANCE))

#endif

#ifdef XMSC_TRACE

#ifdef XMSC_EDITOR

extern int connect_to_sdt (char *myTool);
extern int start_msc (int post_fd);
extern int start_msc_diagram (int post_fd);
extern int send_message (char *msce_buf);


#define RTOSMSCPRINT_START \
    Err = sem_wait(&psmidmsc2); \
    XOS_ERROR("RTOSMSCPRINT_START", "sem_wait", Err) \

#define RTOSMSCPRINT_STOP \
    Err = sem_post(&psmidmsc); \
    XOS_ERROR("RTOSMSCPRINT_STOP", "sem_post", Err) \


#ifdef X_ONE_TASK_PER_INSTANCE_SET


#define RTOSXMSC_TRACE_STATIC_CREATE(INSTANCE, PROC_NAME_STRING) \
  memset(msce_buf, 0, sizeof(msce_buf)); \
  if (strcmp(PROC_NAME_STRING,"Environment")==0){ \
   sprintf(msce_buf,"%lu %s %s %s", ENV_PID, ": instancehead process ",  PROC_NAME_STRING, ";"); \
  } \
  else {  \
   sprintf(msce_buf, "%lu %s %s %s", INSTANCE, ": instancehead process ", PROC_NAME_STRING, ";"); \
  } \
  send_message(msce_buf);

#define RTOSXMSC_TRACE_CREATE( INSTANCE, PROC_NAME_STRING) \
   { SDL_PId ParentPId; ParentPId = SDL_SELF; \
     XMSC_FPRINT((msce_buf, "%lu %s %s %s", INSTANCE, ": instancehead process ", PROC_NAME_STRING, ";")) \
     XMSC_FPRINT((msce_buf, "%lu : %s %lu %s", ParentPId, "create ", INSTANCE, ";")) \
   }

#define RTOSXMSC_TRACE_NEXTSTATE(STATE_NAME_STRING) \
   { SDL_PId CurrentPId; CurrentPId = SDL_SELF; \
     XMSC_FPRINT((msce_buf, "%lu %s %s %s", CurrentPId, ": condition ", STATE_NAME_STRING, ";")) \
   }

#define XMSC_TRACE_INPUT(SIG_NAME_STRING) \
   { SDL_PId CurrentPId, SenderPId; \
     RTOSMSCPRINT_START \
     CurrentPId = SDL_SELF; \
     SenderPId = yVarP->Sender; \
     if (INSIGNAL_PTR->IsTimer) { \
       sprintf(msce_buf, "%lu %s %s %s %d %s %lu %s", \
	           CurrentPId, ": timeout  ", SIG_NAME_STRING, ",", \
			   INSIGNAL_PTR->SignalId, "; /* #SDTNOW(", tickGet(), ") */"); \
     } \
     else { \
       sprintf(msce_buf, "%lu %s %s %s %d %s %lu %s", \
	           CurrentPId, ": in ", SIG_NAME_STRING, ",", \
			   INSIGNAL_PTR->SignalId, " from ", SenderPId, ";"); \
     } \
     RTOSMSCPRINT_STOP \
   }


#define XMSC_TRACE_OUTPUT(RECEIVER, SIGNAL, SIG_NAME_STRING) \
   { SDL_PId CurrentPId; \
     RTOSMSCPRINT_START \
     CurrentPId = SDL_SELF; \
     SignalId = SignalId + 1; \
     SIGNAL->SignalId = SignalId; \
     SIGNAL->IsTimer = 0; \
     if ( xEq_SDL_PId(RECEIVER, ENV_PID) ) { \
       sprintf(msce_buf, "%lu %s %d %s %d %s %lu %s", \
	           CurrentPId, ": out ", SIGNAL->SignalCode, ",", SignalId, " to ", RECEIVER, ";"); \
     } \
     else { \
       sprintf(msce_buf, "%lu %s %s %s %d %s %lu %s", \
	           CurrentPId, ": out ", SIG_NAME_STRING, ",", SignalId, " to ", RECEIVER, ";"); \
     } \
     RTOSMSCPRINT_STOP \
    }


#define XMSC_TRACE_STOP  \
   { SDL_PId CurrentPId; \
     CurrentPId = SDL_SELF; \
     XMSC_FPRINT((msce_buf, "%lu %s", CurrentPId, ": stop;")) \
   }


#define XMSC_TRACE_SET( TIMER, TIMER_NAME_STRING, DUR_EXPR) \
   { SDL_PId CurrentPId; \
     RTOSMSCPRINT_START \
     CurrentPId = SDL_SELF; \
     SignalId = SignalId + 1; \
     TIMER->SignalId = SignalId; \
     TIMER->IsTimer = 1; \
     sprintf(msce_buf, "%lu %s %s %s %d %s %d %s %lu %s", \
	         CurrentPId, ": set ", TIMER_NAME_STRING, ",", \
			 SignalId, " (", DUR_EXPR, "); /* #SDTNOW(", tickGet(), ") */"); \
     RTOSMSCPRINT_STOP \
   }


#define XMSC_TRACE_RESET( TIMER_ID, TIMER_NAME_STRING) \
   { SDL_PId CurrentPId; \
     RTOSMSCPRINT_START \
     CurrentPId = Self; \
     sprintf(msce_buf, "%lu %s %s %s %d %s %lu %s", \
             CurrentPId, ": reset ", TIMER_NAME_STRING, \
			 ",", TIMER_ID, "; /* #SDTNOW(", tickGet(), ") */"); \
     RTOSMSCPRINT_STOP \
   }

#define RTOSSYSINITPR_MSCPRINT \
    Err = sem_wait(&psmidmsc); \
    XOS_ERROR("RTOSSYSINITPR_MSCPRINT", "sem_wait", Err) \
    send_message(msce_buf); \
    memset(msce_buf, 0, sizeof(msce_buf)); \
    Err = sem_post(&psmidmsc2); \
    XOS_ERROR("RTOSMSCPRINT_STOP", "sem_post", Err)

#else   /*  X_ONE_TASK_PER_INSTANCE_SET  */

#define RTOSXMSC_TRACE_STATIC_CREATE(INSTANCE, PROC_NAME_STRING) \
  memset(msce_buf, 0, sizeof(msce_buf)); \
  sprintf(msce_buf, "%lu %s %s %s", INSTANCE, ": instancehead process ", PROC_NAME_STRING, ";"); \
  send_message(msce_buf);
  
#define RTOSXMSC_TRACE_CREATE( INSTANCE, PROC_NAME_STRING) \
   { SDL_PId ParentPId; ParentPId = SDL_SELF; \
      XMSC_FPRINT((msce_buf, "%lu %s %s %s", INSTANCE, \
			": instancehead process ", PROC_NAME_STRING, ";")) \
      XMSC_FPRINT((msce_buf, "%lu : %s %lu %s", \
	              ParentPId, "create ", INSTANCE, ";")) \
   }

#define RTOSXMSC_TRACE_NEXTSTATE(STATE_NAME_STRING) \
   { SDL_PId CurrentPId; CurrentPId = SDL_SELF; \
     XMSC_FPRINT((msce_buf, "%lu %s %s %s", CurrentPId, ": condition ", STATE_NAME_STRING, ";")) \
   }

#define XMSC_TRACE_INPUT(SIG_NAME_STRING) \
   { SDL_PId CurrentPId, SenderPId; \
     RTOSMSCPRINT_START \
     CurrentPId = SDL_SELF; \
     SenderPId = yVarP->Sender; \
     if (INSIGNAL_PTR->IsTimer) { \
       sprintf(msce_buf, "%lu %s %s %s %d %s %lu %s", \
	           CurrentPId, ": timeout  ", SIG_NAME_STRING, \
			   ",", INSIGNAL_PTR->SignalId, "; /* #SDTNOW(", tickGet(), ") */"); \
     } \
     else { \
       sprintf(msce_buf, "%lu %s %s %s %d %s %lu %s", \
	           CurrentPId, ": in ", SIG_NAME_STRING, ",", \
			   INSIGNAL_PTR->SignalId, " from ", SenderPId, ";"); \
     } \
     RTOSMSCPRINT_STOP \
   }

#define XMSC_TRACE_OUTPUT(RECEIVER, SIGNAL, SIG_NAME_STRING) \
   { SDL_PId CurrentPId; \
     RTOSMSCPRINT_START \
     CurrentPId = SDL_SELF; \
     SignalId = SignalId + 1; \
     SIGNAL->SignalId = SignalId; \
     SIGNAL->IsTimer = 0; \
     if ( xEq_SDL_PId(RECEIVER, ENV_PID) ) { \
       sprintf(msce_buf, "%lu %s %d %s %d %s %lu %s", \
	           CurrentPId, ": out ", SIGNAL->SignalCode, ",", SignalId, " to ", RECEIVER, ";"); \
     } \
     else { \
       sprintf(msce_buf, "%lu %s %s %s %d %s %lu %s", \
	           CurrentPId, ": out ", SIG_NAME_STRING, ",", SignalId, " to ", RECEIVER, ";"); \
     } \
     RTOSMSCPRINT_STOP \
    }

#define XMSC_TRACE_STOP  \
   { SDL_PId CurrentPId; \
     CurrentPId = SDL_SELF; \
     XMSC_FPRINT((msce_buf, "%lu %s", CurrentPId, ": stop;")) \
   }

#define XMSC_TRACE_SET( TIMER, TIMER_NAME_STRING, DUR_EXPR) \
   { SDL_PId CurrentPId; \
     RTOSMSCPRINT_START \
     CurrentPId = SDL_SELF; \
     SignalId = SignalId + 1; \
     TIMER->SignalId = SignalId; \
     TIMER->IsTimer = 1; \
     sprintf(msce_buf, "%lu %s %s %s %d %s %d %s %lu %s", \
	         CurrentPId, ": set ", TIMER_NAME_STRING, ",", \
			 SignalId, " (", DUR_EXPR, "); /* #SDTNOW(", tickGet(), ") */"); \
     RTOSMSCPRINT_STOP \
 }

#define XMSC_TRACE_RESET( TIMER_ID, TIMER_NAME_STRING) \
   { SDL_PId CurrentPId; \
     RTOSMSCPRINT_START \
     CurrentPId = Self; \
     sprintf(msce_buf, "%lu %s %s %s %d %s %lu %s", \
             CurrentPId, ": reset ", TIMER_NAME_STRING, \
			 ",", TIMER_ID, "; /* #SDTNOW(", tickGet(), ") */"); \
     RTOSMSCPRINT_STOP \
   }

#define RTOSSYSINITPR_MSCPRINT \
    Err = sem_wait(&psmidmsc); \
    XOS_ERROR("RTOSSYSINITPR_MSCPRINT", "sem_wait", Err) \
    send_message(msce_buf); \
    memset(msce_buf, 0, sizeof(msce_buf)); \
    Err = sem_post(&psmidmsc2); \
    XOS_ERROR("RTOSMSCPRINT_STOP", "sem_post", Err)

#endif   /*  X_ONE_TASK_PER_INSTANCE_SET  */

#else  /* XMSC_EDITOR */

#define RTOSMSCPRINT_START

#define RTOSMSCPRINT_STOP

#ifdef X_ONE_TASK_PER_INSTANCE_SET


#define RTOSXMSC_TRACE_STATIC_CREATE(INSTANCE, PROC_NAME_STRING) \
  if (strcmp(PROC_NAME_STRING,"Environment")==0){ \
   XMSC_FPRINT(("%lu: instancehead process %s;\n", ENV_PID, PROC_NAME_STRING)) \
  } \
  else {  \
   XMSC_FPRINT(("%lu: instancehead process %s;\n", INSTANCE, PROC_NAME_STRING)) \
  }

#define RTOSXMSC_TRACE_CREATE( INSTANCE, PROC_NAME_STRING) \
   { SDL_PId ParentPId; ParentPId = SDL_SELF; \
   XMSC_TRACE_STATIC_CREATE(INSTANCE, PROC_NAME_STRING) \
   XMSC_FPRINT(("%lu: create %lu;\n", ParentPId, INSTANCE)) }

#define RTOSXMSC_TRACE_NEXTSTATE(STATE_NAME_STRING) \
   { SDL_PId CurrentPId; CurrentPId = SDL_SELF; \
   XMSC_FPRINT(("%lu: condition %s;\n", CurrentPId, STATE_NAME_STRING)) }

#define XMSC_TRACE_INPUT(SIG_NAME_STRING) \
   { SDL_PId CurrentPId, SenderPId; \
     CurrentPId = SDL_SELF; \
     SenderPId = (SDL_PId)yVarP->Sender; \
     if (INSIGNAL_PTR->IsTimer) { \
       XMSC_FPRINT(("%lu: timeout  %s,%d; /* #SDTNOW(%lu) */\n", \
         CurrentPId, SIG_NAME_STRING, \
         INSIGNAL_PTR->SignalId, tickGet())) \
     } \
     else { \
       XMSC_FPRINT(("%lu: in %s,%d from %lu;\n", CurrentPId, \
         SIG_NAME_STRING, INSIGNAL_PTR->SignalId, \
         SenderPId))  \
     } \
   }

#define XMSC_TRACE_OUTPUT(RECEIVER, SIGNAL, SIG_NAME_STRING) \
   { SDL_PId CurrentPId; \
     CurrentPId = SDL_SELF; \
     SignalId = SignalId + 1; \
     SIGNAL->SignalId = SignalId; \
     SIGNAL->IsTimer = 0; \
     if ( xEq_SDL_PId(RECEIVER, ENV_PID) ) { \
       XMSC_FPRINT(("%lu: out %d,%d to %lu;\n", CurrentPId, \
	 SIGNAL->SignalCode, SignalId, (SDL_PId)RECEIVER)) \
     } \
     else { \
       XMSC_FPRINT(("%lu: out %s,%d to %lu;\n", CurrentPId, \
       SIG_NAME_STRING, SignalId, (SDL_PId)RECEIVER)) \
    } \
    }

#define XMSC_TRACE_STOP  \
   { SDL_PId CurrentPId; \
     CurrentPId = SDL_SELF; \
   XMSC_FPRINT(("%lu: stop;\n", CurrentPId)) }

#define XMSC_TRACE_SET( TIMER, TIMER_NAME_STRING, DUR_EXPR) \
   { SDL_PId CurrentPId; \
     CurrentPId = SDL_SELF; \
     SignalId = SignalId + 1; \
     TIMER->SignalId = SignalId; \
     TIMER->IsTimer = 1; \
     XMSC_FPRINT(("%lu: set %s,%d (%d); /* #SDTNOW(%lu) */\n", CurrentPId, \
       TIMER_NAME_STRING, SignalId, DUR_EXPR, tickGet())) }

#define XMSC_TRACE_RESET( TIMER_ID, TIMER_NAME_STRING) \
   { SDL_PId CurrentPId; \
     CurrentPId = Self; \
     XMSC_FPRINT(("%lu: reset %s,%d; /* #SDTNOW(%lu) */\n", CurrentPId, \
     TIMER_NAME_STRING, TIMER_ID, tickGet())) }

#define RTOSSYSINITPR_MSCPRINT \
  XMSC_FPRINT(("%lu: in %d,%d from %lu;\n", ENV_PID, \
         yInSignalPtr->SignalCode , yInSignalPtr->SignalId, \
         (SDL_PId)yInSignalPtr->Sender))

#else   /*  X_ONE_TASK_PER_INSTANCE_SET  */

#define RTOSXMSC_TRACE_STATIC_CREATE(INSTANCE, PROC_NAME_STRING) \
   XMSC_FPRINT(("%lu: instancehead process %s;\n", INSTANCE, PROC_NAME_STRING))

#define RTOSXMSC_TRACE_CREATE( INSTANCE, PROC_NAME_STRING) \
   { SDL_PId ParentPId; ParentPId = SDL_SELF; \
   XMSC_TRACE_STATIC_CREATE(INSTANCE, PROC_NAME_STRING) \
   XMSC_FPRINT(("%lu: create %lu;\n", ParentPId, INSTANCE)) }

#define RTOSXMSC_TRACE_NEXTSTATE(STATE_NAME_STRING) \
   { SDL_PId CurrentPId; CurrentPId = SDL_SELF; \
   XMSC_FPRINT(("%lu: condition %s;\n", CurrentPId, STATE_NAME_STRING)) }

#define XMSC_TRACE_INPUT(SIG_NAME_STRING) \
   { SDL_PId CurrentPId, SenderPId; \
     CurrentPId = SDL_SELF; \
     SenderPId = yVarP->Sender; \
     if (INSIGNAL_PTR->IsTimer) { \
       XMSC_FPRINT(("%lu: timeout  %s,%d; /* #SDTNOW(%lu) */\n", \
         CurrentPId, SIG_NAME_STRING, \
         INSIGNAL_PTR->SignalId, tickGet())) \
     } \
     else { \
       XMSC_FPRINT(("%lu: in %s,%d from %lu;\n", CurrentPId, \
         SIG_NAME_STRING, INSIGNAL_PTR->SignalId, \
         SenderPId))  \
     } \
   }

#define XMSC_TRACE_OUTPUT(RECEIVER, SIGNAL, SIG_NAME_STRING) \
   { SDL_PId CurrentPId; \
     CurrentPId = SDL_SELF; \
     SignalId = SignalId + 1; \
     SIGNAL->SignalId = SignalId; \
     SIGNAL->IsTimer = 0; \
     if ( xEq_SDL_PId(RECEIVER, ENV_PID) ) { \
       XMSC_FPRINT(("%lu: out %d,%d to %lu;\n", CurrentPId, \
       SIGNAL->SignalCode, SignalId, RECEIVER)) \
     } \
     else { \
       XMSC_FPRINT(("%lu: out %s,%d to %lu;\n", CurrentPId, \
       SIG_NAME_STRING, SignalId, RECEIVER)) \
    } \
    }

#define XMSC_TRACE_STOP  \
   { SDL_PId CurrentPId; \
     CurrentPId = SDL_SELF; \
   XMSC_FPRINT(("%lu: stop;\n", CurrentPId)) }

#define XMSC_TRACE_SET( TIMER, TIMER_NAME_STRING, DUR_EXPR) \
   { SDL_PId CurrentPId; \
     CurrentPId = SDL_SELF; \
     SignalId = SignalId + 1; \
     TIMER->SignalId = SignalId; \
     TIMER->IsTimer = 1; \
     XMSC_FPRINT(("%lu: set %s,%d (%d); /* #SDTNOW(%lu) */\n", CurrentPId, \
       TIMER_NAME_STRING, SignalId, DUR_EXPR, tickGet())) }

#define XMSC_TRACE_RESET( TIMER_ID, TIMER_NAME_STRING) \
   { SDL_PId CurrentPId; \
     CurrentPId = Self; \
     XMSC_FPRINT(("%lu: reset %s,%d; /* #SDTNOW(%lu) */\n", CurrentPId, \
     TIMER_NAME_STRING, TIMER_ID, tickGet())) }

#define RTOSSYSINITPR_MSCPRINT \
  XMSC_FPRINT(("%lu: in %d,%d from %lu;\n", xEnvPId, \
         yInSignalPtr->SignalCode , yInSignalPtr->SignalId, \
         yInSignalPtr->Sender))

#endif   /*  X_ONE_TASK_PER_INSTANCE_SET  */

#endif  /* XMSC_EDITOR */

#else  /* XMSC_TRACE */

#define RTOSMSCPRINT_START 

#define RTOSMSCPRINT_STOP

#endif   /*  XMSC_TRACE  */

#ifdef XOS_TRACE
#ifndef X_ONE_TASK_PER_INSTANCE_SET
#define XOS_FPRINT(PARAM) \
{  SDL_PId CurrentPId; \
   CurrentPId = yVarP->Self; \
   if (LastUsedPId != CurrentPId) \
     printf("\nProcess instance %s\n", CurrentPId); \
   printf PARAM; \
   LastUsedPId = yVarP->Self; \
}
#define XOS_FPRINTADDR(PARAM) \
   {  \
   SDL_PId CurrentPId; \
   CurrentPId = (*yVarP)->Self; \
   if (LastUsedPId != CurrentPId) \
     printf("\n** Process: %s instance: %s **\n", \
            (*yVarP)->ProcName, CurrentPId); \
   printf PARAM; \
   LastUsedPId = (*yVarP)->Self; \
   }
#else /* ifndef X_ONE_TASK_PER_INSTANCE_SET */
#define XOS_FPRINT(PARAM) \
{  xEPrsNode CurrentPId; \
   CurrentPId = SDL_SELF; \
   if (LastUsedPId != CurrentPId) \
   printf("\n** Process: %s instance: %ld **\n", \
          yInstanceSetVars->name, CurrentPId); \
   printf PARAM; \
   LastUsedPId = SDL_SELF; \
}
#define XOS_FPRINTADDR(PARAM) \
   {  \
   xEPrsNode CurrentPId; \
   CurrentPId = (*yVarP)->PrsNode;  \
   if (LastUsedPId != CurrentPId) \
     printf("\n** Process: %s instance: %ld **\n", \
            yInstanceSetVars->name, CurrentPId); \
   printf PARAM; \
   LastUsedPId = (*yVarP)->PrsNode; \
   }

#endif /* ifndef X_ONE_TASK_PER_INSTANCE_SET */
#else /* ifdef XOS_TRACE */
#define XOS_FPRINT(PARAM) 
#define XOS_FPRINTADDR(PARAM)
#endif /* ifdef XOS_TRACE */


/****+***************************************************************
     SDL Save
********************************************************************/

typedef struct xSignalHeaderStruct xSaveQStruct;
typedef xSignalHeader xSaveQ;

#define RTOSSAVEQ_TYPE xSaveQ 

/****+***************************************************************
     SDL Timer
********************************************************************/

extern void SDL_Reset( xTimerHeader TimerName, xSaveQ SaveQ);

/****+***************************************************************
     sdl
********************************************************************/
extern void xSaveSignal  XPP((
  RTOSSAVEQ_TYPE  SaveQ,
  RTOSSIGNAL_DEF yInSignalPtr));

extern void xDiscardSignal XPP((
  xSignalHeader    *DiscardSignal));

#ifdef X_ONE_TASK_PER_INSTANCE_SET
extern void xKillSaveQ XPP((
  xSignalHeader  SaveQ,
  SDL_PId        CurrentPId));
#else
extern void xKillSaveQ  XPP((
  xSignalHeader     SaveQ));
#endif

extern SDL_PId xTo_Process XPP((
  xPrsIdNode  PrsNode));

extern void xHandle_Sig XPP((
  RTOSSIGNAL_DEF  OutputSignal,SDL_PId Sender,int SigPar_Size,SDL_PId Receiver, RTOSTASK_TYPE ReceiverTask RTOSHANDLEMESS_TYPE));




/****+***************************************************************
     Initialization functions
********************************************************************/

/*---+---------------------------------------------------------------
     System_Init_Process
-------------------------------------------------------------------*/
#define RTOSMAINRETURNTYPE int
#define RTOSMAINNAME main
#define RTOSMAINNAME_PARAM XPP((int argc, char *argv[]))
extern RTOSMAINRETURNTYPE RTOSMAINNAME XPP((int argc, char *argv[]));

#define RTOSMAINRETURNSTMT return 0; /* unreachable code! */

#ifdef XMSC_EDITOR

#define RTOSSYSINITFUNC_VAR \
  xSignalHeader yInSignalPtr; \
  xSignalHeader yOutputSignalPtr; \
  int i; \
  pthread_t   ThreadPid; \
  mqd_t   QueuePId; \
  struct sched_param sched_param_default; \
  int post_fd;

#else

#define RTOSSYSINITFUNC_VAR \
  xSignalHeader yInSignalPtr; \
  xSignalHeader yOutputSignalPtr; \
  int i; \
  pthread_t   ThreadPid; \
  mqd_t   QueuePId; \
  struct sched_param sched_param_default;

#endif  /* XMSC_EDITOR */

#define RTOSSYSINITFUNC_SDLNULL 

#ifdef XMSC_EDITOR

#define RTOSSYSINITPR_SEMCREATE \
  Err = sem_init(&taskSem,1,0); \
  XOS_ERROR("RTOSSYSINITPR_SEMCREATE", "sem_init",Err) \
  Err = sem_init(&Count_Sem, 1, 1); \
  XOS_ERROR("RTOSSYSINITPR_SEMCREATE", "sem_init", Err) \
  Err = sem_init(&Mem_Sem, 1, 1); \
  XOS_ERROR("RTOSSYSINITPR_SEMCREATE", "sem_init", Err) \
  Err = pthread_mutex_init(&createdProcesses_Mutex, 0); \
  XOS_ERROR("RTOSSYSINITPR_SEMCREATE", "pthread_mutex_init", Err) \
  Err = sem_init(&psmidmsc, 1, 0); \
  XOS_ERROR("RTOSSYSINITPR_SEMCREATE", "sem_init", Err) \
  Err = sem_init(&psmidmsc2, 1, 1); \
  XOS_ERROR("RTOSSYSINITPR_SEMCREATE", "sem_init", Err) \
\
  sigemptyset(&signal_set); \
  sigaddset(&signal_set, SIGUSR1); \
  act.sa_flags = 0; \
  act.sa_mask = signal_set; \
  act.sa_handler = &signal_handler; \
  sigaction(SIGUSR1, &act, NULL); \
  mq_attr.mq_maxmsg = MAXNOOFMSG; \
  mq_attr.mq_msgsize = MAXMSGSIZE; \
  mq_attr.mq_flags = 0; /* set queues to block */ \
  pthread_attr_init(&Attributes); \
  pthread_attr_setstacksize(&Attributes, DEF_STACK_SIZE); \
  pthread_attr_setschedpolicy(&Attributes, SCHED_OTHER); \
  pthread_attr_setdetachstate(&Attributes, PTHREAD_CREATE_DETACHED); \
  pthread_attr_setscope(&Attributes, PTHREAD_SCOPE_PROCESS);

#else

#define RTOSSYSINITPR_SEMCREATE \
  Err = sem_init(&taskSem,1,0); \
  XOS_ERROR("RTOSSYSINITPR_SEMCREATE", "sem_init",Err) \
  Err = sem_init(&Count_Sem, 1, 1); \
  XOS_ERROR("RTOSSYSINITPR_SEMCREATE", "sem_init", Err) \
  Err = sem_init(&Mem_Sem, 1, 1); \
  XOS_ERROR("RTOSSYSINITPR_SEMCREATE", "sem_init", Err) \
  Err = pthread_mutex_init(&createdProcesses_Mutex, 0); \
  XOS_ERROR("RTOSSYSINITPR_SEMCREATE", "pthread_mutex_init", Err) \
\
  sigemptyset(&signal_set); \
  sigaddset(&signal_set, SIGUSR1); \
  act.sa_flags = 0; \
  act.sa_mask = signal_set; \
  act.sa_handler = &signal_handler; \
  sigaction(SIGUSR1, &act, NULL); \
  mq_attr.mq_maxmsg = MAXNOOFMSG; \
  mq_attr.mq_msgsize = MAXMSGSIZE; \
  mq_attr.mq_flags = 0; /* set queues to block */ \
  pthread_attr_init(&Attributes); \
  pthread_attr_setstacksize(&Attributes, DEF_STACK_SIZE); \
  pthread_attr_setschedpolicy(&Attributes, SCHED_OTHER); \
  pthread_attr_setdetachstate(&Attributes, PTHREAD_CREATE_DETACHED); \
  pthread_attr_setscope(&Attributes, PTHREAD_SCOPE_PROCESS);

#endif  /* XMSC_EDITOR */

#ifdef XMSC_EDITOR

#define RTOSENV_PROCID \
  post_fd=connect_to_sdt (argv[0]); \
  start_msc (post_fd); \
  start_msc_diagram (post_fd);

#else

#define RTOSENV_PROCID

#endif  /* XMSC_EDITOR */

#define RTOSSYSINITPR_SEMGIVE \
  for (i=1;(i<=createdProcesses);i++) { \
    Err = sem_post(&taskSem); \
    XOS_ERROR("userInit", "sem_post", Err) \
  }

#ifdef XMSC_EDITOR

#define RTOSSYSINITPROC_RECEIVE

#else  /* XMSC_EDITOR */

#ifdef X_ONE_TASK_PER_INSTANCE_SET

#define RTOSSYSINITPROC_RECEIVE \
    yInSignalPtr = xAlloc(MAXMSGLENGTH); \
    QueuePId = mq_open((char *)xEnvPIdQ, 2, 0, 0); \
    mq_open_ERROR("RTOSSYSINITPROC_RECEIVE", "mq_open", QueuePId) \
    Err_Rec = mq_receive(QueuePId ,(char *)yInSignalPtr, MAXMSGLENGTH, NULL); \
    mq_receive_ERROR("RTOSSYSINITPROC_RECEIVE", "mq_receive", Err_Rec) \
    Err = mq_close(QueuePId); /* MAS */ \
    XOS_ERROR("RTOSSYSINITPROC_RECEIVE", "mq_close", Err)

                       
#else

#define RTOSSYSINITPROC_RECEIVE \
    yInSignalPtr = xAlloc(MAXMSGLENGTH); \
    QueuePId = mq_open((char *)xEnvPId, 2, 0, 0); \
    mq_open_ERROR("RTOSSYSINITPROC_RECEIVE", "mq_open", QueuePId) \
    Err_Rec = mq_receive(QueuePId ,(char *)yInSignalPtr, MAXMSGLENGTH, NULL); \
    mq_receive_ERROR("RTOSSYSINITPROC_RECEIVE", "mq_receive", Err_Rec) \
    Err = mq_close(QueuePId); \
    XOS_ERROR("RTOSSYSINITPROC_RECEIVE", "mq_close", Err)


#endif  /* X_ONE_TASK_PER_INSTANCE_SET */

#endif  /* XMSC_EDITOR */

#define RTOSSYSINITPR_SENDER SDL_NULL

/*---+---------------------------------------------------------------
     xInitTimer
-------------------------------------------------------------------*/
#define RTOSXTIMERTASK_PARAM  void *dummy
#define RTOSXTIMERTASK_RTNTYPE void *
extern RTOSXTIMERTASK_RTNTYPE xTimerTask XPP ((RTOSXTIMERTASK_PARAM));

#define RTOSXINITTIMER \
{ \
   int errcode,policy; \
   pthread_t ThreadPid; \
   pthread_attr_t Timer_Attributes; \
   struct sched_param prio; \
   errcode = pthread_attr_init(&Timer_Attributes); \
   XOS_ERROR("RTOSXINITTIMER", "pthread_attr_init", errcode) \
   errcode = pthread_attr_setstacksize(&Timer_Attributes, DEF_STACK_SIZE); \
   XOS_ERROR("RTOSXINITTIMER", "pthread_attr_setstacksize", errcode) \
   errcode = pthread_attr_setschedpolicy(&Timer_Attributes, SCHED_OTHER); \
   XOS_ERROR("RTOSXINITTIMER", "pthread_attr_setschedpolicy", errcode) \
   errcode = pthread_attr_setdetachstate(&Timer_Attributes, PTHREAD_CREATE_DETACHED); \
   XOS_ERROR("RTOSXINITTIMER", "pthread_attr_setdetachstate", errcode) \
   errcode = pthread_attr_setscope(&Timer_Attributes, PTHREAD_SCOPE_SYSTEM); \
   XOS_ERROR("RTOSXINITTIMER", "pthread_attr_setscope", errcode) \
   TimerPIdQ = mq_open("/TimerQ",QUEUEFLAG, QUEUEMODE, &mq_attr); \
   mq_open_ERROR("RTOSXINITTIMER", "mq_open", TimerPIdQ) \
   errcode = pthread_create(&ThreadPid, &Timer_Attributes, xTimerTask, NULL); \
   XOS_ERROR("RTOSXINITTIMER", "pthread_create", errcode) \
   errcode = pthread_getschedparam(pthread_self(), &policy, &prio); \
   XOS_ERROR("RTOSXINITTIMER", "pthread_getschedparam", errcode) \
   prio.sched_priority = (prio.sched_priority)+10; \
   errcode = pthread_setschedparam(ThreadPid, SCHED_OTHER, &prio); \
   XOS_ERROR("RTOSXINITTIMER", "pthread_setschedparam", errcode) \
   errcode = pthread_attr_destroy(&Timer_Attributes); \
   XOS_ERROR("RTOSXINITTIMER", "pthread_attr_destroy", errcode) \
}

/****+***************************************************************
     Timer Procedures
********************************************************************/
/*---+---------------------------------------------------------------
     xSDLReset
-------------------------------------------------------------------*/

#ifdef X_ONE_TASK_PER_INSTANCE_SET

#ifdef XMSC_TRACE
#define XSDLRESETWITHPARAM(TIMER_NAME, SELF,INPUTSIG, OUTPUTSIG,EQUALF, TIMER_NAME_STRING) \
   xSDLReset( TIMER_NAME, SELF, yInstanceSetVars->SaveQ, INPUTSIG, OUTPUTSIG, EQUALF,\
             TIMER_NAME_STRING);

#else /* XMSC_TRACE */

#define XSDLRESETWITHPARAM(TIMER_NAME, SELF,INPUTSIG, OUTPUTSIG,EQUALF, TIMER_NAME_STRING) \
   xSDLReset( TIMER_NAME, SELF, yInstanceSetVars->SaveQ, INPUTSIG, OUTPUTSIG, EQUALF);

#endif /* XMSC_TRACE */

#else /* X_ONE_TASK_PER_INSTANCE_SET */

#ifdef XMSC_TRACE
#define XSDLRESETWITHPARAM(TIMER_NAME, SELF,INPUTSIG, OUTPUTSIG,EQUALF, TIMER_NAME_STRING) \
   xSDLReset( TIMER_NAME, SELF, yVarP->SaveQ, INPUTSIG, OUTPUTSIG, EQUALF,\
             TIMER_NAME_STRING);

#else /* XMSC_TRACE */

#define XSDLRESETWITHPARAM(TIMER_NAME, SELF,INPUTSIG, OUTPUTSIG,EQUALF, TIMER_NAME_STRING) \
   xSDLReset( TIMER_NAME, SELF, yVarP->SaveQ, INPUTSIG, OUTPUTSIG, EQUALF);

#endif /* XMSC_TRACE */
#endif /* X_ONE_TASK_PER_INSTANCE_SET */

#ifdef XMSC_TRACE
extern void xSDLReset  XPP((
  int Timer_Name, 
  SDL_PId Self,
  xSignalHeader SaveQ,
  xSignalHeader InSignalPtr,
  xSignalHeader yOutputSignalPtr,
  xbool (* yEq)(void * VarP1, void * VarP2),
  char *SignalName ));
#else
extern void xSDLReset  XPP((
  int Timer_Name, 
  SDL_PId Self,
  xSignalHeader SaveQ,
  xSignalHeader InSignalPtr,
  xSignalHeader yOutputSignalPtr,
  xbool (* yEq)(void * VarP1, void * VarP2)));
#endif

#ifdef XMSC_TRACE

#define RTOSXSDLRESET_PARAMETERS \
(  int TimerName, \
  SDL_PId Self, \
  xSignalHeader SaveQ, \
  xSignalHeader InSignalPtr, \
  xSignalHeader yOutputSignalPtr, \
  xbool (* yEq)(void * VarP1, void * VarP2), \
  char *SignalName)

#define XSDLRESET( TIMER_NAME,SAVEQ, TIMER_NAME_STRING) \
   xSDLReset( TIMER_NAME,SDL_SELF, SAVEQ, RTOSINSIGNALPTR, NULL, (xbool)0,TIMER_NAME_STRING);
#else


#define RTOSXSDLRESET_PARAMETERS \
(  int TimerName, \
  SDL_PId Self, \
  xSignalHeader SaveQ, \
  xSignalHeader InSignalPtr, \
  xSignalHeader yOutputSignalPtr, \
  xbool (* yEq)(void * VarP1, void * VarP2))

#define XSDLRESET( TIMER_NAME,SAVEQ, TIMER_NAME_STRING) \
   xSDLReset(TIMER_NAME, SDL_SELF, SAVEQ, RTOSINSIGNALPTR, NULL, (xbool)0);
#endif

#define RTOSXSDLRESET_VARS \
  xTimerHeader  yTimerReset; \
  xSignalHeader TempSaved; \
  int           NoOfMessages, i; \
  mqd_t 		QueuePId; \
  struct mq_attr       TmpQueueAttr;

#define RTOSXSDLRESET_INIT \
 yTimerReset = (xTimerHeader)xAlloc( sizeof(xTimerHeaderRec)); \
  yTimerReset->SignalCode = ResetTimer; \
  yTimerReset->Sender = Self; \
  yTimerReset->TimerToSetOrReset = TimerName; \
  yTimerReset->yEq = yEq; \
  yTimerReset->Param = (xTimerHeader)yOutputSignalPtr; \
  yTimerReset->TestParams = (yOutputSignalPtr != NULL && yEq != NULL); \
  Err = mq_send((mqd_t)TimerPIdQ, (char *)yTimerReset, \
                 sizeof(xTimerHeaderRec), \
                 NULL); \
  XOS_ERROR("RTOSXSDLRESET_INIT", "mq_send", Err) \
  xFree((void**)&yTimerReset);

#define RTOSCHECKEQPARAM_INTIMER \
  if(yInSignalPointer->TestParams) { \
    if(yEqFunc(((xTimerHeader)(((xTimerHeader)yInSignalPointer)->Param)+1),(((xTimerHeader)TempTimer)+1))) { \
      break; \
    } \
  } \
  else

#define RTOSCHECKEQPARAM \
  if(yOutputSignalPtr != NULL && yEq !=NULL) { \
    if((*yEq)(((xTimerHeader)yOutputSignalPtr)+1,((xTimerHeader)TempSaved)+1)) { \
      RTOSFREETIMERSTRINGPARAMS1((xTimerHeader)TempSaved); \
      xDiscardSignal(&TempSaved); \
      return; \
    } \
  } \
  else {

#define RTOSCHECKEQPARAM2 \
  if(yOutputSignalPtr != NULL && yEq !=NULL) { \
    if((*yEq)(((xTimerHeader)yOutputSignalPtr)+1,((xTimerHeader)TempSaved)+1)) { \
      return; \
    } \
  } \
  else {

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define RTOSSELF \
(char *)Self->NameNode->PROCID
#else
#define RTOSSELF \
(char *)Self
#endif

#define RTOSXSDLRESET_WAITREPLY \
  yTimerReset = (xTimerHeader)xAlloc(MAXMSGLENGTH); \
  QueuePId = mq_open((char *)RTOSSELF, 2, 0, 0); \
  mq_open_ERROR("RTOSXSDLRESET_WAITREPLY", "mq_open", QueuePId) \
  Err_Rec = mq_receive(QueuePId, \
                      (char *)yTimerReset ,MAXMSGLENGTH, NULL); \
  mq_receive_ERROR("RTOSXSDLRESET_WAITREPLY", "mq_receive1", Err_Rec) \
\
  while (yTimerReset->SignalCode != ResetTimer) { \
    xSaveSignal(SaveQ, (xSignalHeader)yTimerReset); \
    yTimerReset = (xTimerHeader)xAlloc(MAXMSGLENGTH); \
    Err_Rec = mq_receive(QueuePId, \
                      (char *)yTimerReset , MAXMSGLENGTH, NULL); \
    mq_receive_ERROR("RTOSXSDLRESET_WAITREPLY", "mq_receive2", Err_Rec) \
  } \
\
  if (yTimerReset->TimerToSetOrReset == TimerWasFound) { \
    XMSC_TRACE_RESET(yTimerReset->SignalId, SignalName); \
    xFree((void **)&yTimerReset); \
    Err = mq_close(QueuePId); \
    XOS_ERROR("RTOSXSDLRESET_WAITREPLY", "mq_close", Err) \
    return; \
  } \
  xFree((void **)&yTimerReset); \
  Err = mq_close(QueuePId); \
  XOS_ERROR("RTOSXSDLRESET_WAITREPLY", "mq_close", Err)


#define RTOSTEMPSAVED_SIGNO \
TempSaved->SignalCode

#define RTOSXRESETTEMPTIMER_SIGNALID \
yTimerReset->SignalId

#ifdef X_ONE_TASK_PER_INSTANCE_SET

#define RTOSXSDLRESET_REMOVETIMER \
  QueuePId = mq_open((char *)RTOSSELF, 2, 0, 0); \
  mq_open_ERROR("RTOSXSDLRESET_REMOVETIMER", "mq_open", QueuePId) \
  Err = mq_getattr(QueuePId,&TmpQueueAttr); \
  XOS_ERROR("RTOSXSDLRESET_REMOVETIMER", "mq_getattr", Err) \
  NoOfMessages = TmpQueueAttr.mq_curmsgs; \
  for (i=0; i<NoOfMessages; i++) { \
    yTimerReset = (xTimerHeader)xAlloc(MAXMSGLENGTH); \
	QueuePId = mq_open((char *)RTOSSELF, 2, 0, 0); \
    mq_open_ERROR("RTOSXSDLRESET_REMOVETIMER", "mq_open", QueuePId) \
    Err_Rec = mq_receive(QueuePId,  \
           (char *)yTimerReset , MAXMSGLENGTH, NULL); \
    mq_receive_ERROR("RTOSXSDLRESET_REMOVETIMER", "mq_receive", Err_Rec) \
    if ((yTimerReset->SignalCode == TimerName) && (xEq_SDL_PId(yTimerReset->Receiver, Self))) { \
      if (yOutputSignalPtr != NULL) { \
        if ((*yEq)(((xTimerHeader)yOutputSignalPtr)+1, ((xTimerHeader)yTimerReset)+1)) { \
          /* Timer found, free memory and return */ \
          XMSC_TRACE_RESET(yTimerReset->SignalId, SignalName); \
          RTOSFREETIMERSTRINGPARAMS1((xTimerHeader)yTimerReset) \
          xFree((void **)&yTimerReset); \
          Err = mq_close(QueuePId); /*MAS */\
     	  XOS_ERROR("RTOSXSDLRESET_REMOVETIMER", "mq_close", Err) \
          return; \
        } \
      } \
      else { \
        /* Timer found, free memory and return */ \
        XMSC_TRACE_RESET(yTimerReset->SignalId, SignalName); \
        xFree((void **)&yTimerReset); \
        Err = mq_close(QueuePId); /* MAS */\
    	XOS_ERROR("RTOSXSDLRESET_REMOVETIMER", "mq_close", Err) \
        return; \
      } \
    } \
    /* Other signal or timer found, put them in SaveQ and continue */ \
    xSaveSignal( SaveQ, (xSignalHeader)yTimerReset); \
  } \
  Err = mq_close(QueuePId); /* MAS*/  \
  XOS_ERROR("RTOSXSDLRESET_REMOVETIMER", "mq_close", Err) 

#else

#define RTOSXSDLRESET_REMOVETIMER \
  QueuePId = mq_open((char *)RTOSSELF, 2, 0, 0); \
  mq_open_ERROR("RTOSXSDLRESET_REMOVETIMER", "mq_open", QueuePId) \
  Err = mq_getattr(QueuePId,&TmpQueueAttr); \
  XOS_ERROR("RTOSXSDLRESET_REMOVETIMER", "mq_getattr", Err) \
  NoOfMessages = TmpQueueAttr.mq_curmsgs; \
  for (i=0; i<NoOfMessages; i++) { \
    yTimerReset = (xTimerHeader)xAlloc(MAXMSGLENGTH); \
    Err_Rec = mq_receive(QueuePId,  \
           (char *)yTimerReset , MAXMSGLENGTH, NULL); \
    mq_receive_ERROR("RTOSXSDLRESET_REMOVETIMER", "mq_receive", Err_Rec) \
    if (yTimerReset->SignalCode == TimerName) { \
      if (yOutputSignalPtr != NULL) { \
        if ((*yEq)(((xTimerHeader)yOutputSignalPtr)+1, ((xTimerHeader)yTimerReset)+1)) { \
          /* Timer found, free memory and return */ \
          XMSC_TRACE_RESET(yTimerReset->SignalId, SignalName); \
          xFree((void **)&yTimerReset); \
	  Err = mq_close(QueuePId); \
	  XOS_ERROR("RTOSXSDLRESET_REMOVETIMER", "mq_close", Err) \
          return; \
        } \
      } \
      else { \
        /* Timer found, free memory and return */ \
        XMSC_TRACE_RESET(yTimerReset->SignalId, SignalName); \
        xFree((void **)&yTimerReset); \
	Err = mq_close(QueuePId); \
	XOS_ERROR("RTOSXSDLRESET_REMOVETIMER", "mq_close", Err) \
        return; \
      } \
    } \
    /* Other signal or timer found, put them in SaveQ and continue */ \
    xSaveSignal( SaveQ, (xSignalHeader)yTimerReset); \
  } \
  Err = mq_close(QueuePId); \
  XOS_ERROR("RTOSXSDLRESET_REMOVETIMER", "mq_close", Err)

#endif

/*---+---------------------------------------------------------------
     xSDLActive
-------------------------------------------------------------------*/

#define RTOSXSDLACTIVE_PARAMETERS \
XPP(( \
 int TimerName, \
 SDL_PId Self, \
 xSignalHeader SaveQ,\
 xSignalHeader CurrentInSaveQ))

#define RTOSXSDLACTIVE_VARS \
  xTimerHeader  yTimerActive; \
  xSignalHeader TempSaved; \
  int           NoOfMessages, i; \
  mqd_t 		QueuePId; \
  struct mq_attr       TmpQueueAttr;

#ifdef XNOTIMERPARAMS
#define RTOSXSDLACTIVE_ALLOC_EXTRA
#else
#define RTOSXSDLACTIVE_ALLOC_EXTRA \
   yTimerActive->SigSize = sizeof(xTimerHeaderRec);
#endif

#define RTOSXSDLACTIVE_ALLOC \
  yTimerActive = (xTimerHeader)xAlloc( sizeof(xTimerHeaderRec)); \
  yTimerActive->SignalCode = ActiveTimer; \
  RTOSXSDLACTIVE_ALLOC_EXTRA \
  yTimerActive->Sender = Self; 

#define RTOSACTIVEINTIMERPROCESS_VARS \
  mqd_t QueuePId;

#define RTOSXACTIVETIMER_TIMERTOFIND_2 \
  yTimerActive->TimerToSetOrReset

#define RTOSXSDLACTIVE_WAITREPLY \
  yTimerActive = (xTimerHeader)xAlloc(MAXMSGLENGTH); \
  QueuePId = mq_open((char *)RTOSSELF, 2, 0, 0); \
  mq_open_ERROR("RTOSXSDLACTIVE_WAITREPLY", "mq_open", QueuePId) \
  Err_Rec = mq_receive((mqd_t)QueuePId, (char *)yTimerActive , \
                    MAXMSGLENGTH, NULL);\
  mq_receive_ERROR("RTOSXSDLACTIVE_WAITREPLY", "mq_receive", Err_Rec) \
  while (yTimerActive->SignalCode != ActiveTimer) { \
    xSaveSignal(SaveQ, (xSignalHeader)yTimerActive); \
    yTimerActive = (xTimerHeader)xAlloc(MAXMSGSIZE); \
    Err = mq_receive((mqd_t)QueuePId, (char *)yTimerActive , \
                    MAXMSGSIZE, NULL); \
    mq_receive_ERROR("RTOSXSDLACTIVE_WAITREPLY", "mq_receive", Err) \
  } \
\
  if (yTimerActive->TimerToSetOrReset == TimerWasFound) { \
    xFree((void **)&yTimerActive); \
      Err = mq_close(QueuePId); \
    XOS_ERROR("RTOSXSDLACTIVE_WAITREPLY", "mq_close", Err) \
    return( SDL_True); \
  } \
  xFree((void **)&yTimerActive); \
  Err = mq_close(QueuePId); \
  XOS_ERROR("RTOSXSDLACTIVE_WAITREPLY", "mq_close", Err)


#define RTOSSENDTIMERALLOCTIMER

#define RTOSSENDTIMERALLOCREPLY

#define RTOSSENDTIMERALLOC

#ifdef XNOTIMERPARAMS

#define RTOSSENDTIMER(SIGPTR,RECEIVER) \
  QueuePId = mq_open((char *)RECEIVER, 2, 0, 0); \
  mq_open_ERROR("RTOSSENDTIMER", "mq_open", QueuePId) \
  Err = mq_send((mqd_t)QueuePId, \
                (char *)*SIGPTR, sizeof(xTimerHeaderRec), \
                NULL); \
  XOS_ERROR("RTOSSENDTIMER", "mq_send", Err) \
  xFree((void**)SIGPTR); \
  Err = mq_close(QueuePId); \
  XOS_ERROR("RTOSSENDTIMER", "mq_close", Err)

#else

#define RTOSSENDTIMER(SIGPTR,RECEIVER) \
  QueuePId = mq_open((char *)RECEIVER, 2, 0, 0); \
  mq_open_ERROR("RTOSSENDTIMER", "mq_open", QueuePId) \
  Err = mq_send((mqd_t)QueuePId, \
                (char *)*SIGPTR,(*SIGPTR)->SigSize, \
                NULL); \
  XOS_ERROR("RTOSSENDTIMER", "mq_send", Err) \
  xFree((void**)SIGPTR); \
  Err = mq_close(QueuePId); \
  XOS_ERROR("RTOSSENDTIMER", "mq_close", Err)

#endif
       /* XNOTIMERPARAMS */

#define RTOSALLOCMESS \
  yTimerActive = (xTimerHeader)xAlloc(MAXMSGLENGTH); \
  Err = mq_receive((mqd_t)QueuePId, (char *)yTimerActive , \
                    MAXMSGLENGTH, NULL); \
  mq_receive_ERROR("RTOSALLOCMESS", "mq_receive", Err)

#define RTOSLOOK_FOR_TIMER \
     /*  QueuePId = mq_open((char *)RTOSTIMER_QUEUEID, 2, 0, 0); \
  mq_open_ERROR("RTOSLOOK_FOR_TIMER","mq_open", QueuePId)*/ \
  Err = mq_getattr(QueuePId,&TmpQueueAttr); \
  XOS_ERROR("RTOSLOOK_FOR_TIMER", "mq_getattr", Err) \
  /*  Err = mq_close(QueuePId); \
  XOS_ERROR("RTOSLOOK_FOR_TIMER","mq_close",Err)*/ \
  NoOfMessages = TmpQueueAttr.mq_curmsgs;

#define RTOSMSG_IN_Q \
  NoOfMessages >0

#define RTOSYTIMERACTIVE_SIGNO \
  yTimerActive->SignalCode

/****+***************************************************************
     xEPrsNode handling
********************************************************************/

/*---+---------------------------------------------------------------
     xAllocPrsUseMyMemory
-------------------------------------------------------------------*/
#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define RTOSALLOCPRSSEMTAKE
#else
#define RTOSALLOCPRSSEMTAKE
#endif

#define RTOSALLOCPRSSEMGIVE

#ifdef X_ONE_TASK_PER_INSTANCE_SET
extern xEPrsNode xAllocPrsUseMyMemory  XPP(( xPrsIdNode  PType ));
#else
extern xEPrsNode xAllocPrsUseMyMemory XPP(( xPrsIdNode  PType, SDL_PId PId ));
#endif

/****+***************************************************************
     Structure nodes
********************************************************************/

#ifdef X_ONE_TASK_PER_INSTANCE_SET
typedef struct {
  xSignalHeader  SaveQ;
  xSignalHeader  CurrentInSaveQ;
  xSignalHeader  yInSignalPtr;
  char           name[100];
  xptrint        PrsDataSize;
}  xPrsInstanceSetVars;
#endif

#define RTOSXPRSIDCOMP0    void    *         (*RTOSPAD) XPP((void *));
#define RTOSXPRSIDCOMP1 \
   void     (*PAD_Function) XPP((void *, SDL_PId, xPrsInstanceSetVars *));


#define RTOSXPRSIDCOMP2 \
   void              (*PAD_Function) XPP((void *));

#define RTOSXPRSIDCOMP3 \
    char      * PROCID;

/****+***************************************************************
     SDL PId
********************************************************************/
#define xEq_SDL_PId(A,B)        ((A)==(B))
#define xEq_SDL_PId_NULL(A)     ((A)==(SDL_NULL))
extern SDL_PId      xEnvPId;
extern SDL_PId		SDL_NULL;

/****+***************************************************************
sctpred.h
********************************************************************/

/****+***************************************************************
01   Typedef, Default value, Literals
********************************************************************/


/****+***************************************************************
     osesdl.c
********************************************************************/

/****+***************************************************************
     SDL Save
********************************************************************/

/*---+---------------------------------------------------------------
     xSaveSignal
-------------------------------------------------------------------*/
#define RTOSXSAVESIGNAL \
{ \
  /* Insert New signal (yInSignalPtr) last in save queue */ \
  SaveQ->Pre->Suc = (xSaveQ)yInSignalPtr; \
  yInSignalPtr->Suc = (xSignalHeader)SaveQ; \
  yInSignalPtr->Pre = (xSignalHeader)SaveQ->Pre; \
  SaveQ->Pre = (xSaveQ)yInSignalPtr; \
}

/*---+---------------------------------------------------------------
     xKillSaveQ
-------------------------------------------------------------------*/
#define RTOSTEMP_RECEIVER \
Temp1->Receiver

/*------------------------------------------------------------------------
 *      xInputSignal
 *-----------------------------------------------------------------------*/

#define RTOSCURRENTINSAVEQPTR RTOSCURRENTINSAVEQ 

#ifdef X_ONE_TASK_PER_INSTANCE_SET

#define RTOSCURRENTINSAVEQ \
yInstanceSetVars->CurrentInSaveQ


#define RTOSSTARTUPSIGNAL \
yInstanceSetVars->yInSignalPtr->SignalCode

#define RTOSSTARTUPSIGNALVARP \
yInstanceSetVars->yInSignalPtr->Receiver->VarP

#define RTOSSTARTUPSIGNALRESTARTPAD \
yInstanceSetVars->yInSignalPtr->Receiver->NameNode->PAD_Function;

#define RTOSSTARTUPSIGNALRECEIVER \
yInstanceSetVars->yInSignalPtr->Receiver

#define RTOSSTARTUPSIGNALPARENT \
yInstanceSetVars->yInSignalPtr->Sender

#define RTOSXINPUTSIGNALVARS \
  unsigned long RetCode; \
  mqd_t QueuePId;

#define RTOSXINPUTRESTARTPAD_CALL \
(*(*yVarP)->RestartPAD)(*yVarP,(SDL_PId) \
                        ((*yVarP)->PrsNode)->NameNode->PROCID, \
                         yInstanceSetVars);

#define RTOSXINPUTSIGNAL_SEMS

#else

#define RTOSSTARTUPSIGNAL \
(*yVarP)->yInSignalPtr->SignalCode

#define RTOSSTARTUPSIGNAL_PADFUNCTION \
((xStartUpSignalHeader)((*yVarP)->yInSignalPtr+1))->PrsNode->NameNode->PAD_Function;

#define RTOSXINPUTSIGNALVARS \
  unsigned long RetCode; \
  mqd_t QueuePId;

#define RTOSCURRENTINSAVEQ \
(*yVarP)->CurrentInSaveQ

#define RTOSSTARTSIGNAL \
(*yVarP)->yInSignalPtr->sig_no

#define RTOSSIGNALNO \
(*yVarP)->yInSignalPtr->SignalCode

#endif

/****+***************************************************************
     Initialization functions
********************************************************************/

/*---+---------------------------------------------------------------
     xAllocPrs
-------------------------------------------------------------------*/
#define RTOSXALLOCPRS \
{ \
 return 0; \
}
/****+***************************************************************
     SDL Timers
********************************************************************/

#define RTOSTEMPSAVED \
TempSaved

#define RTOSTIMER_QUEUEID \
  "/TimerQ"

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define RTOSTEMPSAVED_RECEIVER \
TempSaved->Receiver
#else
#define RTOSTEMPSAVED_RECEIVER
#endif

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define RTOSYTIMERACTIVE_RECEIVER \
yTimerActive->Receiver
#else
#define RTOSYTIMERACTIVE_RECEIVER
#endif

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define RTOSINSIGNALPTR \
yInstanceSetVars->yInSignalPtr
#else
#define RTOSINSIGNALPTR \
yVarP->yInSignalPtr
#endif

#define RTOSTIMERTASK_VAR \
mqd_t QueuePId; \
unsigned long TickInterval; \
struct sigevent evp; \
struct itimerspec timerval = {0,0};  /* This struct must be initialised */


#define RTOSTIMERTASKALLOC_Q \
  TimerQ = (xTimerHeader)xAlloc( sizeof(xTimerHeaderRec)); \
  TimerQ->SignalCode = EndOfTimerQueue; \
  evp.sigev_notify = SIGEV_SIGNAL_THREAD; \
  evp.sigev_signo = SIGUSR1;

#define RTOSTIMERTASKALLOC_INSIGNAL \
    yInSignalPointer = xAlloc(MAXMSGLENGTH);

#define RTOSSET_SIGNALCODE \
  yInSignalPointer->SignalCode = yInSignalPointer->TimerToSetOrReset;

#define RTOSTIMERTASKVAR_EXTRAS \
timer_t TimerId; \
unsigned long TickInterval; \
struct sigevent evp; \
struct itimerspec timerval;

#define RTOSTIMERQ_PRE \
TimerQ->Pre

#define RTOSTIMERQ_SUC \
TimerQ->Suc

#define RTOSTIMERQ_RECEIVER \
TimerQ->Sender

#define RTOSTIMERQ_TIMERTIME \
TimerQ->TimerTime

#define RTOSTIMERWRAPPTR_PRE \
  (*TimerWrapPtr)->Pre

#define RTOSTIMERWRAPPTR_SUC \
  (*TimerWrapPtr)->Suc

#define RTOSTIMERSENDER \
yInSignalPointer->Sender

#ifdef X_ONE_TASK_PER_INSTANCE_SET 
#define RTOSTIMERSENDER2 \
(char *)yInSignalPointer->Sender->NameNode->PROCID
#else
#define RTOSTIMERSENDER2 \
(char *)yInSignalPointer->Sender
#endif

#define RTOSTEMPTIMERSIGNAL_SENDER \
yInSignalPointer->Sender

#define RTOSTEMPTIMERSIGNAL_PRE \
yInSignalPointer->Pre

#define RTOSTEMPTIMERSIGNAL_SUC \
yInSignalPointer->Suc

#define RTOSTEMPTIMERSIGNAL_TIMERTIME \
yInSignalPointer->TimerTime

#define RTOSXACTIVETIMER_TIMERTOFIND \
yInSignalPointer->TimerToSetOrReset

#define RTOSXRESETTIMER_TIMERTORESET \
yInSignalPointer->TimerToSetOrReset

#define RTOSXRESETTIMER_SIGNALID \
yInSignalPointer->SignalId

#define RTOSTEMPTIMERSIGNAL_RECEIVER \
TempTimer->Sender

#define RTOSTEMPTIMER_TIMERTIME \
TempTimer->TimerTime

#define RTOSTEMPTIMERSIGNAL_SIGNO \
TempTimer->SignalCode

#define RTOSTEMPTIMERSIGNAL_SIGNALID \
TempTimer->SignalId

#define RTOSTEMPTIMER_PRE \
TempTimer->Pre

#define RTOSTEMPTIMER_SUC \
TempTimer->Suc

#define RTOSTEMPTIMER_PRE_SUC \
TempTimer->Pre->Suc

#define RTOSTEMPTIMER_SUC_PRE \
TempTimer->Suc->Pre

#define RTOSHELPTEMPTIMER_PRE \
HelpTempTimer->Pre

#define RTOSHELPTEMPTIMER_SUC \
HelpTempTimer->Suc

#define RTOSHELPTEMPTIMER_PRE_SUC \
HelpTempTimer->Pre->Suc

#define RTOSHELPTEMPTIMER_SUC_PRE \
HelpTempTimer->Suc->Pre

#define RTOSXSDLRESETINTIMERPROCESS_VARS \
  SDL_PId	TempSender; \
  mqd_t QueuePId; \
  xbool   (* yEqFunc)(); \
\
  yEqFunc = yInSignalPointer->yEq;

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define RTOSRESETINTIMER_SENDER \
(char *)(yInSignalPointer->Sender)->NameNode->PROCID
#else
#define RTOSRESETINTIMER_SENDER \
(char *)yInSignalPointer->Sender
#endif

#define RTOSXSDLRESETINTIMERPROCESS_REPLY \
  QueuePId = mq_open((char *)RTOSRESETINTIMER_SENDER, 2, 0, 0); \
  mq_open_ERROR("RTOSXSDLRESETINTIMERPROCESS_REPLY", "mq_open", QueuePId) \
  Err = mq_send(QueuePId, \
                 (char *)yInSignalPointer, sizeof(xTimerHeaderRec), NULL); \
  XOS_ERROR("RTOSXSDLRESETINTIMERPROCESS_REPLY", "mq_send", Err) \
  xFree((void **)&yInSignalPointer); \
  Err = mq_close(QueuePId); \
  XOS_ERROR("RTOSXSDLRESETINTIMERPROCESS_REPLY", "mq_close", Err)

#define RTOSOSTIME \
SDL_Time

#define RTOSSDLNOW1 

#define RTOSSDLNOW2 \
tickGet()

#define RTOSGETCURRENTTIME2 \
CurrentTime = RTOSSDLNOW2;

#define RTOSTIMERRECEIVE(SIGPTR,SELF,WAITTIME, QID) \
      Err_Rec = mq_receive((mqd_t)TimerPIdQ,(char *)yInSignalPointer, \
                        MAXMSGLENGTH, NULL); \
      mq_receive_ERROR("RTOSTIMERRECEIVE", "mq_receive", Err_Rec)

#define RTOSTIMERQ_SUC_TIMERTIME \
TimerQ->Suc->TimerTime

#define RTOSXTIMER_SUC \
yOutputSignalPtr->Suc

#define RTOSTIMERQ_SUC_PRE \
TimerQ->Suc->Pre

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define RTOSOUTPUTSIGNAL_RECEIVER \
yOutputSignalPtr->Sender->NameNode->PROCID
#else
#define RTOSOUTPUTSIGNAL_RECEIVER \
yOutputSignalPtr->Sender
#endif

#define RTOSRECEIVE_MESSAGE2 \
        Err = timer_create(CLOCK_REALTIME, &evp, &TimerId); \
        XOS_ERROR("RTOSRECEIVE_MESSAGE2", "timer_create", Err) \
        TickInterval = TimerQ->Suc->TimerTime - CurrentTime; \
        timerval.it_value.tv_sec = TickInterval/1000; \
        timerval.it_value.tv_nsec = (TickInterval%1000)*1000000; \
        Err = timer_settime(TimerId,0,&timerval,NULL); \
        XOS_ERROR("RTOSRECEIVE_MESSAGE2", "timer_settime", Err) \
        Err_Rec = mq_receive((mqd_t)TimerPIdQ,(char *)yInSignalPointer,\
                          MAXMSGLENGTH, NULL); \
	Err = timer_delete(TimerId); \
        XOS_ERROR("RTOSRECEIVE_MESSAGE2", "timer_delete", Err)

#define RTOSTEMPTIMERSIGNAL_SIG_NO \
yInSignalPointer->SignalCode

#define RTOSSENDTIMERFREE_OUTPUT \
xFree((void**)&yOutputSignalPtr);
/*---+---------------------------------------------------------------
     env
-------------------------------------------------------------------*/
#define RTOSRTOSPAD_HEAD \
extern void *NEUTRINOPAD_env XPP((void *Param1))

#ifdef XENV
#define RTOSRTOSPAD_ENV \
RTOSRTOSPAD_HEAD \
{ \
  sem_t Env_Sem; \
  Err = sem_init(&Env_Sem,1,0); \
  XOS_ERROR("RTOSRTOSPAD_ENV", "sem_init",Err) \
  Err = sem_wait(&Env_Sem); \
  XOS_ERROR("RTOSRTOSPAD_ENV", "sem_wait", Err) \
}

#else

#define RTOSRTOSPAD_ENV \
RTOSRTOSPAD_HEAD \
{ \
}

#endif /* XENV */

/*---+---------------------------------------------------------------
     xAlloc
-------------------------------------------------------------------*/
#define RTOSXALLOC \
  /* standard implementation: */ \
  if ( Size > (xptrint)0 ) { \
    void * AllocatedMem; \
    Err = sem_wait(&Mem_Sem); \
    XOS_ERROR("RTOSXALLOC", "sem_wait", Err) \
    AllocatedMem = calloc((unsigned)1, (unsigned)Size); \
    Err = sem_post(&Mem_Sem); \
    XOS_ERROR("RTOSXALLOC", "sem_post", Err) \
    return AllocatedMem; \
  } \
  else \
    return (void *)0;
/*---+---------------------------------------------------------------
     xFree
-------------------------------------------------------------------*/
#define RTOSXFREE \
  if (*P != 0) { \
    Err = sem_wait(&Mem_Sem); \
    XOS_ERROR("RTOSXFREE", "sem_wait", Err) \
    free((void *)(*P)); \
    *P = (void *)0; \
    Err = sem_post(&Mem_Sem); \
    XOS_ERROR("RTOSXFREE", "sem_post", Err) \
  }

#endif /* _sctneutrino_h */
