/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.3.23566 at Sat Nov 17 11:52:49 AM CET 2012
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1999, 2012.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/******************************************************************

  C-code macros and functions for Nucleus MNT tight integration

  To be used with SDT C Code Generator 4 . 4
  #clearcase sctnucleus.c@@/main/1 07-Sep-98

*******************************************************************/

#include "scttypes.h"


extern SDL_Time SDL_Now
XPP ((void))
{
  return (NU_Retrieve_Clock ());
}

#ifdef NUCLEUS_MNT

void
Application_Initialize (VOID * first_available_memory)
{
  NU_TASK *Task_Ptr;
  VOID *Stack_Ptr;
  Err = NU_Create_Memory_Pool (&System_Memory, "SYSMEM", (VOID *) first_available_memory, MEMORY_SIZE /*Defined by Nucleus */ , MIN_ALLOCATION, NU_PRIORITY);
  XOS_ERROR ("Application_Initialize", "NU_Create_Memory_Pool", Err)
    Err = NU_Allocate_Memory (&System_Memory, (VOID **) & Task_Ptr, sizeof (NU_TASK), NU_NO_SUSPEND);
  XOS_ERROR ("Application_Initialize", "NU_Allocate_Memory1", Err)
    Err = NU_Allocate_Memory (&System_Memory, &Stack_Ptr, MANAGER_STACK_SIZE, NU_NO_SUSPEND);
  XOS_ERROR ("Application_Initialize", "NU_Allocate_Memory2", Err)
    Err = NU_Create_Task (Task_Ptr, "SDL_fn", SDL_main, 0, NULL, Stack_Ptr, MANAGER_STACK_SIZE, MANAGER_TASK_PRIORITY, MANAGER_TIME_SLICE, NU_PREEMPT, NU_START);
  XOS_ERROR ("Application_Initialize", "NU_Create_Task", Err)
    UART_Initialize ();
}

#endif /* NUCLEUS_MNT */

void
Manager_Task (UNSIGNED argc, VOID * argv)
{
  STATUS Err;
  xSignalHeader yInputSignalPtr;
  CHAR task_name[8];
  DATA_ELEMENT task_status;
  UNSIGNED scheduled_count;
  OPTION priority;
  OPTION preempt;
  UNSIGNED time_slice;
  VOID *stack_base;
  UNSIGNED stack_size;
  UNSIGNED minimum_stack;
  while (1)
    {
      while ((Err = NU_Receive_From_Queue (&Task_Manager_Queue, &yInputSignalPtr, 1, &received_size, NU_SUSPEND)) == NU_TIMEOUT)
	XERROR_RECEIVED_WITH_TIMEOUT ("Manager_Task")
	  XOS_ERROR ("Manager_Task", "NU_Receive_From_Queue", Err)
	  Err = NU_Terminate_Task ((NU_TASK *) yInputSignalPtr->Sender);
      XOS_ERROR ("Manager_Task", "NU_Terminate_Task", Err)
	Err = NU_Task_Information ((NU_TASK *) yInputSignalPtr->Sender, task_name,
				   &task_status, &scheduled_count,
				   &priority, &preempt, &time_slice,
				   &stack_base, &stack_size,
				   &minimum_stack);
      XOS_ERROR ("Manager_Task", "NU_Task_Information", Err)
	if (stack_base != 0)
	{
	  Err = NU_Deallocate_Memory (stack_base);
	  XOS_ERROR ("Manager_Task", "NU_Deallocate_Memory1", Err)
	    stack_base = (void *) 0;
	}


      if (yInputSignalPtr->Sender != 0)
	{
	  Err = NU_Deallocate_Memory ((void *) yInputSignalPtr->Sender);
	  XOS_ERROR ("Manager_Task", "NU_Deallocate_Memory2", Err)
	}


#ifndef NUCLEUS_MNT		/* Error occurs in MNT if you delete the Tasks during run-time */
      Err = NU_Delete_Task ((NU_TASK *) yInputSignalPtr->Sender);
      XOS_ERROR ("Manager_Task", "NU_Delete_Task", Err)
#endif
	xFree ((void **) &yInputSignalPtr);
    }
}

VOID
System_Error (int Error)
{
  if (Error < 0)
    {
      printf ("Primitive Error: %d\n\r", Error);
    }
}
