/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.3.23566 at Sat Nov 17 11:52:49 AM CET 2012
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1999, 2012.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/******************************************************************

  C-code macros and functions for Solaris tight integration

  To be used with Cadvanced SDL to C Compiler 4.4
  
*******************************************************************/

#ifdef XMSC_EDITOR

#include "post.h"
#include "sdt.h"
#include <string.h>
#include <errno.h>

#endif

#include "scttypes.h"

unsigned long tickGet()
{
  unsigned long TmpTicks;
  struct timespec SysTime;

  Err = clock_gettime(CLOCK_REALTIME, &SysTime);
/* tickGet resolution is in msec */
  TmpTicks = (SysTime.tv_sec * 1000) + (SysTime.tv_nsec/1000000);
  return TmpTicks;
}

void signal_handler()
{
  /* Dummy function which is called when SIGUSR1 signal is sent when a timer times out */
}  

#ifdef XMSC_EDITOR

/*#include "post.h"
#include "sdt.h"
#include <string.h>
#include <errno.h>
*/
int self;
int mscpid;
int mscbuffid;
int mscobject;
int tty_fd;


/*-------------------------------------------------------------------------
 * Name: connect_to_sdt
 * Author: Tapio J Hahka
 *
 * Description:
 *
 * Return Value:
 * 
 *
 */

extern int connect_to_sdt (char *myTool)
{
  self=SPInit (SET_SDLENV,myTool,spMList);
  if (self==SPERROR)
    {
      printf ("connect_to_sdt: Error in SPInit: %s\n",SPErrorString (sperrno));
      exit (1);
    }
  return(1);
}

/*-------------------------------------------------------------------------
 * Name: start_msc
 * Author: Tapio J Hahka
 *
 * Description:
 *
 * Return Value:
 *
 *
 */

extern int start_msc (int post_fd)
{
  char *data;
  int  message = 0;
  int  len = 0;
  int  ret = 0;
  int  status = 0;
  int  noofpids = 0;
  int  done = 0;

  data = (char *)xAlloc(30);
  sprintf (data,"%d",SET_MSCE);
  ret=SPBroadcast (SEGETTOOLPID,(void*)data,strlen (data));
  if (ret==SPERROR)
    {
      printf ("start_msc: Error in SPBroadcast: %s\n",SPErrorString (sperrno));
      exit (1);
    }
  while (!done)
    {
      ret=SPRead (SPWAITFOREVER,&mscpid,&message,(void*)&data,&len);
      if (ret==SPERROR)
	  {
	    printf ("start_msc: Error in SPRead: %s\n",SPErrorString (sperrno));
	    exit (1);
	  }

      switch (message)
	  {
	   case SEGETTOOLPIDREPLY:
	    sscanf (data,"%d %d %d",&status,&noofpids,&mscpid);
	    if (!noofpids)
		{
	      data = (char *)xAlloc(30);
	      sprintf (data,"%d",SET_MSCE);
	      ret=SPBroadcast (SESTART,(void*)data,strlen (data));
	      if (ret==SPERROR)
		  {
		    printf ("start_msc: Error in SPBroadcast: %s\n",SPErrorString (sperrno));
		    exit (1);
		  }
	    }
	    else if (status)
		{
	      printf ("start_msc: Error in Postmaster communication\n");
	      exit( 1 );
		}
	    else
	      done=1;
	   break;
	   case SESTARTREPLY:
            /* Tool start reply */
         sscanf ( data, "%d %d", &status, &mscpid );
         if (status) 
		 {
           printf ( "start_msc: Error in Postmaster communication\n");
	       exit( 1 );
		 }
	     else
	       done=1;
	    break;
	    default:
	    break;
	  }
  }
  return mscpid;
}

/*-------------------------------------------------------------------------
 * Name: start_msc_diagram
 * Author: Tapio J Hahka
 *
 * Description:
 *
 * Return Value:
 *
 *
 */

extern int start_msc_diagram (int post_fd)
{
  char *data;
  char msgbuffer [100],*msgbuf = msgbuffer;
  int  message = 0;
  int  len = 0;
  int  ret = 0;
  int  status = 0;
  int  done = 0;
  int  msc_diagram = 16;

  data = (char *)xAlloc(30);
  sprintf (data,"%d %s %s",msc_diagram, "RTOS_Trace", "\"\"" );
  ret=SPSendToTool (SET_MSCE,SEMSCECREATEDIAGRAM,(void*)data,strlen (data));
  if (ret==SPERROR)
  {
     printf ("start_msc_diagram: Error in SPSendToTool: %s\n",SPErrorString (sperrno));
     exit (1);
  }

  while (!done)
  {
     ret=SPRead (SPWAITFOREVER,&mscpid,&message,(void*)&data,&len);
     if (ret==SPERROR)
	 {
	   printf ("start_msc_diagram: Error in SPRead: %s\n",SPErrorString (sperrno));
	   exit (1);
	 }

     switch (message)
	 { 
	  case SEMSCECREATEDIAGRAMREPLY:
	    sscanf (data,"%d %d",&status,&mscbuffid);
	    if (status)
		{
	      printf ("start_msc_diagram: Error in Postmaster communication\n");
	      exit (1);
		}
	    done=1;
	  break;
	  default:
	    break;
	 } 
  } 

  sprintf (data,"%d %s",mscbuffid,"\"\"" );
  ret=SPSendToTool (SET_MSCE,SESHOW,(void*)data,strlen (data));
  if (ret==SPERROR)
  {
     printf ("start_msc_diagram: Error in SPSendToTool: %s\n",SPErrorString (sperrno));
     exit (1);
  }

  done=0;

  while (!done)
  {
    ret=SPRead (SPWAITFOREVER,&mscpid,&message,(void*)&data,&len);
    if (ret==SPERROR)
	{
	  printf ("start_msc_diagram: Error in SPRead: %s\n",SPErrorString (sperrno));
	  exit (1);
	}

    switch (message) 
	{
	 case SESHOWREPLY:
	   sscanf (data,"%d",&status);
	   if (status)
	   {
	     printf ("start_msc_diagram: Error in Postmaster communication\n");
	     exit (1);
	   }
	   done=1;
	 break;
	 default:
	   break;
	} 
  }
} 

/*-------------------------------------------------------------------------
 * Name: send_message
 * Author: Tapio J Hahka
 *
 * Description:
 *
 * Return Value:
 *
 *
 */

extern int send_message (char *msge_buf)
{
  char *data;
  char *buffptr;
  int  ret = 0;
  int  done = 0;
  int  status = 0;
  int  pid = 0;
  int  message = 0;
  int  len = 0;
  int  endmsc = 0;
	  
  buffptr = xAlloc( 512 );

  sprintf (buffptr,"%d 0 \"%s\"",mscbuffid, msge_buf);
  ret=SPSendToTool (SET_MSCE,SEINSERTOBJECT,(void*) buffptr, strlen(buffptr) );
  if (ret==SPERROR)
  {
    printf ("send_message: Error in SPSendToTool: %s\n",SPErrorString (sperrno));
    exit (1);
  }

  while (!done)
  {
    ret=SPRead (SPWAITFOREVER,&mscpid,&message,(void*)&data,&len);
    if (ret==SPERROR)
	{
	  printf ("send_message: Error in SPRead: %s\n",SPErrorString (sperrno));
	  exit (1);
	}

    switch (message)
	{
	 case SEINSERTOBJECTREPLY:
	   sscanf (data,"%d %d",&status,&mscobject);
	   if (status)
	   {
	     printf ("send_message: Error in SEINSERTOBJECTREPLY\n");
	     exit (1);
	   }
	   done=1;
	 break;
	 default:
	   break;
	} 
  }
  done=0;

  sprintf (buffptr,"%d %d",mscbuffid,mscobject);
  ret=SPSendToTool (SET_MSCE,SESHOWOBJECT,(void*)buffptr,strlen (buffptr));
  if (ret==SPERROR)
  {
    printf ("send_message: Error in SPSendToTool: %s\n",SPErrorString (sperrno));
    exit (1);
  }

  while (!done)
  {
    ret=SPRead (SPWAITFOREVER,&mscpid,&message,(void*)&data,&len);
    if (ret==SPERROR)
	{
	  printf ("send_message: Error in SPRead: %s\n",SPErrorString (sperrno));
	  exit (1);
	}

    switch (message)
	{
	 case SESHOWOBJECTREPLY:
	   sscanf (data,"%d",&status);
	   if (status)
	   {
	     printf ("send_message: Error in SESHOWOBJECTREPLY \n");
	     exit (1);
	   }
	   done=1;
	 break;
	 default:
	 break;
	} 
  } 
  xFree( (void **) &buffptr);
  return endmsc;
}  

#endif  /* XMSC_EDITOR */
