/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.3.23566 at Sat Nov 17 11:52:49 AM CET 2012
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1999, 2012.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
#ifndef _sctvxworks_h
#define _sctvxworks_h

/*****************************************************************************

  C-code macros for RTOS-integrations

  To be used with Cadvanced SDL to C Compiler 4.4
  
*****************************************************************************/



#include "errno.h"

#include "vxWorks.h"
#include "msgQLib.h"        /* msgQCreate msgQDelete msgQSend TmsgQReceive */
                            /* TmsgQNumMsgs */
#include "taskLib.h"        /* TtaskSpawn */
#include "wdLib.h"          /* wdCreate wdDelete wdStart wdCancel */
#include "memLib.h"
#include "usrLib.h"         /* printErrno */
#include "stdioLib.h"
#include "string.h"         /* memset */

#include "sctcommon.h"

/*
#ifdef TESTENV
extern void exttask XPP ((void));
PROCESS exttask_;
#endif
*/

#define MAX_INPUTPORT_LENGTH  250
#define VXMAXMSGLENGTH sizeof(xTimerHeaderRec)+200
#define VX_TASK_OPTIONS VX_FP_TASK
#define VXMAXBUFFER 1000
#define VX_DEF_STACK_SIZE 80000
#define XENVPRIO       10

int Err;
#define MAXINDEX 100

extern SEM_ID taskSem;
extern int createdProcesses;
#define RTOSGLOBAL_VAR \
SEM_ID taskSem; \
int createdProcesses= 0;

#ifdef X_ONE_TASK_PER_INSTANCE_SET
typedef xEPrsNode SDL_PId;
#else
typedef MSG_Q_ID  SDL_PId;
#endif
#define NIL NULL


/****+***************************************************************
     SDL Signal, Timer and Now
********************************************************************/
/****+***************************************************************
01   Typedef, Default value, Literals
********************************************************************/
#include "sctpred.h"

#define SDT_TICKPERSEC 100
#define SDT_NANOSECPERTICK 10000000

/* NOTE! xTimerHeaderRec and xSignalHeaderRec areidentical except
   for TimerTime last in xTimerHeaderRec. This means that it is
   possible to cast pointer between these two types freely as long
   as the TimerTime component is not accessed. */

#ifdef XOPTSIGNALALLOC

extern xSignalNode xGetSignal XPP((xSignalIdNode, SDL_PId, SDL_PId));
#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define INSIGNAL_DATA_PTR (yInstanceSetVars->yInSignalPtr)

#define SIGNALVARSCOMP1 \
      SDL_PId        Receiver;
#else
#define INSIGNAL_DATA_PTR (yVarP->yInSignalPtr)
#define SIGNALVARSCOMP1
#endif /* X_ONE_TASK_PER_INSTANCE_SET */

#ifdef XNOTIMERPARAMS
#define SIGNALVARSCOMP3
#else
#define SIGNALVARSCOMP3 \
      int            IsTimerSignal; \
      int            SigSize;
#endif
#ifdef XMSC_TRACE
#define SIGNALVARSCOMP2 \
      int            SignalId; \
      int            IsTimer;
#else
#define SIGNALVARSCOMP2
#endif

#define SIGNAL_VARS \
      int            SignalCode; \
      xSignalHeader  Pre, Suc; \
      SDL_PId        Sender; \
      xSignalIdNode NameNode; \
      int           MaxSize; \
      SIGNALVARSCOMP1 \
      SIGNALVARSCOMP2 \
      SIGNALVARSCOMP3

#ifdef XNOTIMERPARAMS
#define TIMERSIGNALVARSCOMP1
#else
#define TIMERSIGNALVARSCOMP1 \
      int            IsTimerSignal; \
      int            SigSize;
#endif

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define TIMERSIGNALVARSCOMP2 \
      SDL_PId        Receiver;
#else
#define TIMERSIGNALVARSCOMP2
#endif

#ifdef XMSC_TRACE
#define TIMERSIGNALVARSCOMP3 \
      int            SignalId; \
      int            IsTimer;
#else
#define TIMERSIGNALVARSCOMP3
#endif

#define TIMERSIGNALVARSCOMP4 \
      SDL_Time       TimerTime; \
      int            TimerToSetOrReset; \
      int           (* yEq)(); \
      int           TestParams; \
      xTimerHeader   Param;

#define TIMER_VARS \
      int            SignalCode; \
      xTimerHeader  Pre, Suc; \
      SDL_PId        Sender; \
      xSignalIdNode NameNode; \
      int           MaxSize; \
      TIMERSIGNALVARSCOMP1 \
      TIMERSIGNALVARSCOMP2 \
      TIMERSIGNALVARSCOMP3 \
      TIMERSIGNALVARSCOMP4

#else /* XOPTSIGNALALLOC */

#define SIGNAL_VARS

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define INSIGNAL_DATA_PTR (yInstanceSetVars->yInSignalPtr)+1
#else
#define INSIGNAL_DATA_PTR (yVarP->yInSignalPtr)+1
#endif

#define TIMER_VARS

#endif /* XOPTSIGNALALLOC */


#define XSIGNALHEADERTYPE xSignalHeaderRec

#define STARTUP_VARS \
   xEPrsNode PrsNode;

typedef struct xSignalHeaderStruct *xSignalHeader;
typedef struct xSignalHeaderStruct {
      int            SignalCode;
      xSignalHeader  Pre, Suc;
      SDL_PId        Sender;
      void          *SigP;
#ifdef X_SIGNAL_PRIO
      int            Priority;
#endif
#ifdef XOPTSIGNALALLOC
      xSignalIdNode NameNode;
      int           MaxSize;
#endif
#ifndef XNOTIMERPARAMS
      int            IsTimerSignal; \
      int            SigSize;
#endif
#ifdef X_ONE_TASK_PER_INSTANCE_SET
      SDL_PId        Receiver;
#endif
#ifdef XMSC_TRACE
      int            SignalId;
      int            IsTimer;
#endif
#ifdef XTORNADOINT
      int           IsTornadoTimer;
      int           SignalId;
#endif
} xSignalHeaderRec;

/* Macro to access the SignalCode (or number) with
   a given Pointer to a SignalHeaderStruct 
*/
#define RTOS_SIGNAL_SIGNAL_CODE(XSIGPTR) (XSIGPTR)->SignalCode

/* Macro to access the Signal Parameters with
   a given Pointer to a SignalHeaderStruct
   */
#define RTOS_SIGNAL_VAR_PTR(XSIGPTR)  (XSIGPTR)+1  /*MAS*/
/*#define RTOS_SIGNAL_VAR_PTR(XSIGPTR) ((xSignalHeader) XSIGPTR)+1*/

				   
#ifdef XOPTSIGNALALLOC
typedef struct xStartUpSignalHeaderStruct *xStartUpSignalHeader;
typedef struct xStartUpSignalHeaderStruct {
  SIGNAL_VARS
  STARTUP_VARS
} xStartUpSignalHeaderRec;
#else
typedef struct xStartUpSignalHeaderStruct *xStartUpSignalHeader;
typedef struct xStartUpSignalHeaderStruct {
  STARTUP_VARS
} xStartUpSignalHeaderRec;
#endif /* XOPTSIGNALALLOC */

typedef struct xTimerHeaderStruct *xTimerHeader;
typedef struct xTimerHeaderStruct {
      int            SignalCode;
      xTimerHeader   Pre, Suc;
      SDL_PId        Sender;
      void          *SigP;
#ifdef X_SIGNAL_PRIO
      int            Priority;
#endif
#ifdef XOPTSIGNALALLOC
      xSignalIdNode NameNode;
      int           MaxSize;
#endif
#ifndef XNOTIMERPARAMS
      int            IsTimerSignal;
      int            SigSize; 
#endif
#ifdef X_ONE_TASK_PER_INSTANCE_SET
      SDL_PId        Receiver;
#endif
#ifdef XMSC_TRACE
      int            SignalId;
      int            IsTimer;
#endif
#ifdef XTORNADOINT
      int           IsTornadoTimer;
      int           SignalId;
#endif /* XTORNADOINT */
      SDL_Time       TimerTime;
      int            TimerToSetOrReset;
      xbool          (* yEq)();
      xbool          TestParams;
      xTimerHeader   Param;
} xTimerHeaderRec;

/* Macro to access the number of Timer to set or rest with
   a given Pointer to a Timer HeaderStruct.
   */
#define RTOS_TIMER_TO_RE_SET(XSIGPTR) (XSIGPTR)->TimerToSetOrReset

   /* Macro to access the Signal Parameters with
   a given Pointer to a SignalHeaderStruct
   */
/*#define RTOS_TIMER_VAR_PTR(XSIGPTR) (XSIGPTR)->SigP*/
#define RTOS_TIMER_VAR_PTR(XSIGPTR) (XSIGPTR)+1

#define RTOSPRIODEFAULT      100
#define RTOSTASK_TYPE MSG_Q_ID
#define RTOSSIGNAL_DEF \
xSignalHeader
#define RTOSHANDLEMESS_TYPE
#define RTOSHANDLESIG_PAR
#define RTOSTIMER_DEF \
xTimerHeader
#define RTOSTIMER_QUEUEID TimerPId
#define XOS_ERROR(STRING1, STRING2, ERRCODE) \
  if (ERRCODE == ERROR) { \
    taskLock(); \
    printf("Error during %s found in VXWORKS function %s. Error code %s\n", \
            STRING1, STRING2, strerror(errno)); \
   taskUnlock();   \
   }
/****+***************************************************************
     Macros to Implement SDL
********************************************************************/

#ifdef X_ONE_TASK_PER_INSTANCE_SET
static  unsigned long VXWORKSQ_env;

#define RTOSXPROCESSDEF_C(PROC_NAME, PROC_NAME_STRING, PREFIX_PROC_NAME,PAD_FUNCTION, VDEF_TYPE) \
extern void XCAT(VXWORKSPAD_,PREFIX_PROC_NAME) XPP(( \
  unsigned long notUsedHere, \
  unsigned long InputPortQ)) \
{ \
  xPrsInstanceSetVars   yInstanceSetVars; \
  yInstanceSetVars.SaveQ = (xSaveQ)xAlloc(sizeof(xSaveQStruct)); \
  yInstanceSetVars.SaveQ->Suc = yInstanceSetVars.SaveQ; \
  yInstanceSetVars.SaveQ->Pre = yInstanceSetVars.SaveQ; \
  yInstanceSetVars.CurrentInSaveQ = yInstanceSetVars.SaveQ; \
  yInstanceSetVars.PrsDataSize = sizeof(VDEF_TYPE); \
  strcpy( yInstanceSetVars.name, PROC_NAME_STRING); \
  Err = semTake(taskSem,WAIT_FOREVER); \
  XOS_ERROR("OUTPUT", "semTake", Err) \
  PAD_FUNCTION((void *)0,(SDL_PId)InputPortQ, &yInstanceSetVars ); \
}

#define RTOSXPROCESSDEF_H(PROC_NAME, PROC_NAME_STRING, PREFIX_PROC_NAME, PAD_FUNCTION, VDEF_TYPE) \
extern void XCAT(VXWORKSPAD_,PREFIX_PROC_NAME) XPP(( \
  unsigned long notUsedHere, \
  unsigned long InputPortQ)); \
static unsigned long XCAT(VXWORKSQ_,PREFIX_PROC_NAME);
#else

#define RTOSXPROCESSDEF_C(PROC_NAME, PROC_NAME_STRING, PREFIX_PROC_NAME, PAD_FUNCTION, VDEF_TYPE) \
 extern void XCAT(VXWORKSPAD_,PREFIX_PROC_NAME) XPP(( \
  unsigned long notUsedHere, \
  unsigned long Self)) \
{ \
  VDEF_TYPE  yVarPVar; \
  VDEF_TYPE *yVarP = &yVarPVar; \
  yVarP->RestartAddress = 0; \
  yVarP->PrsNode = 0; \
  yVarP->RestartPAD = PAD_FUNCTION; \
  yVarP->ActivePrd = (xPrdNode)0; \
  yVarP->Offspring = SDL_NULL; \
  yVarP->Parent = SDL_NULL; \
  yVarP->Self = (SDL_PId) Self; \
  yVarP->Sender = (SDL_PId )Self;\
  yVarP->State = START_STATE; \
  yVarP->StateAfterRPC = 0; \
  yVarP->FirstTime = 1; \
  yVarP->SaveQ = (xSaveQ)xAlloc(sizeof(xSaveQStruct)); \
  yVarP->SaveQ->Suc = yVarP->SaveQ; \
  yVarP->SaveQ->Pre = yVarP->SaveQ; \
  yVarP->CurrentInSaveQ = yVarP->SaveQ; \
  yVarP->pREPLY_Waited_For = (XSIGTYPE)0; \
  strcpy( yVarP->ProcName, PROC_NAME_STRING); \
  Err = semTake(taskSem,WAIT_FOREVER); \
  XOS_ERROR("OUTPUT", "semTake", Err) \
  PAD_FUNCTION((void *)yVarP); \
}

#define RTOSXPROCESSDEF_H(PROC_NAME, PROC_NAME_STRING, PREFIX_PROC_NAME, PAD_FUNCTION, VDEF_TYPE) \
extern void XCAT(VXWORKSPAD_,PREFIX_PROC_NAME) XPP((\
  unsigned long notUsedHere, \
  unsigned long Self));

#endif
       /* X_ONE_TASK_PER_INSTANCE_SET */


/* ----------------- Extra components in IdNodes ----------------- */
#define RTOSXOSETRACE_INIT
#define RTOSSTATENAME(STATE_NAME_STRING)

  /* Process, Process type */
#ifdef X_ONE_TASK_PER_INSTANCE_SET 
#define XPRS_EXTRAS(PREFIX_PROC_NAME) \
  , XCAT(VXWORKSPAD_,PREFIX_PROC_NAME), &XCAT(VXWORKSQ_,PREFIX_PROC_NAME)
#else
#define XPRS_EXTRAS(PREFIX_PROC_NAME) , XCAT(VXWORKSPAD_,PREFIX_PROC_NAME)
#endif
#define RTOSXPAD_STRUCT_COMP \
void (*RestartPAD) XPP(( void *VarP,SDL_PId, \
xPrsInstanceSetVars *yInstanceSetVars ));

 /*---------------- Variables in the PAD function ---------------- */
#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define YPAD_TEMP_VARS \
   xSignalHeader  yOutputSignalPtr; \
   xSignalHeader  pREPLY_Signal; \
   SDL_PId		  SenderRPCCall; \
   unsigned long  RetCode; \
   xPrdNode       yTempPrd;
#else

#ifdef XTORNADOINT
#define PROCESS_VARS \
   int            RestartAddress; \
   xPrdNode       ActivePrd; \
   XPAD_STRUCT_COMP \
   SDL_PId        Self; \
   SDL_PId        Offspring; \
   SDL_PId        Parent; \
   SDL_PId        Sender; \
   SDL_PId        Receiver; \
   int            State; \
   int            StateAfterRPC; \
   xSignalHeader  SaveQ; \
   xSignalHeader  yInSignalPtr; \
   xSignalHeader  CurrentInSaveQ; \
   xEPrsNode      PrsNode; \
   XSIGTYPE       pREPLY_Waited_For; \
   char           ProcName[100]; \
   int     FirstTime;
#else
#define PROCESS_VARS \
   int            RestartAddress; \
   xPrdNode       ActivePrd; \
   XPAD_STRUCT_COMP \
   SDL_PId        Self; \
   SDL_PId        Offspring; \
   SDL_PId        Parent; \
   SDL_PId        Sender; \
   int            State; \
   int            StateAfterRPC; \
   xSignalHeader  SaveQ; \
   xSignalHeader  yInSignalPtr; \
   xSignalHeader  CurrentInSaveQ; \
   xEPrsNode      PrsNode; \
   XSIGTYPE       pREPLY_Waited_For; \
   char           ProcName[100]; \
   int     FirstTime;
#endif /* XTORNADOINT */

#define YPAD_TEMP_VARS \
   xSignalHeader  yOutputSignalPtr; \
   xSignalHeader  pREPLY_Signal; \
   SDL_PId		  SenderRPCCall; \
   unsigned long  RetCode; \
   xPrdNode       yTempPrd;
#endif
       /* X_ONE_TASK_PER_INSTANCE_SET */

#define YPRD_TEMP_VARS \
   xSignalHeader  yOutputSignalPtr; \
   xSignalHeader  pREPLY_Signal; \
   SDL_PId		  SenderRPCCall; \
   xPrdNode       yTempPrd; \
   int            Err;

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define SDL_SELF                yVarP->PrsNode
#define RTOSENV_PROCID
#else
#define SDL_SELF                yVarP->Self
#define RTOSENV_PROCID
#endif

#define SDL_SENDER              yVarP->Sender

/* ------------------ Structure of PAD function ------------------ */

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define YPAD_PROTOTYPE(PAD)     void PAD ( void *VarP, SDL_PId  InputPortQ, xPrsInstanceSetVars *yInstanceSetVars );
#define YPAD_FUNCTION(PAD)      void PAD ( void *VarP, SDL_PId InputPortQ, xPrsInstanceSetVars *yInstanceSetVars )
#define YPRD_PROTOTYPE(PAD)     xbool PAD ( void *VarP, xPrsInstanceSetVars *yInstanceSetVars );
#define YPRD_FUNCTION(PAD)      xbool PAD ( void *VarP, xPrsInstanceSetVars *yInstanceSetVars )
#endif

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define RTOSBEGIN_PAD(VDEF_TYPE) \
   if (xInputSignal((xPrsNode*)&yVarP,yInstanceSetVars,0,InputPortQ)) return;\
   goto Label_Execute_Transition;


#ifdef XNOTIMERPARAMS
#define RTOSLOOP_LABEL \
   Label_New_Transition_No_Free : \
     if (xInputSignal((xPrsNode*)&yVarP,yInstanceSetVars,2, InputPortQ)) return; \
     goto Label_Execute_Transition; \
   Label_New_Transition : \
     if (xInputSignal((xPrsNode*)&yVarP,yInstanceSetVars,1,InputPortQ)) return; \
   Label_Execute_Transition : \
     ySVarP =(xSignalHeader)(INSIGNAL_DATA_PTR); \
     yVarP->Sender = yInstanceSetVars->yInSignalPtr->Sender;
#else
#define RTOSLOOP_LABEL \
   Label_New_Transition_No_Free : \
     if (xInputSignal((xPrsNode*)&yVarP,yInstanceSetVars,2, InputPortQ)) return; \
     goto Label_Execute_Transition; \
   Label_New_Transition : \
     if (xInputSignal((xPrsNode*)&yVarP,yInstanceSetVars,1,InputPortQ)) return; \
   Label_Execute_Transition : \
     if(yInstanceSetVars->yInSignalPtr->IsTimerSignal) \
       ySVarP =((xTimerHeader)INSIGNAL_DATA_PTR); \
     else \
       ySVarP =((xSignalHeader)INSIGNAL_DATA_PTR); \
     yVarP->Sender = yInstanceSetVars->yInSignalPtr->Sender;
#endif /* XNOTIMERPARAMS */

#else /* X_ONE_TASK_PER_INSTANCE_SET */

#define RTOSBEGIN_PAD(VDEF_TYPE) \
   if(yVarP->FirstTime) { \
      memset((((xPrsRec*)yVarP)+1),NULL,sizeof(VDEF_TYPE)-sizeof(xPrsRec)); \
      yVarP->FirstTime = 0; \
   } \
   if (xInputSignal((xPrsNode*)&yVarP,0)) return; \
   goto Label_Execute_Transition;

#ifdef XNOTIMERPARAMS
#define RTOSLOOP_LABEL \
   Label_New_Transition_No_Free : \
     if (xInputSignal((xPrsNode*)&yVarP,2)) return; \
     goto Label_Execute_Transition; \
   Label_New_Transition : \
     if (xInputSignal((xPrsNode*)&yVarP,1)) return; \
   Label_Execute_Transition : \
     ySVarP =((xSignalHeader)INSIGNAL_DATA_PTR); \
     yVarP->Sender = yVarP->yInSignalPtr->Sender;
#else
#define RTOSLOOP_LABEL \
   Label_New_Transition_No_Free : \
     if (xInputSignal((xPrsNode*)&yVarP,2)) return; \
     goto Label_Execute_Transition; \
   Label_New_Transition : \
     if (xInputSignal((xPrsNode*)&yVarP,1)) return; \
   Label_Execute_Transition : \
     if(yVarP->yInSignalPtr->IsTimerSignal) \
       ySVarP =((xTimerHeader)INSIGNAL_DATA_PTR); \
     else \
       ySVarP =((xSignalHeader)INSIGNAL_DATA_PTR); \
     yVarP->Sender = yVarP->yInSignalPtr->Sender;
#endif /* XNOTIMERPARAMS */
#endif
       /* X_ONE_TASK_PER_INSTANCE_SET */

#ifdef XOPTSIGNALALLOC
#define RTOSFREE_BUF(SIGPTR) xReleaseSignal((void*)SIGPTR)
#else
#define RTOSFREE_BUF(SIGPTR) xFree((void**)SIGPTR)
#endif /* XOPTSIGNALALLOC */

#define RTOSFREE_BUF_SIGP(SIGPTR)

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#ifdef XOPTSIGNALALLOC
#define RTOSLOOP_LABEL_PRD \
   XOS_TRACE_CALL \
   if (yPrdVarP->RestartAddress != 0) { \
   if(yInstanceSetVars->yInSignalPtr->IsTimerSignal) ySVarP =((xTimerHeader)(yInstanceSetVars->yInSignalPtr)+1 ); /* MAS*/ \
   else ySVarP =((xSignalHeader)(yInstanceSetVars->yInSignalPtr)+1 ); /* MAS */\
   yVarP->Sender = yInstanceSetVars->yInSignalPtr->Sender; \
   }
#else
#define RTOSLOOP_LABEL_PRD \
   XOS_TRACE_CALL \
   if (yPrdVarP->RestartAddress != 0) { \
   if(yInstanceSetVars->yInSignalPtr->IsTimerSignal) ySVarP =((xTimerHeader)(yInstanceSetVars->yInSignalPtr)+1 ); \
   else ySVarP =((xSignalHeader)(yInstanceSetVars->yInSignalPtr)+1 ); /* MAS */ \
       yVarP->Sender = yInstanceSetVars->yInSignalPtr->Sender; \
   }
#endif /* XOPTSIGNALALLOC */


#ifdef XOPTSIGNALALLOC
extern xSignalHeader xAvailSignalLists[];
#define RTOSRECEIVE(SIGPTR,SELF,MSGLEN, QID) \
     if(xAvailSignalLists[VXMAXMSGLENGTH] !=(xSignalNode)0) { \
       SIGPTR = xAvailSignalLists[VXMAXMSGLENGTH]; \
       xAvailSignalLists[VXMAXMSGLENGTH] = xAvailSignalLists[VXMAXMSGLENGTH]->Suc; \
     } else { \
       SIGPTR = xAlloc(VXMAXMSGLENGTH); \
     } \
     Err = TmsgQReceive((MSG_Q_ID)InputPortQ, \
                       (char *)(yInstanceSetVars->yInSignalPtr) , \
                       VXMAXMSGLENGTH ,  WAIT_FOREVER); \
     XOS_ERROR("INPUT", "TmsgQReceive", Err) \
     yInstanceSetVars->yInSignalPtr->MaxSize = 1;
#else /* XOPTSIGNALALLOC */
#define RTOSRECEIVE(SIGPTR,SELF,MSGLEN, QID) \
     SIGPTR = xAlloc(VXMAXMSGLENGTH); \
     Err = TmsgQReceive((MSG_Q_ID)InputPortQ, \
                       (char *)(yInstanceSetVars->yInSignalPtr) , \
                       VXMAXMSGLENGTH ,  WAIT_FOREVER); \
     XOS_ERROR("INPUT", "TmsgQReceive", Err) 

#endif /* XOPTSIGNALALLOC */

#else /* X_ONE_TASK_PER_INSTANCE_SET */

#ifdef XOPTSIGNALALLOC
extern xSignalHeader xAvailSignalLists[];
#define RTOSRECEIVE(SIGPTR,SELF,MSGLEN, QID) \
     if(xAvailSignalLists[VXMAXMSGLENGTH] !=(xSignalNode)0) { \
       SIGPTR = xAvailSignalLists[VXMAXMSGLENGTH]; \
       xAvailSignalLists[VXMAXMSGLENGTH] = xAvailSignalLists[VXMAXMSGLENGTH]->Suc; \
     } else { \
       SIGPTR = xAlloc(VXMAXMSGLENGTH); \
     } \
     Err = TmsgQReceive((*yVarP)->Self,(char *)(*yVarP)->yInSignalPtr , \
                       VXMAXMSGLENGTH ,  WAIT_FOREVER); \
     XOS_ERROR("INPUT", "TmsgQReceive", Err) \
     (*yVarP)->yInSignalPtr->MaxSize = 1;

#define RTOSRECEIVEPRD(SIGPTR,SELF,MSGLEN, QID) \
     if(xAvailSignalLists[VXMAXMSGLENGTH] !=(xSignalNode)0) { \
       SIGPTR = xAvailSignalLists[VXMAXMSGLENGTH]; \
       xAvailSignalLists[VXMAXMSGLENGTH] = xAvailSignalLists[VXMAXMSGLENGTH]->Suc; \
     } else { \
       SIGPTR = xAlloc(VXMAXMSGLENGTH); \
     } \
     Err = TmsgQReceive(yVarP->Self,(char *)yVarP->yInSignalPtr , \
                       VXMAXMSGLENGTH ,  WAIT_FOREVER); \
     XOS_ERROR("INPUT", "TmsgQReceive", Err) \
     yVarP->yInSignalPtr->MaxSize = 1; \
     yVarP->Parent = yVarP->yInSignalPtr->Sender;

#define RTOSLABEL_EXECUTE_TRANSITION \
     if(yVarP->yInSignalPtr->IsTimerSignal) ySVarP =((xTimerHeader)(yVarP->yInSignalPtr)+1 ); \
 	 else ySVarP =((xSignalHeader)(yVarP->yInSignalPtr)+1 ); \
     /* ySVarP = ((xSignalHeader)(yVarP->yInSignalPtr)); */ \
     yVarP->Sender = yVarP->yInSignalPtr->Sender;

#else /* XOPTSIGNALALLOC */

#define RTOSRECEIVE(SIGPTR,SELF,MSGLEN, QID) \
     SIGPTR = xAlloc(VXMAXMSGLENGTH); \
     Err = TmsgQReceive((*yVarP)->Self,(char *)(*yVarP)->yInSignalPtr , \
                       VXMAXMSGLENGTH ,  WAIT_FOREVER); \
     XOS_ERROR("INPUT", "TmsgQReceive", Err) 

#define RTOSRECEIVEPRD(SIGPTR,SELF,MSGLEN, QID) \
     SIGPTR = xAlloc(VXMAXMSGLENGTH); \
     Err = TmsgQReceive(yVarP->Self,(char *)yVarP->yInSignalPtr , \
                       VXMAXMSGLENGTH ,  WAIT_FOREVER); \
     XOS_ERROR("INPUT", "TmsgQReceive", Err) \
     yVarP->Parent = yVarP->yInSignalPtr->Sender;
#define RTOSLABEL_EXECUTE_TRANSITION \
     if(yVarP->yInSignalPtr->IsTimerSignal) ySVarP =((xTimerHeader)(yVarP->yInSignalPtr)+1 ); \
 	 else ySVarP =((xSignalHeader)(yVarP->yInSignalPtr)+1 ); \
     /* ySVarP = ((xSignalHeader)INSIGNAL_DATA_PTR);*/ /* MAS */ \
     yVarP->Sender = yVarP->yInSignalPtr->Sender;

#endif /* XOPTSIGNALALLOC */
#endif
   /* X_ONE_TASK_PER_INSTANCE_SET */


#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define RTOSSENDER yInstanceSetVars->yInSignalPtr->Sender;
#define RTOSCALLSUPER_PAD(PAD) \
   PAD(yVarP, InputPortQ, yInstanceSetVars); 
#else

#define RTOSSENDER yVarP->yInSignalPtr->Sender; 

#endif
       /* X_ONE_TASK_PER_INSTANCE_SET */


#define INSIGNAL_NAME           INSIGNAL_PTR->SignalCode

/* ---------------------------- Output --------------------------- */

#ifdef XNOTIMERPARAMS
#define RTOSALLOC_RPC_SIGNAL_EXTRA
#else
#define RTOSALLOC_RPC_SIGNAL_EXTRA \
   pREPLY_Signal->IsTimerSignal = 0; \
   pREPLY_Signal->SigSize = 0;
#endif /* XNOTIMERPARAMS */

#ifdef XNOTIMERPARAMS
#define RTOSALLOC_SIGNAL_EXTRA
#else
#define RTOSALLOC_SIGNAL_EXTRA \
   yOutputSignalPtr->IsTimerSignal = 0; \
   yOutputSignalPtr->SigSize = 0;
#endif /* XNOTIMERPARAMS */

#ifdef XOPTSIGNALALLOC
#define RTOSALLOC_SIGNAL(SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_TYPE) \
   yOutputSignalPtr = xGetSignal(SIG_IDNODE, SDL_NULL, SDL_SELF); \
   yOutputSignalPtr->SignalCode = SIG_NAME; \
   RTOSALLOC_SIGNAL_EXTRA \
   yOutputSignalPtr->Sender = SDL_SELF;

#define RTOSALLOC_SIGNAL_PAR(SIG_NAME,SIG_IDNODE, RECEIVER, SIG_PAR_TYPE) \
   yOutputSignalPtr = xGetSignal(SIG_IDNODE, SDL_NULL, SDL_SELF); \
   yOutputSignalPtr->SignalCode = SIG_NAME; \
   RTOSALLOC_SIGNAL_EXTRA \
   yOutputSignalPtr->Sender = SDL_SELF;

#else /* XOPTSIGNALALLOC */

#ifdef XTORNADOINT
#define RTOSALLOC_SIGNAL(SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_TYPE) \
   yOutputSignalPtr = xAlloc(sizeof(xSignalHeaderRec)); \
   yOutputSignalPtr->SignalCode = SIG_NAME; \
   yOutputSignalPtr->SignalId = SignalId; \
   yOutputSignalPtr->SigP = (xSignalHeader)yOutputSignalPtr+1; \
   RTOSALLOC_SIGNAL_EXTRA \
   yOutputSignalPtr->Sender = SDL_SELF; \
   yVarP->Receiver = RECEIVER;

#define RTOSALLOC_SIGNAL_PAR(SIG_NAME,SIG_IDNODE, RECEIVER, SIG_PAR_TYPE) \
   yOutputSignalPtr = \
        xAlloc(sizeof(xSignalHeaderRec)+sizeof(SIG_PAR_TYPE)); \
   yOutputSignalPtr->SignalCode = SIG_NAME; \
   yOutputSignalPtr->SignalId = SignalId; \
   yOutputSignalPtr->SigP = (xSignalHeader)yOutputSignalPtr+1; \
   RTOSALLOC_SIGNAL_EXTRA \
   yOutputSignalPtr->Sender = SDL_SELF; \
   yVarP->Receiver = RECEIVER;
#else
#define RTOSALLOC_SIGNAL(SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_TYPE) \
   yOutputSignalPtr = xAlloc(sizeof(xSignalHeaderRec)); \
   yOutputSignalPtr->SignalCode = SIG_NAME; \
   yOutputSignalPtr->SigP = (xSignalHeader)yOutputSignalPtr+1; \
   RTOSALLOC_SIGNAL_EXTRA \
   yOutputSignalPtr->Sender = SDL_SELF;

#define RTOSALLOC_SIGNAL_PAR(SIG_NAME,SIG_IDNODE, RECEIVER, SIG_PAR_TYPE) \
   yOutputSignalPtr = \
        xAlloc(sizeof(xSignalHeaderRec)+sizeof(SIG_PAR_TYPE)); \
   yOutputSignalPtr->SignalCode = SIG_NAME; \
   yOutputSignalPtr->SigP = (xSignalHeader)yOutputSignalPtr+1; \
   RTOSALLOC_SIGNAL_EXTRA \
   yOutputSignalPtr->Sender = SDL_SELF;
#endif /* XTORNADOINT */
#endif /* XOPTSIGNALALLOC */

#ifdef XOPTSIGNALALLOC
 #define OUTSIGNAL_DATA_PTR \
   ((xSignalHeader)yOutputSignalPtr)
#else
#define OUTSIGNAL_DATA_PTR \
   ((xSignalHeader)yOutputSignalPtr->SigP)
#endif

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define RTOSXHANDLESIG_BODY \
   OutputSignal->Receiver = Receiver; \
   Err = msgQSend((MSG_Q_ID)ReceiverTask, \
            (char *)OutputSignal, \
            sizeof(xSignalHeaderRec)+ SigPar_Size, NO_WAIT, MSG_PRI_NORMAL); \
   RTOSFREE_BUF(&OutputSignal); \
   XOS_ERROR("OUTPUT", "msgQSend", Err)

#define RTOSXHANDLETIMER_BODY \
   ((xTimerHeader)OutputSignal)->SignalCode = SetTimer; \
   ((xTimerHeader)OutputSignal)->Sender = Sender; \
   ((xTimerHeader)OutputSignal)->Receiver = Sender; \
   ((xTimerHeader)OutputSignal)->TimerTime = Dur_Expr; \
   ((xTimerHeader)OutputSignal)->TestParams = 0; \
   Err = msgQSend((MSG_Q_ID)TimerPId, (char *)OutputSignal, \
                 sizeof(xTimerHeaderRec), \
                 NO_WAIT, MSG_PRI_NORMAL);\
   RTOSFREE_BUF(&OutputSignal); \
   XOS_ERROR("SDLSET", "msgQSend", Err)

#else

#ifdef XOPTSIGNALALLOC
#define RTOSSEND(SIGPTR,RECEIVER,SIG_PAR_SIZE) \
   Err = msgQSend(RECEIVER, (char *)*SIGPTR, sizeof(xSignalHeaderRec)+ \
                 SIG_PAR_SIZE, NO_WAIT, MSG_PRI_NORMAL); \
   xReleaseSignal((void *)SIGPTR); \
   XOS_ERROR("OUTPUT", "msgQSend", Err)

#define RTOSXHANDLETIMER_BODY \
   ((xTimerHeader)OutputSignal)->SignalCode = SetTimer; \
   ((xTimerHeader)OutputSignal)->Sender = Sender; \
   ((xTimerHeader)OutputSignal)->TimerTime = Dur_Expr; \
   ((xTimerHeader)OutputSignal)->TestParams = 0; \
   Err = msgQSend((MSG_Q_ID)TimerPId, (char *)OutputSignal, \
                 sizeof(xTimerHeaderRec), \
                 NO_WAIT, MSG_PRI_NORMAL); \
   xReleaseSignal((void*)&OutputSignal); \
   XOS_ERROR("SDLSET", "msgQSend", Err)
#else
#define RTOSSEND(SIGPTR,RECEIVER,SIG_PAR_SIZE) \
   Err = msgQSend(RECEIVER, (char *)*SIGPTR, sizeof(xSignalHeaderRec)+ \
                 SIG_PAR_SIZE, NO_WAIT, MSG_PRI_NORMAL); \
   xFree((void**)SIGPTR); \
   XOS_ERROR("OUTPUT", "msgQSend", Err)

#define RTOSXHANDLETIMER_BODY \
   ((xTimerHeader)OutputSignal)->SignalCode = SetTimer; \
   ((xTimerHeader)OutputSignal)->Sender = Sender; \
   ((xTimerHeader)OutputSignal)->TimerTime = Dur_Expr; \
   ((xTimerHeader)OutputSignal)->TestParams = 0; \
   Err = msgQSend((MSG_Q_ID)TimerPId, (char *)OutputSignal, \
                 sizeof(xTimerHeaderRec), \
                 NO_WAIT, MSG_PRI_NORMAL);\
   xFree((void**)&OutputSignal); \
   XOS_ERROR("SDLSET", "msgQSend", Err)
#endif /* XOPTSIGNALALLOC */
#endif
/* ----------------------------- RPC ----------------------------- */
#ifdef XOPTSIGNALALLOC
#define RTOSALLOC_REPLY_SIGNAL(SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_TYPE) \
   pREPLY_Signal = xGetSignal(SIG_IDNODE,SDL_NULL,SDL_NULL); \
   pREPLY_Signal->SignalCode = SIG_NAME; \
   RTOSALLOC_RPC_SIGNAL_EXTRA \
   pREPLY_Signal->Sender = SDL_SELF; \
   SenderRPCCall = yVarP->Sender;

#define RTOSALLOC_REPLY_SIGNAL_PAR(SIG_NAME, SIG_IDNODE, RECEIVER, \
                                   SIG_PAR_TYPE) \
   pREPLY_Signal = xGetSignal(SIG_IDNODE,SDL_NULL,SDL_NULL); \
   pREPLY_Signal->SignalCode = SIG_NAME; \
   RTOSALLOC_RPC_SIGNAL_EXTRA \
   pREPLY_Signal->Sender = SDL_SELF; \
   SenderRPCCall = yVarP->Sender;

#define RTOSALLOC_REPLY_SIGNAL_PRD(SIG_NAME, SIG_IDNODE, RECEIVER, \
                                   SIG_PAR_TYPE) \
   pREPLY_Signal = xGetSignal(SIG_IDNODE,SDL_NULL,SDL_NULL); \
   pREPLY_Signal->SignalCode = SIG_NAME; \
   RTOSALLOC_RPC_SIGNAL_EXTRA \
   pREPLY_Signal->Sender = SDL_SELF; \
   SenderRPCCall = yVarP->Sender;

#define RTOSALLOC_REPLY_SIGNAL_PRD_PAR(SIG_NAME, SIG_IDNODE, RECEIVER, \
                                   SIG_PAR_TYPE) \
   pREPLY_Signal = xGetSignal(SIG_IDNODE,SDL_NULL,SDL_NULL); \
   pREPLY_Signal->SignalCode = SIG_NAME; \
   RTOSALLOC_RPC_SIGNAL_EXTRA \
   pREPLY_Signal->Sender = SDL_SELF; \
   SenderRPCCall = yVarP->Sender;


#define REPLYSIGNAL_DATA_PTR \
   ((xSignalHeader)pREPLY_Signal)
#define REPLYSIGNAL_DATA_PTR_PRD \
   ((xSignalHeader)pREPLY_Signal)

#else

#define RTOSALLOC_REPLY_SIGNAL(SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_TYPE) \
   pREPLY_Signal = xAlloc(sizeof(xSignalHeaderRec)+sizeof(SIG_PAR_TYPE)); \
   pREPLY_Signal->SignalCode = SIG_NAME; \
   pREPLY_Signal->SigP = (xSignalHeader)pREPLY_Signal+1; \
   RTOSALLOC_RPC_SIGNAL_EXTRA \
   pREPLY_Signal->Sender = SDL_SELF; \
   SenderRPCCall = yVarP->Sender;

#define RTOSALLOC_REPLY_SIGNAL_PAR(SIG_NAME, SIG_IDNODE, RECEIVER, \
                                   SIG_PAR_TYPE) \
   pREPLY_Signal = xAlloc(sizeof(xSignalHeaderRec)+sizeof(SIG_PAR_TYPE)); \
   pREPLY_Signal->SignalCode = SIG_NAME; \
   pREPLY_Signal->SigP = (xSignalHeader)pREPLY_Signal+1; \
   RTOSALLOC_RPC_SIGNAL_EXTRA \
   pREPLY_Signal->Sender = SDL_SELF; \
   SenderRPCCall = yVarP->Sender;

#define RTOSALLOC_REPLY_SIGNAL_PRD(SIG_NAME, SIG_IDNODE, RECEIVER, \
                                   SIG_PAR_TYPE) \
   pREPLY_Signal = xAlloc(sizeof(xSignalHeaderRec)+sizeof(SIG_PAR_TYPE)); \
   pREPLY_Signal->SignalCode = SIG_NAME; \
   pREPLY_Signal->SigP = (xSignalHeader)pREPLY_Signal+1; \
   RTOSALLOC_RPC_SIGNAL_EXTRA \
   pREPLY_Signal->Sender = SDL_SELF; \
   SenderRPCCall = yVarP->Sender;

#define RTOSALLOC_REPLY_SIGNAL_PRD_PAR(SIG_NAME, SIG_IDNODE, RECEIVER, \
                                   SIG_PAR_TYPE) \
   pREPLY_Signal = xAlloc(sizeof(xSignalHeaderRec)+sizeof(SIG_PAR_TYPE)); \
   pREPLY_Signal->SignalCode = SIG_NAME; \
   pREPLY_Signal->SigP = (xSignalHeader)pREPLY_Signal+1; \
   RTOSALLOC_RPC_SIGNAL_EXTRA \
   pREPLY_Signal->Sender = SDL_SELF; \
   SenderRPCCall = yVarP->Sender;


#define REPLYSIGNAL_DATA_PTR \
   ((xSignalHeader)pREPLY_Signal+1)
#define REPLYSIGNAL_DATA_PTR_PRD \
   ((xSignalHeader)pREPLY_Signal+1)

#endif /* XOPTSIGNALALLOC */


/* ---------------------------- Create --------------------------- */

#ifdef XOPTSIGNALALLOC

#define RTOSALLOC_STARTUP(PROC_NAME, STARTUP_IDNODE, STARTUP_PAR_TYPE) \
   yOutputSignalPtr = xGetSignal(STARTUP_IDNODE,SDL_NULL,SDL_NULL); \
   yOutputSignalPtr->SignalCode = STARTUPSIGNAL; \
   RTOSALLOC_SIGNAL_EXTRA \
   yOutputSignalPtr->Sender = SDL_SELF;

#define RTOSALLOC_STARTUP_PAR(PROC_NAME, STARTUP_IDNODE, STARTUP_PAR_TYPE) \
   yOutputSignalPtr = xGetSignal(STARTUP_IDNODE,SDL_NULL,SDL_NULL); \
   yOutputSignalPtr->SignalCode = STARTUPSIGNAL; \
   RTOSALLOC_SIGNAL_EXTRA \
   yOutputSignalPtr->Sender = SDL_SELF;

#else /* XOPTSIGNALALLOC */
#define RTOSALLOC_STARTUP(PROC_NAME, STARTUP_IDNODE, STARTUP_PAR_TYPE) \
{ \
   int sigstruct_size = (sizeof(xSignalHeaderRec)+sizeof(STARTUP_PAR_TYPE)); \
   yOutputSignalPtr = xAlloc(sigstruct_size); \
   yOutputSignalPtr->SignalCode = STARTUPSIGNAL; \
   yOutputSignalPtr->SigP = (xSignalHeader)yOutputSignalPtr+1; \
   RTOSALLOC_SIGNAL_EXTRA \
   yOutputSignalPtr->Sender = SDL_SELF;

#define RTOSALLOC_STARTUP_PAR(PROC_NAME, STARTUP_IDNODE, STARTUP_PAR_TYPE) \
{ \
   int sigstruct_size = (sizeof(xSignalHeaderRec)+sizeof(STARTUP_PAR_TYPE)); \
   yOutputSignalPtr = xAlloc(sigstruct_size); \
   yOutputSignalPtr->SignalCode = STARTUPSIGNAL; \
   yOutputSignalPtr->SigP = (xSignalHeader)yOutputSignalPtr+1; \
   RTOSALLOC_SIGNAL_EXTRA \
   yOutputSignalPtr->Sender = SDL_SELF;

#endif /* XOPTSIGNALALLOC */

#ifdef XOPTSIGNALALLOC
#define STARTUP_DATA_PTR \
   (yOutputSignalPtr)
#else
#define STARTUP_DATA_PTR \
   ((xSignalHeader)yOutputSignalPtr+1)
#endif /* XOPTSIGNALALLOC */

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define RTOSSDL_CREATE(PROC_NAME, PROC_IDNODE, PROC_NAME_STRING) \
   CHECK_INSTANCE_LIMIT1(PROC_IDNODE) \
   yOutputSignalPtr->Receiver = xAllocPrsUseMyMemory(PROC_IDNODE); \
   yOutputSignalPtr->Receiver->BlockInstNumber = \
     yVarP->PrsNode->BlockInstNumber; \
   yVarP->Offspring = yOutputSignalPtr->Receiver; \
   XOS_TRACE_CREATE( yVarP->Offspring, PROC_NAME_STRING) \
   XMSC_TRACE_CREATE( yVarP->Offspring, PROC_NAME_STRING) \
   Err = msgQSend((MSG_Q_ID)yVarP->Offspring->NameNode->PROCID,\
         (char *)yOutputSignalPtr,sigstruct_size, \
         NO_WAIT, MSG_PRI_NORMAL); \
   RTOSFREE_BUF(&yOutputSignalPtr); \
   Err = semGive(taskSem); \
     XOS_ERROR("CREATE", "msgQSend", Err) \
   CHECK_INSTANCE_LIMIT2(PROC_IDNODE) \
   }

#else

#define RTOSSDL_CREATE(PROC_NAME, PROC_IDNODE, PROC_NAME_STRING) \
     CHECK_INSTANCE_LIMIT1(PROC_IDNODE) \
     yVarP->Offspring = msgQCreate(MAX_INPUTPORT_LENGTH , VXMAXMSGLENGTH, \
                                   MSG_Q_FIFO); \
     if(yVarP->Offspring == NULL){ \
        XOS_ERROR("CREATE", "msgQCreate", ERROR) \
     } \
     Err = TtaskSpawn(PROC_NAME_STRING, (PROC_IDNODE)->Prio, VX_TASK_OPTIONS, \
                     VX_DEF_STACK_SIZE, (FUNCPTR) (PROC_IDNODE)->RTOSPAD, \
                     0,(int)yVarP->Offspring,0,0,0,0,0,0,0,0); \
     XOS_ERROR("CREATE", "TtaskSpawn", Err) \
     if (Err==ERROR){ \
                          printf(" %s %d \n", PROC_NAME_STRING, Err); } \
     Err = semGive(taskSem); \
     XOS_ERROR("CREATE", "semGive", Err) \
     ((xStartUpSignalHeader)STARTUP_DATA_PTR)->PrsNode = \
       xAllocPrsUseMyMemory(PROC_IDNODE, yVarP->Offspring); \
     ((xStartUpSignalHeader)STARTUP_DATA_PTR)->PrsNode->BlockInstNumber = \
       yVarP->PrsNode->BlockInstNumber; \
     XOS_TRACE_CREATE(yVarP->Offspring, PROC_NAME_STRING) \
     XMSC_TRACE_CREATE( yVarP->Offspring,PROC_NAME_STRING) \
     Err = msgQSend(yVarP->Offspring, (char *)yOutputSignalPtr,\
                    sigstruct_size,\
                    NO_WAIT, MSG_PRI_NORMAL); \
     xFree((void**)&yOutputSignalPtr); \
     XOS_ERROR("CREATE", "msgQSend", Err) \
     CHECK_INSTANCE_LIMIT2(PROC_IDNODE)	\
     }

#endif

/* ------------------------- Static Create ------------------------ */
#define YINIT_TEMP_VARS \
  SDL_PId    TempPId; \
  xSignalHeader yOutputSignalPtr; \
  int CurrentPId; \
  int Err;

#ifndef X_ONE_TASK_PER_INSTANCE_SET
#ifdef XOS_TRACE
#define BEGIN_YINIT \
  xInitTimer(); \
  LastUsedPId =SDL_NULL;
#elif XMSC_TRACE
#define BEGIN_YINIT \
  xInitTimer(); 
#else
#define BEGIN_YINIT \
  xInitTimer();
#endif
#endif
       /* X_ONE_TASK_PER_INSTANCE_SET */

#ifdef XENV
#define RTOSXCREATE_ENV_PROCESS \
   yOutputSignalPtr = (xSignalHeader)xAlloc(sizeof(xSignalHeaderRec)); \
   yOutputSignalPtr->SignalCode = 0; \
   yOutputSignalPtr->Sender = SDL_NULL; \
   yOutputSignalPtr->SigP = (xSignalHeader)yOutputSignalPtr+1; \
   xEnvPId = msgQCreate(MAX_INPUTPORT_LENGTH , VXMAXMSGLENGTH, \
                                 MSG_Q_FIFO); \
   if(xEnvPId == NULL){ \
      XOS_ERROR("CREATE_ENV", "msgQCreate", ERROR) \
   } \
   Err = TtaskSpawn("EnvTask", XENVPRIO, VX_TASK_OPTIONS, \
                   VX_DEF_STACK_SIZE, (FUNCPTR) xEnvTask, \
                   0,(int) xEnvPId, \
                   0,0,0,0,0,0,0,0); \
   XOS_ERROR("CREATE_ENV", "TtaskSpawn", Err) \
   xAllocPrsUseMyMemory(xEnvId, xEnvPId); \
   Err = msgQSend(xEnvPId, (char *)yOutputSignalPtr,\
                  sizeof(xSignalHeaderRec),\
                  NO_WAIT, MSG_PRI_NORMAL); \
   xFree((void**)&yOutputSignalPtr); \
   XOS_ERROR("CREATE_ENV", "msgQSend", Err)
#else

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define RTOSXCREATE_ENV_PROCESS \
  /* Create a gueue to handle signal to environment */ \
  xEnvId->PROCID = (unsigned long *)msgQCreate(MAX_INPUTPORT_LENGTH , \
                      VXMAXMSGLENGTH, MSG_Q_FIFO); \
  if(xEnvId->PROCID == NULL){ \
     XOS_ERROR("CREATE_ENV", "msgQCreate", ERROR) \
  } \
  xEnvPIdQ=(unsigned long)xEnvId->PROCID; \
  xEnvPrs = xAllocPrsUseMyMemory(xEnvId);
#else

#define RTOSXCREATE_ENV_PROCESS \
  xEnvPId = msgQCreate(MAX_INPUTPORT_LENGTH , VXMAXMSGLENGTH, \
                                 MSG_Q_FIFO); \
  xEnvPrs = xAllocPrsUseMyMemory(xEnvId, xEnvPId);

#endif
#endif

#define RTOSINIT_PROCESS_TYPE(PROC_NAME,PREFIX_PROC_NAME, PROC_IDNODE, \
PROC_NAME_STRING, MAX_NO_OF_INST, STATIC_INST, PRIV_DATA_TYPE, PRIO, \
PAD_FUNCTION) \
   PROC_IDNODE->PROCID = (unsigned long*)msgQCreate(MAX_INPUTPORT_LENGTH ,\
                            VXMAXMSGLENGTH,MSG_Q_FIFO); \
   if(PROC_IDNODE->PROCID == NULL){ \
      XOS_ERROR("INIT PROCESS", "msgQCreate", ERROR) \
   } \
   Err = TtaskSpawn(PROC_NAME_STRING, PRIO, VX_TASK_OPTIONS, \
     VX_DEF_STACK_SIZE, (FUNCPTR) XCAT(VXWORKSPAD_,PREFIX_PROC_NAME), \
     0,(int) PROC_IDNODE->PROCID,0,0,0,0,0,0,0,0); \
   createdProcesses++; \
   XOS_ERROR("INIT PROCESS", "TtaskSpawn", Err)

#ifdef X_ONE_TASK_PER_INSTANCE_SET

#ifdef XOPTSIGNALALLOC
#define RTOSSDL_STATIC_CREATE(PROC_NAME, PREFIX_PROC_NAME, PROC_IDNODE, \
PROC_NAME_STRING, STARTUP_IDNODE, STARTUP_PAR_TYPE, PRIV_DATA_TYPE, \
PRIO, PAD_FUNCTION, BLOCK_INST_NUMBER) \
   yOutputSignalPtr = (xSignalHeader)xGetSignal( \
    STARTUP_IDNODE,SDL_NULL,SDL_NULL) ; \
   yOutputSignalPtr->SignalCode = STARTUPSIGNAL; \
   yOutputSignalPtr->Sender = SDL_NULL; \
   yOutputSignalPtr->Receiver = xAllocPrsUseMyMemory(PROC_IDNODE); \
   yOutputSignalPtr->Receiver->BlockInstNumber = BLOCK_INST_NUMBER; \
   XOS_TRACE_STATIC_CREATE(yOutputSignalPtr->Receiver, PROC_NAME_STRING) \
   XMSC_TRACE_STATIC_CREATE(yOutputSignalPtr->Receiver, PROC_NAME_STRING) \
   Err = msgQSend((MSG_Q_ID)PROC_IDNODE->PROCID, (char *)yOutputSignalPtr,\
                  sizeof(xSignalHeaderRec)+sizeof(STARTUP_PAR_TYPE),\
                   NO_WAIT, MSG_PRI_NORMAL); \
   RTOSFREE_BUF((void *)&(yOutputSignalPtr)); \
     XOS_ERROR("SDL_STATIC_CREATE", "msgQSend", Err)
#else
#define RTOSSDL_STATIC_CREATE(PROC_NAME, PREFIX_PROC_NAME, PROC_IDNODE, \
PROC_NAME_STRING, STARTUP_IDNODE, STARTUP_PAR_TYPE, PRIV_DATA_TYPE, \
PRIO, PAD_FUNCTION, BLOCK_INST_NUMBER) \
   yOutputSignalPtr = (xSignalHeader)xAlloc( sizeof(XSIGNALHEADERTYPE)+ \
   sizeof(STARTUP_PAR_TYPE)); \
   yOutputSignalPtr->SignalCode = STARTUPSIGNAL; \
   yOutputSignalPtr->SigP = (xSignalHeader)yOutputSignalPtr+1; \
   RTOSALLOC_SIGNAL_EXTRA \
   yOutputSignalPtr->Sender = SDL_NULL; \
   yOutputSignalPtr->Receiver = xAllocPrsUseMyMemory(PROC_IDNODE); \
   yOutputSignalPtr->Receiver->BlockInstNumber = BLOCK_INST_NUMBER; \
   XOS_TRACE_STATIC_CREATE(yOutputSignalPtr->Receiver, PROC_NAME_STRING) \
   XMSC_TRACE_STATIC_CREATE(yOutputSignalPtr->Receiver, PROC_NAME_STRING) \
   Err = msgQSend((MSG_Q_ID)PROC_IDNODE->PROCID, (char *)yOutputSignalPtr,\
                  sizeof(xSignalHeaderRec)+sizeof(STARTUP_PAR_TYPE),\
                   NO_WAIT, MSG_PRI_NORMAL); \
   xFree((void**)&yOutputSignalPtr); \
     XOS_ERROR("SDL_STATIC_CREATE", "msgQSend", Err)
#endif /* XOPTSIGNALALLOC */

#else

#ifdef XOPTSIGNALALLOC
#define RTOSSDL_STATIC_CREATE(PROC_NAME, PREFIX_PROC_NAME, PROC_IDNODE,  \
  PROC_NAME_STRING, STARTUP_IDNODE, STARTUP_PAR_TYPE, PRIV_DATA_TYPE, PRIO, \
  PAD_FUNCTION, BLOCK_INST_NUMBER) \
   yOutputSignalPtr = xGetSignal(STARTUP_IDNODE,SDL_NULL,SDL_NULL); \
   yOutputSignalPtr->SignalCode = STARTUPSIGNAL; \
   yOutputSignalPtr->Sender = SDL_NULL; \
     TempPId = msgQCreate(MAX_INPUTPORT_LENGTH , VXMAXMSGLENGTH, \
                                   MSG_Q_FIFO); \
     if(TempPId == NULL){ \
        XOS_ERROR("SDL_STATIC_CREATE", "msgQCreate", ERROR) \
     } \
     Err = TtaskSpawn(PROC_NAME_STRING, PRIO, VX_TASK_OPTIONS, \
                     VX_DEF_STACK_SIZE, (FUNCPTR) XCAT(VXWORKSPAD_, \
                     PREFIX_PROC_NAME), \
                     0,(unsigned long) TempPId, \
                     0,0,0,0,0,0,0,0); \
     XOS_ERROR("SDL_STATIC_CREATE", "TtaskSpawn", Err) \
     ((STARTUP_PAR_TYPE *)STARTUP_DATA_PTR)->PrsNode = \
       xAllocPrsUseMyMemory(PROC_IDNODE, TempPId); \
     ((STARTUP_PAR_TYPE *)STARTUP_DATA_PTR)->PrsNode->BlockInstNumber = \
       BLOCK_INST_NUMBER; \
     XOS_TRACE_STATIC_CREATE(TempPId, PROC_NAME_STRING) \
     XMSC_TRACE_STATIC_CREATE(TempPId, PROC_NAME_STRING) \
     Err = msgQSend(TempPId, (char *)yOutputSignalPtr,\
                    sizeof(xSignalHeaderRec)+sizeof(STARTUP_PAR_TYPE),\
                    NO_WAIT, MSG_PRI_NORMAL); \
     createdProcesses++; \
     RTOSFREE_BUF((void *)&(yOutputSignalPtr)); \
     XOS_ERROR("SDL_STATIC_CREATE", "msgQSend", Err)
#else /* XOPTSIGNALALLOC */
#define RTOSSDL_STATIC_CREATE(PROC_NAME, PREFIX_PROC_NAME, PROC_IDNODE,  \
  PROC_NAME_STRING, STARTUP_IDNODE, STARTUP_PAR_TYPE, PRIV_DATA_TYPE, PRIO, \
  PAD_FUNCTION, BLOCK_INST_NUMBER) \
   yOutputSignalPtr = (xSignalHeader)xAlloc( sizeof(XSIGNALHEADERTYPE) + \
                       sizeof(STARTUP_PAR_TYPE)); \
   yOutputSignalPtr->SignalCode = STARTUPSIGNAL; \
   yOutputSignalPtr->SigP = (xSignalHeader)yOutputSignalPtr+1; \
   RTOSALLOC_SIGNAL_EXTRA \
   yOutputSignalPtr->Sender = SDL_NULL; \
     TempPId = msgQCreate(MAX_INPUTPORT_LENGTH , VXMAXMSGLENGTH, \
                                   MSG_Q_FIFO); \
     if(TempPId == NULL){ \
        XOS_ERROR("SDL_STATIC_CREATE", "msgQCreate", ERROR) \
     } \
     Err = TtaskSpawn(PROC_NAME_STRING, PRIO, VX_TASK_OPTIONS, \
                     VX_DEF_STACK_SIZE, (FUNCPTR) XCAT(VXWORKSPAD_, \
                     PREFIX_PROC_NAME), \
                     0,(unsigned long) TempPId, \
                     0,0,0,0,0,0,0,0); \
     XOS_ERROR("SDL_STATIC_CREATE", "TtaskSpawn", Err) \
     ((STARTUP_PAR_TYPE *)STARTUP_DATA_PTR)->PrsNode = \
       xAllocPrsUseMyMemory(PROC_IDNODE, TempPId); \
     ((STARTUP_PAR_TYPE *)STARTUP_DATA_PTR)->PrsNode->BlockInstNumber = \
       BLOCK_INST_NUMBER; \
     XOS_TRACE_STATIC_CREATE(TempPId, PROC_NAME_STRING) \
     XMSC_TRACE_STATIC_CREATE(TempPId, PROC_NAME_STRING) \
     Err = msgQSend(TempPId, (char *)yOutputSignalPtr,\
                    sizeof(xSignalHeaderRec)+sizeof(STARTUP_PAR_TYPE),\
                    NO_WAIT, MSG_PRI_NORMAL); \
     createdProcesses++; \
     RTOSFREE_BUF((void *)&(yOutputSignalPtr)); \
     XOS_ERROR("SDL_STATIC_CREATE", "msgQSend", Err)
#endif /* XOPTSIGNALALLOC */ 
#endif

/* ----------------------------- Stop ---------------------------- */
#ifdef X_ONE_TASK_PER_INSTANCE_SET

#ifdef XOPTSIGNALALLOC
#define RTOSEMPTYQUEUE(SIGPTR) \
   while(TmsgQNumMsgs((MSG_Q_ID)SDL_SELF->NameNode->PROCID)!=0){ \
     if(xAvailSignalLists[VXMAXMSGLENGTH] !=(xSignalNode)0) { \
       yInstanceSetVars->yInSignalPtr = xAvailSignalLists[VXMAXMSGLENGTH]; \
       xAvailSignalLists[VXMAXMSGLENGTH] = xAvailSignalLists[VXMAXMSGLENGTH]->Suc; \
     } else { \
       yInstanceSetVars->yInSignalPtr = xAlloc(VXMAXMSGLENGTH); \
     } \
       Err = TmsgQReceive((MSG_Q_ID)SDL_SELF->NameNode->PROCID, \
                         (char *)yInstanceSetVars->yInSignalPtr, \
                         VXMAXMSGLENGTH, WAIT_FOREVER); \
       yInstanceSetVars->yInSignalPtr->MaxSize = 1; \
     if ( xEq_SDL_PId( yInstanceSetVars->yInSignalPtr->Receiver, SDL_SELF) ){ \
       xReleaseSignal((void*)(&(yInstanceSetVars->yInSignalPtr))); \
     } \
     else \
       xSaveSignal( yInstanceSetVars->SaveQ, yInstanceSetVars->yInSignalPtr); \
   }
#define RTOSSDL_STOPREMOVETIMERS \
   xKillSaveQ(yInstanceSetVars->SaveQ, SDL_SELF); \
   yOutputSignalPtr = xGetSignal(&(TimerIdDummy),SDL_NULL,SDL_NULL); \
   yOutputSignalPtr->SignalCode = RemoveTimers; \
   yOutputSignalPtr->Sender = SDL_SELF; \
   Err = msgQSend((MSG_Q_ID)TimerPId, (char *)yOutputSignalPtr, \
                  sizeof(xTimerHeaderRec), \
                  NO_WAIT, MSG_PRI_NORMAL); \
   xReleaseSignal((void*)&yOutputSignalPtr); \
   XOS_ERROR("RemoveTimers", "msgQSend", Err) \
   xFreePrs(&yVarP->PrsNode); \
   goto Label_New_Transition_No_Free;

#else /* XOPTSIGNALALLOC */
#define RTOSEMPTYQUEUE(SIGPTR) \
   while(TmsgQNumMsgs((MSG_Q_ID)SDL_SELF->NameNode->PROCID)!=0){ \
       yInstanceSetVars->yInSignalPtr = xAlloc(VXMAXMSGLENGTH); \
       Err = TmsgQReceive((MSG_Q_ID)SDL_SELF->NameNode->PROCID, \
                         (char *)yInstanceSetVars->yInSignalPtr, \
                         VXMAXMSGLENGTH, WAIT_FOREVER); \
     if ( xEq_SDL_PId( yInstanceSetVars->yInSignalPtr->Receiver, SDL_SELF) ){ \
       xFree((void*)(&(yInstanceSetVars->yInSignalPtr))); \
     } \
     else \
       xSaveSignal( yInstanceSetVars->SaveQ, yInstanceSetVars->yInSignalPtr); \
   } \

#define RTOSSDL_STOPREMOVETIMERS \
   xKillSaveQ(yInstanceSetVars->SaveQ, SDL_SELF); \
   yOutputSignalPtr = xAlloc(sizeof(xTimerHeaderRec)); \
   yOutputSignalPtr->SignalCode = RemoveTimers; \
   yOutputSignalPtr->SigP = (xTimerHeaderRec*)yOutputSignalPtr+1; \
   RTOSALLOC_SIGNAL_EXTRA \
   yOutputSignalPtr->Sender = SDL_SELF; \
   Err = msgQSend((MSG_Q_ID)TimerPId, (char *)yOutputSignalPtr, \
                  sizeof(xTimerHeaderRec), \
                  NO_WAIT, MSG_PRI_NORMAL); \
   xFree((void**)&yOutputSignalPtr); \
   XOS_ERROR("RemoveTimers", "msgQSend", Err) \
   xFreePrs(&yVarP->PrsNode); \
   goto Label_New_Transition_No_Free;
#endif /* XOPTSIGNALALLOC */

#else /* X_ONE_TASK_PER_INSTANCE_SET */

#ifdef XOPTSIGNALALLOC
#define RTOSEMPTYQUEUE(SIGPTR) \
     while(TmsgQNumMsgs(yVarP->Self)!=0){ \
     if(xAvailSignalLists[VXMAXMSGLENGTH] !=(xSignalNode)0) { \
       yVarP->yInSignalPtr = xAvailSignalLists[VXMAXMSGLENGTH]; \
       xAvailSignalLists[VXMAXMSGLENGTH] = xAvailSignalLists[VXMAXMSGLENGTH]->Suc; \
     } else { \
       yVarP->yInSignalPtr = xAlloc(VXMAXMSGLENGTH); \
     } \
       Err = TmsgQReceive(yVarP->Self,(char *)yVarP->yInSignalPtr, \
                         VXMAXMSGLENGTH, WAIT_FOREVER); \
       yVarP->yInSignalPtr->MaxSize = 1; \
       xReleaseSignal((void *)&(yVarP->yInSignalPtr)); \
     }
#define RTOSSDL_STOPREMOVETIMERS \
   yOutputSignalPtr = xGetSignal(&(TimerIdDummy), SDL_NULL, SDL_NULL); \
   yOutputSignalPtr->SignalCode = RemoveTimers; \
   yOutputSignalPtr->Sender = yVarP->Self; \
   Err = msgQSend(TimerPId, (char *)yOutputSignalPtr, \
                 sizeof(xTimerHeaderRec), \
                 NO_WAIT, MSG_PRI_NORMAL); \
   xReleaseSignal((void*)&yOutputSignalPtr); \
   XOS_ERROR("RemoveTimers", "msgQSend", Err)
#define RTOSKILL_PROC \
   Err = msgQDelete(yVarP->Self); \
   XOS_ERROR("STOP", "msgQdelete", Err) \
   Err = TtaskDelete(taskIdSelf()); \
   XOS_ERROR("STOP", "TtaskDelete", Err)
#else /* XOPTSIGNALALLOC */
#define RTOSEMPTYQUEUE(SIGPTR) \
     while(TmsgQNumMsgs(yVarP->Self)!=0){ \
       yVarP->yInSignalPtr = xAlloc(VXMAXMSGLENGTH); \
       Err = TmsgQReceive(yVarP->Self,(char *)yVarP->yInSignalPtr, \
                         VXMAXMSGLENGTH, WAIT_FOREVER); \
       xFree((void *)&(yVarP->yInSignalPtr)); \
     }

#define RTOSSDL_STOPREMOVETIMERS \
   yOutputSignalPtr = xAlloc(sizeof(xTimerHeaderRec)); \
   yOutputSignalPtr->SignalCode = RemoveTimers; \
   yOutputSignalPtr->SigP = (xTimerHeaderRec*)yOutputSignalPtr+1; \
   RTOSALLOC_SIGNAL_EXTRA \
   yOutputSignalPtr->Sender = yVarP->Self; \
   Err = msgQSend(TimerPId, (char *)yOutputSignalPtr, \
                 sizeof(xTimerHeaderRec), \
                 NO_WAIT, MSG_PRI_NORMAL); \
   xFree((void**)&yOutputSignalPtr); \
   XOS_ERROR("RemoveTimers", "msgQSend", Err)

#define RTOSKILL_PROC \
   Err = msgQDelete(yVarP->Self); \
   XOS_ERROR("STOP", "msgQdelete", Err) \
   Err = TtaskDelete(taskIdSelf()); \
   XOS_ERROR("STOP", "TtaskDelete", Err)
#endif /* XOPTSIGNALALLOC */
#endif /* X_ONE_TASK_PER_INSTANCE_SET */

/* ---------------------------- Timers --------------------------- */
#ifdef XOPTSIGNALALLOC
#define TIMER_DATA_PTR \
yOutputSignalPtr
#else
#define TIMER_DATA_PTR \
((xTimerHeader)yOutputSignalPtr+1)
#endif

#ifdef XNOTIMERPARAMS
#define RTOSALLOC_TIMER_SIGNAL_EXTRA(TIMER_PAR_TYPE)
#else
#ifdef XOPTSIGNALALLOC
#define RTOSALLOC_TIMER_SIGNAL_EXTRA(TIMER_PAR_TYPE) \
   ((xTimerHeader)yOutputSignalPtr)->IsTimerSignal = 1; \
   ((xTimerHeader)yOutputSignalPtr)->SigSize = sizeof(TIMER_PAR_TYPE);
#else
#define RTOSALLOC_TIMER_SIGNAL_EXTRA(TIMER_PAR_TYPE) \
   ((xTimerHeader)yOutputSignalPtr)->IsTimerSignal = 1; \
   ((xTimerHeader)yOutputSignalPtr)->SigSize = sizeof(xTimerHeaderRec)+ sizeof(TIMER_PAR_TYPE);
#endif /* XOPTSIGNALALLOC */
#endif

#ifdef XOPTSIGNALALLOC

#define RTOSALLOC_TIMER_SIGNAL(TIMER_NAME_PARAMETER,DUR_EXPR,TIMER_IDNODE) \
   yOutputSignalPtr = xGetSignal(TIMER_IDNODE,SDL_NULL,SDL_NULL); \
   ((xTimerHeader)yOutputSignalPtr)->TimerToSetOrReset = TIMER_NAME_PARAMETER; \
   RTOSALLOC_TIMER_SIGNAL_EXTRA(xTimerHeaderRec)
#define RTOS_ALLOC_TIMER_SIGNAL_PAR(TIMER_NAME, TIMER_IDNODE, TIMER_PAR_TYPE) \
  yOutputSignalPtr = (xSignalHeader)xGetSignal(TIMER_IDNODE,SDL_NULL,SDL_NULL); \
  ((xTimerHeader)yOutputSignalPtr)->TimerToSetOrReset = TIMER_NAME; \
  ((xTimerHeader)yOutputSignalPtr)->TestParams = 1; \
   RTOSALLOC_TIMER_SIGNAL_EXTRA(TIMER_PAR_TYPE)

#else /* XOPTSIGNALALLOC */

#define RTOSALLOC_TIMER_SIGNAL(TIMER_NAME_PARAMETER,DUR_EXPR) \
   yOutputSignalPtr = (xSignalHeader)xAlloc(sizeof(xTimerHeaderRec)); \
   ((xTimerHeader)yOutputSignalPtr)->TimerToSetOrReset = TIMER_NAME_PARAMETER;\
   yOutputSignalPtr->SigP = (xTimerHeaderRec*)yOutputSignalPtr+1; \
   RTOSALLOC_TIMER_SIGNAL_EXTRA(NULL)

#define RTOS_ALLOC_TIMER_SIGNAL_PAR(TIMER_NAME, TIMER_IDNODE, TIMER_PAR_TYPE) \
  yOutputSignalPtr = (xSignalHeader)xAlloc(sizeof(xTimerHeaderRec)+sizeof(TIMER_PAR_TYPE)); \
  ((xTimerHeader)yOutputSignalPtr)->TimerToSetOrReset = TIMER_NAME; \
  ((xTimerHeader)yOutputSignalPtr)->TestParams = 1; \
   yOutputSignalPtr->SigP = (xTimerHeaderRec*)yOutputSignalPtr+1; \
  RTOSALLOC_TIMER_SIGNAL_EXTRA(TIMER_PAR_TYPE)

#endif /* XOPTSIGNALALLOC */

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define  RTOS_SDL_SET_DUR_WITH_PARA_EXTRA \
  yOutputSignalPtr->Receiver = SDL_SELF;
#else
#define  RTOS_SDL_SET_DUR_WITH_PARA_EXTRA
#endif /* X_ONE_TASK_PER_INSTANCE_SET */

#ifdef XOPTSIGNALALLOC
#define RTOS_SDL_SET_DUR_WITH_PARA(TIME_EXPR, DUR_EXPR, TIMER_NAME, TIMER_IDNODE, TIMER_PAR_TYPE, EQ_FUNC, TIMER_VAR, TIMER_NAME_STRING) \
  XOS_TRACE_SET(TIMER_NAME_STRING) \
  yVarP->TIMER_VAR = TIMER_NAME; \
  yOutputSignalPtr->Sender = SDL_SELF; \
  RTOS_SDL_SET_DUR_WITH_PARA_EXTRA \
  ((xTimerHeader)yOutputSignalPtr)->TimerTime = DUR_EXPR; \
  ((xTimerHeader)yOutputSignalPtr)->SignalCode = SetTimer; \
  XSDLRESETWITHPARAM(TIMER_NAME, SDL_SELF,RTOSINSIGNALPTR, yOutputSignalPtr,EQ_FUNC,TIMER_NAME_STRING); \
  XMSC_TRACE_SET(yOutputSignalPtr, TIMER_NAME_STRING, DUR_EXPR) \
  Err = msgQSend((MSG_Q_ID)TimerPId, (char *)yOutputSignalPtr, \
                 sizeof(TIMER_PAR_TYPE), \
                   NO_WAIT, MSG_PRI_NORMAL); \
  xReleaseSignal((void*)&yOutputSignalPtr); \
  XOS_ERROR("OUTPUT", "msgQSend", Err)
#else
#define RTOS_SDL_SET_DUR_WITH_PARA(TIME_EXPR, DUR_EXPR, TIMER_NAME, TIMER_IDNODE, TIMER_PAR_TYPE, EQ_FUNC, TIMER_VAR, TIMER_NAME_STRING) \
  XOS_TRACE_SET(TIMER_NAME_STRING) \
  yVarP->TIMER_VAR = TIMER_NAME; \
  yOutputSignalPtr->Sender = SDL_SELF; \
  RTOS_SDL_SET_DUR_WITH_PARA_EXTRA \
  ((xTimerHeader)yOutputSignalPtr)->TimerTime = DUR_EXPR; \
  ((xTimerHeader)yOutputSignalPtr)->SignalCode = SetTimer; \
  XSDLRESETWITHPARAM(TIMER_NAME, SDL_SELF,RTOSINSIGNALPTR, yOutputSignalPtr,EQ_FUNC,TIMER_NAME_STRING); \
  XMSC_TRACE_SET(yOutputSignalPtr, TIMER_NAME_STRING, DUR_EXPR) \
  Err = msgQSend((MSG_Q_ID)TimerPId, (char *)yOutputSignalPtr, \
                 sizeof(xTimerHeaderRec)+sizeof(TIMER_PAR_TYPE), \
                   NO_WAIT, MSG_PRI_NORMAL); \
  xFree((void**)&yOutputSignalPtr); \
  XOS_ERROR("OUTPUT", "msgQSend", Err)
#endif /* XOPTSIGNALALLOC */

#ifdef XOPTSIGNALALLOC
#define RTOS_SDL_RESET_WITH_PARA(EQ_FUNC, TIMER_VAR, TIMER_NAME_STRING) \
  XOS_TRACE_RESET(TIMER_NAME_STRING) \
  yOutputSignalPtr->Sender = SDL_SELF; \
  ((xTimerHeader)yOutputSignalPtr)->TimerTime = 0; \
  XSDLRESETWITHPARAM(yVarP->TIMER_VAR, SDL_SELF,RTOSINSIGNALPTR, yOutputSignalPtr,EQ_FUNC,TIMER_NAME_STRING); \
  xReleaseSignal((void*)&yOutputSignalPtr); \
  XOS_ERROR("OUTPUT", "msgQSend", Err)
#else
#define RTOS_SDL_RESET_WITH_PARA(EQ_FUNC, TIMER_VAR, TIMER_NAME_STRING) \
  XOS_TRACE_RESET(TIMER_NAME_STRING) \
  yOutputSignalPtr->Sender = SDL_SELF; \
  ((xTimerHeader)yOutputSignalPtr)->TimerTime = 0; \
  XSDLRESETWITHPARAM(yVarP->TIMER_VAR, SDL_SELF,RTOSINSIGNALPTR, yOutputSignalPtr,EQ_FUNC,TIMER_NAME_STRING); \
  xFree((void**)&yOutputSignalPtr); \
  XOS_ERROR("OUTPUT", "msgQSend", Err)
#endif /* XOPTSIGNALALLOC */

/* ------------------------ Execution trace ---------------------- */

#define RTOSMSCPRINT_START

#define RTOSMSCPRINT_STOP

#ifdef XMSC_TRACE

#define RTOSXMSC_TRACE_CREATE( INSTANCE, PROC_NAME_STRING) \
   { SDL_PId ParentPId; ParentPId = SDL_SELF; \
   XMSC_TRACE_STATIC_CREATE(INSTANCE, PROC_NAME_STRING) \
   XMSC_FPRINT(("%lu : create %lu;\n", ParentPId, INSTANCE)) }

#define RTOSXMSC_TRACE_STATIC_CREATE(INSTANCE, PROC_NAME_STRING) \
   XMSC_FPRINT(("%lu: instancehead process %s;\n", INSTANCE,\
                 PROC_NAME_STRING))

#define RTOSXMSC_TRACE_NEXTSTATE(STATE_NAME_STRING) \
   { SDL_PId CurrentPId; CurrentPId = SDL_SELF; \
   XMSC_FPRINT(("%lu: condition %s;\n", CurrentPId, STATE_NAME_STRING)) }

#define XMSC_TRACE_INPUT(SIG_NAME_STRING) \
   { unsigned long CurrentPId, SenderPId; \
     unsigned long ticks; \
     CurrentPId = (unsigned long)SDL_SELF; \
     SenderPId = (unsigned long)yVarP->Sender; \
     if (INSIGNAL_PTR->IsTimer) { \
       ticks = tickGet(); \
       XMSC_FPRINT(("%lu: timeout  %s,%d; /* #SDTNOW(%ld) */\n", \
         CurrentPId, SIG_NAME_STRING, \
         INSIGNAL_PTR->SignalId, ticks)) \
     } \
     else \
       XMSC_FPRINT(("%lu: in %s,%d from %lu;\n", CurrentPId, \
         SIG_NAME_STRING, INSIGNAL_PTR->SignalId, \
         SenderPId))  \
   }

#define XMSC_TRACE_OUTPUT(RECEIVER, SIGNAL, SIG_NAME_STRING) \
   { SDL_PId CurrentPId; \
     CurrentPId = SDL_SELF; \
     SignalId = SignalId + 1; \
     SIGNAL->SignalId = SignalId; \
     SIGNAL->IsTimer = 0; \
     if ( xEq_SDL_PId(RECEIVER, xEnvPId) ) \
       XMSC_FPRINT(("%lu: out %d,%d to %lu;\n", CurrentPId, \
                     SIGNAL->SignalCode, SignalId, RECEIVER)) \
     else \
       XMSC_FPRINT(("%lu: out %s,%d to %lu;\n", CurrentPId, \
                     SIG_NAME_STRING, SignalId, RECEIVER)) }

#define XMSC_TRACE_STOP  \
   { SDL_PId CurrentPId; \
     CurrentPId = SDL_SELF; \
   XMSC_FPRINT(("%lu: endinstance;\n", CurrentPId)) }

#define XMSC_TRACE_SET( TIMER, TIMER_NAME_STRING, DUR_EXPR) \
   { SDL_PId CurrentPId; \
     unsigned long ticks; \
     CurrentPId = SDL_SELF; \
     SignalId = SignalId + 1; \
     TIMER->SignalId = SignalId; \
     TIMER->IsTimer = 1; \
     ticks = tickGet(); \
     XMSC_FPRINT(("%lu: set %s,%d (%d); /* #SDTNOW(%ld) */\n", CurrentPId, \
       TIMER_NAME_STRING, SignalId, DUR_EXPR, ticks)) }

#define XMSC_TRACE_RESET( TIMER_ID, TIMER_NAME_STRING) \
   { SDL_PId CurrentPId; \
     unsigned long ticks; \
     CurrentPId = Self; \
     ticks = tickGet(); \
     XMSC_FPRINT(("%lu: reset %s,%d; /* #SDTNOW(%ld) */\n", CurrentPId, \
     TIMER_NAME_STRING, TIMER_ID, ticks)) }
#endif


#ifdef XOS_TRACE
#ifndef X_ONE_TASK_PER_INSTANCE_SET
#define RTOSXOS_TRACE_STATIC_CREATE(INSTANCE, PROC_NAME_STRING) \
  XOS_STATIC_FPRINT(("Process %s:%lu created\n", PROC_NAME_STRING, INSTANCE))

#define RTOSXOS_TRACE_CREATE(INSTANCE, PROC_NAME_STRING) \
 XOS_FPRINT(("%s: process %s:%lu created\n", ProcName, \
 PROC_NAME_STRING, INSTANCE))

#define XOS_FPRINT(PARAM) \
{  SDL_PId CurrentPId; \
   CurrentPId = yVarP->Self; \
   if (LastUsedPId != CurrentPId) \
     printf("\nProcess instance %lu\n", CurrentPId); \
   printf PARAM; \
   LastUsedPId = yVarP->Self; \
}
#define XOS_FPRINTADDR(PARAM) \
   {  \
   SDL_PId CurrentPId; \
   CurrentPId = (*yVarP)->Self; \
   if (LastUsedPId != CurrentPId) \
     printf("\n** Process: %s instance: %lu **\n", \
            (*yVarP)->ProcName, CurrentPId); \
   printf PARAM; \
   LastUsedPId = (*yVarP)->Self; \
   }
#else

#define RTOSXOS_TRACE_STATIC_CREATE(INSTANCE, PROC_NAME_STRING) \
  XOS_STATIC_FPRINT(("Process %s:%lu created\n", PROC_NAME_STRING, INSTANCE))

#define RTOSXOS_TRACE_CREATE(INSTANCE, PROC_NAME_STRING) \
 XOS_FPRINT(("%s: process %s:%lu created\n", ProcName, \
 PROC_NAME_STRING, INSTANCE))

#define XOS_FPRINT(PARAM) \
{  xEPrsNode CurrentPId; \
   CurrentPId = SDL_SELF; \
   if (LastUsedPId != CurrentPId) \
   printf("\n** Process: %s instance: %lu **\n", \
          yInstanceSetVars->name, CurrentPId); \
   printf PARAM; \
   LastUsedPId = SDL_SELF; \
}
#define XOS_FPRINTADDR(PARAM) \
   {  \
   xEPrsNode CurrentPId; \
   CurrentPId = (*yVarP)->PrsNode;  \
   if (LastUsedPId != CurrentPId) \
     printf("\n** Process: %s instance: %lu **\n", \
            yInstanceSetVars->name, CurrentPId); \
   printf PARAM; \
   LastUsedPId = (*yVarP)->PrsNode; \
   }

#endif
#endif


/****+***************************************************************
     SDL Save
********************************************************************/

typedef struct xSignalHeaderStruct xSaveQStruct;
typedef xSignalHeader xSaveQ;

#define RTOSSAVEQ_TYPE xSaveQ 

/****+***************************************************************
     SDL Timer
********************************************************************/

extern void SDL_Reset( xTimerHeader TimerName, xSaveQ SaveQ);

/****+***************************************************************
     sdl
********************************************************************/
extern void xSaveSignal  XPP((
  RTOSSAVEQ_TYPE  SaveQ,
  RTOSSIGNAL_DEF yInSignalPtr));

extern void xDiscardSignal XPP((
  xSignalHeader    *DiscardSignal));

#ifdef X_ONE_TASK_PER_INSTANCE_SET
extern void xKillSaveQ XPP((
  xSignalHeader  SaveQ,
  SDL_PId        CurrentPId));
#else
extern void xKillSaveQ  XPP((
  xSignalHeader     SaveQ));
#endif

extern SDL_PId xTo_Process XPP((
  xPrsIdNode  PrsNode));

extern void xHandle_Sig XPP((
  RTOSSIGNAL_DEF  OutputSignal,SDL_PId Sender,int SigPar_Size,SDL_PId Receiver, RTOSTASK_TYPE ReceiverTask RTOSHANDLEMESS_TYPE));


/*
extern SDL_PId xProc2PId XPP((PROCESS exttaskproc, SDL_PId exttaskpid));
*/


/****+***************************************************************
     Initialization functions
********************************************************************/

/*---+---------------------------------------------------------------
     System_Init_Process
-------------------------------------------------------------------*/
#define RTOSMAINRETURNTYPE void
#define RTOSMAINNAME System_Init_Process
#define RTOSMAINNAME_PARAM XPP((void))
extern RTOSMAINRETURNTYPE RTOSMAINNAME RTOSMAINNAME_PARAM;
#define RTOSMAINRETURNSTMT /* unreachable code! */

#define RTOSMAINNAME_PARAM \
XPP((void))

#define RTOSSYSINITFUNC_VAR \
  xSignalHeader yInSignalPtr; \
  xSignalHeader yOutputSignalPtr; \
  int i;

#define RTOSSYSINITFUNC_SDLNULL 

#define RTOSSYSINITPR_SEMCREATE \
  taskSem = semCCreate(SEM_Q_FIFO,0);

#define RTOSSYSINITPR_SEMGIVE \
  for (i=1;(i<=createdProcesses);i++) { \
    Err = semGive( taskSem); \
    XOS_ERROR("userInit", "semGive", Err) \
  }

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define RTOSSYSINITPROC_RECEIVE \
    yInSignalPtr = xAlloc(VXMAXMSGLENGTH); \
    TmsgQReceive((MSG_Q_ID) xEnvPIdQ,(char *)yInSignalPtr, \
                VXMAXMSGLENGTH, WAIT_FOREVER);
#else
#define RTOSSYSINITPROC_RECEIVE \
    yInSignalPtr = xAlloc(VXMAXMSGLENGTH); \
    TmsgQReceive((MSG_Q_ID) xEnvPId,(char *)yInSignalPtr, \
                VXMAXMSGLENGTH, WAIT_FOREVER);
#endif

#define RTOSSYSINITPR_SENDER SDL_NULL
#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define RTOSSYSINITPR_MSCPRINT \
  XMSC_FPRINT(("%lu: in %d,%d from %lu;\n", xEnvPrs, \
         yInSignalPtr->SignalCode , yInSignalPtr->SignalId,\
         yInSignalPtr->Sender)) 
#else
#define RTOSSYSINITPR_MSCPRINT \
  XMSC_FPRINT(("%lu: in %d,%d from %lu;\n", xEnvPId, \
         yInSignalPtr->SignalCode , yInSignalPtr->SignalId,\
         yInSignalPtr->Sender))
#endif

/*---+---------------------------------------------------------------
     xInitTimer
-------------------------------------------------------------------*/
#define RTOSXTIMERTASK_PARAM void
#define RTOSXTIMERTASK_RTNTYPE void
extern void xTimerTask XPP(( RTOSXTIMERTASK_PARAM ));

#define RTOSXINITTIMER \
{ \
   int errcode; \
   TimerPId = msgQCreate(MAX_INPUTPORT_LENGTH , VXMAXMSGLENGTH, \
                          MSG_Q_FIFO); \
   if((SDL_PId)TimerPId == NULL){ \
      XOS_ERROR("CREATE", "msgQCreate", ERROR) \
   } \
   Err = TtaskSpawn("TimerTask", 90, VX_TASK_OPTIONS, \
                   4096, (FUNCPTR)xTimerTask, \
                   0,0,0,0,0,0,0,0,0,0); \
   XOS_ERROR("CREATE", "TtaskSpawn", Err) \
}

/****+***************************************************************
     Timer Procedures
********************************************************************/
/*---+---------------------------------------------------------------
     xSDLReset
-------------------------------------------------------------------*/
#ifdef X_ONE_TASK_PER_INSTANCE_SET
#ifdef XMSC_TRACE
#define XSDLRESETWITHPARAM(TIMER_NAME, SELF,INPUTSIG,OUTPUTSIG,EQUALF, TIMER_NAME_STRING) \
   xSDLReset( TIMER_NAME, SELF, yInstanceSetVars->SaveQ,INPUTSIG, OUTPUTSIG, EQUALF,\
             TIMER_NAME_STRING);
#else /* XMSC_TRACE */
#define XSDLRESETWITHPARAM(TIMER_NAME, SELF,INPUTSIG,OUTPUTSIG,EQUALF, TIMER_NAME_STRING) \
   xSDLReset( TIMER_NAME, SELF, yInstanceSetVars->SaveQ,INPUTSIG, OUTPUTSIG, EQUALF);
#endif /* XMSC_TRACE */

#else /* X_ONE_TASK_PER_INSTANCE_SET */

#ifdef XMSC_TRACE
#define XSDLRESETWITHPARAM(TIMER_NAME, SELF,INPUTSIG,OUTPUTSIG,EQUALF, TIMER_NAME_STRING) \
   xSDLReset( TIMER_NAME, SELF, yVarP->SaveQ,INPUTSIG, OUTPUTSIG, EQUALF,\
             TIMER_NAME_STRING);
#else /* XMSC_TRACE */
#define XSDLRESETWITHPARAM(TIMER_NAME, SELF,INPUTSIG,OUTPUTSIG,EQUALF, TIMER_NAME_STRING) \
   xSDLReset( TIMER_NAME, SELF, yVarP->SaveQ,INPUTSIG, OUTPUTSIG, EQUALF);
#endif /* XMSC_TRACE */
#endif /* X_ONE_TASK_PER_INSTANCE_SET */

#ifdef XMSC_TRACE
#define RTOSXSDLRESET_PARAMETERS \
(  int TimerName, \
  SDL_PId Self, \
  xSignalHeader SaveQ, \
  xSignalHeader InSignalPtr, \
  xSignalHeader yOutputSignalPtr, \
  xbool (* yEq)(void * VarP1, void * VarP2), \
  char *SignalName)
#define XSDLRESET( TIMER_NAME,SAVEQ, TIMER_NAME_STRING) \
   xSDLReset( TIMER_NAME,SDL_SELF, SAVEQ,RTOSINSIGNALPTR,(xbool)0, (xbool)0,TIMER_NAME_STRING);

#else /*XMSC_TRACE */

#define RTOSXSDLRESET_PARAMETERS \
(  int TimerName, \
  SDL_PId Self, \
  xSignalHeader SaveQ, \
  xSignalHeader InSignalPtr, \
  xSignalHeader yOutputSignalPtr, \
  xbool (* yEq)(void * VarP1, void * VarP2))
#define XSDLRESET( TIMER_NAME,SAVEQ, TIMER_NAME_STRING) \
   xSDLReset(TIMER_NAME, SDL_SELF, SAVEQ, RTOSINSIGNALPTR,(xbool)0,(xbool)0);
#endif

#define RTOSXSDLRESET_VARS \
 xTimerHeader  yTimerReset; \
  xSignalHeader TempSaved; \
  int           NoOfMessages, i; \
  int           Err;

#define RTOSXSDLRESET_INIT \
  RTOSALLOCTIMER_TIMERMSG(yTimerReset,sizeof(xTimerHeaderRec)) \
  yTimerReset->SignalCode = ResetTimer; \
  yTimerReset->Sender = Self; \
  yTimerReset->TimerToSetOrReset = TimerName; \
  yTimerReset->yEq = yEq; \
  yTimerReset->Param = (xTimerHeader)yOutputSignalPtr; \
  yTimerReset->TestParams = (yOutputSignalPtr != NULL&&yEq!=NULL); \
  Err = msgQSend((MSG_Q_ID)TimerPId, (char *)yTimerReset, \
                 sizeof(xTimerHeaderRec), \
                   NO_WAIT, MSG_PRI_NORMAL); \
  RTOSFREE_BUF((void**)&yTimerReset); \
  XOS_ERROR("OUTPUT", "msgQSend", Err)

/*
#define RTOSXSDLRESET_ALLOC \
(xTimerHeader)xAlloc( sizeof(xTimerHeaderRec));

#define RTOSXRESETTIMER_TIMERTORESET_2 \
yTimerReset->xResetTimer.TimerToReset

#define RTOSXRESETTIMER_SENDER \
yTimerReset->xResetTimer.Sender

#define RTOSXRESETTIMER_RECEIVER \
yTimerReset->xResetTimer.Receiver
*/

#ifdef XOPTSIGNALALLOC
#define RTOSCHECKEQPARAM_INTIMER \
  if(yInSignalPointer->TestParams) { \
    if(yEqFunc((xTimerHeader)(((xTimerHeader)yInSignalPointer)->Param),((xTimerHeader)TempTimer))) { \
      break; \
    } \
  } \
  else

#define RTOSCHECKEQPARAM \
  if(yOutputSignalPtr != NULL && yEq !=NULL) { \
    if((*yEq)(((xTimerHeader)(((xTimerHeader)yOutputSignalPtr))),(((xTimerHeader)TempSaved)))) { \
      xDiscardSignal(&TempSaved); \
      return; \
    } \
  } \
  else {

#define RTOSCHECKEQPARAM2 \
  if(yOutputSignalPtr != NULL && yEq !=NULL) { \
    if((*yEq)(((xTimerHeader)yOutputSignalPtr), ((xTimerHeader)TempSaved))) { \
      return; \
    } \
  } \
  else {

#else

#define RTOSCHECKEQPARAM_INTIMER \
  if(yInSignalPointer->TestParams) { \
    if(yEqFunc(((xTimerHeader)(((xTimerHeader)yInSignalPointer)->Param)+1),(((xTimerHeader)TempTimer)+1))) { \
      break; \
    } \
  } \
  else

#define RTOSCHECKEQPARAM \
  if(yOutputSignalPtr != NULL && yEq !=NULL) { \
    if((*yEq)(((xTimerHeader)(((xTimerHeader)yOutputSignalPtr))+1),(((xTimerHeader)TempSaved)+1))) { \
      xDiscardSignal(&TempSaved); \
      return; \
    } \
  } \
  else {

#define RTOSCHECKEQPARAM2 \
  if(yOutputSignalPtr != NULL && yEq !=NULL) { \
    if((*yEq)((((xTimerHeader)yOutputSignalPtr)+1), (((xTimerHeader)TempSaved)+1))) { \
      return; \
    } \
  } \
  else {
#endif /* XOPTSIGNALALLOC */


#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define RTOSSELF \
(MSG_Q_ID)Self->NameNode->PROCID

#else
#define RTOSSELF \
(MSG_Q_ID)Self
#endif

#define RTOSXSDLRESET_WAITREPLY \
  RTOSALLOCTIMER_TIMERMSG(yTimerReset,VXMAXMSGLENGTH) \
    Err = TmsgQReceive(RTOSSELF, \
                      (char *)yTimerReset ,VXMAXMSGLENGTH, WAIT_FOREVER); \
  XOS_ERROR("RESET", "msgQSReceive", Err) \
\
  while (yTimerReset->SignalCode != ResetTimer) { \
    xSaveSignal(SaveQ, (xSignalHeader)yTimerReset); \
    RTOSALLOCTIMER_TIMERMSG(yTimerReset,VXMAXMSGLENGTH) \
    Err = TmsgQReceive(RTOSSELF, \
                      (char *)yTimerReset , VXMAXMSGLENGTH, WAIT_FOREVER); \
    XOS_ERROR("RESET", "msgQSReceive", Err) \
  } \
\
  if (yTimerReset->TimerToSetOrReset == TimerWasFound) { \
    XMSC_TRACE_RESET(yTimerReset->SignalId, SignalName); \
    RTOSFREE_BUF(&yTimerReset); \
    return; \
  } \
  RTOSFREE_BUF(&yTimerReset);

#define RTOSTEMPSAVED \
TempSaved

#define RTOSTEMPSAVED_SIGNO \
TempSaved->SignalCode

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define RTOSTEMPSAVED_RECEIVER \
TempSaved->Receiver
#else
#define RTOSTEMPSAVED_RECEIVER
#endif

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define RTOSYTIMERACTIVE_RECEIVER \
yTimerActive->Receiver
#else
#define RTOSYTIMERACTIVE_RECEIVER
#endif

#define RTOSXRESETTEMPTIMER_SIGNALID \
yTimerReset->SignalId

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#ifdef XOPTSIGNALALLOC
#define RTOSXSDLRESET_REMOVETIMER \
  NoOfMessages = TmsgQNumMsgs((MSG_Q_ID)Self); \
  for (i=0; i<NoOfMessages; i++) { \
   if(xAvailSignalLists[VXMAXMSGLENGTH] !=(xSignalNode)0) { \
     yTimerReset = (xTimerHeader)xAvailSignalLists[VXMAXMSGLENGTH]; \
     xAvailSignalLists[VXMAXMSGLENGTH] = xAvailSignalLists[VXMAXMSGLENGTH]->Suc; \
     } else { \
       yTimerReset = xAlloc(VXMAXMSGLENGTH); \
    } \
    Err = TmsgQReceive(RTOSSELF,  \
           (char *)yTimerReset , VXMAXMSGLENGTH, WAIT_FOREVER); \
    XOS_ERROR("RESET", "msgQSReceive", Err) \
    yTimerReset->MaxSize = 1; \
    if ((yTimerReset->SignalCode == TimerName) &&(xEq_SDL_PId(yTimerReset->Receiver,Self))) { \
      if (yOutputSignalPtr != NULL) { \
        if ((*yEq)(((xTimerHeader)yOutputSignalPtr), ((xTimerHeader)yTimerReset))) { \
          /* Timer found, free memory and return */ \
          XMSC_TRACE_RESET(yTimerReset->SignalId, SignalName); \
          xReleaseSignal((void *)&yTimerReset); \
          return; \
        } \
      } \
      else { \
        /* Timer found, free memory and return */ \
        XMSC_TRACE_RESET(yTimerReset->SignalId, SignalName); \
        xReleaseSignal((void *)&yTimerReset); \
        return; \
      } \
    } \
    /* Other signal or timer found, put them in SaveQ and continue */ \
    xSaveSignal( SaveQ, (xSignalHeader)yTimerReset); \
  }
#else /* XOPTSIGNALALLOC */
#define RTOSXSDLRESET_REMOVETIMER \
  NoOfMessages = TmsgQNumMsgs((MSG_Q_ID)Self); \
  for (i=0; i<NoOfMessages; i++) { \
    yTimerReset = (xTimerHeader)xAlloc(VXMAXMSGLENGTH); \
    Err = TmsgQReceive(RTOSSELF,  \
           (char *)yTimerReset , VXMAXMSGLENGTH, WAIT_FOREVER); \
    XOS_ERROR("RESET", "msgQSReceive", Err) \
    if ((yTimerReset->SignalCode == TimerName) &&(xEq_SDL_PId(yTimerReset->Receiver,Self))) { \
      if (yOutputSignalPtr != NULL) { \
        if ((*yEq)(((xTimerHeader)yOutputSignalPtr)+1, ((xTimerHeader)yTimerReset)+1)) { \
          /* Timer found, free memory and return */ \
          XMSC_TRACE_RESET(yTimerReset->SignalId, SignalName); \
          xFree((void **)&yTimerReset); \
          return; \
        } \
      } \
      else { \
        /* Timer found, free memory and return */ \
        XMSC_TRACE_RESET(yTimerReset->SignalId, SignalName); \
        xFree((void **)&yTimerReset); \
        return; \
      } \
    } \
    /* Other signal or timer found, put them in SaveQ and continue */ \
    xSaveSignal( SaveQ, (xSignalHeader)yTimerReset); \
  }
#endif /* XOPTSIGNALALLOC */

#else /* X_ONE_TASK_PER_INSTANCE_SET */
#ifdef XOPTSIGNALALLOC
#define RTOSXSDLRESET_REMOVETIMER \
  NoOfMessages = TmsgQNumMsgs((MSG_Q_ID)Self); \
  for (i=0; i<NoOfMessages; i++) { \
   if(xAvailSignalLists[VXMAXMSGLENGTH] !=(xSignalNode)0) { \
     yTimerReset = (xTimerHeader)xAvailSignalLists[VXMAXMSGLENGTH]; \
     xAvailSignalLists[VXMAXMSGLENGTH] = xAvailSignalLists[VXMAXMSGLENGTH]->Suc; \
     } else { \
       yTimerReset = xAlloc(VXMAXMSGLENGTH); \
    } \
    Err = TmsgQReceive(RTOSSELF,  \
           (char *)yTimerReset , VXMAXMSGLENGTH, WAIT_FOREVER); \
    XOS_ERROR("RESET", "msgQSReceive", Err) \
    if (yTimerReset->SignalCode == TimerName) { \
      if (yOutputSignalPtr != NULL) { \
        if ((*yEq)((xTimerHeader)(yOutputSignalPtr), (xTimerHeader)(TempSaved))) { \
          /* Timer found, free memory and return */ \
          XMSC_TRACE_RESET(yTimerReset->SignalId, SignalName); \
          xFree((void **)&yTimerReset); \
          return; \
        } \
      } \
      else { \
        /* Timer found, free memory and return */ \
        XMSC_TRACE_RESET(yTimerReset->SignalId, SignalName); \
        xFree((void **)&yTimerReset); \
        return; \
      } \
    } \
    /* Other signal or timer found, put them in SaveQ and continue */ \
    xSaveSignal( SaveQ, (xSignalHeader)yTimerReset); \
  }
#else /* XOPTSIGNALALLOC */
#define RTOSXSDLRESET_REMOVETIMER \
  NoOfMessages = TmsgQNumMsgs((MSG_Q_ID)Self); \
  for (i=0; i<NoOfMessages; i++) { \
    yTimerReset = (xTimerHeader)xAlloc(VXMAXMSGLENGTH); \
    Err = TmsgQReceive(RTOSSELF,  \
           (char *)yTimerReset , VXMAXMSGLENGTH, WAIT_FOREVER); \
    XOS_ERROR("RESET", "msgQSReceive", Err) \
    if (yTimerReset->SignalCode == TimerName) { \
      if (yOutputSignalPtr != NULL) { \
        if ((*yEq)(((xTimerHeader)yOutputSignalPtr)+1, ((xTimerHeader)yTimerReset)+1)) { \
          /* Timer found, free memory and return */ \
          XMSC_TRACE_RESET(yTimerReset->SignalId, SignalName); \
          xFree((void **)&yTimerReset); \
          return; \
        } \
      } \
      else { \
        /* Timer found, free memory and return */ \
        XMSC_TRACE_RESET(yTimerReset->SignalId, SignalName); \
        xFree((void **)&yTimerReset); \
        return; \
      } \
    } \
    /* Other signal or timer found, put them in SaveQ and continue */ \
    xSaveSignal( SaveQ, (xSignalHeader)yTimerReset); \
  }
#endif /* XOPTSIGNALALLOC */
#endif /*X_ONE_TASK_PER_INSTANCE_SET*/

/*---+---------------------------------------------------------------
     xSDLActive
-------------------------------------------------------------------*/

#define RTOSXSDLACTIVE_PARAMETERS \
XPP(( \
 int TimerName, \
 SDL_PId Self, \
 xSignalHeader SaveQ,\
 xSignalHeader CurrentInSaveQ))

#define RTOSXSDLACTIVE_VARS \
  xTimerHeader  yTimerActive; \
  xSignalHeader TempSaved; \
  int           NoOfMessages, i; \
  int           Err;

#ifdef XNOTIMERPARAMS
#define RTOSXSDLACTIVE_ALLOC_EXTRA
#else
#define RTOSXSDLACTIVE_ALLOC_EXTRA \
   yTimerActive->SigSize = sizeof(xTimerHeaderRec);
#endif

#ifdef XOPTSIGNALALLOC
#define RTOSXSDLACTIVE_ALLOC \
0; \
   yTimerActive =(xTimerHeader) xGetSignal(&(TimerIdDummy), SDL_NULL,SDL_NULL); \
  yTimerActive->SignalCode = ActiveTimer; \
  RTOSXSDLACTIVE_ALLOC_EXTRA \
  yTimerActive->Sender = Self;
#else
#define RTOSXSDLACTIVE_ALLOC \
  (xTimerHeader)xAlloc( sizeof(xTimerHeaderRec)); \
  yTimerActive->SignalCode = ActiveTimer; \
  yTimerActive->SigP = (xTimerHeaderRec*)yTimerActive+1; \
  RTOSXSDLACTIVE_ALLOC_EXTRA \
  yTimerActive->Sender = Self; 
#endif /* XOPTSIGNALALLOC */

#define RTOSACTIVEINTIMERPROCESS_VARS

#define RTOSXACTIVETIMER_TIMERTOFIND_2 \
  yTimerActive->TimerToSetOrReset

#ifdef XOPTSIGNALALLOC
#define RTOSALLOCTIMER_TIMERMSG(msg,msgsize) \
     if(xAvailSignalLists[VXMAXMSGLENGTH] !=(xSignalNode)0) { \
       msg =(xTimerHeader) xAvailSignalLists[VXMAXMSGLENGTH]; \
       xAvailSignalLists[VXMAXMSGLENGTH] = xAvailSignalLists[VXMAXMSGLENGTH]->Suc; \
     } else { \
       msg = xAlloc(VXMAXMSGLENGTH); \
     } \
     msg->MaxSize = 1;

#else /* XOPTSIGNALALLOC */

#define RTOSALLOCTIMER_TIMERMSG(msg,msgsize) \
 msg = (xTimerHeader)xAlloc(msgsize);
#endif

#ifdef XOPTSIGNALALLOC
#define RTOSXSDLACTIVE_WAITREPLY \
  yTimerActive = (xTimerHeader)xGetSignal(&(TimerIdDummy), SDL_NULL,SDL_NULL); \
  Err = TmsgQReceive((MSG_Q_ID)RTOSSELF, (char *)yTimerActive , \
                    sizeof(xTimerHeaderRec), WAIT_FOREVER);\
  XOS_ERROR("RESET", "msgQSReceive", Err) \
  while (yTimerActive->SignalCode != ActiveTimer) { \
    xSaveSignal(SaveQ, (xSignalHeader)yTimerActive); \
    yTimerActive = (xTimerHeader)xGetSignal(&(TimerIdDummy),SDL_NULL,SDL_NULL); \
    Err = TmsgQReceive((MSG_Q_ID)RTOSSELF, (char *)yTimerActive, \
                      sizeof(xTimerHeaderRec), WAIT_FOREVER); \
    XOS_ERROR("OUTPUT", "msgQSend", Err) \
  } \
\
  if (yTimerActive->TimerToSetOrReset == TimerWasFound) { \
    RTOSFREE_BUF(&yTimerActive); \
    return( SDL_True); \
  } \
  RTOSFREE_BUF(&yTimerActive);
#else
#define RTOSXSDLACTIVE_WAITREPLY \
  yTimerActive = (xTimerHeader)xAlloc( sizeof(xTimerHeaderRec)); \
  yTimerActive->SigP = (xTimerHeaderRec*)yTimerActive+1; \
  Err = TmsgQReceive((MSG_Q_ID)RTOSSELF, (char *)yTimerActive , \
                    sizeof(xTimerHeaderRec), WAIT_FOREVER);\
  XOS_ERROR("RESET", "msgQSReceive", Err) \
  while (yTimerActive->SignalCode != ActiveTimer) { \
    xSaveSignal(SaveQ, (xSignalHeader)yTimerActive); \
    yTimerActive = (xTimerHeader)xAlloc( sizeof(xTimerHeaderRec)); \
    yTimerActive->SigP = (xTimerHeaderRec*)yTimerActive+1; \
    Err = TmsgQReceive((MSG_Q_ID)RTOSSELF, (char *)yTimerActive, \
                      sizeof(xTimerHeaderRec), WAIT_FOREVER); \
    XOS_ERROR("OUTPUT", "msgQSend", Err) \
  } \
\
  if (yTimerActive->TimerToSetOrReset == TimerWasFound) { \
    xFree((void **)&yTimerActive); \
    return( SDL_True); \
  } \
  xFree((void **)&yTimerActive); 
#endif /* XOPTSIGNALALLOC */

#define RTOSSENDTIMERALLOCTIMER

#define RTOSSENDTIMERALLOCREPLY

#define RTOSSENDTIMERALLOC

#ifdef XNOTIMERPARAMS
#define RTOSSENDTIMER(SIGPTR,RECEIVER) \
  Err = msgQSend((MSG_Q_ID)RECEIVER, \
                (char *)*SIGPTR, sizeof(xTimerHeaderRec), \
                NO_WAIT, MSG_PRI_NORMAL); \
  RTOSFREE_BUF((void**)SIGPTR); \
  XOS_ERROR("RELEASETIMER", "msgQSend", Err)
#else
#define RTOSSENDTIMER(SIGPTR,RECEIVER) \
  Err = msgQSend((MSG_Q_ID)RECEIVER, \
                (char *)*SIGPTR, (*SIGPTR)->SigSize, \
                NO_WAIT, MSG_PRI_NORMAL); \
  RTOSFREE_BUF((void**)SIGPTR); \
  XOS_ERROR("RELEASETIMER", "msgQSend", Err)
#endif


#ifdef XOPTSIGNALALLOC
#define RTOSALLOCMESS \
   if(xAvailSignalLists[VXMAXMSGLENGTH] !=(xSignalNode)0) { \
     yTimerActive = (xTimerHeader)xAvailSignalLists[VXMAXMSGLENGTH]; \
     xAvailSignalLists[VXMAXMSGLENGTH] = xAvailSignalLists[VXMAXMSGLENGTH]->Suc; \
     } else { \
       yTimerActive = xAlloc(VXMAXMSGLENGTH); \
    } \
    Err = TmsgQReceive(RTOSSELF,  \
           (char *)yTimerActive , VXMAXMSGLENGTH, WAIT_FOREVER); \
    XOS_ERROR("RESET", "msgQSReceive", Err) \
    yTimerActive->MaxSize = 1;
#else /* XOPTSIGNALALLOC */
#define RTOSALLOCMESS \
    yTimerActive = (xTimerHeader)xAlloc(VXMAXMSGLENGTH); \
    Err = TmsgQReceive(RTOSSELF,  \
           (char *)yTimerActive , VXMAXMSGLENGTH, WAIT_FOREVER); \
    XOS_ERROR("RESET", "msgQSReceive", Err)
#endif /* XOPTSIGNALALLOC */
 

#define RTOSLOOK_FOR_TIMER \
  NoOfMessages = TmsgQNumMsgs(RTOSSELF);

#define RTOSMSG_IN_Q \
  NoOfMessages >0

#define RTOSYTIMERACTIVE_SIGNO \
  yTimerActive->SignalCode
/****+***************************************************************
     xEPrsNode handling
********************************************************************/

/*---+---------------------------------------------------------------
     xAllocPrsUseMyMemory
-------------------------------------------------------------------*/
#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define RTOSALLOCPRSSEMTAKE
#else
#define RTOSALLOCPRSSEMTAKE
#endif

#define RTOSALLOCPRSSEMGIVE

#ifdef X_ONE_TASK_PER_INSTANCE_SET
extern xEPrsNode xAllocPrsUseMyMemory  XPP(( xPrsIdNode  PType ));
#else
extern xEPrsNode xAllocPrsUseMyMemory XPP(( xPrsIdNode  PType, SDL_PId PId ));
#endif

/****+***************************************************************
     Structure nodes
********************************************************************/

#ifdef X_ONE_TASK_PER_INSTANCE_SET
typedef struct {
  xSignalHeader  SaveQ;
  xSignalHeader  CurrentInSaveQ;
  xSignalHeader  yInSignalPtr;
  char           name[100];
  xptrint        PrsDataSize;
}  xPrsInstanceSetVars;
#endif

#define RTOSXPRSIDCOMP0    void              (*RTOSPAD) XPP((unsigned long, unsigned long));
#define RTOSXPRSIDCOMP1 \
   void     (*PAD_Function) XPP((void *, SDL_PId, xPrsInstanceSetVars *));


#define RTOSXPRSIDCOMP2 \
   void              (*PAD_Function) XPP((void *));

#define RTOSXPRSIDCOMP3 \
    unsigned long       * PROCID;

/****+***************************************************************
     SDL PId
********************************************************************/
#define xEq_SDL_PId(A,B)        ((A)==(B))
#define xEq_SDL_PId_NULL(A)     ((A)==(SDL_NULL))
extern SDL_PId          xEnvPId;
extern SDL_PId      SDL_NULL;
unsigned long    xEnvPIdQ;

/****+***************************************************************
sctpred.h
********************************************************************/

/****+***************************************************************
01   Typedef, Default value, Literals
********************************************************************/

/****+***************************************************************
     osesdl.c
********************************************************************/

/****+***************************************************************
     SDL Save
********************************************************************/

/*---+--------------------------------------------------------------
     Signal priority upgrade (fab)
     Redefinition of RTOSXSAVESIGNAL
-------------------------------------------------------------------*/

/*---+---------------------------------------------------------------
     xSaveSignal
-------------------------------------------------------------------*/
#ifndef X_SIGNAL_PRIO
#define RTOSXSAVESIGNAL \
{ \
  /* Insert New signal (yInSignalPtr) last in save queue */ \
  SaveQ->Pre->Suc = (xSaveQ)yInSignalPtr; \
  yInSignalPtr->Suc = (xSignalHeader)SaveQ; \
  yInSignalPtr->Pre = (xSignalHeader)SaveQ->Pre; \
  SaveQ->Pre = (xSaveQ)yInSignalPtr; \
}
#else
#define RTOSXSAVESIGNAL \
{ \
       /* Insert New signal (yInSignalPtr) in save queue in priority order */ \
   { \
       xSignalHeader PreOfTemp;  \
       xSignalHeader Temp; \
       Temp = SaveQ->Suc; \
       while (Temp != SaveQ) { /* Stop when new signal should be inserted between Temp and */ \
                               /* Temp->Pre, i.e. when the priority index of the new signal */ \
                               /* is less than Temp */ \
         if (yInSignalPtr->Priority < Temp->Priority) break; \
         Temp = Temp->Suc; \
       } \
       /* It works also if Temp is equal to SaveQ now, and when SaveQ is initially empty */ \
       PreOfTemp = Temp->Pre; \
       Temp->Pre = yInSignalPtr; \
       yInSignalPtr->Suc = Temp; \
       PreOfTemp->Suc = yInSignalPtr; \
       yInSignalPtr->Pre = PreOfTemp; \
   } \
}
#endif

/*---+---------------------------------------------------------------
     xKillSaveQ
-------------------------------------------------------------------*/
#define RTOSTEMP_RECEIVER \
Temp1->Receiver

/*------------------------------------------------------------------------
 *      xInputSignal
 *-----------------------------------------------------------------------*/

#define RTOSCURRENTINSAVEQPTR RTOSCURRENTINSAVEQ 

#ifdef X_ONE_TASK_PER_INSTANCE_SET

#define RTOSINSIGNALPTR \
yInstanceSetVars->yInSignalPtr

#define RTOSCURRENTINSAVEQ \
yInstanceSetVars->CurrentInSaveQ


#define RTOSSTARTUPSIGNAL \
yInstanceSetVars->yInSignalPtr->SignalCode

#define RTOSSTARTUPSIGNALVARP \
yInstanceSetVars->yInSignalPtr->Receiver->VarP

#define RTOSSTARTUPSIGNALRESTARTPAD \
yInstanceSetVars->yInSignalPtr->Receiver->NameNode->PAD_Function;

#define RTOSSTARTUPSIGNALRECEIVER \
yInstanceSetVars->yInSignalPtr->Receiver

#define RTOSSTARTUPSIGNALPARENT \
yInstanceSetVars->yInSignalPtr->Sender

#define RTOSXINPUTSIGNALVARS \
  unsigned long RetCode;

#define RTOSXINPUTRESTARTPAD_CALL \
(*(*yVarP)->RestartPAD)(*yVarP,(SDL_PId) \
                        ((*yVarP)->PrsNode)->NameNode->PROCID, \
                         yInstanceSetVars);

#define RTOSXINPUTSIGNAL_SEMS


#else

#define RTOSINSIGNALPTR \
yVarP->yInSignalPtr

#ifdef XOPTSIGNALALLOC
#define RTOSSTARTUPSIGNAL_PADFUNCTION \
((xStartUpSignalHeader)((*yVarP)->yInSignalPtr))->PrsNode->NameNode->PAD_Function;
#else
#define RTOSSTARTUPSIGNAL_PADFUNCTION \
((xStartUpSignalHeader)((*yVarP)->yInSignalPtr+1))->PrsNode->NameNode->PAD_Function;
#endif

#define RTOSSTARTUPSIGNAL \
(*yVarP)->yInSignalPtr->SignalCode

#define RTOSXINPUTSIGNALVARS \
  unsigned long RetCode;

#define RTOSCURRENTINSAVEQ \
(*yVarP)->CurrentInSaveQ

#define RTOSSTARTSIGNAL \
(*yVarP)->yInSignalPtr->sig_no

#define RTOSSIGNALNO \
(*yVarP)->yInSignalPtr->SignalCode

#endif

/****+***************************************************************
     Initialization functions
********************************************************************/

/*---+---------------------------------------------------------------
     xAllocPrs
-------------------------------------------------------------------*/
#define RTOSXALLOCPRS \
{ \
}
/****+***************************************************************
     SDL Timers
********************************************************************/

#define RTOSTIMERTASK_VAR

#define RTOSTIMERTASKALLOC_Q \
  TimerQ = (xTimerHeader)xAlloc( VXMAXMSGLENGTH); \
  TimerQ->SignalCode = EndOfTimerQueue;

#ifdef XOPTSIGNALALLOC
#define RTOSTIMERTASKALLOC_INSIGNAL \
     if(xAvailSignalLists[VXMAXMSGLENGTH] !=(xSignalNode)0) { \
       yInSignalPointer =(xTimerHeader) xAvailSignalLists[VXMAXMSGLENGTH]; \
       xAvailSignalLists[VXMAXMSGLENGTH] = xAvailSignalLists[VXMAXMSGLENGTH]->Suc; \
     } else { \
       yInSignalPointer = xAlloc(VXMAXMSGLENGTH); \
     } \
     yInSignalPointer->MaxSize = 1;
#else
#define RTOSTIMERTASKALLOC_INSIGNAL \
    yInSignalPointer = xAlloc(VXMAXMSGLENGTH);
#endif

#define RTOSSET_SIGNALCODE \
  yInSignalPointer->SignalCode = yInSignalPointer->TimerToSetOrReset;

#define RTOSTIMERTASKVAR_EXTRAS \
int Err;

#define RTOSTIMERQ_PRE \
TimerQ->Pre

#define RTOSTIMERQ_SUC \
TimerQ->Suc

#define RTOSTIMERQ_RECEIVER \
TimerQ->Sender

#define RTOSTIMERQ_TIMERTIME \
TimerQ->TimerTime

#define RTOSTIMERSENDER \
yInSignalPointer->Sender

#ifdef X_ONE_TASK_PER_INSTANCE_SET 
#define RTOSTIMERSENDER2 \
(MSG_Q_ID)yInSignalPointer->Sender->NameNode->PROCID
#else
#define RTOSTIMERSENDER2 \
(MSG_Q_ID)yInSignalPointer->Sender
#endif

#define RTOSTEMPTIMERSIGNAL_SENDER \
yInSignalPointer->Sender

#define RTOSTEMPTIMERSIGNAL_PRE \
yInSignalPointer->Pre

#define RTOSTEMPTIMERSIGNAL_SUC \
yInSignalPointer->Suc

#define RTOSTEMPTIMERSIGNAL_TIMERTIME \
yInSignalPointer->TimerTime

#define RTOSXACTIVETIMER_TIMERTOFIND \
yInSignalPointer->TimerToSetOrReset

#define RTOSXRESETTIMER_TIMERTORESET \
yInSignalPointer->TimerToSetOrReset

#define RTOSXRESETTIMER_SIGNALID \
yInSignalPointer->SignalId

#define RTOSTEMPTIMERSIGNAL_RECEIVER \
TempTimer->Sender

#define RTOSTEMPTIMER_TIMERTIME \
TempTimer->TimerTime

#define RTOSTEMPTIMERSIGNAL_SIGNO \
TempTimer->SignalCode

#define RTOSTEMPTIMERSIGNAL_SIGNALID \
TempTimer->SignalId

#define RTOSTEMPTIMER_PRE \
TempTimer->Pre

#define RTOSTEMPTIMER_SUC \
TempTimer->Suc

#define RTOSTEMPTIMER_PRE_SUC \
TempTimer->Pre->Suc

#define RTOSTEMPTIMER_SUC_PRE \
TempTimer->Suc->Pre

#define RTOSTIMERWRAPPTR_PRE \
(*TimerWrapPtr)->Pre

#define RTOSTIMERWRAPPTR_SUC \
(*TimerWrapPtr)->Suc

#define RTOSHELPTEMPTIMER_PRE \
HelpTempTimer->Pre

#define RTOSHELPTEMPTIMER_SUC \
HelpTempTimer->Suc

#define RTOSHELPTEMPTIMER_PRE_SUC \
HelpTempTimer->Pre->Suc

#define RTOSHELPTEMPTIMER_SUC_PRE \
HelpTempTimer->Suc->Pre

#define RTOSXSDLRESETINTIMERPROCESS_VARS \
SDL_PId TempSender; \
xbool         (* yEqFunc)(); \
\
  yEqFunc = yInSignalPointer->yEq;

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define RTOSRESETINTIMER_SENDER \
(MSG_Q_ID)(yInSignalPointer->Sender)->NameNode->PROCID
#else
#define RTOSRESETINTIMER_SENDER \
(MSG_Q_ID)yInSignalPointer->Sender
#endif

#define RTOSXSDLRESETINTIMERPROCESS_REPLY \
  Err = msgQSend(RTOSRESETINTIMER_SENDER, \
                 (char *)yInSignalPointer, sizeof(xTimerHeaderRec),NO_WAIT,  \
                 MSG_PRI_NORMAL); \
  RTOSFREE_BUF(&yInSignalPointer); \
  XOS_ERROR("OUTPUT", "msgQSend", Err)

#define RTOSOSTIME \
SDL_Time

#define RTOSSDLNOW1 

#define RTOSSDLNOW2 \
tickGet()

#define RTOSGETCURRENTTIME2 \
CurrentTime = RTOSSDLNOW2;

#define RTOSTIMERRECEIVE(SIGPTR,SELF,WAITTIME, QID) \
      Err = TmsgQReceive((MSG_Q_ID)TimerPId,(char *)yInSignalPointer, \
                        VXMAXMSGLENGTH, WAIT_FOREVER); \
      XOS_ERROR("TIMERTASK", "TmsgQReceive", Err)

#define RTOSTIMERQ_SUC_TIMERTIME \
TimerQ->Suc->TimerTime

#define RTOSXTIMER_SUC \
yOutputSignalPtr->Suc

#define RTOSTIMERQ_SUC_PRE \
TimerQ->Suc->Pre

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define RTOSOUTPUTSIGNAL_RECEIVER \
yOutputSignalPtr->Sender->NameNode->PROCID
#else
#define RTOSOUTPUTSIGNAL_RECEIVER \
yOutputSignalPtr->Sender
#endif

#define RTOSRECEIVE_MESSAGE2 \
        Err = TmsgQReceive((MSG_Q_ID)TimerPId,(char *)yInSignalPointer,\
                          VXMAXMSGLENGTH,  \
                          (TimerQ->Suc->TimerTime - CurrentTime)); \
        if (Err == ERROR) { \
         RTOSFREE_BUF(&yInSignalPointer); \
        }

#define RTOSTEMPTIMERSIGNAL_SIG_NO \
yInSignalPointer->SignalCode

#define RTOSSENDTIMERFREE_OUTPUT  \
RTOSFREE_BUF(&yInSignalPointer);

/*---+---------------------------------------------------------------
     env
-------------------------------------------------------------------*/
#define RTOSRTOSPAD_HEAD \
extern void VXWORKSPAD_env XPP((unsigned long param1, unsigned long Param2))
#define RTOSRTOSPAD_ENV \
RTOSRTOSPAD_HEAD \
{ \
}

/*---+---------------------------------------------------------------
     xAlloc
-------------------------------------------------------------------*/
#define RTOSXALLOC \
  /* standard implementation: */ \
  if ( Size > (xptrint)0 ) { \
    return (void *)calloc((unsigned)1, (unsigned)Size); \
  } \
  else \
    return (void *)0;
/*---+---------------------------------------------------------------
     xFree
-------------------------------------------------------------------*/
#define RTOSXFREE \
  if (*P != 0) { \
    free((void *)(*P)); \
    *P = (void *)0; \
  }

#ifdef X_SIGNAL_PRIO
/*---+--------------------------------------------------------------
     Signal priority upgrade (fab)
     Redefinition of msgQReceive, msgQNumMsgs, taskSpawn, taskDelete
-------------------------------------------------------------------*/

int TmsgQReceive (MSG_Q_ID msgQId, char* buffer, UINT maxNBytes, int timeout);
int TmsgQNumMsgs (MSG_Q_ID msgQId);
int TtaskSpawn (
    char* name,
    int priority,
    int options,
    int stackSize,
    FUNCPTR entryPt,
    int arg1,
    int arg2,
    int arg3,
    int arg4,
    int arg5,
    int arg6,
    int arg7,
    int arg8,
    int arg9,
    int arg10
);
STATUS TtaskDelete (int tid);

/*---+--------------------------------------------------------------
     A macro which returns the caller thread id in the operating 
     system
-------------------------------------------------------------------*/
#define RTOSGETCURRENTTASKID taskIdSelf ()

/*---+--------------------------------------------------------------
     Intermediate queue object
-------------------------------------------------------------------*/

typedef struct TIQElem { /* intermediate queue element */
  void* Data;   /* o.s. message data */
  int Len;      /* *Data length (ignored but returned to object clients) */
  int Priority; /* Mantained since generic object doesn't know where to find it */
  struct TIQElem* Pre; /* Link towards queue tail (tail = where lowest prio signals stay) */
} TIQElem;

typedef struct {
  TIQElem* Head;  /* Highest priority element or NULL if empty */
} TIntermediateQueue;

/* Initialize the intermediate queue */
void TIQInit (TIntermediateQueue* Q);

/* Add a signal to the intermediate queue, *S is copied to an internally allocated copy
   (but not S->Data!), S->Pre is meaningless and can be uninitialized */
void TIQAdd (TIntermediateQueue* Q, TIQElem* S);

/* Test if the intermediate queue is empty */
int  TIQIsEmpty (TIntermediateQueue* Q);

/* Extract a signal from the intermediate queue (in priority order). One signal at least 
   must exist. *S is the destination of a copy of the element structure, which is internally
   deallocated */
void TIQExtract (TIntermediateQueue* Q, TIQElem* S);

/* Force queue flush, deallocating any Data member with xFree */
void TIQForceFlush (TIntermediateQueue* Q);

/* Count messages in the queue */
int TIQCountMsg (TIntermediateQueue* Q);

/*---+--------------------------------------------------------------
   Thread-Intermediate queue association object (temporary version)
-------------------------------------------------------------------*/

typedef int TTaskId; /* o.s. dependent */
typedef SEM_ID TSemaphoreId; /* o.s. dependent */

typedef struct {
  TTaskId TaskId;            /* o.s. thread id */
  TIntermediateQueue Queue;  /* intermediate queue associated */
  int Free;                  /* true if free location */
} TIQAssociationRecord;

#define ASS_ELEMENTS 100
typedef struct {
  TIQAssociationRecord AssArray [ASS_ELEMENTS];
  TSemaphoreId Semaphore; /* provided for list integrity */
} TAssociationObj;

/* Initialize the association object */
void TAOInit (TAssociationObj* A);

/* Register a new task */
void TAORegisterTask (TAssociationObj* A, TTaskId Id);

/* Free a task */
void TAOFreeTask (TAssociationObj* A, TTaskId Id);

/* Get intermediate queue access for a given task */
TIntermediateQueue* TAOGetQueue (TAssociationObj* A, TTaskId Id);

/* Create Semaphore (o.s. dependent) */
void TAOCreateSemaphore (TAssociationObj* A);

/* Wait on Semaphore (o.s. dependent) */
void TAOWaitSemaphore (TAssociationObj* A);

/* Give Semaphore (o.s. dependent) */
void TAOGiveSemaphore (TAssociationObj* A);
#else
 /* traditional o.s. functions */
#define TmsgQReceive msgQReceive
#define TmsgQNumMsgs msgQNumMsgs
#define TtaskSpawn   taskSpawn
#define TtaskDelete  taskDelete
#endif /* X_SIGNAL_PRIO */

#ifdef RTOSTEST
extern void waitreboot();
#define RTOSTEST_ABORT waitreboot();
#endif

#endif /* _sctvxworks_h */
