/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.3.23566 at Sat Nov 17 11:52:49 AM CET 2012
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1999, 2012.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/******************************************************************

  C-code macros and functions for Win32 tight integration

  To be used with Cadvanced SDL to C Compiler 4.4
  
*******************************************************************/

#include "scttypes.h"

/*---+--------------------------------------------------------------
     SDL_Now
-------------------------------------------------------------------*/

extern SDL_Time SDL_Now XPP((void))
{
  /* Note: The "Windows Ticker"works in milliseconds and therefore */ 
  /* will "overflow" if windows is left running for 49.7 days. */
  return (SDL_Time) GetTickCount();
}




#ifdef XMSC_EDITOR

#include "post.h"
#include "sdt.h"
#include <string.h>

#include <errno.h>

int self;
int mscpid;
int mscbuffid;
int mscobject;
int tty_fd;


/*-------------------------------------------------------------------------
 * Name: connect_to_sdt
 * Author: Tapio J Hahka
 *
 * Description:
 *
 * Return Value:
 * 
 *
 */

int connect_to_sdt (char *myTool)
{
  self=SPInit (SET_SDLENV,myTool,spMList);
  if (self==SPERROR)
    {
      printf ("connect_to_sdt: Error in SPInit: %s\n",SPErrorString (sperrno));
      exit (1);
    }
  return(1);
}

/*-------------------------------------------------------------------------
 * Name: start_msc
 * Author: Tapio J Hahka
 *
 * Description:
 *
 * Return Value:
 *
 *
 */

int start_msc (int post_fd)
{
  char *data;
  int  message = 0;
  int  len = 0;
  int  ret = 0;
  int  status = 0;
  int  noofpids = 0;
  int  done = 0;

  data = (char *)xAlloc(30);
  sprintf (data,"%d",SET_MSCE);
  ret=SPBroadcast (SEGETTOOLPID,(void*)data,strlen (data));
  if (ret==SPERROR)
    {
      printf ("start_msc: Error in SPBroadcast: %s\n",SPErrorString (sperrno));
      exit (1);
    }
  while (!done)
    {
      ret=SPRead (SPWAITFOREVER,&mscpid,&message,(void*)&data,&len);
      if (ret==SPERROR)
	  {
	    printf ("start_msc: Error in SPRead: %s\n",SPErrorString (sperrno));
	    exit (1);
	  }

      switch (message)
	  {
	   case SEGETTOOLPIDREPLY:
	    sscanf (data,"%d %d %d",&status,&noofpids,&mscpid);
	    if (!noofpids)
		{
	      data = (char *)xAlloc(30);
	      sprintf (data,"%d",SET_MSCE);
	      ret=SPBroadcast (SESTART,(void*)data,strlen (data));
	      if (ret==SPERROR)
		  {
		    printf ("start_msc: Error in SPBroadcast: %s\n",SPErrorString (sperrno));
		    exit (1);
		  }
	    }
	    else if (status)
		{
	      printf ("start_msc: Error in Postmaster communication\n");
	      exit( 1 );
		}
	    else
	      done=1;
	   break;
	   case SESTARTREPLY:
            /* Tool start reply */
         sscanf ( data, "%d %d", &status, &mscpid );
         if (status) 
		 {
           printf ( "start_msc: Error in Postmaster communication\n");
	       exit( 1 );
		 }
	     else
	       done=1;
	    break;
	    default:
	    break;
	  }
  }
  return mscpid;
}

/*-------------------------------------------------------------------------
 * Name: start_msc_diagram
 * Author: Tapio J Hahka
 *
 * Description:
 *
 * Return Value:
 *
 *
 */

int start_msc_diagram (int post_fd)
{
  char *data;
  char msgbuffer [100],*msgbuf = msgbuffer;
  int  message = 0;
  int  len = 0;
  int  ret = 0;
  int  status = 0;
  int  done = 0;
  int  msc_diagram = 16;

  data = (char *)xAlloc(30);
  sprintf (data,"%d %s %s",msc_diagram, "RTOS_Trace", "\"\"" );
  ret=SPSendToTool (SET_MSCE,SEMSCECREATEDIAGRAM,(void*)data,strlen (data));
  if (ret==SPERROR)
  {
     printf ("start_msc_diagram: Error in SPSendToTool: %s\n",SPErrorString (sperrno));
     exit (1);
  }

  while (!done)
  {
     ret=SPRead (SPWAITFOREVER,&mscpid,&message,(void*)&data,&len);
     if (ret==SPERROR)
	 {
	   printf ("start_msc_diagram: Error in SPRead: %s\n",SPErrorString (sperrno));
	   exit (1);
	 }

     switch (message)
	 { 
	  case SEMSCECREATEDIAGRAMREPLY:
	    sscanf (data,"%d %d",&status,&mscbuffid);
	    if (status)
		{
	      printf ("start_msc_diagram: Error in Postmaster communication\n");
	      exit (1);
		}
	    done=1;
	  break;
	  default:
	    break;
	 } 
  } 

  sprintf (data,"%d %s",mscbuffid,"\"\"" );
  ret=SPSendToTool (SET_MSCE,SESHOW,(void*)data,strlen (data));
  if (ret==SPERROR)
  {
     printf ("start_msc_diagram: Error in SPSendToTool: %s\n",SPErrorString (sperrno));
     exit (1);
  }

  done=0;

  while (!done)
  {
    ret=SPRead (SPWAITFOREVER,&mscpid,&message,(void*)&data,&len);
    if (ret==SPERROR)
	{
	  printf ("start_msc_diagram: Error in SPRead: %s\n",SPErrorString (sperrno));
	  exit (1);
	}

    switch (message) 
	{
	 case SESHOWREPLY:
	   sscanf (data,"%d",&status);
	   if (status)
	   {
	     printf ("start_msc_diagram: Error in Postmaster communication\n");
	     exit (1);
	   }
	   done=1;
	 break;
	 default:
	   break;
	} 
  }
} 

/*-------------------------------------------------------------------------
 * Name: send_message
 * Author: Tapio J Hahka
 *
 * Description:
 *
 * Return Value:
 *
 *
 */

int send_message (char *msge_buf)
{
  char *data;
  char *buffptr;
  int  ret = 0;
  int  done = 0;
  int  status = 0;
  int  pid = 0;
  int  message = 0;
  int  len = 0;
  int  endmsc = 0;
	  
  buffptr = xAlloc( 512 );

  sprintf (buffptr,"%d 0 \"%s\"",mscbuffid, msge_buf);
  ret=SPSendToTool (SET_MSCE,SEINSERTOBJECT,(void*) buffptr, strlen(buffptr) );
  if (ret==SPERROR)
  {
    printf ("send_message: Error in SPSendToTool: %s\n",SPErrorString (sperrno));
    exit (1);
  }

  while (!done)
  {
    ret=SPRead (SPWAITFOREVER,&mscpid,&message,(void*)&data,&len);
    if (ret==SPERROR)
	{
	  printf ("send_message: Error in SPRead: %s\n",SPErrorString (sperrno));
	  exit (1);
	}

    switch (message)
	{
	 case SEINSERTOBJECTREPLY:
	   sscanf (data,"%d %d",&status,&mscobject);
	   if (status)
	   {
	     printf ("send_message: Error in SEINSERTOBJECTREPLY\n");
	     exit (1);
	   }
	   done=1;
	 break;
	 default:
	   break;
	} 
  }
  done=0;

  sprintf (buffptr,"%d %d",mscbuffid,mscobject);
  ret=SPSendToTool (SET_MSCE,SESHOWOBJECT,(void*)buffptr,strlen (buffptr));
  if (ret==SPERROR)
  {
    printf ("send_message: Error in SPSendToTool: %s\n",SPErrorString (sperrno));
    exit (1);
  }

  while (!done)
  {
    ret=SPRead (SPWAITFOREVER,&mscpid,&message,(void*)&data,&len);
    if (ret==SPERROR)
	{
	  printf ("send_message: Error in SPRead: %s\n",SPErrorString (sperrno));
	  exit (1);
	}

    switch (message)
	{
	 case SESHOWOBJECTREPLY:
	   sscanf (data,"%d",&status);
	   if (status)
	   {
	     printf ("send_message: Error in SESHOWOBJECTREPLY \n");
	     exit (1);
	   }
	   done=1;
	 break;
	 default:
	 break;
	} 
  } 
  xFree( (void **) &buffptr);
  return endmsc;
}  

#endif  /* XMSC_EDITOR */


#ifdef X_SIGNAL_PRIO

/*---+--------------------------------------------------------------

     Signal priority upgrade (fab)

     Association object among threads and intermediate queues

-------------------------------------------------------------------*/

TAssociationObj AssociationObj;



/*---+--------------------------------------------------------------

     Signal priority upgrade (fab)

	 Redefinition of GetMessage, PeekMessage, CreateThread,

	 ExitThread

-------------------------------------------------------------------*/



BOOL TGetMessage (LPMSG lpMsg, HWND hWnd, UINT wMsgFilterMin, UINT wMsgFilterMax) {

  MSG win32Mess;

  TIQElem Elem;

  TIntermediateQueue* Q;

  /* Access the queue */

  Q = TAOGetQueue (&AssociationObj, GetCurrentThreadId ());

  /* Extract all messages from the queue */

  while (PeekMessage (&win32Mess, hWnd, wMsgFilterMin, wMsgFilterMax, PM_REMOVE)) {

    Elem.Data = xAlloc (sizeof (win32Mess));

	Elem.Len = sizeof (win32Mess);

	memcpy (Elem.Data, &win32Mess, sizeof (win32Mess));

	Elem.Priority = ((xSignalHeader) win32Mess.wParam)->Priority;

    TIQAdd (Q, &Elem); /* add them to the intermediate queue */

  }

  /* Return the first message from the queue or wait another message if empty */

  if (!TIQIsEmpty (Q)) {

    TIQExtract (Q, &Elem);

    memcpy (lpMsg, Elem.Data, Elem.Len);

	xFree (Elem.Data);

	return 1; /* a non 0 value (WM_QUIT is not expected here) */

  } 

  /* if both system and intermediate queues are empty, can avoid to insert and extract

     next message from the queue */

  return GetMessage (lpMsg, hWnd, wMsgFilterMin, wMsgFilterMax);

}



BOOL TPeekMessage (LPMSG lpMsg, HWND hWnd, UINT wMsgFilterMin, UINT wMsgFilterMax, UINT wRemoveMsg) {

  MSG win32Mess;

  TIQElem Elem;

  TIntermediateQueue* Q;

  /* Access the queue */

  Q = TAOGetQueue (&AssociationObj, GetCurrentThreadId ());

  /* Extract all messages from the queue */

  while (PeekMessage (&win32Mess, hWnd, wMsgFilterMin, wMsgFilterMax, PM_REMOVE)) {

    Elem.Data = xAlloc (sizeof (win32Mess));

	Elem.Len = sizeof (win32Mess);

	memcpy (Elem.Data, &win32Mess, sizeof (win32Mess));

	Elem.Priority = ((xSignalHeader) win32Mess.wParam)->Priority;

    TIQAdd (Q, &Elem); /* add them to the intermediate queue */

  }

  /* Return the first message from the queue or nothing if empty */

  if (!TIQIsEmpty (Q)) {

    TIQExtract (Q, &Elem);

    memcpy (lpMsg, Elem.Data, Elem.Len);

	xFree (Elem.Data);

	return 1;

  } 

  return 0;

}



HANDLE TCreateThread (

    LPSECURITY_ATTRIBUTES lpThreadAttributes,

    DWORD dwStackSize,

    LPTHREAD_START_ROUTINE lpStartAddress,

    LPVOID lpParameter,

    DWORD dwCreationFlags,

    LPDWORD lpThreadId) {

  HANDLE Ret;

  Ret = CreateThread (lpThreadAttributes, dwStackSize, lpStartAddress, lpParameter, dwCreationFlags,

                      lpThreadId);

  TAORegisterTask (&AssociationObj, *lpThreadId);

  return Ret;

}



void TExitThread (DWORD dwExitCode) {

  TAOFreeTask (&AssociationObj, GetCurrentThreadId ());

  ExitThread (dwExitCode);

}

/*---+--------------------------------------------------------------

     Signal priority upgrade (fab)

	 Intermediate queue implementation

-------------------------------------------------------------------*/



void TIQInit (TIntermediateQueue* Q) {Q->Head = NULL;}



void TIQAdd (TIntermediateQueue* Q, TIQElem* S) {

  /* We navigate the queue from head to tail. The incoming signal should be added 

     before the first signal having less priority that the new one (i.e., having a

	 greater priority index) */

  TIQElem* NewEl;

  TIQElem* P;

  TIQElem* SucOfP;



  /* Copying the element */

  NewEl = (TIQElem*) xAlloc (sizeof (*S));

  memcpy (NewEl, S, sizeof (*NewEl));

  /* Navigating the list and inserting the element */

  P = Q->Head;

  SucOfP = NULL;

  while (P) { /* exit loop when P points the element where to insert

                                        the new one, between *P and its Suc */

	if (!P) break; /* go to add at tail */

	else if (P->Priority > NewEl->Priority) break; /* go to add inside */

    SucOfP = P;

   	P = P->Pre;

  }



  NewEl->Pre = P; /* can be NULL, but it's OK */

  if (SucOfP) SucOfP->Pre = NewEl; /* handle classical list */

  else Q->Head = NewEl;

}



int  TIQIsEmpty (TIntermediateQueue* Q) {

  return Q->Head == NULL;

}



void TIQExtract (TIntermediateQueue* Q, TIQElem* S) {

  if (!TIQIsEmpty (Q)) { /* melius est abundare quam deficere */

    memcpy (S, Q->Head, sizeof (*S));

	xFree (&Q->Head);

	Q->Head = S->Pre; /* can be NULL, it's OK */

	S->Pre = NULL; /* never leave unwanted accesses */

  }

}



void TIQForceFlush (TIntermediateQueue* Q) {

  TIQElem S;

  while (!TIQIsEmpty (Q)) {

    TIQExtract (Q, &S);

    if (S.Data) xFree (&S.Data);

  }

}



int TIQCountMsg (TIntermediateQueue* Q) {

  int Ret = 0;

  TIQElem* P;

  P = Q->Head;

  while (P) {

    Ret ++;

   	P = P->Pre;

  }

  return Ret;    

}



/*---+--------------------------------------------------------------

     Signal priority upgrade (fab)

	 Thread-Intermediate queue association object implementation

-------------------------------------------------------------------*/



void TAOInit (TAssociationObj* A) {

  int I;

  for (I = 0; I < ASS_ELEMENTS; I ++) {

    A->AssArray [I].Free = 1;

  }

  TAOCreateSemaphore (A);

}



void TAORegisterTask (TAssociationObj* A, TTaskId Id) {

  int I;

  /* Integrity protection */

  TAOWaitSemaphore (A);

  /* Find a free location */

  for (I = 0; I < ASS_ELEMENTS; I ++) {

    if (A->AssArray [I].Free) break;

  }

  if (I >= ASS_ELEMENTS) {

    XOS_ERROR ("TAORegisterTask", "List Is Full", 0);

	exit (1);

  } else {

    A->AssArray [I].Free = 0;

    A->AssArray [I].TaskId = Id;

    TIQInit (&(A->AssArray [I].Queue));

  }

  /* Integrity protection */

  TAOGiveSemaphore (A);

  printf ("Registering a new task\n");

}



/* Free a task */

void TAOFreeTask (TAssociationObj* A, TTaskId Id) {

  int I;

  /* Integrity protection */

  TAOWaitSemaphore (A);

  /* Find the location */

  for (I = 0; I < ASS_ELEMENTS; I ++) {

    if (A->AssArray [I].TaskId == Id && !(A->AssArray [I].Free)) break;  }

  if (I >= ASS_ELEMENTS) {

    XOS_ERROR ("TAOFreeTask", "Task Not Found", Id);

	exit (1);

  } else {

    A->AssArray [I].Free = 1;

    TIQForceFlush (&(A->AssArray [I].Queue));

  }

  /* Integrity protection */

  TAOGiveSemaphore (A);

  printf ("Freing a new task\n");

}



/* Get intermediate queue access for a given task */

TIntermediateQueue* TAOGetQueue (TAssociationObj* A, TTaskId Id) {

  int I;

  TIntermediateQueue* Ret;

  /* Integrity protection */

  TAOWaitSemaphore (A);

  /* Find the location */

  for (I = 0; I < ASS_ELEMENTS; I ++) {

    if (A->AssArray [I].TaskId == Id && !(A->AssArray [I].Free)) break;

  }

  if (I >= ASS_ELEMENTS) {

    XOS_ERROR ("TAOGetQueue", "Task Not Found", Id);

  	exit (1);

  }

  Ret = &(A->AssArray [I].Queue);

  /* Integrity protection */

  TAOGiveSemaphore (A);

  return Ret;

}



void TAOCreateSemaphore (TAssociationObj* A) {

  A->Semaphore = CreateSemaphore (NULL, 1, MAX_INT, "TAO");

}



void TAOWaitSemaphore (TAssociationObj* A) {

  WaitForSingleObject (A->Semaphore, INFINITE);

}



void TAOGiveSemaphore (TAssociationObj* A) {

  ReleaseSemaphore (A->Semaphore, 1, NULL);

}



#endif

 /* X_SIGNAL_PRIO */



/*---+--------------------------------------------------------------

     Instance number check (fab)

	 Function which counts active instances given a symtab  node

-------------------------------------------------------------------*/



#ifdef X_INSTANCE_CHECK

int GetActiveInstances (xPrsIdNode Node) {

  int Ret = 0;

  xEPrsNode P;

  RTOSALLOCPRSSEMTAKE

  P = *Node->ActivePrsList;

  while (P) {

    Ret ++;

	P = P->NextPrs;

  }

  RTOSALLOCPRSSEMGIVE

  /* printf ("Returning %d\n", Ret); */

  return Ret;

}

#endif
