/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.3.23566 at Sat Nov 17 11:52:49 AM CET 2012
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1999, 2012.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/******************************************************************

  C-code macros and functions for Win32 tight integration

  To be used with Cadvanced SDL to C Compiler 4.4
  
*******************************************************************/

#ifndef _sctwin32_h
#define _sctwin32_h

/*  If Borland command line argument is exceeded then the define
    macros should be defined here  */
/*#ifndef XRTOSTIME
#define XRTOSTIME
#endif
#ifndef XINCLUDE_HS_FILE
#define XINCLUDE_HS_FILE
#endif*/

#include "sctcommon.h"
#include <process.h>   /*mge*/


/****+***************************************************************
     sctpred.h
********************************************************************/

/****+***************************************************************
01   Typedef, Default value, Literals
********************************************************************/

/*---+---------------------------------------------------------------
     Duration
-------------------------------------------------------------------*/

#include "sctpred.h"

#define SDT_TICKPERSEC 1000
#define SDT_NANOSECPERTICK 1000000

/****+***************************************************************
     scttypes.h
********************************************************************/
#define RTOSXOSETRACE_INIT

#define RTOSSTATENAME(STATE_NAME_STRING)


/****+***************************************************************
     General macros
********************************************************************/

#ifndef NIL
#define NIL 0
#endif

/* Win32 specific includes */

#ifdef XUSING_SCCD  /* Can only be used with the Microsoft compiler */

#define GERXCAT(X,Y) X##Y

#define LIMITS_h GERXCAT(#,include "limits.h")
#define WINDOWS_h GERXCAT(#,include "windows.h")
LIMITS_h
WINDOWS_h

#else

#include "limits.h"
#include "windows.h"

#endif

#ifdef XWINCE  /* WinCE does not contain <stdio.h> */
/*	int wceprintf(const char *fmt, ...);
	#define PRINTF	wceprintf */
#define PRINTF

#else
	#include <stdio.h>
	#define PRINTF	printf
#endif

/* Win32 specific defines */
#define MAX_INT INT_MAX
#define DEF_SEC_ATTR NULL
#define DEF_STACK 0
#define WM_SDL_SIGNAL WM_USER+1
#define EXITCODE 0

#define XCONST_COMP

#define XINIT_SYSTEMIDNODE(AA)

#define	SIGNAL_VARS
#define	TIMER_VARS
#define TIMER_PARA_VARS


#define RTOSPRIODEFAULT THREAD_PRIORITY_NORMAL /* This may require changing if the #PRIO 
                                                  directive is being used */

#define xbool int

#define RTOSTASK_TYPE SDL_PId

/****+***************************************************************
     Macros to Implement SDL
********************************************************************/

#ifdef X_ONE_TASK_PER_INSTANCE_SET

static unsigned long 	WIN32Q_env;

#define RTOSXPROCESSDEF_C(PROC_NAME, PROC_NAME_STRING, PREFIX_PROC_NAME,PAD_FUNCTION, VDEF_TYPE) \
extern void XCAT(WIN32PAD_,PREFIX_PROC_NAME) XPP(( \
  unsigned long InputPortQ)) \
{ \
  xPrsInstanceSetVars   yInstanceSetVars; \
  unsigned long rc; \
  MSG win32Mess; \
  semCount++; \
  rc = TPeekMessage( &win32Mess, NULL, WM_USER, WM_USER, PM_NOREMOVE); \
  XOS_ERROR("RTOSXPROCESSDEF_C", "TPeekMessage", rc) \
  rc = (unsigned long)(WaitForSingleObject( TaskSem, INFINITE )); \
  XOS_ERROR("XPROCESSDEF_C", "WaitForSingleObject", rc) \
\
  yInstanceSetVars.SaveQ = (xSignalHeader)xAlloc(sizeof(xSaveQStruct)); \
  yInstanceSetVars.SaveQ->Suc = yInstanceSetVars.SaveQ; \
  yInstanceSetVars.SaveQ->Pre = yInstanceSetVars.SaveQ; \
  yInstanceSetVars.CurrentInSaveQ = yInstanceSetVars.SaveQ; \
  yInstanceSetVars.PrsDataSize = sizeof(VDEF_TYPE); \
  strcpy( yInstanceSetVars.name, PROC_NAME_STRING); \
  PAD_FUNCTION((void *)0, InputPortQ, &yInstanceSetVars ); \
}

#define RTOSXPROCESSDEF_H(PROC_NAME, PROC_NAME_STRING, PREFIX_PROC_NAME, PAD_FUNCTION, VDEF_TYPE) \
extern void XCAT(WIN32PAD_,PREFIX_PROC_NAME) XPP(( \
  unsigned long InputPortQ)); \
static unsigned long XCAT(WIN32Q_,PREFIX_PROC_NAME);

#else  /* X_ONE_TASK_PER_INSTANCE_SET */

#ifdef XWINCE

#define RTOSXPROCESSDEF_C(PROC_NAME, PROC_NAME_STRING, PREFIX_PROC_NAME, PAD_FUNCTION, VDEF_TYPE) \
extern void XCAT(WIN32PAD_,PREFIX_PROC_NAME) XPP(( )) \
{ \
  VDEF_TYPE  yVarPVar; \
  VDEF_TYPE *yVarP = &yVarPVar; \
  unsigned long rc; \
  MSG win32Mess; \
  rc = TPeekMessage(&win32Mess, (HWND) NULL, 0, 0, PM_NOREMOVE ); \
  XOS_ERROR("RTOSXPROCESSDEF_C", "TPeekMessage", rc) \
  semCount++; \
  yVarP->RestartAddress = 0; \
  yVarP->PrsNode = 0; \
  yVarP->RestartPAD = PAD_FUNCTION; \
  yVarP->ActivePrd = (xPrdNode)0; \
  yVarP->Offspring = SDL_NULL; \
  SDL_SELF = GetCurrentThreadId(); /* Self  */ \
  yVarP->Sender = SDL_NULL; \
  yVarP->Parent = SDL_NULL; \
  yVarP->State = START_STATE; \
  yVarP->StateAfterRPC = 0; \
  yVarP->SaveQ = (xSignalHeader)xAlloc(sizeof(xSaveQStruct)); \
  yVarP->SaveQ->Suc = yVarP->SaveQ; \
  yVarP->SaveQ->Pre = yVarP->SaveQ; \
  yVarP->CurrentInSaveQ = yVarP->SaveQ; \
  yVarP->FirstTime = 1; \
  yVarP->pREPLY_Waited_For = (XSIGTYPE)0; \
  strcpy( yVarP->ProcName, PROC_NAME_STRING); \
  PAD_FUNCTION((void *)yVarP); \
}

#else /* XWINCE */

#define RTOSXPROCESSDEF_C(PROC_NAME, PROC_NAME_STRING, PREFIX_PROC_NAME, PAD_FUNCTION, VDEF_TYPE) \
extern void XCAT(WIN32PAD_,PREFIX_PROC_NAME) XPP(( )) \
{ \
  VDEF_TYPE  yVarPVar; \
  VDEF_TYPE *yVarP = &yVarPVar; \
  unsigned long rc; \
  MSG win32Mess; \
  rc = TPeekMessage(&win32Mess, (HWND) NULL, 0, 0, PM_NOREMOVE ); \
  XOS_ERROR("RTOSXPROCESSDEF_C", "TPeekMessage", rc) \
  semCount++; \
  rc = (unsigned long)(WaitForSingleObject( TaskSem, INFINITE )); \
  XOS_ERROR("RTOSXPROCESSDEF_C", "WaitForSingleObject", rc)  \
  yVarP->RestartAddress = 0; \
  yVarP->PrsNode = 0; \
  yVarP->RestartPAD = PAD_FUNCTION; \
  yVarP->ActivePrd = (xPrdNode)0; \
  yVarP->Offspring = SDL_NULL; \
  SDL_SELF = GetCurrentThreadId(); /* Self  */ \
  yVarP->Sender = SDL_NULL; \
  yVarP->Parent = SDL_NULL; \
  yVarP->State = START_STATE; \
  yVarP->StateAfterRPC = 0; \
  yVarP->SaveQ = (xSignalHeader)xAlloc(sizeof(xSaveQStruct)); \
  yVarP->SaveQ->Suc = yVarP->SaveQ; \
  yVarP->SaveQ->Pre = yVarP->SaveQ; \
  yVarP->CurrentInSaveQ = yVarP->SaveQ; \
  yVarP->FirstTime = 1; \
  yVarP->pREPLY_Waited_For = (XSIGTYPE)0; \
  strcpy( yVarP->ProcName, PROC_NAME_STRING); \
  PAD_FUNCTION((void *)yVarP); \
}

#endif  /* XWINCE */

#define RTOSXPROCESSDEF_H(PROC_NAME, PROC_NAME_STRING, PREFIX_PROC_NAME, PAD_FUNCTION, VDEF_TYPE) \
extern void XCAT(WIN32PAD_,PREFIX_PROC_NAME) XPP(( ));

#endif
       /* X_ONE_TASK_PER_INSTANCE_SET */

/* ----------------- Extra components in IdNodes ----------------- */

  /* Process, Process type */
#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define XPRS_EXTRAS(PREFIX_PROC_NAME) \
  , XCAT(WIN32PAD_,PREFIX_PROC_NAME), &XCAT(WIN32Q_,PREFIX_PROC_NAME)
#else
#define XPRS_EXTRAS(PREFIX_PROC_NAME) , XCAT(WIN32PAD_,PREFIX_PROC_NAME)
#endif

/* ---------------- Variables in the PAD function ---------------- */

#ifdef X_ONE_TASK_PER_INSTANCE_SET

#define YPAD_TEMP_VARS \
   xSignalHeader  yOutputSignalPtr; \
   xSignalHeader  pREPLY_Signal; \
   SDL_PId        SenderRPCCall; \
   MSG            win32Mess; \
   unsigned long  RetCode;  \
   xPrdNode       yTempPrd;

#define RTOSXPAD_STRUCT_COMP void (*RestartPAD) XPP(( void *VarP, unsigned long, xPrsInstanceSetVars *yInstanceSetVars ));

#else

#define PROCESS_VARS \
   int            RestartAddress; \
   xPrdNode       ActivePrd; \
   XPAD_STRUCT_COMP \
   SDL_PId	  Parent; \
   SDL_PId	  Offspring; \
   SDL_PId	  Self; \
   SDL_PId	  Sender; \
   int            State; \
   int            StateAfterRPC; \
   xSignalHeader  SaveQ; \
   xSignalHeader  CurrentInSaveQ; \
   xSignalHeader  yInSignalPtr; \
   xEPrsNode	  PrsNode; \
   XSIGTYPE       pREPLY_Waited_For; \
   char		  ProcName[100]; \
   int            FirstTime;

#define YPAD_TEMP_VARS \
   xSignalHeader  yOutputSignalPtr; \
   xSignalHeader  pREPLY_Signal; \
   SDL_PId        SenderRPCCall; \
   MSG            win32Mess; \
   unsigned long  RetCode; \
   xPrdNode       yTempPrd; \
   int            Prio;

#endif
       /* X_ONE_TASK_PER_INSTANCE_SET */

#define YPRD_TEMP_VARS \
   xSignalHeader  yOutputSignalPtr; \
   xSignalHeader  pREPLY_Signal; \
   SDL_PId        SenderRPCCall; \
   MSG            win32Mess; \
   unsigned long  RetCode; \
   xPrdNode       yTempPrd;  \
   int            Prio;


#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define SDL_SELF                yVarP->PrsNode
#else
#define SDL_SELF                yVarP->Self
#endif
#define SDL_SENDER              yVarP->Sender

/* ------------------ Structure of PAD function ------------------ */

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define YPAD_PROTOTYPE(PAD)     void PAD ( void *VarP, unsigned long InputPortQ, xPrsInstanceSetVars *yInstanceSetVars );
#define YPAD_FUNCTION(PAD)      void PAD ( void *VarP, unsigned long InputPortQ, xPrsInstanceSetVars *yInstanceSetVars )
#define YPRD_PROTOTYPE(PAD)     xbool PAD ( void *VarP, xPrsInstanceSetVars *yInstanceSetVars );
#define YPRD_FUNCTION(PAD)      xbool PAD ( void *VarP, xPrsInstanceSetVars *yInstanceSetVars ) 
#endif
       /* X_ONE_TASK_PER_INSTANCE_SET */

#ifdef X_ONE_TASK_PER_INSTANCE_SET

#define RTOSBEGIN_PAD(VDEF_TYPE) \
   if (xInputSignal((xPrsNode*)&yVarP,yInstanceSetVars,0,(SDL_PId)InputPortQ)) return;\
   goto Label_Execute_Transition;

#define RTOSLOOP_LABEL \
   Label_New_Transition_No_Free : \
     if (xInputSignal((xPrsNode*)&yVarP,yInstanceSetVars,2,(SDL_PId)InputPortQ)) return; \
     goto Label_Execute_Transition; \
   Label_New_Transition : \
     if (xInputSignal((xPrsNode*)&yVarP,yInstanceSetVars,1,(SDL_PId)InputPortQ)) return; \
   Label_Execute_Transition : \
     ySVarP = yInstanceSetVars->yInSignalPtr->SigP; \
     yVarP->Sender = yInstanceSetVars->yInSignalPtr->Sender;

#else

#define RTOSBEGIN_PAD(VDEF_TYPE) \
   if(yVarP->FirstTime) { \
     memset((((xPrsRec*)yVarP)+1),(int)0,sizeof(VDEF_TYPE)-sizeof(xPrsRec)); \
     yVarP->FirstTime = 0; \
   } \
   if (xInputSignal((xPrsNode*)&yVarP,0)) return; \
   goto Label_Execute_Transition;

#define RTOSLOOP_LABEL \
   Label_New_Transition_No_Free : \
     if (xInputSignal((xPrsNode*)&yVarP,2)) return; \
     goto Label_Execute_Transition; \
   Label_New_Transition : \
     if (xInputSignal((xPrsNode*)&yVarP,1)) return; \
   Label_Execute_Transition : \
     ySVarP = yVarP->yInSignalPtr->SigP; \
     yVarP->Sender = yVarP->yInSignalPtr->Sender;

#endif
       /* X_ONE_TASK_PER_INSTANCE_SET */

#ifdef X_ONE_TASK_PER_INSTANCE_SET

#define RTOSLOOP_LABEL_PRD \
   XOS_TRACE_CALL \
   if (yPrdVarP->RestartAddress != 0) { \
     ySVarP = yInstanceSetVars->yInSignalPtr->SigP; \
     yVarP->Sender = yInstanceSetVars->yInSignalPtr->Sender; \
   }

#define RTOSFREE_BUF(SIGPTR) xFree((void*)SIGPTR)
#define RTOSFREE_BUF_SIGP(SIGPTR)

#else

#define RTOSFREE_BUF(SIGPTR) xFree((void*)SIGPTR)
#define RTOSFREE_BUF_SIGP(SIGPTR)

#define RTOSRECEIVEPRD(SIGPTR,SELF,MSGLEN, QID) \
     RetCode = TGetMessage(&win32Mess,(HWND)NULL,0,0); \
     XOS_ERROR("RTOSRECEIVEPRD", "TGetMessage", RetCode) \
     yVarP->yInSignalPtr = (xSignalHeader)(win32Mess.wParam);

#define RTOSLABEL_EXECUTE_TRANSITION \
     ySVarP = yVarP->yInSignalPtr->SigP; \
     yVarP->Sender = yVarP->yInSignalPtr->Sender;

#endif
   /* X_ONE_TASK_PER_INSTANCE_SET */

#ifdef X_ONE_TASK_PER_INSTANCE_SET

#define RTOSSENDER yInstanceSetVars->yInSignalPtr->Sender;

#define RTOSCALLSUPER_PAD(PAD) \
   PAD(yVarP, InputPortQ, yInstanceSetVars);

#else

#define RTOSSENDER yVarP->yInSignalPtr->Sender;

#endif
       /* X_ONE_TASK_PER_INSTANCE_SET */

#define INSIGNAL_NAME           INSIGNAL_PTR->SignalCode

/* ---------------------------- Output --------------------------- */

#define XSIGNALHEADERTYPE xSignalHeaderRec

#define RTOSALLOC_SIGNAL(SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_TYPE) \
   yOutputSignalPtr = (xSignalHeader)xAlloc( sizeof(SIG_PAR_TYPE)); \
   yOutputSignalPtr->SignalCode = SIG_NAME; \
   yOutputSignalPtr->Sender = SDL_SELF; \
   yOutputSignalPtr->IsTimerSignal=0; \
   win32Mess.wParam = (WPARAM) yOutputSignalPtr;

#define RTOSALLOC_SIGNAL_PAR(SIG_NAME,SIG_IDNODE, RECEIVER, SIG_PAR_TYPE) \
   yOutputSignalPtr = (xSignalHeader)xAlloc( sizeof(SIG_PAR_TYPE) + \
                                             sizeof(XSIGNALHEADERTYPE)); \
   yOutputSignalPtr->SigP = yOutputSignalPtr+1; \
   yOutputSignalPtr->SignalCode = SIG_NAME; \
   yOutputSignalPtr->Sender = SDL_SELF; \
   yOutputSignalPtr->IsTimerSignal=0; \
   win32Mess.wParam = (WPARAM) yOutputSignalPtr;

#define OUTSIGNAL_DATA_PTR \
   (yOutputSignalPtr->SigP)

/* ----------------------------- RPC ----------------------------- */

#define RTOSSEND(SIGPTR,RECEIVER,SIG_PAR_SIZE) \
   win32Mess.lParam = (LPARAM) RECEIVER; \
   RetCode = PostThreadMessage(win32Mess.lParam, WM_SDL_SIGNAL, win32Mess.wParam, win32Mess.lParam); \
   while (RetCode == 0) { \
     int i=0; \
     Sleep(0); \
     printf("PostThreadMessage failed : %d\n", i); \
   RetCode = PostThreadMessage(win32Mess.lParam, WM_SDL_SIGNAL, win32Mess.wParam, win32Mess.lParam); \
   }
   /*   XOS_ERROR("RTOSSEND", "PostThreadMessage", RetCode) */

#ifdef X_ONE_TASK_PER_INSTANCE_SET

#define RTOSHANDLEMESS_TYPE , MSG win32Mess

#define RTOSHANDLESIG_PAR , win32Mess

#define RTOSXHANDLESIG_BODY \
   unsigned long RetCode; \
   OutputSignal->Receiver = Receiver; \
   win32Mess.lParam = (LPARAM)Receiver->NameNode->PROCID; \
   RetCode = PostThreadMessage(win32Mess.lParam, WM_SDL_SIGNAL, win32Mess.wParam, win32Mess.lParam); \
   XOS_ERROR("RTOSXHANDLESIG_BODY", "PostThreadMessage", RetCode)

#endif
       /* X_ONE_TASK_PER_INSTANCE_SET */

#define RTOSALLOC_REPLY_SIGNAL(SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_TYPE) \
   pREPLY_Signal = (xSignalHeader)xAlloc( sizeof(SIG_PAR_TYPE)); \
   pREPLY_Signal->SignalCode = SIG_NAME; \
   pREPLY_Signal->Sender = SDL_SELF; \
   pREPLY_Signal->IsTimerSignal=0; \
   win32Mess.wParam = (WPARAM) pREPLY_Signal; \
   SenderRPCCall = yVarP->Sender;

#define RTOSALLOC_REPLY_SIGNAL_PAR(SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_TYPE) \
   pREPLY_Signal = (xSignalHeader)xAlloc( sizeof(SIG_PAR_TYPE) + \
					     sizeof(XSIGNALHEADERTYPE)); \
   pREPLY_Signal->SigP = pREPLY_Signal+1; \
   pREPLY_Signal->SignalCode = SIG_NAME; \
   pREPLY_Signal->Sender = SDL_SELF; \
   pREPLY_Signal->IsTimerSignal=0; \
   win32Mess.wParam = (WPARAM) pREPLY_Signal; \
   SenderRPCCall = yVarP->Sender;

#define RTOSALLOC_REPLY_SIGNAL_PRD(SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_TYPE) \
   pREPLY_Signal = (xSignalHeader)xAlloc( sizeof(SIG_PAR_TYPE)); \
   pREPLY_Signal->SignalCode = SIG_NAME; \
   pREPLY_Signal->Sender = SDL_SELF; \
   pREPLY_Signal->IsTimerSignal=0; \
   win32Mess.wParam = (WPARAM) pREPLY_Signal; \
   SenderRPCCall = yVarP->Sender;

#define RTOSALLOC_REPLY_SIGNAL_PRD_PAR(SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_TYPE) \
   pREPLY_Signal = (xSignalHeader)xAlloc( sizeof(SIG_PAR_TYPE) + sizeof(XSIGNALHEADERTYPE)); \
   pREPLY_Signal->SigP = pREPLY_Signal+1; \
   pREPLY_Signal->SignalCode = SIG_NAME; \
   pREPLY_Signal->Sender = SDL_SELF; \
   pREPLY_Signal->IsTimerSignal=0; \
   win32Mess.wParam = (WPARAM) pREPLY_Signal; \
   SenderRPCCall = yVarP->Sender;

#define REPLYSIGNAL_DATA_PTR \
   (pREPLY_Signal->SigP)
#define REPLYSIGNAL_DATA_PTR_PRD \
   (pREPLY_Signal->SigP)

/* ---------------------------- Create --------------------------- */

#define STARTUP_VARS \
   xEPrsNode PrsNode;

#define RTOSALLOC_STARTUP(PROC_NAME, STARTUP_IDNODE, STARTUP_PAR_TYPE) \
   yOutputSignalPtr = (xSignalHeader)xAlloc( sizeof(STARTUP_PAR_TYPE) + \
                                             sizeof(XSIGNALHEADERTYPE)); \
   yOutputSignalPtr->SigP = yOutputSignalPtr+1; \
   yOutputSignalPtr->SignalCode = STARTUPSIGNAL; \
   yOutputSignalPtr->Sender = SDL_SELF; \
   yOutputSignalPtr->IsTimerSignal=0; \
   win32Mess.wParam = (WPARAM) yOutputSignalPtr;

#define RTOSALLOC_STARTUP_PAR(PROC_NAME, STARTUP_IDNODE, STARTUP_PAR_TYPE) \
   yOutputSignalPtr = (xSignalHeader)xAlloc( sizeof(STARTUP_PAR_TYPE) + \
                                             sizeof(XSIGNALHEADERTYPE)); \
   yOutputSignalPtr->SigP = yOutputSignalPtr+1; \
   yOutputSignalPtr->SignalCode = STARTUPSIGNAL; \
   yOutputSignalPtr->Sender = SDL_SELF; \
   yOutputSignalPtr->IsTimerSignal=0; \
   win32Mess.wParam = (WPARAM) yOutputSignalPtr;

#define STARTUP_DATA_PTR \
   (yOutputSignalPtr->SigP)

#ifdef X_ONE_TASK_PER_INSTANCE_SET

#define RTOSSDL_CREATE(PROC_NAME, PROC_IDNODE, PROC_NAME_STRING) \
   CHECK_INSTANCE_LIMIT1(PROC_IDNODE) \
   yOutputSignalPtr->Receiver = xAllocPrsUseMyMemory(PROC_IDNODE); \
   yOutputSignalPtr->Receiver->BlockInstNumber = \
     yVarP->PrsNode->BlockInstNumber; \
   yVarP->Offspring = yOutputSignalPtr->Receiver; \
   XOS_TRACE_CREATE( yVarP->Offspring, PROC_NAME_STRING) \
   XMSC_TRACE_CREATE( yVarP->Offspring, PROC_NAME_STRING) \
   win32Mess.lParam = (WPARAM) yVarP->Offspring->NameNode->PROCID; \
   RetCode = 0; \
   while (RetCode == 0) { \
   RetCode = PostThreadMessage(win32Mess.lParam, WM_SDL_SIGNAL, win32Mess.wParam, win32Mess.lParam); \
   } \
   XOS_ERROR("CREATE", "PostThreadMessage", RetCode) \
   CHECK_INSTANCE_LIMIT2(PROC_IDNODE)
   
#else  /* X_ONE_TASK_PER_INSTANCE_SET */

#ifdef XWINCE

#define RTOSSDL_CREATE(PROC_NAME, PROC_IDNODE, PROC_NAME_STRING) \
   RetCode =  (unsigned long)(TCreateThread(NULL, 0, (LPTHREAD_START_ROUTINE) (PROC_IDNODE)->WIN32PAD, NULL, 0, (LPDWORD)&win32Mess.lParam));\
   XOS_ERROR("RTOSSDL_CREATE", "TCreateThread", RetCode) \
   Prio = SetThreadPriority((HANDLE)RetCode, (PROC_IDNODE)->Prio); \
   XOS_ERROR("RTOSSDL_CREATE", "SetThreadPriority", Prio) \
   yVarP->Offspring = (unsigned long)win32Mess.lParam; \
   ((xStartUpSignalHeader)STARTUP_DATA_PTR)->PrsNode = \
     xAllocPrsUseMyMemory(PROC_IDNODE, win32Mess.lParam); \
   ((xStartUpSignalHeader)STARTUP_DATA_PTR)->PrsNode->BlockInstNumber = \
     yVarP->PrsNode->BlockInstNumber; \
   XOS_TRACE_CREATE(win32Mess.lParam, PROC_NAME_STRING) \
   XMSC_TRACE_CREATE(win32Mess.lParam, PROC_NAME_STRING) \
   RetCode = TPeekMessage( &win32Mess, NULL, WM_USER, WM_USER, PM_NOREMOVE); \
   XOS_ERROR("RTOSSDL_CREATE", "TPeekMessage", RetCode) \
   RetCode = 0; \
   while (RetCode == 0) { \
      RetCode = PostThreadMessage( win32Mess.lParam, WM_SDL_SIGNAL, win32Mess.wParam, win32Mess.lParam); \
   } \
   XOS_ERROR("RTOSSDL_CREATE", "PostThreadMessage", RetCode)

#else  /* XWINCE */

#define RTOSSDL_CREATE(PROC_NAME, PROC_IDNODE, PROC_NAME_STRING) \
   CHECK_INSTANCE_LIMIT1(PROC_IDNODE) \
   RetCode =  (unsigned long)(TCreateThread(DEF_SEC_ATTR, DEF_STACK, (LPTHREAD_START_ROUTINE) (PROC_IDNODE)->WIN32PAD, NULL, 0, (LPDWORD)&win32Mess.lParam));\
   XOS_ERROR("RTOSSDL_CREATE", "TCreateThread", RetCode) \
   Prio = SetThreadPriority((HANDLE)RetCode, (PROC_IDNODE)->Prio); \
   XOS_ERROR("RTOSSDL_CREATE", "SetThreadPriority", Prio) \
   yVarP->Offspring = (unsigned long)win32Mess.lParam; \
   ((xStartUpSignalHeader)STARTUP_DATA_PTR)->PrsNode = \
     xAllocPrsUseMyMemory(PROC_IDNODE, win32Mess.lParam); \
   ((xStartUpSignalHeader)STARTUP_DATA_PTR)->PrsNode->BlockInstNumber = \
     yVarP->PrsNode->BlockInstNumber; \
   XOS_TRACE_CREATE(win32Mess.lParam, PROC_NAME_STRING) \
   XMSC_TRACE_CREATE(win32Mess.lParam, PROC_NAME_STRING) \
   RetCode = TPeekMessage( &win32Mess, NULL, WM_USER, WM_USER, PM_NOREMOVE); \
   XOS_ERROR("RTOSSDL_CREATE", "TPeekMessage", RetCode) \
   RetCode = 0; \
   while (RetCode == 0) { \
      RetCode = PostThreadMessage( win32Mess.lParam, WM_SDL_SIGNAL, win32Mess.wParam, win32Mess.lParam); \
   } \
   XOS_ERROR("RTOSSDL_CREATE", "PostThreadMessage", RetCode) \
   RetCode = ReleaseSemaphore ( TaskSem, 1, NULL ); \
   XOS_ERROR("RTOSSDL_CREATE", "ReleaseSemaphore",RetCode ) \
   CHECK_INSTANCE_LIMIT2(PROC_IDNODE)

#endif  /* XWINCE */

#endif
       /* X_ONE_TASK_PER_INSTANCE_SET */

/* ------------------------- Static Create ------------------------ */

#define YINIT_TEMP_VARS \
  MSG	  	win32Mess;\
  xSignalHeader yOutputSignalPtr; \
  unsigned long RetCode; \
  int Prio;

#ifdef XENV

#ifdef X_ONE_TASK_PER_INSTANCE_SET

#ifdef XWINCE

#define RTOSXCREATE_ENV_PROCESS \
{ \
  unsigned long RetCode; \
  int Prio; \
  RetCode = (unsigned long)(TCreateThread(NULL, 0, (LPTHREAD_START_ROUTINE) WIN32PAD_env, NULL, 0,(LPDWORD)&win32Mess.lParam)); \
  XOS_ERROR("RTOSXCREATE_ENV_PROCESS", "TCreateThread", RetCode); \
  Prio = SetThreadPriority((HANDLE)RetCode,THREAD_PRIORITY_NORMAL); \
  XOS_ERROR("RTOSXCREATE_ENV_PROCESS", "SetThreadPriority", Prio); \
  xEnvId->PROCID = (LPDWORD)win32Mess.lParam; \
  XOS_ERROR("XCREATE_ENV_PROCESS", "TCreateThread", RetCode) \
  xEnvPrs = xAllocPrsUseMyMemory(xEnvId); \
}

#else  /* XWINCE */

#define RTOSXCREATE_ENV_PROCESS \
{ \
  unsigned long RetCode; \
  int Prio; \
  RetCode = (unsigned long)(TCreateThread(DEF_SEC_ATTR, DEF_STACK, (LPTHREAD_START_ROUTINE) WIN32PAD_env, NULL, 0,(LPDWORD)&win32Mess.lParam)); \
  XOS_ERROR("RTOSXCREATE_ENV_PROCESS", "TCreateThread", RetCode); \
  Prio = SetThreadPriority((HANDLE)RetCode,THREAD_PRIORITY_NORMAL); \
  XOS_ERROR("RTOSXCREATE_ENV_PROCESS", "SetThreadPriority", Prio); \
  xEnvId->PROCID = (LPDWORD)win32Mess.lParam; \
  XOS_ERROR("XCREATE_ENV_PROCESS", "TCreateThread", RetCode) \
  xEnvPrs = xAllocPrsUseMyMemory(xEnvId); \
}

#endif  /* XWINCE */

#else /* X_ONE_TASK_PER_INSTANCE_SET */

#ifdef XWINCE

#define RTOSXCREATE_ENV_PROCESS \
{ \
  unsigned long RetCode; \
  int Prio; \
  RetCode = (unsigned long)(TCreateThread(NULL, 0, (LPTHREAD_START_ROUTINE) WIN32PAD_env, NULL,0,(LPDWORD)&win32Mess.lParam)); \
  XOS_ERROR("RTOSXCREATE_ENV_PROCESS", "TCreateThread", RetCode); \
  Prio = SetThreadPriority((HANDLE)RetCode,THREAD_PRIORITY_NORMAL); \
  XOS_ERROR("RTOSXCREATE_ENV_PROCESS", "SetThreadPriority", Prio); \
  xEnvPId = (SDL_PId)win32Mess.lParam; \
  xEnvPrs = xAllocPrsUseMyMemory(xEnvId, xEnvPId); \
}

#else  /* XWINCE */

#define RTOSXCREATE_ENV_PROCESS \
{ \
  unsigned long RetCode; \
  int Prio; \
  RetCode = (unsigned long)(TCreateThread(DEF_SEC_ATTR, DEF_STACK, (LPTHREAD_START_ROUTINE) WIN32PAD_env, NULL,0,(LPDWORD)&win32Mess.lParam)); \
  XOS_ERROR("RTOSXCREATE_ENV_PROCESS", "TCreateThread", RetCode); \
  Prio = SetThreadPriority((HANDLE)RetCode,THREAD_PRIORITY_NORMAL); \
  XOS_ERROR("RTOSXCREATE_ENV_PROCESS", "SetThreadPriority", Prio); \
  xEnvPId = (SDL_PId)win32Mess.lParam; \
  xEnvPrs = xAllocPrsUseMyMemory(xEnvId, xEnvPId); \
}

#endif  /* XWINCE */
#endif /* X_ONE_TASK_PER_INSTANCE_SET */

#else  /* XENV */

#ifdef X_ONE_TASK_PER_INSTANCE_SET

#define RTOSXCREATE_ENV_PROCESS \
  xEnvId->PROCID = (LPDWORD)GetCurrentThreadId(); \
  xEnvPrs = xAllocPrsUseMyMemory(xEnvId);

#else

#define RTOSXCREATE_ENV_PROCESS \
  xEnvPId = GetCurrentThreadId(); \
  xEnvPrs = xAllocPrsUseMyMemory(xEnvId, xEnvPId);

#endif  /* X_ONE_TASK_PER_INSTANCE_SET */

#endif  /* XENV */

#ifndef X_ONE_TASK_PER_INSTANCE_SET

#ifdef XOS_TRACE
#define BEGIN_YINIT \
  xInitTimer(); \
  LastUsedPId = SDL_NULL; \
  printf("\n\nSystem startup\n\n");
#else
#define BEGIN_YINIT \
  xInitTimer();
#endif

#endif
       /* X_ONE_TASK_PER_INSTANCE_SET */

#ifdef X_ONE_TASK_PER_INSTANCE_SET

#ifdef XWINCE

#define RTOSINIT_PROCESS_TYPE(PROC_NAME,PREFIX_PROC_NAME, PROC_IDNODE, \
PROC_NAME_STRING, MAX_NO_OF_INST, STATIC_INST, PRIV_DATA_TYPE, PRIO, \
PAD_FUNCTION) \
   RetCode = (unsigned long)(TCreateThread(NULL, 0,(LPTHREAD_START_ROUTINE)XCAT(WIN32PAD_,PREFIX_PROC_NAME),NULL,0,(LPDWORD)&win32Mess.lParam));\
   XOS_ERROR("RTOSINIT_PROCESS_TYPE", "TCreateThread", RetCode) \
   Prio = SetThreadPriority((HANDLE)RetCode,PRIO); \
   XOS_ERROR("RTOSINIT_PROCESS_TYPE", "SetThreadPriority", Prio) \
   PROC_IDNODE->PROCID = (LPDWORD)win32Mess.lParam; \
   createdProcesses++; 

#else  /* XWINCE */

#define RTOSINIT_PROCESS_TYPE(PROC_NAME,PREFIX_PROC_NAME, PROC_IDNODE, \
PROC_NAME_STRING, MAX_NO_OF_INST, STATIC_INST, PRIV_DATA_TYPE, PRIO, \
PAD_FUNCTION) \
   RetCode = (unsigned long)(TCreateThread(DEF_SEC_ATTR,DEF_STACK,(LPTHREAD_START_ROUTINE)XCAT(WIN32PAD_,PREFIX_PROC_NAME),NULL,0,(LPDWORD)&win32Mess.lParam));\
   XOS_ERROR("RTOSINIT_PROCESS_TYPE", "TCreateThread", RetCode) \
   Prio = SetThreadPriority((HANDLE)RetCode,PRIO); \
   XOS_ERROR("RTOSINIT_PROCESS_TYPE", "SetThreadPriority", Prio) \
   PROC_IDNODE->PROCID = (LPDWORD)win32Mess.lParam; \
   createdProcesses++; 

#endif  /* XWINCE */
#endif
       /* X_ONE_TASK_PER_INSTANCE_SET */

#ifdef X_ONE_TASK_PER_INSTANCE_SET

#define RTOSSDL_STATIC_CREATE(PROC_NAME, PREFIX_PROC_NAME, PROC_IDNODE, \
PROC_NAME_STRING, STARTUP_IDNODE, STARTUP_PAR_TYPE, PRIV_DATA_TYPE, \
PRIO, PAD_FUNCTION, BLOCK_INST_NUMBER) \
   yOutputSignalPtr = (xSignalHeader)xAlloc( sizeof(STARTUP_PAR_TYPE) + \
                                             sizeof(XSIGNALHEADERTYPE)); \
   yOutputSignalPtr->SigP = yOutputSignalPtr+1; \
   yOutputSignalPtr->SignalCode = STARTUPSIGNAL; \
   yOutputSignalPtr->Sender = SDL_NULL; \
   win32Mess.wParam = (WPARAM) yOutputSignalPtr; \
   yOutputSignalPtr->Receiver = xAllocPrsUseMyMemory(PROC_IDNODE); \
   yOutputSignalPtr->Receiver->BlockInstNumber = BLOCK_INST_NUMBER; \
   XOS_TRACE_STATIC_CREATE(yOutputSignalPtr->Receiver, PROC_NAME_STRING) \
   XMSC_TRACE_STATIC_CREATE(yOutputSignalPtr->Receiver, PROC_NAME_STRING)  \
   RetCode = 0; \
   while (RetCode == 0) { \
      RetCode = PostThreadMessage( win32Mess.lParam, WM_SDL_SIGNAL, win32Mess.wParam, win32Mess.lParam); \
   } \
   XOS_ERROR("RTOSSDL_STATIC_CREATE", "PostThreadMessage", RetCode)

#else  /* X_ONE_TASK_PER_INSTANCE_SET */

#ifdef XWINCE

#define RTOSSDL_STATIC_CREATE(PROC_NAME, PREFIX_PROC_NAME, PROC_IDNODE, PROC_NAME_STRING, STARTUP_IDNODE, STARTUP_PAR_TYPE, PRIV_DATA_TYPE, PRIO, PAD_FUNCTION, BLOCK_INST_NUMBER) \
   yOutputSignalPtr = (xSignalHeader)xAlloc( sizeof(STARTUP_PAR_TYPE) + \
                                             sizeof(XSIGNALHEADERTYPE)); \
   yOutputSignalPtr->SigP = yOutputSignalPtr+1; \
   yOutputSignalPtr->SignalCode = STARTUPSIGNAL; \
   yOutputSignalPtr->Sender = SDL_NULL; \
   win32Mess.wParam = (WPARAM) yOutputSignalPtr; \
   RetCode = (unsigned long)(TCreateThread(NULL, 0, (LPTHREAD_START_ROUTINE) XCAT(WIN32PAD_,PREFIX_PROC_NAME),NULL,0,(LPDWORD)&(win32Mess.lParam))); \
   XOS_ERROR("RTOSSDL_STATIC_CREATE", "TCreateThread", RetCode) \
   Prio = SetThreadPriority((HANDLE)RetCode,PRIO); \
   XOS_ERROR("RTOSSDL_STATIC_CREATE", "SetThreadPriority", Prio) \
   ((STARTUP_PAR_TYPE *)STARTUP_DATA_PTR)->PrsNode = \
     xAllocPrsUseMyMemory(PROC_IDNODE, win32Mess.lParam); \
   ((STARTUP_PAR_TYPE *)STARTUP_DATA_PTR)->PrsNode->BlockInstNumber = \
     BLOCK_INST_NUMBER; \
   createdProcesses++; \
   XOS_TRACE_STATIC_CREATE(win32Mess.lParam, PROC_NAME_STRING) \
   XMSC_TRACE_STATIC_CREATE(win32Mess.lParam, PROC_NAME_STRING) \
   RetCode = 0; \
   while (RetCode == 0) { \
      RetCode = PostThreadMessage( win32Mess.lParam, WM_SDL_SIGNAL, win32Mess.wParam, win32Mess.lParam); \
   } \
   XOS_ERROR("RTOSSDL_STATIC_CREATE", "PostThreadMessage", RetCode)

#else  /* XWINCE */

#define RTOSSDL_STATIC_CREATE(PROC_NAME, PREFIX_PROC_NAME, PROC_IDNODE, PROC_NAME_STRING, STARTUP_IDNODE, STARTUP_PAR_TYPE, PRIV_DATA_TYPE, PRIO, PAD_FUNCTION, BLOCK_INST_NUMBER) \
   yOutputSignalPtr = (xSignalHeader)xAlloc( sizeof(STARTUP_PAR_TYPE) + \
                                             sizeof(XSIGNALHEADERTYPE)); \
   yOutputSignalPtr->SigP = yOutputSignalPtr+1; \
   yOutputSignalPtr->SignalCode = STARTUPSIGNAL; \
   yOutputSignalPtr->Sender = SDL_NULL; \
   win32Mess.wParam = (WPARAM) yOutputSignalPtr; \
   RetCode = (unsigned long)(TCreateThread(DEF_SEC_ATTR,DEF_STACK, (LPTHREAD_START_ROUTINE) XCAT(WIN32PAD_,PREFIX_PROC_NAME),NULL,0,(LPDWORD)&(win32Mess.lParam))); \
   XOS_ERROR("RTOSSDL_STATIC_CREATE", "TCreateThread", RetCode) \
   Prio = SetThreadPriority((HANDLE)RetCode,PRIO); \
   XOS_ERROR("RTOSSDL_STATIC_CREATE", "SetThreadPriority", Prio) \
   ((STARTUP_PAR_TYPE *)STARTUP_DATA_PTR)->PrsNode = \
     xAllocPrsUseMyMemory(PROC_IDNODE, win32Mess.lParam); \
   ((STARTUP_PAR_TYPE *)STARTUP_DATA_PTR)->PrsNode->BlockInstNumber = \
     BLOCK_INST_NUMBER; \
   createdProcesses++; \
   XOS_TRACE_STATIC_CREATE(win32Mess.lParam, PROC_NAME_STRING) \
   XMSC_TRACE_STATIC_CREATE(win32Mess.lParam, PROC_NAME_STRING) \
   RetCode = 0; \
   while (RetCode == 0) { \
      RetCode = PostThreadMessage( win32Mess.lParam, WM_SDL_SIGNAL, win32Mess.wParam, win32Mess.lParam); \
   } \
   XOS_ERROR("RTOSSDL_STATIC_CREATE", "PostThreadMessage", RetCode)

#endif  /* XWINCE */
#endif
       /* X_ONE_TASK_PER_INSTANCE_SET */

/* ----------------------------- Stop ---------------------------- */

#ifdef X_ONE_TASK_PER_INSTANCE_SET

#define RTOSEMPTYQUEUE(SIGPTR) \
   win32Mess.lParam = (LPARAM)SDL_SELF->NameNode->PROCID; \
   RetCode = TPeekMessage(&win32Mess, (HWND) NULL, 0, 0, PM_REMOVE); \
   XOS_ERROR("RTOSEMPTYQUEUE", "TPeekMessage", RetCode) \
   while (RTOSMSG_IN_Q) { /* (RetCode != ERR_NOMSG) */ \
     yInstanceSetVars->yInSignalPtr = (xSignalHeader)win32Mess.wParam; \
     if ( xEq_SDL_PId( yInstanceSetVars->yInSignalPtr->Receiver, SDL_SELF) ) \
       xFree((void *)(&win32Mess.wParam)); \
     else \
       xSaveSignal( yInstanceSetVars->SaveQ, yInstanceSetVars->yInSignalPtr); \
     RetCode = TPeekMessage(&win32Mess, (HWND) NULL, 0, 0, PM_REMOVE); \
     XOS_ERROR("RTOSEMPTYQUEUE", "TPeekMessage", RetCode) \
   }

#define RTOSSDL_STOPREMOVETIMERS \
   xKillSaveQ(yInstanceSetVars->SaveQ, SDL_SELF); \
   yOutputSignalPtr = xAlloc(sizeof(xSignalHeaderRec)); \
   yOutputSignalPtr->SignalCode = RemoveTimers; \
   yOutputSignalPtr->Sender = SDL_SELF; \
   yOutputSignalPtr->IsTimerSignal = 1; \
   win32Mess.wParam = (WPARAM) yOutputSignalPtr; \
   RetCode = PostThreadMessage( TimerThread, WM_SDL_SIGNAL, win32Mess.wParam, win32Mess.lParam); \
   XOS_ERROR("RemoveTimers", "PostThreadMessage", RetCode) \
   xFreePrs(&yVarP->PrsNode); \
   goto Label_New_Transition_No_Free;

#else

#define RTOSEMPTYQUEUE(SIGPTR) \
   while (TPeekMessage(&win32Mess, (HWND) NULL, 0, 0, PM_REMOVE)) { \
     xFree((void *)(&win32Mess.wParam)); \
   }

#define RTOSSDL_STOPREMOVETIMERS \
   yOutputSignalPtr = xAlloc(sizeof(xSignalHeaderRec)); \
   yOutputSignalPtr->SignalCode = RemoveTimers; \
   yOutputSignalPtr->Sender = SDL_SELF; \
   yOutputSignalPtr->IsTimerSignal = 1; \
   win32Mess.wParam = (WPARAM) yOutputSignalPtr; \
   RetCode = PostThreadMessage( TimerThread, WM_SDL_SIGNAL, win32Mess.wParam, win32Mess.lParam); \
   XOS_ERROR("RTOSSDL_STOPREMOVETIMERS", "PostThreadMessage", RetCode)

#define RTOSKILL_PROC \
   TExitThread(EXITCODE); \
   XOS_ERROR("RTOSKILL_PROC", "TExitThread", EXITCODE)


#endif
       /* X_ONE_TASK_PER_INSTANCE_SET */

/* ---------------------------- Timers --------------------------- */
#define TIMER_DATA_PTR \
(yOutputSignalPtr->SigP)

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define  RTOS_SDL_SET_DUR_WITH_PARA_EXTRA \
  yOutputSignalPtr->Receiver = SDL_SELF;
#else
#define  RTOS_SDL_SET_DUR_WITH_PARA_EXTRA
#endif /* X_ONE_TASK_PER_INSTANCE_SET */

#define RTOS_SDL_SET_DUR_WITH_PARA(TIME_EXPR, DUR_EXPR, TIMER_NAME, TIMER_IDNODE, TIMER_PAR_TYPE, EQ_FUNC, TIMER_VAR, TIMER_NAME_STRING) \
  XOS_TRACE_SET(TIMER_NAME_STRING) \
  TIMER_VAR = TIMER_NAME; \
  yOutputSignalPtr->Sender = SDL_SELF; \
  yOutputSignalPtr->IsTimerSignal = 1; \
  RTOS_SDL_SET_DUR_WITH_PARA_EXTRA \
  ((xTimerHeader)yOutputSignalPtr)->TimerTime = DUR_EXPR; \
  ((xTimerHeader)yOutputSignalPtr)->SignalCode = XXXSetTimer; \
  XSDLRESETWITHPARAM(TIMER_NAME, SDL_SELF, RTOSINSIGNALPTR, yOutputSignalPtr,EQ_FUNC,TIMER_NAME_STRING); \
  XMSC_TRACE_SET(yOutputSignalPtr, TIMER_NAME_STRING, DUR_EXPR) \
  win32Mess.wParam = (WPARAM) yOutputSignalPtr; \
  RetCode = PostThreadMessage( TimerThread, WM_SDL_SIGNAL, win32Mess.wParam, 0 ); \
  XOS_ERROR("RTOS_SDL_SET_DUR_WITH_PARA", "PostThreadMessage", RetCode)

#define RTOS_SDL_RESET_WITH_PARA(EQ_FUNC, TIMER_VAR, TIMER_NAME_STRING) \
  XOS_TRACE_RESET(TIMER_NAME_STRING) \
  yOutputSignalPtr->Sender = SDL_SELF; \
  yOutputSignalPtr->IsTimerSignal = 1; \
  ((xTimerHeader)yOutputSignalPtr)->TimerTime = 0; \
  XSDLRESETWITHPARAM(TIMER_VAR, SDL_SELF, RTOSINSIGNALPTR, yOutputSignalPtr,EQ_FUNC,TIMER_NAME_STRING); \
  RTOSFREETIMERSTRINGPARAMS2((xTimerHeader)yOutputSignalPtr) \
  xFree((void**)&yOutputSignalPtr); \
  XOS_ERROR("OUTPUT", "msgQSend", Err)

#define RTOSALLOC_TIMER_SIGNAL(TIMER_NAME_PARAMETER, DUR_EXPR) \
   yOutputSignalPtr = (xSignalHeader)xAlloc(sizeof(xTimerHeaderRec)); \
   ((xTimerHeader)yOutputSignalPtr)->IsTimerSignal = 1; \
   ((xTimerHeader)yOutputSignalPtr)->TimerToSetOrReset = TIMER_NAME_PARAMETER;

#define RTOS_ALLOC_TIMER_SIGNAL_PAR(TIMER_NAME, TIMER_IDNODE, TIMER_PAR_TYPE) \
  yOutputSignalPtr = (xSignalHeader)xAlloc(sizeof(xTimerHeaderRec)+sizeof(TIMER_PAR_TYPE)); \
  yOutputSignalPtr->SigP = ((xTimerHeader)yOutputSignalPtr) + 1; \
  ((xTimerHeader)yOutputSignalPtr)->TimerToSetOrReset = TIMER_NAME; \
  ((xTimerHeader)yOutputSignalPtr)->TestParams = 1; \
  ((xTimerHeader)yOutputSignalPtr)->IsTimerSignal = 1;
  
#ifdef X_ONE_TASK_PER_INSTANCE_SET

#define RTOSXHANDLETIMER_BODY \
   MSG win32Mess; \
   unsigned long RetCode; \
   ((xTimerHeader)OutputSignal)->SignalCode = XXXSetTimer; \
   ((xTimerHeader)OutputSignal)->Sender = Sender; \
   ((xTimerHeader)OutputSignal)->Receiver = Sender; \
   ((xTimerHeader)OutputSignal)->TimerTime = Dur_Expr; \
   ((xTimerHeader)OutputSignal)->TestParams = 0; \
   win32Mess.wParam = (WPARAM) OutputSignal; \
   RetCode=PostThreadMessage(TimerThread, WM_SDL_SIGNAL, win32Mess.wParam, win32Mess.lParam); \
   XOS_ERROR("RTOSXHANDLETIMER_BODY", "PostThreadMessage", RetCode)

#else

#define RTOSXHANDLETIMER_BODY \
   MSG win32Mess; \
   unsigned long RetCode; \
   ((xTimerHeader)OutputSignal)->SignalCode = XXXSetTimer; \
   ((xTimerHeader)OutputSignal)->Sender = Sender; \
   ((xTimerHeader)OutputSignal)->TimerTime = Dur_Expr; \
   ((xTimerHeader)OutputSignal)->TestParams = 0; \
   win32Mess.wParam = (WPARAM) OutputSignal; \
   RetCode=PostThreadMessage(TimerThread, WM_SDL_SIGNAL, win32Mess.wParam, win32Mess.lParam); \
   XOS_ERROR("RTOSXHANDLETIMER_BODY", "PostThreadMessage", RetCode)

#endif
       /* X_ONE_TASK_PER_INSTANCE_SET */


/* ------------------------ Execution trace ---------------------- */

#define RTOSXOS_TRACE_CREATE(INSTANCE, PROC_NAME_STRING) \
  XOS_FPRINT(("%s: process %s:%lu created\n", ProcName, \
    PROC_NAME_STRING, INSTANCE))

#define RTOSXOS_TRACE_STATIC_CREATE(INSTANCE, PROC_NAME_STRING) \
   XOS_STATIC_FPRINT(("Process %s:%lu created\n", PROC_NAME_STRING, INSTANCE))


#ifdef XMSC_TRACE

#ifdef XMSC_EDITOR

#define RTOSMSCPRINT_START \
	WaitForSingleObject(psmidmsc2,INFINITE);

#define RTOSMSCPRINT_STOP \
	ReleaseSemaphore(psmidmsc,1,NULL);

#define XSDLRESET( TIMER_NAME, SAVEQ, TIMER_NAME_STRING) \
   xSDLReset( TIMER_NAME, SDL_SELF, SAVEQ, RTOSINSIGNALPTR, NULL, NULL, TIMER_NAME_STRING);

#ifdef X_ONE_TASK_PER_INSTANCE_SET


#define RTOSXMSC_TRACE_STATIC_CREATE(INSTANCE, PROC_NAME_STRING) \
  memset(msce_buf, 0, sizeof(msce_buf)); \
  if (strcmp(PROC_NAME_STRING,"Environment")==0){ \
   sprintf(msce_buf,"%lu %s %s %s", ENV_PID, ": instancehead process ",  PROC_NAME_STRING, ";"); \
  } \
  else {  \
   sprintf(msce_buf, "%lu %s %s %s", INSTANCE, ": instancehead process ", PROC_NAME_STRING, ";"); \
  } \
  send_message(&msce_buf);

#define RTOSXMSC_TRACE_CREATE( INSTANCE, PROC_NAME_STRING) \
   { SDL_PId ParentPId; ParentPId = SDL_SELF; \
     XMSC_FPRINT((msce_buf, "%lu %s %s %s", INSTANCE, ": instancehead process ", PROC_NAME_STRING, ";")) \
     XMSC_FPRINT((msce_buf, "%lu : %s %lu %s", ParentPId, "create ", INSTANCE, ";")) \
   }

#define RTOSXMSC_TRACE_NEXTSTATE(STATE_NAME_STRING) \
   { SDL_PId CurrentPId; CurrentPId = SDL_SELF; \
     XMSC_FPRINT((msce_buf, "%lu %s %s %s", CurrentPId, ": condition ", STATE_NAME_STRING, ";")) \
   }

#define XMSC_TRACE_INPUT(SIG_NAME_STRING) \
   { SDL_PId CurrentPId, SenderPId; \
     RTOSMSCPRINT_START \
     CurrentPId = SDL_SELF; \
     SenderPId = yVarP->Sender; \
     if (INSIGNAL_PTR->IsTimer) { \
       sprintf(msce_buf, "%lu %s %s %s %d %s %ld %s", \
	           CurrentPId, ": timeout  ", SIG_NAME_STRING, ",", \
			   INSIGNAL_PTR->SignalId, "; /* #SDTNOW(", GetTickCount(), ") */"); \
     } \
     else { \
       sprintf(msce_buf, "%lu %s %s %s %d %s %lu %s", \
	           CurrentPId, ": in ", SIG_NAME_STRING, ",", \
			   INSIGNAL_PTR->SignalId, " from ", SenderPId, ";"); \
     } \
     RTOSMSCPRINT_STOP \
   }


#define XMSC_TRACE_OUTPUT(RECEIVER, SIGNAL, SIG_NAME_STRING) \
   { SDL_PId CurrentPId; \
     RTOSMSCPRINT_START \
     CurrentPId = SDL_SELF; \
     SignalId = SignalId + 1; \
     SIGNAL->SignalId = SignalId; \
     SIGNAL->IsTimer = 0; \
     if ( xEq_SDL_PId(RECEIVER, ENV_PID) ) { \
       sprintf(msce_buf, "%lu %s %d %s %d %s %lu %s", \
	           CurrentPId, ": out ", SIGNAL->SignalCode, ",", SignalId, " to ", RECEIVER, ";"); \
     } \
     else { \
       sprintf(msce_buf, "%lu %s %s %s %d %s %lu %s", \
	           CurrentPId, ": out ", SIG_NAME_STRING, ",", SignalId, " to ", RECEIVER, ";"); \
     } \
     RTOSMSCPRINT_STOP \
    }


#define XMSC_TRACE_STOP  \
   { SDL_PId CurrentPId; \
     CurrentPId = SDL_SELF; \
     XMSC_FPRINT((msce_buf, "%lu %s", CurrentPId, ": stop;")) \
   }


#define XMSC_TRACE_SET( TIMER, TIMER_NAME_STRING, DUR_EXPR) \
   { SDL_PId CurrentPId; \
     RTOSMSCPRINT_START \
     CurrentPId = SDL_SELF; \
     SignalId = SignalId + 1; \
     TIMER->SignalId = SignalId; \
     TIMER->IsTimer = 1; \
     sprintf(msce_buf, "%lu %s %s %s %d %s %d %s %ld %s", \
	         CurrentPId, ": set ", TIMER_NAME_STRING, ",", \
			 SignalId, " (", DUR_EXPR, "); /* #SDTNOW(", GetTickCount(), ") */"); \
     RTOSMSCPRINT_STOP \
   }


#define XMSC_TRACE_RESET( TIMER_ID, TIMER_NAME_STRING) \
   { SDL_PId CurrentPId; \
     RTOSMSCPRINT_START \
     CurrentPId = Self; \
     sprintf(msce_buf, "%lu %s %s %s %d %s %ld %s", \
             CurrentPId, ": reset ", TIMER_NAME_STRING, \
			 ",", TIMER_ID, "; /* #SDTNOW(", GetTickCount(), ") */"); \
     RTOSMSCPRINT_STOP \
   }

#define RTOSSYSINITPR_MSCPRINT \
    WaitForSingleObject(psmidmsc,INFINITE); \
    send_message(&msce_buf); \
    memset(msce_buf, 0, sizeof(msce_buf)); \
    ReleaseSemaphore(psmidmsc2,1,NULL);

#else   /*  X_ONE_TASK_PER_INSTANCE_SET  */

#define RTOSXMSC_TRACE_STATIC_CREATE(INSTANCE, PROC_NAME_STRING) \
  memset(msce_buf, 0, sizeof(msce_buf)); \
  sprintf(msce_buf, "%lu %s %s %s", INSTANCE, ": instancehead process ", PROC_NAME_STRING, ";"); \
  send_message(&msce_buf);
  
#define RTOSXMSC_TRACE_CREATE( INSTANCE, PROC_NAME_STRING) \
   { SDL_PId ParentPId; ParentPId = SDL_SELF; \
      XMSC_FPRINT((msce_buf, "%lu %s %s %s", INSTANCE, \
			": instancehead process ", PROC_NAME_STRING, ";")) \
      XMSC_FPRINT((msce_buf, "%lu : %s %lu %s", \
	              ParentPId, "create ", INSTANCE, ";")) \
   }

#define RTOSXMSC_TRACE_NEXTSTATE(STATE_NAME_STRING) \
   { SDL_PId CurrentPId; CurrentPId = SDL_SELF; \
     XMSC_FPRINT((msce_buf, "%lu %s %s %s", CurrentPId, ": condition ", STATE_NAME_STRING, ";")) \
   }

#define XMSC_TRACE_INPUT(SIG_NAME_STRING) \
   { SDL_PId CurrentPId, SenderPId; \
     RTOSMSCPRINT_START \
     CurrentPId = SDL_SELF; \
     SenderPId = yVarP->Sender; \
     if (INSIGNAL_PTR->IsTimer) { \
       sprintf(msce_buf, "%lu %s %s %s %d %s %ld %s", \
	           CurrentPId, ": timeout  ", SIG_NAME_STRING, \
			   ",", INSIGNAL_PTR->SignalId, "; /* #SDTNOW(", GetTickCount(), ") */"); \
     } \
     else { \
       sprintf(msce_buf, "%lu %s %s %s %d %s %lu %s", \
	           CurrentPId, ": in ", SIG_NAME_STRING, ",", \
			   INSIGNAL_PTR->SignalId, " from ", SenderPId, ";"); \
     } \
     RTOSMSCPRINT_STOP \
   }

#define XMSC_TRACE_OUTPUT(RECEIVER, SIGNAL, SIG_NAME_STRING) \
   { SDL_PId CurrentPId; \
     RTOSMSCPRINT_START \
     CurrentPId = SDL_SELF; \
     SignalId = SignalId + 1; \
     SIGNAL->SignalId = SignalId; \
     SIGNAL->IsTimer = 0; \
     if ( xEq_SDL_PId(RECEIVER, ENV_PID) ) { \
       sprintf(msce_buf, "%lu %s %d %s %d %s %lu %s", \
	           CurrentPId, ": out ", SIGNAL->SignalCode, ",", SignalId, " to ", RECEIVER, ";"); \
     } \
     else { \
       sprintf(msce_buf, "%lu %s %s %s %d %s %lu %s", \
	           CurrentPId, ": out ", SIG_NAME_STRING, ",", SignalId, " to ", RECEIVER, ";"); \
     } \
     RTOSMSCPRINT_STOP \
    }

#define XMSC_TRACE_STOP  \
   { SDL_PId CurrentPId; \
     CurrentPId = SDL_SELF; \
     XMSC_FPRINT((msce_buf, "%lu %s", CurrentPId, ": stop;")) \
   }

#define XMSC_TRACE_SET( TIMER, TIMER_NAME_STRING, DUR_EXPR) \
   { SDL_PId CurrentPId; \
     RTOSMSCPRINT_START \
     CurrentPId = SDL_SELF; \
     SignalId = SignalId + 1; \
     TIMER->SignalId = SignalId; \
     TIMER->IsTimer = 1; \
     sprintf(msce_buf, "%lu %s %s %s %d %s %d %s %ld %s", \
	         CurrentPId, ": set ", TIMER_NAME_STRING, ",", \
			 SignalId, " (", DUR_EXPR, "); /* #SDTNOW(", GetTickCount(), ") */"); \
     RTOSMSCPRINT_STOP \
 }

#define XMSC_TRACE_RESET( TIMER_ID, TIMER_NAME_STRING) \
   { SDL_PId CurrentPId; \
     RTOSMSCPRINT_START \
     CurrentPId = Self; \
     sprintf(msce_buf, "%lu %s %s %s %d %s %ld %s", \
             CurrentPId, ": reset ", TIMER_NAME_STRING, \
			 ",", TIMER_ID, "; /* #SDTNOW(", GetTickCount(), ") */"); \
     RTOSMSCPRINT_STOP \
   }

#define RTOSSYSINITPR_MSCPRINT \
    WaitForSingleObject(psmidmsc,INFINITE); \
    send_message(&msce_buf); \
    memset(msce_buf, 0, sizeof(msce_buf)); \
    ReleaseSemaphore(psmidmsc2,1,NULL);

#endif
         /*  X_ONE_TASK_PER_INSTANCE_SET  */

#else  /* XMSC_EDITOR */

#define RTOSMSCPRINT_START \
     WaitForSingleObject(psmid,INFINITE);

#define RTOSMSCPRINT_STOP \
     ReleaseSemaphore(psmid,1,NULL);

#define XSDLRESET( TIMER_NAME, SAVEQ, TIMER_NAME_STRING) \
   xSDLReset( TIMER_NAME, SDL_SELF, SAVEQ, RTOSINSIGNALPTR, NULL, NULL, TIMER_NAME_STRING);

#ifdef X_ONE_TASK_PER_INSTANCE_SET


#define RTOSXMSC_TRACE_STATIC_CREATE(INSTANCE, PROC_NAME_STRING) \
  if (strcmp(PROC_NAME_STRING,"Environment")==0){ \
   XMSC_FPRINT(("%lu: instancehead process %s;\n", ENV_PID, PROC_NAME_STRING)) \
  } \
  else {  \
   XMSC_FPRINT(("%lu: instancehead process %s;\n", INSTANCE, PROC_NAME_STRING)) \
  }

#define RTOSXMSC_TRACE_CREATE( INSTANCE, PROC_NAME_STRING) \
   { SDL_PId ParentPId; ParentPId = SDL_SELF; \
   XMSC_TRACE_STATIC_CREATE(INSTANCE, PROC_NAME_STRING) \
   XMSC_FPRINT(("%lu: create %lu;\n", ParentPId, INSTANCE)) }

#define RTOSXMSC_TRACE_NEXTSTATE(STATE_NAME_STRING) \
   { SDL_PId CurrentPId; CurrentPId = SDL_SELF; \
   XMSC_FPRINT(("%lu: condition %s;\n", CurrentPId, STATE_NAME_STRING)) }

#define XMSC_TRACE_INPUT(SIG_NAME_STRING) \
   { SDL_PId CurrentPId, SenderPId; \
     CurrentPId = SDL_SELF; \
     SenderPId = (SDL_PId)yVarP->Sender; \
     if (INSIGNAL_PTR->IsTimer) { \
       XMSC_FPRINT(("%lu: timeout  %s,%d; /* #SDTNOW(%ld) */\n", \
         CurrentPId, SIG_NAME_STRING, \
         INSIGNAL_PTR->SignalId, GetTickCount())) \
     } \
     else { \
       XMSC_FPRINT(("%lu: in %s,%d from %lu;\n", CurrentPId, \
         SIG_NAME_STRING, INSIGNAL_PTR->SignalId, \
         SenderPId))  \
     } \
   }

#define XMSC_TRACE_OUTPUT(RECEIVER, SIGNAL, SIG_NAME_STRING) \
   { SDL_PId CurrentPId; \
     CurrentPId = SDL_SELF; \
     SignalId = SignalId + 1; \
     SIGNAL->SignalId = SignalId; \
     SIGNAL->IsTimer = 0; \
     if ( xEq_SDL_PId(RECEIVER, ENV_PID) ) { \
       XMSC_FPRINT(("%lu: out %d,%d to %lu;\n", CurrentPId, \
	 SIGNAL->SignalCode, SignalId, (SDL_PId)RECEIVER)) \
     } \
     else { \
       XMSC_FPRINT(("%lu: out %s,%d to %lu;\n", CurrentPId, \
       SIG_NAME_STRING, SignalId, (SDL_PId)RECEIVER)) \
    } \
    }

#define XMSC_TRACE_STOP  \
   { SDL_PId CurrentPId; \
     CurrentPId = SDL_SELF; \
   XMSC_FPRINT(("%lu: stop;\n", CurrentPId)) }

#define XMSC_TRACE_SET( TIMER, TIMER_NAME_STRING, DUR_EXPR) \
   { SDL_PId CurrentPId; \
     CurrentPId = SDL_SELF; \
     SignalId = SignalId + 1; \
     TIMER->SignalId = SignalId; \
     TIMER->IsTimer = 1; \
     XMSC_FPRINT(("%lu: set %s,%d (%d); /* #SDTNOW(%ld) */\n", CurrentPId, \
       TIMER_NAME_STRING, SignalId, DUR_EXPR, GetTickCount())) }

#define XMSC_TRACE_RESET( TIMER_ID, TIMER_NAME_STRING) \
   { SDL_PId CurrentPId; \
     CurrentPId = Self; \
     XMSC_FPRINT(("%lu: reset %s,%d; /* #SDTNOW(%ld) */\n", CurrentPId, \
     TIMER_NAME_STRING, TIMER_ID, GetTickCount())) }

#define RTOSSYSINITPR_MSCPRINT \
  XMSC_FPRINT(("%lu: in %d,%d from %lu;\n", ENV_PID, \
         yInSignalPtr->SignalCode , yInSignalPtr->SignalId, \
         (SDL_PId)yInSignalPtr->Sender))

#else   /*  X_ONE_TASK_PER_INSTANCE_SET  */

#define RTOSXMSC_TRACE_STATIC_CREATE(INSTANCE, PROC_NAME_STRING) \
   XMSC_FPRINT(("%lu: instancehead process %s;\n", INSTANCE, PROC_NAME_STRING))

#define RTOSXMSC_TRACE_CREATE( INSTANCE, PROC_NAME_STRING) \
   { SDL_PId ParentPId; ParentPId = SDL_SELF; \
   XMSC_TRACE_STATIC_CREATE(INSTANCE, PROC_NAME_STRING) \
   XMSC_FPRINT(("%lu: create %lu;\n", ParentPId, INSTANCE)) }

#define RTOSXMSC_TRACE_NEXTSTATE(STATE_NAME_STRING) \
   { SDL_PId CurrentPId; CurrentPId = SDL_SELF; \
   XMSC_FPRINT(("%lu: condition %s;\n", CurrentPId, STATE_NAME_STRING)) }

#define XMSC_TRACE_INPUT(SIG_NAME_STRING) \
   { SDL_PId CurrentPId, SenderPId; \
     CurrentPId = SDL_SELF; \
     SenderPId = yVarP->Sender; \
     if (INSIGNAL_PTR->IsTimer) { \
       XMSC_FPRINT(("%lu: timeout  %s,%d; /* #SDTNOW(%ld) */\n", \
         CurrentPId, SIG_NAME_STRING, \
         INSIGNAL_PTR->SignalId, GetTickCount())) \
     } \
     else { \
       XMSC_FPRINT(("%lu: in %s,%d from %lu;\n", CurrentPId, \
         SIG_NAME_STRING, INSIGNAL_PTR->SignalId, \
         SenderPId))  \
     } \
   }

#define XMSC_TRACE_OUTPUT(RECEIVER, SIGNAL, SIG_NAME_STRING) \
   { SDL_PId CurrentPId; \
     CurrentPId = SDL_SELF; \
     SignalId = SignalId + 1; \
     SIGNAL->SignalId = SignalId; \
     SIGNAL->IsTimer = 0; \
     if ( xEq_SDL_PId(RECEIVER, ENV_PID) ) { \
       XMSC_FPRINT(("%lu: out %d,%d to %lu;\n", CurrentPId, \
       SIGNAL->SignalCode, SignalId, RECEIVER)) \
     } \
     else { \
       XMSC_FPRINT(("%lu: out %s,%d to %lu;\n", CurrentPId, \
       SIG_NAME_STRING, SignalId, RECEIVER)) \
    } \
    }

#define XMSC_TRACE_STOP  \
   { SDL_PId CurrentPId; \
     CurrentPId = SDL_SELF; \
   XMSC_FPRINT(("%lu: stop;\n", CurrentPId)) }

#define XMSC_TRACE_SET( TIMER, TIMER_NAME_STRING, DUR_EXPR) \
   { SDL_PId CurrentPId; \
     CurrentPId = SDL_SELF; \
     SignalId = SignalId + 1; \
     TIMER->SignalId = SignalId; \
     TIMER->IsTimer = 1; \
     XMSC_FPRINT(("%lu: set %s,%d (%d); /* #SDTNOW(%ld) */\n", CurrentPId, \
       TIMER_NAME_STRING, SignalId, DUR_EXPR, GetTickCount())) }

#define XMSC_TRACE_RESET( TIMER_ID, TIMER_NAME_STRING) \
   { SDL_PId CurrentPId; \
     CurrentPId = Self; \
     XMSC_FPRINT(("%lu: reset %s,%d; /* #SDTNOW(%ld) */\n", CurrentPId, \
     TIMER_NAME_STRING, TIMER_ID, GetTickCount())) }

#define RTOSSYSINITPR_MSCPRINT \
  XMSC_FPRINT(("%lu: in %d,%d from %lu;\n", xEnvPId, \
         yInSignalPtr->SignalCode , yInSignalPtr->SignalId, \
         yInSignalPtr->Sender))

#endif
         /*  X_ONE_TASK_PER_INSTANCE_SET  */


#endif  /* XMSC_EDITOR */

#else  /* XMSC_TRACE */

#define RTOSMSCPRINT_START 

#define RTOSMSCPRINT_STOP

#define XSDLRESET( TIMER_NAME, SAVEQ, TIMER_NAME_STRING) \
   xSDLReset( TIMER_NAME, SDL_SELF, SAVEQ, RTOSINSIGNALPTR, NULL, NULL);

#endif
         /*  XMSC_TRACE  */

#ifdef XOS_TRACE

#define XOS_TRACE_STRING(STRING) \
   XOS_STATIC_FPRINT(("%s\n",STRING))

#else

#define XOS_TRACE_STRING(STRING)

#endif

#ifdef XOS_TRACE

#ifdef X_ONE_TASK_PER_INSTANCE_SET

#define XOS_FPRINT(PARAM) \
   {  \
   xEPrsNode CurrentPId; \
   WaitForSingleObject(psmid,INFINITE);\
   CurrentPId = SDL_SELF;  \
   if (LastUsedPId != CurrentPId) \
     PRINTF("\n** Process: %s instance: %lu **\n", \
            yInstanceSetVars->name, CurrentPId); \
   PRINTF PARAM; \
   LastUsedPId = SDL_SELF; \
   ReleaseSemaphore(psmid,1,NULL); \
   }

#define XOS_FPRINTADDR(PARAM) \
   {  \
   xEPrsNode CurrentPId; \
   WaitForSingleObject(psmid,INFINITE);\
   CurrentPId = (*yVarP)->PrsNode;  \
   if (LastUsedPId != CurrentPId) \
     PRINTF("\n** Process: %s instance: %lu **\n", \
            yInstanceSetVars->name, CurrentPId); \
   PRINTF PARAM; \
   LastUsedPId = (*yVarP)->PrsNode; \
   ReleaseSemaphore(psmid,1,NULL); \
   }

#else

#define XOS_FPRINT(PARAM) \
   {  \
   unsigned long CurrentPId; \
   WaitForSingleObject(psmid,INFINITE);\
   CurrentPId = SDL_SELF; \
   if (LastUsedPId != CurrentPId) \
     PRINTF("\n** Process: %s instance: %lu **\n", \
            yVarP->ProcName, CurrentPId); \
   PRINTF PARAM; \
   LastUsedPId = SDL_SELF; \
   ReleaseSemaphore(psmid,1,NULL); \
   }

#define XOS_FPRINTADDR(PARAM) \
   {  \
   unsigned long CurrentPId; \
   WaitForSingleObject(psmid,INFINITE);\
   CurrentPId = (*yVarP)->Self; \
   if (LastUsedPId != CurrentPId) \
     PRINTF("\n** Process: %s instance: %lu **\n", \
            (*yVarP)->ProcName, CurrentPId); \
   PRINTF PARAM; \
   LastUsedPId = (*yVarP)->Self; \
   ReleaseSemaphore(psmid,1,NULL); \
   }

#endif
       /* X_ONE_TASK_PER_INSTANCE_SET */

#endif

/*---Error Messaging---*/
#ifdef XERR
#define XOS_ERROR(STRING1, STRING2, RETCODE) \
  WaitForSingleObject(psmid,INFINITE); \
  PRINTF("%s %s %lu ThreadId = %lu\n", STRING1, STRING2, RETCODE, GetCurrentThreadId()); \
  ReleaseSemaphore(psmid,1,NULL);
#else
#define XOS_ERROR(STRING1, STRING2, RETCODE)
#endif

/****+***************************************************************
     SDL 
********************************************************************/

#ifdef X_ONE_TASK_PER_INSTANCE_SET
typedef xEPrsNode SDL_PId;
#else
typedef unsigned long SDL_PId;
#endif

typedef struct xSignalHeaderStruct *xSignalHeader;
typedef struct xSignalHeaderStruct {
  int            SignalCode;
  xSignalHeader  Pre, Suc;
  SDL_PId        Sender;
  void          *SigP;
#ifdef X_SIGNAL_PRIO
  int            Priority;
#endif
  int            IsTimerSignal; 
#ifdef X_ONE_TASK_PER_INSTANCE_SET
  SDL_PId        Receiver;
#endif
#ifdef XMSC_TRACE
  int            SignalId;
  int            IsTimer;
#endif
} xSignalHeaderRec;

/* Macro to access the SignalCode (or number) with
   a given Pointer to a SignalHeaderStruct 
*/
#define RTOS_SIGNAL_SIGNAL_CODE(XSIGPTR) (XSIGPTR)->SignalCode

/* Macro to access the Signal Parameters with
   a given Pointer to a SignalHeaderStruct
   */
/*#define RTOS_SIGNAL_VAR_PTR(XSIGPTR) (XSIGPTR)->SigP*/
#define RTOS_SIGNAL_VAR_PTR(XSIGPTR) (XSIGPTR)+1

typedef struct xStartUpSignalHeaderStruct *xStartUpSignalHeader;
typedef struct xStartUpSignalHeaderStruct {
  STARTUP_VARS
} xStartUpSignalHeaderRec;

typedef struct xTimerHeaderStruct *xTimerHeader;
typedef struct xTimerHeaderStruct {
  int            SignalCode;
  xTimerHeader   Pre, Suc;
  SDL_PId        Sender;
  void          *SigP;
#ifdef X_SIGNAL_PRIO
  int            Priority;
#endif
  int            IsTimerSignal; 
#ifdef X_ONE_TASK_PER_INSTANCE_SET
  SDL_PId        Receiver;
#endif
#ifdef XMSC_TRACE
  int            SignalId;
  int            IsTimer;
#endif
  SDL_Duration   TimerTime;
  int            TimerToSetOrReset;
  xbool          (* yEq)();
  xbool          TestParams;
  xTimerHeader   Param;
} xTimerHeaderRec;

/* Macro to access the number of Timer to set or rest with
   a given Pointer to a Timer HeaderStruct.
   */
#define RTOS_TIMER_TO_RE_SET(XSIGPTR) (XSIGPTR)->TimerToSetOrReset

   /* Macro to access the Signal Parameters with
   a given Pointer to a SignalHeaderStruct
   */
/*#define RTOS_TIMER_VAR_PTR(XSIGPTR) (XSIGPTR)->SigP*/
#define RTOS_TIMER_VAR_PTR(XSIGPTR) (XSIGPTR)+1


#ifdef X_ONE_TASK_PER_INSTANCE_SET

typedef struct {
  xSignalHeader  SaveQ;
  xSignalHeader  CurrentInSaveQ;
  xSignalHeader  yInSignalPtr;
  char		 name[100];
  xptrint        PrsDataSize;
}  xPrsInstanceSetVars;

#endif

/****+***************************************************************
     SDL Save
********************************************************************/

typedef struct xSignalHeaderStruct xSaveQStruct;

typedef xSignalHeader xSaveQ;

/****+***************************************************************
     SDL Timer
********************************************************************/

extern void SDL_Set  XPP((
  SDL_Duration  Tick_Expr, 
  xTimerHeader  Timer,
  xSignalHeader SaveQ ));

#ifdef XMSC_TRACE
extern void xSDLReset  XPP((
  int Timer_Name, 
  SDL_PId Self,
  xSignalHeader SaveQ,
  xSignalHeader InSignalPtr,
  xSignalHeader yOutputSignalPtr,
  xbool (* yEq)(void * VarP1, void * VarP2),
  char *SignalName ));
#else
extern void xSDLReset  XPP((
  int Timer_Name, 
  SDL_PId Self,
  xSignalHeader SaveQ,
  xSignalHeader InSignalPtr,
  xSignalHeader yOututSignalPtr,
  xbool (* yEq)(void * VarP1, void * VarP2) ));
#endif

extern xbool xSDLActive  XPP((
  int Timer_Name,
  SDL_PId   Self,
  xSignalHeader SaveQ,
  xSignalHeader CurrentInSaveQ ));

#define RTOSOSTIME SDL_Time

extern void xTicks XPP ((void));

/****+***************************************************************
     Save
********************************************************************/

extern void xSaveSignal  XPP((
  xSignalHeader  SaveQ, 
  xSignalHeader  yInSignalPtr));

extern void xDiscardSignal XPP((
  xSignalHeader  *DiscardSignal));

#ifdef X_ONE_TASK_PER_INSTANCE_SET
extern void xKillSaveQ XPP((
  xSignalHeader  SaveQ, 
  SDL_PId        CurrentPId));
#else
extern void xKillSaveQ  XPP((
  xSignalHeader  SaveQ));
#endif

/****+***************************************************************
     os
********************************************************************/
extern void * xAlloc  XPP(( xptrint  Size ));
extern void xFree XPP(( void * *  P ));

/****+***************************************************************
     Structure nodes
********************************************************************/

#ifdef XBREAKBEFORE

#define RTOSXPRSIDCOMP0 \
   char            * RefToDefinition; \
   void              (*WIN32PAD) XPP((unsigned long, unsigned long));

#else

#define RTOSXPRSIDCOMP0 \
   void              (*WIN32PAD) XPP(( ));

#endif

#define RTOSXPRSIDCOMP1 \
   void              (*PAD_Function) XPP((void *, unsigned long, xPrsInstanceSetVars* ));

#define RTOSXPRSIDCOMP2 \
   void              (*PAD_Function) XPP((void *));

#define RTOSXPRSIDCOMP3 \
   unsigned long   * PROCID;

/****+***************************************************************
     SDL PId
********************************************************************/

#define xEq_SDL_PId(A,B)        ((A)==(B))
#define xEq_SDL_PId_NULL(A)     ((A)==(SDL_NULL))
extern SDL_PId          xEnvPId;
extern SDL_PId          SDL_NULL;

/****+***************************************************************
     sctsdl.c
********************************************************************/


/*HANDLE for Semaphore RTOSALLOCPRSSEM mge*/
HANDLE pRtosAllocPrsSemaphore;

/*mge*/
#define RTOSALLOCPRS_SEMCREATE \
pRtosAllocPrsSemaphore = CreateSemaphore(0,1,1,"RtosAllocPrsSemaphore");


extern void yInit XPP((void));

extern int createdProcesses;
extern char msce_buf[1024];

extern int semCount;
extern HANDLE TaskSem;
extern HANDLE ThreadHandle;

/* Queue used by the timer thread */
extern unsigned long TimerThread;

#if (defined XOS_TRACE) || (defined XERR) || (defined XMSC_TRACE)

extern HANDLE psmid; /* used by XOS_TRACE to get the printouts correct */
extern HANDLE psmidmsc; /* used by XMSC_EDITOR to get the printouts correct */
extern HANDLE psmidmsc2; /* used by XMSC_EDITOR to get the printouts correct */

#define RTOSGLOBAL_VAR \
HANDLE TaskSem; \
int semCount; \
unsigned long TimerThread; \
HANDLE psmid; /* used by XOS_TRACE to get the printouts correct */ \
HANDLE psmidmsc; /* used by XMSC_EDITOR to get the printouts correct */ \
HANDLE psmidmsc2; /* used by XMSC_EDITOR to get the printouts correct */ \
int createdProcesses= 0; \
char msce_buf[1024];

#else

#define RTOSGLOBAL_VAR \
HANDLE TaskSem; \
int semCount; \
unsigned long TimerThread; \
int createdProcesses= 0;

#endif

extern SDL_PId xTo_Process XPP((
  xPrsIdNode  PrsNode));
 
extern void xInitTimer XPP(( void )); 

/****+***************************************************************
     SDL Save
********************************************************************/

/*---+---------------------------------------------------------------
     xSaveSignal
-------------------------------------------------------------------*/

#define RTOSSAVEQ_TYPE xSignalHeader

#define RTOSSIGNAL_DEF xSignalHeader

#define RTOSTIMER_DEF xTimerHeader

/*---+--------------------------------------------------------------
     Signal priority upgrade (fab)
	 Redefinition of RTOSXSAVESIGNAL
-------------------------------------------------------------------*/

#ifndef X_SIGNAL_PRIO
#define RTOSXSAVESIGNAL \
{ \
       /* Insert New signal (yInSignalPtr) last in save queue */ \
       SaveQ->Pre->Suc = yInSignalPtr; \
       yInSignalPtr->Suc = SaveQ; \
       yInSignalPtr->Pre = SaveQ->Pre; \
       SaveQ->Pre = yInSignalPtr; \
}
#else
#define RTOSXSAVESIGNAL \
{ \
       /* Insert New signal (yInSignalPtr) in save queue in priority order */ \
   { \
	   xSignalHeader PreOfTemp;  \
       xSignalHeader Temp; \
	   Temp = SaveQ->Suc; \
	   while (Temp != SaveQ) { /* Stop when new signal should be inserted between Temp and */ \
	                           /* Temp->Pre, i.e. when the priority index of the new signal */ \
							   /* is less than Temp */ \
		 if (yInSignalPtr->Priority < Temp->Priority) break; \
         Temp = Temp->Suc; \
	   } \
	   /* It works also if Temp is equal to SaveQ now, and when SaveQ is initially empty */ \
       PreOfTemp = Temp->Pre; \
	   Temp->Pre = yInSignalPtr; \
	   yInSignalPtr->Suc = Temp; \
	   PreOfTemp->Suc = yInSignalPtr; \
	   yInSignalPtr->Pre = PreOfTemp; \
   } \
}
#endif
/*---+---------------------------------------------------------------
     xKillSaveQ
-------------------------------------------------------------------*/

#define RTOSTEMP_RECEIVER \
Temp1->Receiver

/*------------------------------------------------------------------------
 *      xInputSignal
 *-----------------------------------------------------------------------*/

#define RTOSXINPUTSIGNALVARS \
  unsigned long RetCode; \
  MSG win32Mess;

#define RTOSCURRENTINSAVEQPTR RTOSCURRENTINSAVEQ

#ifdef X_ONE_TASK_PER_INSTANCE_SET

#define RTOSINSIGNALPTR \
yInstanceSetVars->yInSignalPtr

#define RTOSCURRENTINSAVEQ \
yInstanceSetVars->CurrentInSaveQ

#define RTOSRECEIVE(SIGPTR,SELF,MSGLEN, QID) \
  RetCode = TGetMessage(&win32Mess, (HWND) NULL, WM_SDL_SIGNAL, WM_SDL_SIGNAL ); \
  XOS_ERROR("xInputSignal", "TGetMessage", RetCode) \
  SIGPTR = (xSignalHeader) win32Mess.wParam;

#define RTOSSTARTUPSIGNAL \
yInstanceSetVars->yInSignalPtr->SignalCode

#define RTOSSTARTUPSIGNALVARP \
yInstanceSetVars->yInSignalPtr->Receiver->VarP

#define RTOSSTARTUPSIGNALRESTARTPAD \
yInstanceSetVars->yInSignalPtr->Receiver->NameNode->PAD_Function

#define RTOSSTARTUPSIGNALRECEIVER \
yInstanceSetVars->yInSignalPtr->Receiver

#define RTOSSTARTUPSIGNALPARENT \
yInstanceSetVars->yInSignalPtr->Sender

#define RTOSXINPUTRESTARTPAD_CALL \
(*(*yVarP)->RestartPAD)(*yVarP, (unsigned long)((*yVarP)->PrsNode->NameNode->PROCID), yInstanceSetVars);

#define RTOSXINPUTSIGNAL_SEMS

#else

#define RTOSINSIGNALPTR \
yVarP->yInSignalPtr

#define RTOSCURRENTINSAVEQ \
(*yVarP)->CurrentInSaveQ

#define RTOSSTARTUPSIGNAL_PADFUNCTION \
*(*(xStartUpSignalHeader)(*yVarP)->yInSignalPtr->SigP).PrsNode->NameNode->PAD_Function;

#define RTOSRECEIVE(SIGPTR,SELF,MSGLEN, QID) \
  RetCode = TGetMessage(&win32Mess, (HWND) NULL, 0, 0 ); \
  XOS_ERROR("xInputSignal", "TGetMessage", RetCode) \
  SIGPTR = (xSignalHeader) win32Mess.wParam;

#define RTOSSTARTUPSIGNAL \
(*yVarP)->yInSignalPtr->SignalCode

#define RTOSSIGNALNO \
(*yVarP)->yInSignalPtr->SignalCode

#endif
       /* X_ONE_TASK_PER_INSTANCE_SET */

/****+***************************************************************
     Initialization functions
********************************************************************/

/*---+---------------------------------------------------------------
     System_Init_Func
-------------------------------------------------------------------*/

#ifdef XWINCE

#define RTOSMAINRETURNTYPE int
#define RTOSMAINNAME wWinMain
#define RTOSMAINNAME_PARAM (HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow)

RTOSMAINRETURNTYPE WINAPI RTOSMAINNAME RTOSMAINNAME_PARAM;

#define RTOSMAINRETURNSTMT return 0; /* unreachable code! */

#else

#define RTOSMAINRETURNTYPE void
#define RTOSMAINNAME main
#define RTOSMAINNAME_PARAM XPP((int argc, char *argv[]))

extern RTOSMAINRETURNTYPE RTOSMAINNAME RTOSMAINNAME_PARAM;

#define RTOSMAINRETURNSTMT /* unreachable code! */

#endif  /* XWINCE */

#ifdef XMSC_EDITOR

#define RTOSSYSINITFUNC_VAR \
  unsigned long rc; \
  MSG win32Mess; \
  xSignalHeader yInSignalPtr; \
  int i; \
  int post_fd;

#else

#define RTOSSYSINITFUNC_VAR \
  unsigned long rc; \
  MSG win32Mess; \
  xSignalHeader yInSignalPtr; \
  int i;

#endif  /* XMSC_EDITOR */


#ifdef XWINCE

#define RTOSSYSINITPR_SEMCREATE \
  SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_ABOVE_NORMAL);

#else  /* XWINCE */

#if (defined XOS_TRACE) || (defined XERR) || (defined XMSC_TRACE)

#define RTOSSYSINITPR_SEMCREATE \
  /* Create printout semaphore */ \
  rc = (unsigned long)(psmid = CreateSemaphore ( NULL, 1, MAX_INT, "print_sm" )); \
  XOS_ERROR("RTOSSYSINITPR_SEMCREATE", "CreateSemaphore", rc) \
  /* Create printout semaphore for Environment*/ \
  rc = (unsigned long)(psmidmsc = CreateSemaphore ( NULL, 0, MAX_INT, "print_smmsc" )); \
  XOS_ERROR("RTOSSYSINITPR_SEMCREATE", "CreateSemaphore", rc) \
  rc = (unsigned long)(psmidmsc2 = CreateSemaphore ( NULL, 1, MAX_INT, "print_smmsc2" )); \
  XOS_ERROR("RTOSSYSINITPR_SEMCREATE", "CreateSemaphore", rc) \
  /* Create task semaphore */ \
  rc = (unsigned long)(TaskSem = CreateSemaphore (NULL, 0, MAX_INT, "tini" )); \
  XOS_ERROR("RTOSSYSINITPR_SEMCREATE", "CreateSemaphore", rc) \
  semCount = 0;
  
#else

#define RTOSSYSINITPR_SEMCREATE \
  /* Create task semaphore */ \
  rc = (unsigned long)(TaskSem = CreateSemaphore ( NULL, 0, MAX_INT, "tini" )); \
  XOS_ERROR("main", "CreateSemaphore", rc) \
  semCount = 0;
  
#endif
#endif  /* XWINCE */

#ifdef XMSC_EDITOR

#define RTOSENV_PROCID \
  post_fd=connect_to_sdt (argv[0]); \
  start_msc (post_fd); \
  start_msc_diagram (post_fd);

#else

#define RTOSENV_PROCID 

#endif  /* XMSC_EDITOR */

#define RTOSSYSINITFUNC_SDLNULL

#ifdef XWINCE
#define RTOSSYSINITPR_SEMGIVE \
  SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_NORMAL);

#else  /* XWINCE */

#define RTOSSYSINITPR_SEMGIVE \
  for (i=1;(i<=createdProcesses);i++) { \
    rc = ReleaseSemaphore ( TaskSem, 1, NULL ); \
    XOS_ERROR("main", "ReleaseSemaphore", rc) \
  }
#endif  /* XWINCE */

#ifdef RTOSTEST

#define RTOSSYSINITPROC_RECEIVE \
{ \
  unsigned long rc; \
  MSG win32Mess; \
  UINT win32Timer; \
  win32Timer = SetTimer ( (HWND) NULL, 0, 60000, (TIMERPROC) NULL ); \
  rc = TGetMessage(&win32Mess, (HWND) NULL, 0, 0); \
  XOS_ERROR("main", "TGetMessage", rc) \
  KillTimer((HWND) NULL, win32Timer); \
  if (win32Mess.message == WM_TIMER) { \
    printf("************* TEST CASE FAILED *****************\n"); \
    exit(3); \
  } \
  else \
  yInSignalPtr = (xSignalHeader) win32Mess.wParam; \
}

#else  /* RTOSTEST */

#ifdef XMSC_EDITOR

#define RTOSSYSINITPROC_RECEIVE

#else

#if !defined(XMSC_EDITOR) & defined(XMSC_TRACE)

#define RTOSSYSINITPROC_RECEIVE \
{ \
  unsigned long rc; \
  MSG win32Mess; \
  rc = TGetMessage(&win32Mess, (HWND) NULL, 0, 0); \
  rc = WaitForSingleObject(psmid,INFINITE); \
  XOS_ERROR("main", "TGetMessage", rc) \
  yInSignalPtr = (xSignalHeader) win32Mess.wParam; \
}

#else

#define RTOSSYSINITPROC_RECEIVE \
{ \
  unsigned long rc; \
  MSG win32Mess; \
  rc = TGetMessage(&win32Mess, (HWND) NULL, 0, 0); \
  XOS_ERROR("main", "TGetMessage", rc) \
  yInSignalPtr = (xSignalHeader) win32Mess.wParam; \
}

#endif  /* XMSC_TRACE */
#endif  /* XMSC_EDITOR */
#endif  /* RTOS_TEST */

#ifdef RTOSTEST
#define RTOSTEST_ABORT \
exit(2);
#else
#define RTOSTEST_ABORT
#endif

#define RTOSSYSINITPR_SENDER SenderPId

/*---+---------------------------------------------------------------
     xInitTimer
-------------------------------------------------------------------*/
#define RTOSXTIMERTASK_PARAM void
#define RTOSXTIMERTASK_RTNTYPE void
extern RTOSXTIMERTASK_RTNTYPE xTimerTask XPP ((RTOSXTIMERTASK_PARAM));

#ifdef XWINCE

#define RTOSXINITTIMER \
{ \
  unsigned long RetCode; \
  int ThreadPrio; \
\
  RetCode = (unsigned long)(TCreateThread( NULL, 0, (LPTHREAD_START_ROUTINE)xTimerTask, NULL, 0, &TimerThread )); \
  XOS_ERROR("xInitTimer", "TCreateThread", RetCode); \
  ThreadPrio = SetThreadPriority((HANDLE) RetCode, THREAD_PRIORITY_HIGHEST); \
  XOS_ERROR("ThreadPrio", "SetThreadPriority", ThreadPrio); \
}

#else  /* XWINCE */

#define RTOSXINITTIMER \
{ \
  unsigned long RetCode; \
  int ThreadPrio; \
\
  RetCode = (unsigned long)(TCreateThread( DEF_SEC_ATTR, DEF_STACK, (LPTHREAD_START_ROUTINE)xTimerTask, NULL, 0, &TimerThread )); \
  XOS_ERROR("xInitTimer", "TCreateThread", RetCode); \
  ThreadPrio = SetThreadPriority((HANDLE) RetCode, THREAD_PRIORITY_HIGHEST); \
  XOS_ERROR("ThreadPrio", "SetThreadPriority", ThreadPrio); \
}

#endif  /* XWINCE */
/****+***************************************************************
     xEPrsNode handling
********************************************************************/

/*---+---------------------------------------------------------------
     xAllocPrs
-------------------------------------------------------------------*/
/*mge*/
#define RTOSALLOCPRSSEMTAKE \
WaitForSingleObject(pRtosAllocPrsSemaphore, INFINITE);

#ifdef X_ONE_TASK_PER_INSTANCE_SET
extern xEPrsNode xAllocPrsUseMyMemory  XPP(( xPrsIdNode  PType ));
#else
extern xEPrsNode xAllocPrsUseMyMemory XPP(( xPrsIdNode  PType, SDL_PId PId ));
#endif /* X_ONE_TASK_PER_INSTANCE_SET */

/*mge*/
#define RTOSALLOCPRSSEMGIVE	\
ReleaseSemaphore(pRtosAllocPrsSemaphore, 1, 0);

#define RTOSXALLOCPRS \
{ \
 return 0; \
}

/****+***************************************************************
     SDL Timers
********************************************************************/

#define RTOSTIMER_QUEUEID \
TimerThread

/*---+---------------------------------------------------------------
     xSDLActiveInTimerProcess
-------------------------------------------------------------------*/

#define RTOSACTIVEINTIMERPROCESS_VARS \
  unsigned long RetCode; \
  MSG win32Mess;

#define RTOSTIMERQ_PRE TimerQ->Pre

#define RTOSTIMERSENDER yInSignalPointer->Sender

#define RTOSTEMPTIMERSIGNAL_RECEIVER TempTimer->Sender

#define RTOSTEMPTIMERSIGNAL_SIGNO TempTimer->SignalCode

#define RTOSXACTIVETIMER_TIMERTOFIND yInSignalPointer->TimerToSetOrReset

#define RTOSTEMPTIMER_PRE TempTimer->Pre

#define RTOSSENDTIMERALLOCREPLY

#ifdef X_ONE_TASK_PER_INSTANCE_SET

#define RTOSSENDTIMER(SIGPTR,RECEIVER) \
  win32Mess.wParam = (WPARAM) *(SIGPTR); \
  win32Mess.lParam = (WPARAM)RECEIVER; \
  RetCode = PostThreadMessage(win32Mess.lParam, WM_SDL_SIGNAL, win32Mess.wParam, win32Mess.lParam); \
  XOS_ERROR("xSDLActive", "PostThreadMessage", RetCode)
  
#else

#define RTOSSENDTIMER(SIGPTR,RECEIVER) \
  win32Mess.wParam = (WPARAM) *(SIGPTR); \
  RetCode = PostThreadMessage (RECEIVER, WM_SDL_SIGNAL, win32Mess.wParam, win32Mess.lParam); \
  XOS_ERROR("xSDLActive", "PostThreadMessage", RetCode)

#endif
       /* X_ONE_TASK_PER_INSTANCE_SET */

#ifdef X_ONE_TASK_PER_INSTANCE_SET

#define RTOSTIMERSENDER2 \
yInSignalPointer->Sender->NameNode->PROCID

#else

#define RTOSTIMERSENDER2 \
yInSignalPointer->Sender

#endif

/*---+---------------------------------------------------------------
     xSDL_Active
-------------------------------------------------------------------*/

#define RTOSXSDLACTIVE_PARAMETERS \
( int TimerName, \
  SDL_PId Self, \
  xSignalHeader SaveQ, \
  xSignalHeader CurrentInSaveQ)

#define RTOSXSDLACTIVE_VARS \
  xTimerHeader  yTimerActive; \
  xSignalHeader	TempSaved; \
  unsigned long RetCode; \
  MSG win32Mess;

#define RTOSXSDLACTIVE_ALLOC \
  (xTimerHeader)xAlloc( sizeof(xTimerHeaderRec)); \
  yTimerActive->SignalCode = ActiveTimer; \
  yTimerActive->Sender = Self; \
  yTimerActive->IsTimerSignal = 1;
  
#define RTOSXACTIVETIMER_TIMERTOFIND_2 yTimerActive->TimerToSetOrReset

#define RTOSSENDTIMERALLOC

#ifdef X_ONE_TASK_PER_INSTANCE_SET

#define RTOSXSDLACTIVE_WAITREPLY \
  win32Mess.lParam = (LPARAM)Self->NameNode->PROCID; \
  RetCode = TGetMessage( &win32Mess, (HWND) NULL, 0, 0); \
  XOS_ERROR("xSDL_Active", "TGetMessage", RetCode) \
    yTimerActive  = (xTimerHeader) win32Mess.wParam; \
  while (yTimerActive->SignalCode != ActiveTimer) { \
    xSaveSignal(SaveQ, (xSignalHeader)yTimerActive); \
    RetCode = TGetMessage( &win32Mess, (HWND) NULL, 0, 0); \
    XOS_ERROR("xSDL_Active", "TGetMessage", RetCode) \
    yTimerActive  = (xTimerHeader) win32Mess.wParam; \
  } \
  if (yTimerActive->TimerToSetOrReset == TimerWasFound) { \
    xFree((void **)&yTimerActive); \
      return( SDL_True); \
  } \
  xFree((void **)&yTimerActive);

#else

#define RTOSXSDLACTIVE_WAITREPLY \
  RetCode = TGetMessage ( &win32Mess, (HWND) NULL, 0, 0 ); \
  XOS_ERROR("xSDLActive", "TGetMessage", RetCode) \
    yTimerActive  = (xTimerHeader) win32Mess.wParam; \
  while (yTimerActive->SignalCode != ActiveTimer) { \
    xSaveSignal(SaveQ, (xSignalHeader)yTimerActive); \
    RetCode = TGetMessage ( &win32Mess, (HWND) NULL, 0, 0 ); \
    XOS_ERROR("xSDLActive", "TGetMessage", RetCode) \
    yTimerActive  = (xTimerHeader) win32Mess.wParam; \
  } \
  if (yTimerActive->TimerToSetOrReset == TimerWasFound) { \
    xFree((void **)&yTimerActive); \
      return( SDL_True); \
  } \
  xFree((void **)&yTimerActive);

#endif

#ifdef X_ONE_TASK_PER_INSTANCE_SET

#define RTOSLOOK_FOR_TIMER \
  win32Mess.lParam = (LPARAM)Self->NameNode->PROCID; \
  RetCode = TPeekMessage( &win32Mess, (HWND) NULL, 0, 0, PM_REMOVE); \
  XOS_ERROR("xSDL_Active", "TPeekMessage", RetCode) \
  yTimerActive  = (xTimerHeader) win32Mess.wParam;

#else

#define RTOSLOOK_FOR_TIMER \
  RetCode = TPeekMessage ( &win32Mess, (HWND) NULL, 0, 0, PM_REMOVE ); \
  XOS_ERROR("xSDLActive", "TPeekMessage", RetCode); \
  yTimerActive = (xTimerHeader) win32Mess.wParam;

#endif
       /* X_ONE_TASK_PER_INSTANCE_SET */

#define RTOSMSG_IN_Q RetCode !=  0 /* ERR_NOMSG */

#define RTOSALLOCMESS

#define RTOSYTIMERACTIVE_SIGNO yTimerActive->SignalCode

/*---+---------------------------------------------------------------
     xRemoveTimers
-------------------------------------------------------------------*/

#define RTOSHELPTEMPTIMER_SUC_PRE HelpTempTimer->Suc->Pre

#define RTOSHELPTEMPTIMER_PRE HelpTempTimer->Pre

#define RTOSHELPTEMPTIMER_PRE_SUC HelpTempTimer->Pre->Suc

#define RTOSHELPTEMPTIMER_SUC HelpTempTimer->Suc

/*---+---------------------------------------------------------------
     xSDLResetInTimerProcess
-------------------------------------------------------------------*/

#define RTOSXSDLRESETINTIMERPROCESS_VARS \
  unsigned long RetCode; \
  MSG           win32Mess; \
  SDL_PId       TempSender; \
  xbool         (* yEqFunc)(); \
\
  yEqFunc = yInSignalPointer->yEq;

#define RTOSXRESETTIMER_TIMERTORESET yInSignalPointer->TimerToSetOrReset

#define RTOSTEMPTIMER_SUC_PRE TempTimer->Suc->Pre

#define RTOSTEMPTIMER_PRE_SUC TempTimer->Pre->Suc

#define RTOSTEMPTIMER_SUC TempTimer->Suc

#define RTOSXRESETTIMER_SIGNALID yInSignalPointer->SignalId

#define RTOSTEMPTIMERSIGNAL_SIGNALID TempTimer->SignalId

#ifdef X_ONE_TASK_PER_INSTANCE_SET

#define RTOSXSDLRESETINTIMERPROCESS_REPLY \
  win32Mess.wParam = (WPARAM) yInSignalPointer; \
  win32Mess.lParam = (WPARAM)(yInSignalPointer->Sender)->NameNode->PROCID; \
  RetCode = PostThreadMessage(win32Mess.lParam, WM_SDL_SIGNAL, win32Mess.wParam, win32Mess.lParam); \
  XOS_ERROR("xSDLResetInTimerProcess", "PostThreadMessage", RetCode)

#else

#define RTOSXSDLRESETINTIMERPROCESS_REPLY \
  win32Mess.wParam = (WPARAM) yInSignalPointer; \
  RetCode = PostThreadMessage(yInSignalPointer->Sender, WM_SDL_SIGNAL, win32Mess.wParam, win32Mess.lParam); \
  XOS_ERROR("xSDLResetInTimerProcess", "PostThreadMessage", RetCode)

#endif
       /* X_ONE_TASK_PER_INSTANCE_SET */

/*---+---------------------------------------------------------------
     xSDLReset
-------------------------------------------------------------------*/
#ifdef X_ONE_TASK_PER_INSTANCE_SET
#ifdef XMSC_TRACE
#define XSDLRESETWITHPARAM(TIMER_NAME, SELF,INPUTSIG, OUTPUTSIG,EQUALF, TIMER_NAME_STRING) \
   xSDLReset( TIMER_NAME, SELF, yInstanceSetVars->SaveQ, INPUTSIG, OUTPUTSIG, EQUALF,\
             TIMER_NAME_STRING);
#else /* XMSC_TRACE */
#define XSDLRESETWITHPARAM(TIMER_NAME, SELF,INPUTSIG, OUTPUTSIG,EQUALF, TIMER_NAME_STRING) \
   xSDLReset( TIMER_NAME, SELF, yInstanceSetVars->SaveQ, INPUTSIG, OUTPUTSIG, EQUALF);
#endif /* XMSC_TRACE */

#else /* X_ONE_TASK_PER_INSTANCE_SET */

#ifdef XMSC_TRACE
#define XSDLRESETWITHPARAM(TIMER_NAME, SELF,INPUTSIG, OUTPUTSIG,EQUALF, TIMER_NAME_STRING) \
   xSDLReset( TIMER_NAME, SELF, yVarP->SaveQ, INPUTSIG, OUTPUTSIG, EQUALF,\
             TIMER_NAME_STRING);
#else /* XMSC_TRACE */
#define XSDLRESETWITHPARAM(TIMER_NAME, SELF,INPUTSIG, OUTPUTSIG,EQUALF, TIMER_NAME_STRING) \
   xSDLReset( TIMER_NAME, SELF, yVarP->SaveQ, INPUTSIG, OUTPUTSIG, EQUALF);
#endif /* XMSC_TRACE */
#endif /* X_ONE_TASK_PER_INSTANCE_SET */

#ifdef XMSC_TRACE
#define RTOSXSDLRESET_PARAMETERS \
( int TimerName, \
  SDL_PId Self, \
  xSignalHeader SaveQ, \
  xSignalHeader InSignalPtr, \
  xSignalHeader yOutputSignalPtr, \
  xbool (* yEq)(void * VarP1, void * VarP2), \
  char *SignalName)

#else  /*XMSC_TRACE */

#define RTOSXSDLRESET_PARAMETERS \
( int TimerName, \
  SDL_PId Self, \
  xSignalHeader SaveQ, \
  xSignalHeader InSignalPtr, \
  xSignalHeader yOutputSignalPtr, \
  xbool (* yEq)(void * VarP1, void * VarP2))
#endif
       /* XMSC_TRACE */

#define RTOSXSDLRESET_VARS \
  xTimerHeader	yTimerReset; \
  xSignalHeader	TempSaved; \
  unsigned long RetCode; \
  MSG win32Mess;

#define RTOSXSDLRESET_INIT \
  yTimerReset = (xTimerHeader)xAlloc( sizeof(xTimerHeaderRec)); \
  yTimerReset->SignalCode = ResetTimer; \
  yTimerReset->Sender = Self; \
  yTimerReset->IsTimerSignal=1; \
  yTimerReset->TimerToSetOrReset = TimerName; \
  yTimerReset->yEq = yEq; \
  yTimerReset->Param = (xTimerHeader)yOutputSignalPtr; \
  yTimerReset->TestParams = (yOutputSignalPtr != NULL && yEq != NULL); \
  win32Mess.wParam = (WPARAM) yTimerReset; \
  RetCode = PostThreadMessage ( TimerThread, WM_SDL_SIGNAL, win32Mess.wParam, win32Mess.lParam ); \
  XOS_ERROR("xSDLReset", "PostThreadMessage", RetCode)

#define RTOSCHECKEQPARAM_INTIMER \
  if(yInSignalPointer->TestParams) { \
    if(yEqFunc(((xTimerHeader)(((xTimerHeader)yInSignalPointer)->Param)->SigP),(((xTimerHeader)TempTimer)->SigP))) { \
      break; \
    } \
  } \
  else

#define RTOSCHECKEQPARAM \
  if(yOutputSignalPtr != NULL && yEq !=NULL) { \
    if((*yEq)(((xTimerHeader)yOutputSignalPtr)->SigP, ((xTimerHeader)TempSaved)->SigP)) { \
      RTOSFREETIMERSTRINGPARAMS1((xTimerHeader)TempSaved); \
      xDiscardSignal(&TempSaved); \
      return; \
    } \
  } \
  else {

#define RTOSCHECKEQPARAM2 \
  if(yOutputSignalPtr != NULL && yEq !=NULL) { \
    if((*yEq)(((xTimerHeader)yOutputSignalPtr)->SigP, ((xTimerHeader)TempSaved)->SigP)) { \
      return; \
    } \
  } \
  else {

#ifdef X_ONE_TASK_PER_INSTANCE_SET

#define RTOSXSDLRESET_WAITREPLY \
  win32Mess.lParam = (LPARAM)Self->NameNode->PROCID; \
  RetCode = TGetMessage( &win32Mess, (HWND) NULL, 0, 0); \
  XOS_ERROR("xSDLReset", "TGetMessage", RetCode) \
  yTimerReset  = (xTimerHeader) win32Mess.wParam; \
  while (yTimerReset->SignalCode != ResetTimer) { \
    xSaveSignal(SaveQ, (xSignalHeader)yTimerReset); \
    RetCode = TGetMessage( &win32Mess, (HWND) NULL, 0, 0); \
    XOS_ERROR("xSDLReset", "TGetMessage", RetCode) \
    yTimerReset  = (xTimerHeader) win32Mess.wParam; \
  } \
\
  if (yTimerReset->TimerToSetOrReset == TimerWasFound) { \
    XMSC_TRACE_RESET( yTimerReset->SignalId, SignalName) \
    xFree((void **)&yTimerReset); \
    return; \
  } \
  xFree((void **)&yTimerReset);

#else

#define RTOSXSDLRESET_WAITREPLY \
  RetCode = TGetMessage ( &win32Mess, (HWND) NULL, 0, 0 ); \
  XOS_ERROR("xSDLReset", "TGetMessage", RetCode) \
  yTimerReset  = (xTimerHeader) win32Mess.wParam; \
  while (yTimerReset->SignalCode != ResetTimer) { \
    xSaveSignal(SaveQ, (xSignalHeader)yTimerReset); \
    RetCode = TGetMessage ( &win32Mess, (HWND) NULL, 0, 0 ); \
    XOS_ERROR("xSDLReset", "TGetMessage", RetCode) \
    yTimerReset  = (xTimerHeader) win32Mess.wParam; \
  } \
\
  if (yTimerReset->TimerToSetOrReset == TimerWasFound) { \
    XMSC_TRACE_RESET( yTimerReset->SignalId, SignalName) \
    xFree((void **)&yTimerReset); \
    return; \
  } \
  xFree((void **)&yTimerReset);

#endif
       /* X_ONE_TASK_PER_INSTANCE_SET */

#define RTOSTEMPSAVED \
TempSaved

#define RTOSTEMPSAVED_SIGNO \
TempSaved->SignalCode

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define RTOSTEMPSAVED_RECEIVER \
TempSaved->Receiver
#else
#define RTOSTEMPSAVED_RECEIVER
#endif

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define RTOSYTIMERACTIVE_RECEIVER \
yTimerActive->Receiver
#else
#define RTOSYTIMERACTIVE_RECEIVER
#endif

#define RTOSXRESETTEMPTIMER_SIGNALID \
TempSaved->SignalId

#ifdef X_ONE_TASK_PER_INSTANCE_SET

#define RTOSXSDLRESET_REMOVETIMER  \
  win32Mess.lParam = (LPARAM)Self->NameNode->PROCID; \
  RetCode = TPeekMessage(&win32Mess, (HWND) NULL, 0, 0, PM_REMOVE ); \
  XOS_ERROR("RTOSXSDLRESET_REMOVETIMER", "TPeekMessage", RetCode) \
  while ( RTOSMSG_IN_Q ) { /* RetCode != ERR_NOMSG   MSG IN QUEUE OR ERROR */ \
    yTimerReset  = (xTimerHeader) win32Mess.wParam; \
    if ((yTimerReset->SignalCode == TimerName) && (xEq_SDL_PId(yTimerReset->Receiver,Self))) { \
      if (yOutputSignalPtr != NULL) { \
        if ((*yEq)(((xTimerHeader)yOutputSignalPtr)->SigP, ((xTimerHeader)yTimerReset)->SigP)) { \
          /* Timer found, free memory and return */ \
          XMSC_TRACE_RESET( yTimerReset->SignalId, SignalName) \
          RTOSFREETIMERSTRINGPARAMS1((xTimerHeader)yTimerReset) \
          xFree((void **)&yTimerReset); \
          return; \
        } \
      } \
      else { \
        /* Timer found, free memory and return */ \
        XMSC_TRACE_RESET( yTimerReset->SignalId, SignalName) \
        xFree((void **)&yTimerReset); \
        return; \
      } \
    } \
    /* Other signal or timer found, put them in SaveQ and continue */ \
    xSaveSignal( SaveQ, (xSignalHeader)yTimerReset); \
    RetCode = TPeekMessage ( &win32Mess, (HWND) NULL, 0, 0, PM_REMOVE ); \
    XOS_ERROR("xSDLReset", "TPeekMessage", RetCode) \
  }

#else

#define RTOSXSDLRESET_REMOVETIMER \
  while ( RetCode = TPeekMessage(&win32Mess, (HWND) NULL, 0, 0, PM_REMOVE ) ) { \
    XOS_ERROR("xSDLReset", "TPeekMessage", RetCode) \
    yTimerReset  = (xTimerHeader) win32Mess.wParam; \
    if (yTimerReset->SignalCode == TimerName) { \
      if (yOutputSignalPtr != NULL) { \
        if ((*yEq)(((xTimerHeader)yOutputSignalPtr)->SigP, ((xTimerHeader)yTimerReset)->SigP)) { \
	  /* Timer found, free memory and return */ \
	  XMSC_TRACE_RESET( yTimerReset->SignalId, SignalName) \
          xFree((void **)&yTimerReset); \
          return; \
        } \
      } \
      else { \
	/* Timer found, free memory and return */ \
	XMSC_TRACE_RESET( yTimerReset->SignalId, SignalName) \
        xFree((void **)&yTimerReset); \
        return; \
      } \
    } \
    else { \
      /* Other signal or timer found, put them in SaveQ and continue */ \
      xSaveSignal( SaveQ, (xSignalHeader)yTimerReset); \
    } \
  }

#endif
       /* X_ONE_TASK_PER_INSTANCE_SET */

/*---+---------------------------------------------------------------
     xSDLSet
-------------------------------------------------------------------*/

#define RTOSSET_SIGNALCODE \
yInSignalPointer->SignalCode = yInSignalPointer->TimerToSetOrReset;

#define RTOSTEMPTIMERSIGNAL_TIMERTIME yInSignalPointer->TimerTime

#define RTOSSDLNOW2 SDL_Now ()

#define RTOSTEMPTIMER_TIMERTIME TempTimer->TimerTime

#define RTOSTEMPTIMERSIGNAL_PRE yInSignalPointer->Pre

#define RTOSTEMPTIMERSIGNAL_SUC yInSignalPointer->Suc

/*---+---------------------------------------------------------------
     TimerTask
-------------------------------------------------------------------*/

#define RTOSTIMERTASK_VAR \
  SDL_Time       DiffTime; \
  MSG 		 win32Mess; \
  UINT		 win32Timer; \
  unsigned long  RetCode;

#define RTOSTIMERTASKALLOC_Q \
TimerQ = (xTimerHeader)xAlloc( sizeof(xTimerHeaderRec)); \
TimerQ->SignalCode = EndOfTimerQueue;

#define RTOSTIMERQ_SUC TimerQ->Suc

#define RTOSTIMERQ_RECEIVER TimerQ->Sender

#define RTOSTIMERQ_TIMERTIME TimerQ->TimerTime

#define RTOSTIMERWRAPPTR_PRE \
  (*TimerWrapPtr)->Pre

#define RTOSTIMERWRAPPTR_SUC \
  (*TimerWrapPtr)->Suc

#define RTOSTIMERTASKALLOC_INSIGNAL

#define RTOSTIMERRECEIVE(SIGPTR,SELF,WAITTIME, QID) \
      RetCode = TGetMessage ( &win32Mess, (HWND) NULL, 0, 0 ); \
      SIGPTR = (xTimerHeader)win32Mess.wParam; \
      XOS_ERROR("RTOSTIMERRECEIVE", "TGetMessage", RetCode)

#define RTOSGETCURRENTTIME2 CurrentTime = SDL_Now ();

#define RTOSTIMERQ_SUC_TIMERTIME TimerQ->Suc->TimerTime

#define RTOSXTIMER_SUC yOutputSignalPtr->Suc

#define RTOSTIMERQ_SUC_PRE TimerQ->Suc->Pre

#ifdef X_ONE_TASK_PER_INSTANCE_SET

#define RTOSOUTPUTSIGNAL_RECEIVER \
  (yOutputSignalPtr->Sender)->NameNode->PROCID

#else

#define RTOSOUTPUTSIGNAL_RECEIVER \
yOutputSignalPtr->Sender

#endif
       /* X_ONE_TASK_PER_INSTANCE_SET */

#define RTOSSENDTIMERFREE_OUTPUT

#define RTOSRECEIVE_MESSAGE2 \
		  /* Create timer for wait = difftime (milliseconds) */ \
		  /* Note! This timer must be killed later on, Win32 timers are recurrent */ \
		  /* When this timer expires it generates a WM_TIMER message to the Timer thread */ \
		  DiffTime = TimerQ->Suc->TimerTime - CurrentTime; \
		  win32Timer = SetTimer ( (HWND) NULL, 0, DiffTime, (TIMERPROC) NULL ); \
		  XOS_ERROR("xTimerTask", "SetTimer", win32Timer) \
		  RetCode = TGetMessage ( &win32Mess, (HWND) NULL, WM_TIMER, WM_SDL_SIGNAL ); \
		  XOS_ERROR("xTimerTask", "TGetMessage", RetCode) \
		  KillTimer((HWND) NULL, win32Timer); \
		  XOS_ERROR("xTimerTask", "KillTimer", 0) \
		  if (win32Mess.message == WM_TIMER) { \
		  /* No message received during waiting time */ \
			 yInSignalPointer = NIL; \
		  } \
		  else { \
			 yInSignalPointer = (xTimerHeader)win32Mess.wParam; \
		  }

#define RTOSTEMPTIMERSIGNAL_SIG_NO yInSignalPointer->SignalCode

/*---+---------------------------------------------------------------
     env
-------------------------------------------------------------------*/

#ifdef XMSC_TRACE

#define RTOSRTOSPAD_ENV \
RTOSRTOSPAD_HEAD \
{ \
	/* This must be updated to handle incoming/outgoing signals */ \
  SDL_PId SenderPId; \
  xSignalHeader yInSignalPtr; \
  RTOSSYSINITPROC_RECEIVE \
  SenderPId = RTOSSYSINITPR_SENDER; \
  RTOSSYSINITPR_MSCPRINT \
  xFree((void **)(&yInSignalPtr)); \
  SuspendThread(GetCurrentThread()); \
}

#else

#define RTOSRTOSPAD_ENV \
RTOSRTOSPAD_HEAD \
{ \
	/* This must be updated to handle incoming/outgoing signals */ \
  xSignalHeader yInSignalPtr; \
  RTOSSYSINITPROC_RECEIVE \
    printf("Signal to environment is received.\n"); \
  xFree((void **)(&yInSignalPtr)); \
  SuspendThread(GetCurrentThread()); \
}

#endif  /* XMSC_TRACE */

#define RTOSRTOSPAD_HEAD \
extern void WIN32PAD_env XPP(( ))

/****+***************************************************************
     sctos.c
********************************************************************/

/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 *  OS routines
 *++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 * xAlloc for Win32
 *++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

#ifdef XCHECKALLOC

#define RTOSXALLOC \
  if ( Size > (xptrint)0 ) { \
	 char  *Temp; \
         Temp = HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, (DWORD) Size); \
         if (Temp == NULL) \
                XOS_ERROR("xAlloc", "HeapAlloc", Temp); \
         return Temp; \
  } \
  else \
	 return (void *)0;

#else

#define RTOSXALLOC \
  if ( Size > (xptrint)0 ) { \
	 char  *Temp; \
	 Temp = HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, (DWORD) Size); \
	 return Temp; \
  } \
  else  \
	 return (void *)0; 

#endif

/*---+---------------------------------------------------------------
     xFree
-------------------------------------------------------------------*/

#define RTOSXFREE \
  if (*P != 0) { \
    HeapFree(GetProcessHeap(), 0, (LPVOID) *P); \
    *P = (void *)0; \
  }

/****+***************************************************************
     sctwin32.c
********************************************************************/

/*---+---------------------------------------------------------------
     SDL_Now
-------------------------------------------------------------------*/

#ifdef X_SIGNAL_PRIO
/*---+--------------------------------------------------------------
     Signal priority upgrade (fab)
	 Redefinition of GetMessage, PeekMessage, CreateThread, 
	 ExitThread
-------------------------------------------------------------------*/
BOOL TGetMessage (LPMSG lpMsg, HWND hWnd, UINT wMsgFilterMin, UINT wMsgFilterMax);
BOOL TPeekMessage (LPMSG lpMsg, HWND hWnd, UINT wMsgFilterMin, UINT wMsgFilterMax, UINT wRemoveMsg);
HANDLE TCreateThread (
    LPSECURITY_ATTRIBUTES lpThreadAttributes,
    DWORD dwStackSize,
    LPTHREAD_START_ROUTINE lpStartAddress,
    LPVOID lpParameter,
    DWORD dwCreationFlags,
    LPDWORD lpThreadId);
void TExitThread (
    DWORD dwExitCode
    );

/*---+--------------------------------------------------------------
     A macro which returns the caller thread id in the operating 
	 system
-------------------------------------------------------------------*/
#define RTOSGETCURRENTTASKID GetCurrentThreadId ()

/*---+--------------------------------------------------------------
     Intermediate queue object
-------------------------------------------------------------------*/

typedef struct TIQElem { /* intermediate queue element */
  void* Data;   /* o.s. message data */
  int Len;      /* *Data length (ignored but returned to object clients) */
  int Priority; /* Mantained since generic object doesn't know where to find it */
  struct TIQElem* Pre; /* Link towards queue tail (tail = where lowest prio signals stay) */
} TIQElem;

typedef struct {
  TIQElem* Head;  /* Highest priority element or NULL if empty */
} TIntermediateQueue;

/* Initialize the intermediate queue */
void TIQInit (TIntermediateQueue* Q);

/* Add a signal to the intermediate queue, *S is copied to an internally allocated copy
   (but not S->Data!), S->Pre is meaningless and can be uninitialized */
void TIQAdd (TIntermediateQueue* Q, TIQElem* S);

/* Test if the intermediate queue is empty */
int  TIQIsEmpty (TIntermediateQueue* Q);

/* Extract a signal from the intermediate queue (in priority order). One signal at least 
   must exist. *S is the destination of a copy of the element structure, which is internally
   deallocated */
void TIQExtract (TIntermediateQueue* Q, TIQElem* S);

/* Force queue flush, deallocating any Data member with xFree */
void TIQForceFlush (TIntermediateQueue* Q);

/* Count messages in the queue */
int TIQCountMsg (TIntermediateQueue* Q);

/*---+--------------------------------------------------------------
   Thread-Intermediate queue association object (temporary version)
-------------------------------------------------------------------*/

typedef DWORD TTaskId; /* o.s. dependent */
typedef HANDLE TSemaphoreId; /* o.s. dependent */

typedef struct {
  TTaskId TaskId;            /* o.s. thread id */
  TIntermediateQueue Queue;  /* intermediate queue associated */
  int Free;					 /* true if free location */
} TIQAssociationRecord;

#define ASS_ELEMENTS 100
typedef struct {
  TIQAssociationRecord AssArray [ASS_ELEMENTS];
  TSemaphoreId Semaphore; /* provided for list integrity */
} TAssociationObj;

/* Initialize the association object */
void TAOInit (TAssociationObj* A);

/* Register a new task */
void TAORegisterTask (TAssociationObj* A, TTaskId Id);

/* Free a task */
void TAOFreeTask (TAssociationObj* A, TTaskId Id);

/* Get intermediate queue access for a given task */
TIntermediateQueue* TAOGetQueue (TAssociationObj* A, TTaskId Id);

/* Create Semaphore (o.s. dependent) */
void TAOCreateSemaphore (TAssociationObj* A);

/* Wait on Semaphore (o.s. dependent) */
void TAOWaitSemaphore (TAssociationObj* A);

/* Give Semaphore (o.s. dependent) */
void TAOGiveSemaphore (TAssociationObj* A);
#else
 /* traditional o.s. functions */
#define TGetMessage GetMessage
#define TPeekMessage PeekMessage
#define TCreateThread CreateThread
#define TExitThread ExitThread
#endif
 /* X_SIGNAL_PRIO */

#endif /* _sctwin32_h */
