/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.3.23566 at Sat Nov 17 11:52:46 AM CET 2012
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1990, 2012.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

#include "cucf.h"
#include "er/per/per_content.h"

#ifndef CODER_REMOVE_PER

/*************************************************/
/******************* ENCODE **********************/
/*************************************************/

/**************************************************
 * NAME: PEREncode
 *       
 *
 */

int
PEREncode(tCoder* Coder, tASN1TypeInfo* Type, void* Val)
{
  int retCode;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PEREncode\n");
#endif

  if ((retCode = BufGetErrorCode(Coder)) != ec_SUCCESS)
    return retCode;

  CUCFSetErrorCatcher(Coder, retCode);
  if (retCode == 0)
    {
      tVMSULong Length;

      EPInit(Coder, Type);
      VMSInit(Coder, Type, Val);
      Coder->ER.MemStart = BufGetMemory(Coder, &Length);
      Coder->ER.MemEnd   = Coder->ER.MemStart + Length;
      Coder->ER.DataEnd  = BufGetDataEnd(Coder, &Coder->ER.BitEnd);
      Coder->ER.DataCurr = Coder->ER.DataEnd;
      Coder->ER.BitCurr  = Coder->ER.BitEnd;
      if (!(Coder->ER.Rule & er_PER))
        Coder->ER.Rule = (er_PER | CUCF_PER_VARIANT);

      PEREncVal(Coder, Type, Val);

      if ((Coder->ER.DataCurr == Coder->ER.DataEnd) && (Coder->ER.BitCurr == Coder->ER.BitEnd))
        {
          PERPutByte(Coder, 0);
        }
      if (!(Coder->ER.Rule & er_NoEndPad))
        {
          PERAlign(Coder);
        }

      BufSetDataEnd(Coder, Coder->ER.DataCurr - Coder->ER.DataEnd, Coder->ER.BitCurr);
      Coder->ER.ValueBitLength = ((Coder->ER.DataCurr - Coder->ER.DataEnd) << 3) + (Coder->ER.BitEnd - Coder->ER.BitCurr);
    }

  Coder->EMS.IsAssigned = 0;
  return Coder->EMS.ErrorCode;
}

#endif /* !CODER_REMOVE_PER */
